
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

typedef unsigned char DSTATUS;

typedef enum {
RES_OK = 0,		
RES_ERROR,		
RES_WRPRT,		
RES_NOTRDY,		
RES_PARERR		
} DRESULT;

DSTATUS disk_initialize (unsigned char drv);
DSTATUS disk_status (unsigned char drv);
DRESULT disk_read (unsigned char drv, unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_write (unsigned char drv, const unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_ioctl (unsigned char drv, unsigned char ctrl, void* buff);
void disk_timerproc (void);

#pragma library sdcard.lib

typedef char XCHAR;		

typedef struct _FATFS_ {
unsigned char	fs_type;	
unsigned char	drive;		
unsigned char	csize;		
unsigned char	n_fats;		
unsigned char	wflag;		
unsigned char	fsi_flag;	
unsigned short	id;		
unsigned short	n_rootdir;	
unsigned long	last_clust;	
unsigned long	free_clust;	
unsigned long	fsi_sector;	
unsigned long	cdir;		
unsigned long	sects_fat;	
unsigned long	max_clust;	
unsigned long	fatbase;	
unsigned long	dirbase;	
unsigned long	database;	
unsigned long	winsect;	
unsigned char	win[512];
} FATFS;

typedef struct _DIR_ {
FATFS*	fs;			
unsigned short	id;		
unsigned short	index;	
unsigned long	sclust;	
unsigned long	clust;	
unsigned long	sect;	
unsigned char*	dir;		
unsigned char*	fn;		
} DIR;

typedef struct _FIL_ {
FATFS*	fs;			
unsigned short	id;		
unsigned char	flag;	
unsigned char	csect;	
unsigned long	fptr;		
unsigned long	fsize;		
unsigned long	org_clust;	
unsigned long	curr_clust;	
unsigned long	dsect;		
unsigned long	dir_sect;	
unsigned char*	dir_ptr;	
unsigned char	buf[512];
} FIL;

typedef struct _FILINFO_ {
unsigned long	fsize;	
unsigned short	fdate;	
unsigned short	ftime;	
unsigned char	fattrib;	
char	fname[13];	
} FILINFO;

typedef enum {
FR_OK = 0,		
FR_DISK_ERR,		
FR_INT_ERR,		
FR_NOT_READY,		
FR_NO_FILE,		
FR_NO_PATH,		
FR_INVALID_NAME,	
FR_DENIED,		
FR_EXIST,			
FR_INVALID_OBJECT,	
FR_WRITE_PROTECTED,	
FR_INVALID_DRIVE,	
FR_NOT_ENABLED,	
FR_NO_FILESYSTEM,	
FR_MKFS_ABORTED,	
FR_TIMEOUT		
} FRESULT;

FRESULT f_mount (unsigned char vol , FATFS* fs);

FRESULT f_open (FIL* fp, const XCHAR* path, unsigned char mode);

FRESULT f_read (FIL* fp, void* buff, unsigned int btr, unsigned int* br);

FRESULT f_write (FIL* fp, const void* buff, unsigned int btw, unsigned int* bw);

FRESULT f_lseek (FIL* fp, unsigned long ofs);

FRESULT f_close (FIL* fp);

FRESULT f_opendir (DIR* dj, const XCHAR* path);

FRESULT f_readdir (DIR* dj, FILINFO* fno);

FRESULT f_stat (const XCHAR* path, FILINFO* fno);

FRESULT f_getfree (const XCHAR* path, unsigned long* nclst, FATFS** fatfs);

FRESULT f_truncate (FIL* fp);

FRESULT f_sync (FIL* fp);

FRESULT f_unlink (const XCHAR* path);

FRESULT f_mkdir (const XCHAR* path);

FRESULT f_chmod (const XCHAR* path, unsigned char value, unsigned char mask);

FRESULT f_utime (const XCHAR* path, const FILINFO* fno);

FRESULT f_rename (const XCHAR* path_old, const XCHAR* path_new);

FRESULT f_chdir (const XCHAR* path);

FRESULT f_chdrive (unsigned char drv);

extern void (*prtc_get_time) (unsigned char *hour, unsigned char *min, unsigned char *sec);

extern void (*prtc_get_date) (unsigned char *date, unsigned char *month, unsigned *year);

#pragma library ff.lib

int fgetc(FIL *fp);
char *fgets(char *str,unsigned int len,FIL *fp);
int fputc(char k,FIL* fp);
int fputs(char *str,FIL* fp);
int fputsf(char flash *str,FIL* fp);
int fprintf(FIL *fp, char flash *fmtstr,...);
int fscanf(FIL *fp, char flash *fmtstr,...);
unsigned char feof(FIL* fp);
unsigned char ferror(FIL *fp);

#pragma used-

#pragma library stdio.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strlcpy(char *dest,char *src,unsigned char n);	
unsigned char strlcpyf(char *dest,char flash *src,unsigned char n); 
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-

#pragma library ctype.lib

typedef signed char             								int8;
typedef unsigned char           								uint8;
typedef signed int              								int16;
typedef unsigned int            								uint16;
typedef signed long int         								int32;
typedef unsigned long int       								uint32;

typedef enum {
TFT_MODE_NORMAL,
TFT_MODE_INVERSE,
TFT_MODE_FULL
} TFT_mode_t;

extern int 																	TFT_margin_xl;
extern int 																	TFT_margin_xr;
extern int 																	TFT_margin_yu;
extern int 																	TFT_margin_yl;

void TFTOutCmd(unsigned short ins);
void TFTOutDat(unsigned short dat); 											
void TFTOutDat2(unsigned char dath, unsigned char datl); 	

unsigned short TFTInDat(void); 														

void TFTSetReg(unsigned short index,unsigned short val); 	
unsigned short TFTGetReg(unsigned short index); 					

void TFTInit(void); 

void TFTBacklight(unsigned char x);
unsigned short TFTGetID(void);

void TFTSetArea(int sx,int ex,int sy,int ey);
void TFTResetArea(void);

void TFTGotoXY(int x,int y);

void TFTPutPixel(int x,int y,unsigned short color,TFT_mode_t mode);
void TFTFillRect(int sx,int ex,int sy,int ey,unsigned short color,TFT_mode_t mode); 

void TFTShowPic(int sx,int ex,int sy,int ey,const unsigned short *pic,TFT_mode_t mode);

extern void Line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color);
extern void Rectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color);
extern void RoundRectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned int radius, unsigned char fill, unsigned short color);
extern void Circle_Fill(unsigned int x, unsigned int y, unsigned int radius, unsigned char fill, unsigned short color);

void Line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color)
{
signed int  	x, y, addx, addy, dx, dy;
signed long 	P;
int 					i;

dx = abs((signed int)(x2 - x1));
dy = abs((signed int)(y2 - y1));
x  = x1;
y  = y1;

addx = addy = 1;
if(x1 > x2)		addx = -1;
if(y1 > y2)		addy = -1;

if (dx >= dy)
{
P = 2L*dy - dx;
for (i=0; i<=dx; ++i)
{
TFTPutPixel(x, y, color, TFT_MODE_NORMAL);
if(P < 0)
{
P += 2*dy;
x += addx;
}
else
{
P += 2*dy - 2*dx;
x += addx;
y += addy;
}
}
}
else
{
P = 2L*dx - dy;
for(i=0; i<=dy; ++i)
{
TFTPutPixel(x, y, color, TFT_MODE_NORMAL);
if(P < 0)
{
P += 2*dx;
y += addy;
}
else
{
P += 2*dx - 2*dy;
x += addx;
y += addy;
}
}
}
}	

void Rectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color)
{
TFTFillRect(x1, x2, y1, y1, color, TFT_MODE_NORMAL);    
TFTFillRect(x1, x2, y2, y2, color, TFT_MODE_NORMAL);    
TFTFillRect(x1, x1, y1, y2, color, TFT_MODE_NORMAL);    
TFTFillRect(x2, x2, y1, y2, color, TFT_MODE_NORMAL);    
}	

void RoundRectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned int radius, unsigned char fill, unsigned short color)
{
signed int 		a, b, P;

a  = 0;       				
b  = radius;  				
P  = 1 - radius;

if (fill)
{		
TFTFillRect(x1, x2, y1+radius, y2-radius, color, TFT_MODE_NORMAL);

do
{
TFTFillRect(x1-a+radius, a+x2-radius, y1-b+radius, y1-b+radius, color, TFT_MODE_NORMAL);	
TFTFillRect(x1-b+radius, b+x2-radius, y1-a+radius, y1-a+radius, color, TFT_MODE_NORMAL);	
TFTFillRect(x1-b+radius, b+x2-radius, a+y2-radius, a+y2-radius, color, TFT_MODE_NORMAL);	
TFTFillRect(x1-a+radius, a+x2-radius, b+y2-radius, b+y2-radius, color, TFT_MODE_NORMAL);	

if(P < 0)		P+= 3 + 2*a++;
else				P+= 5 + 2*(a++ - b--);
} while(a <= b);
} 
else
{
TFTFillRect(x1+radius, x2-radius, y1, y1, color, TFT_MODE_NORMAL);	
TFTFillRect(x1+radius, x2-radius, y2, y2, color, TFT_MODE_NORMAL);	
TFTFillRect(x1, x1, y1+radius, y2-radius, color, TFT_MODE_NORMAL);	
TFTFillRect(x2, x2, y1+radius, y2-radius, color, TFT_MODE_NORMAL);	

do
{
TFTPutPixel(a+x2-radius, y1-b+radius, color, TFT_MODE_NORMAL);	
TFTPutPixel(b+x2-radius, y1-a+radius, color, TFT_MODE_NORMAL);	

TFTPutPixel(b+x2-radius, a+y2-radius, color, TFT_MODE_NORMAL);	
TFTPutPixel(a+x2-radius, b+y2-radius, color, TFT_MODE_NORMAL);	

TFTPutPixel(x1-a+radius, b+y2-radius, color, TFT_MODE_NORMAL);	
TFTPutPixel(x1-b+radius, a+y2-radius, color, TFT_MODE_NORMAL);	

TFTPutPixel(x1-b+radius, y1-a+radius, color, TFT_MODE_NORMAL);	
TFTPutPixel(x1-a+radius, y1-b+radius, color, TFT_MODE_NORMAL);	

if(P < 0)		P+= 3 + 2*a++;
else				P+= 5 + 2*(a++ - b--);
} while(a <= b);
} 
}	

void Circle_Fill(unsigned int x, unsigned int y, unsigned int radius, unsigned char fill, unsigned short color)
{
signed int 	a, b, P;

a = 0;
b = radius;
P = 1 - radius;

do
{
if(fill)
{
TFTFillRect(x-a, x+a, y+b, y+b, color, TFT_MODE_NORMAL);	
TFTFillRect(x-a, x+a, y-b, y-b, color, TFT_MODE_NORMAL);	
TFTFillRect(x-b, x+b, y+a, y+a, color, TFT_MODE_NORMAL);	
TFTFillRect(x-b, x+b, y-a, y-a, color, TFT_MODE_NORMAL);	
}
else
{

TFTPutPixel(a+x, b+y, color, TFT_MODE_NORMAL);	
TFTPutPixel(b+x, a+y, color, TFT_MODE_NORMAL);	
TFTPutPixel(x-a, b+y, color, TFT_MODE_NORMAL);	
TFTPutPixel(x-b, a+y, color, TFT_MODE_NORMAL);	
TFTPutPixel(b+x, y-a, color, TFT_MODE_NORMAL);	
TFTPutPixel(a+x, y-b, color, TFT_MODE_NORMAL);	
TFTPutPixel(x-a, y-b, color, TFT_MODE_NORMAL);	
TFTPutPixel(x-b, y-a, color, TFT_MODE_NORMAL);	
}

if(P < 0)    P+= 3 + 2*a++;
else         P+= 5 + 2*(a++ - b--);
} while(a <= b);
}	
