
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

typedef unsigned char DSTATUS;

typedef enum {
RES_OK = 0,		
RES_ERROR,		
RES_WRPRT,		
RES_NOTRDY,		
RES_PARERR		
} DRESULT;

DSTATUS disk_initialize (unsigned char drv);
DSTATUS disk_status (unsigned char drv);
DRESULT disk_read (unsigned char drv, unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_write (unsigned char drv, const unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_ioctl (unsigned char drv, unsigned char ctrl, void* buff);
void disk_timerproc (void);

#pragma library sdcard.lib

typedef char XCHAR;		

typedef struct _FATFS_ {
unsigned char	fs_type;	
unsigned char	drive;		
unsigned char	csize;		
unsigned char	n_fats;		
unsigned char	wflag;		
unsigned char	fsi_flag;	
unsigned short	id;		
unsigned short	n_rootdir;	
unsigned long	last_clust;	
unsigned long	free_clust;	
unsigned long	fsi_sector;	
unsigned long	cdir;		
unsigned long	sects_fat;	
unsigned long	max_clust;	
unsigned long	fatbase;	
unsigned long	dirbase;	
unsigned long	database;	
unsigned long	winsect;	
unsigned char	win[512];
} FATFS;

typedef struct _DIR_ {
FATFS*	fs;			
unsigned short	id;		
unsigned short	index;	
unsigned long	sclust;	
unsigned long	clust;	
unsigned long	sect;	
unsigned char*	dir;		
unsigned char*	fn;		
} DIR;

typedef struct _FIL_ {
FATFS*	fs;			
unsigned short	id;		
unsigned char	flag;	
unsigned char	csect;	
unsigned long	fptr;		
unsigned long	fsize;		
unsigned long	org_clust;	
unsigned long	curr_clust;	
unsigned long	dsect;		
unsigned long	dir_sect;	
unsigned char*	dir_ptr;	
unsigned char	buf[512];
} FIL;

typedef struct _FILINFO_ {
unsigned long	fsize;	
unsigned short	fdate;	
unsigned short	ftime;	
unsigned char	fattrib;	
char	fname[13];	
} FILINFO;

typedef enum {
FR_OK = 0,		
FR_DISK_ERR,		
FR_INT_ERR,		
FR_NOT_READY,		
FR_NO_FILE,		
FR_NO_PATH,		
FR_INVALID_NAME,	
FR_DENIED,		
FR_EXIST,			
FR_INVALID_OBJECT,	
FR_WRITE_PROTECTED,	
FR_INVALID_DRIVE,	
FR_NOT_ENABLED,	
FR_NO_FILESYSTEM,	
FR_MKFS_ABORTED,	
FR_TIMEOUT		
} FRESULT;

FRESULT f_mount (unsigned char vol , FATFS* fs);

FRESULT f_open (FIL* fp, const XCHAR* path, unsigned char mode);

FRESULT f_read (FIL* fp, void* buff, unsigned int btr, unsigned int* br);

FRESULT f_write (FIL* fp, const void* buff, unsigned int btw, unsigned int* bw);

FRESULT f_lseek (FIL* fp, unsigned long ofs);

FRESULT f_close (FIL* fp);

FRESULT f_opendir (DIR* dj, const XCHAR* path);

FRESULT f_readdir (DIR* dj, FILINFO* fno);

FRESULT f_stat (const XCHAR* path, FILINFO* fno);

FRESULT f_getfree (const XCHAR* path, unsigned long* nclst, FATFS** fatfs);

FRESULT f_truncate (FIL* fp);

FRESULT f_sync (FIL* fp);

FRESULT f_unlink (const XCHAR* path);

FRESULT f_mkdir (const XCHAR* path);

FRESULT f_chmod (const XCHAR* path, unsigned char value, unsigned char mask);

FRESULT f_utime (const XCHAR* path, const FILINFO* fno);

FRESULT f_rename (const XCHAR* path_old, const XCHAR* path_new);

FRESULT f_chdir (const XCHAR* path);

FRESULT f_chdrive (unsigned char drv);

extern void (*prtc_get_time) (unsigned char *hour, unsigned char *min, unsigned char *sec);

extern void (*prtc_get_date) (unsigned char *date, unsigned char *month, unsigned *year);

#pragma library ff.lib

int fgetc(FIL *fp);
char *fgets(char *str,unsigned int len,FIL *fp);
int fputc(char k,FIL* fp);
int fputs(char *str,FIL* fp);
int fputsf(char flash *str,FIL* fp);
int fprintf(FIL *fp, char flash *fmtstr,...);
int fscanf(FIL *fp, char flash *fmtstr,...);
unsigned char feof(FIL* fp);
unsigned char ferror(FIL *fp);

#pragma used-

#pragma library stdio.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strlcpy(char *dest,char *src,unsigned char n);	
unsigned char strlcpyf(char *dest,char flash *src,unsigned char n); 
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-

#pragma library ctype.lib

typedef signed char             								int8;
typedef unsigned char           								uint8;
typedef signed int              								int16;
typedef unsigned int            								uint16;
typedef signed long int         								int32;
typedef unsigned long int       								uint32;

typedef enum {
TFT_MODE_NORMAL,
TFT_MODE_INVERSE,
TFT_MODE_FULL
} TFT_mode_t;

extern int 																	TFT_margin_xl;
extern int 																	TFT_margin_xr;
extern int 																	TFT_margin_yu;
extern int 																	TFT_margin_yl;

void TFTOutCmd(unsigned short ins);
void TFTOutDat(unsigned short dat); 											
void TFTOutDat2(unsigned char dath, unsigned char datl); 	

unsigned short TFTInDat(void); 														

void TFTSetReg(unsigned short index,unsigned short val); 	
unsigned short TFTGetReg(unsigned short index); 					

void TFTInit(void); 

void TFTBacklight(unsigned char x);
unsigned short TFTGetID(void);

void TFTSetArea(int sx,int ex,int sy,int ey);
void TFTResetArea(void);

void TFTGotoXY(int x,int y);

void TFTPutPixel(int x,int y,unsigned short color,TFT_mode_t mode);
void TFTFillRect(int sx,int ex,int sy,int ey,unsigned short color,TFT_mode_t mode); 

void TFTShowPic(int sx,int ex,int sy,int ey,const unsigned short *pic,TFT_mode_t mode);

unsigned short							TFT_ID_code				= 0x0000;

int 												TFT_margin_xl 		= 0;
int 												TFT_margin_xr 		= 240 - 1;
int 												TFT_margin_yu 		= 0;
int 												TFT_margin_yl 		= 320 - 1;

unsigned int 								newX							= 0;
unsigned int 								newY							= 0;

void delay200ns(unsigned char n)													
{
while(n--)
{	

#asm("nop");
#asm("nop");
#asm("nop");
}
} 

void TFTPortInit(void)																		
{
{DDRC			 = 0xFF; PORTC = 0x00;};										

{DDRD |= (1<<(2)); PORTD |= (1<<(2));};										
{DDRD |= (1<<(4)); PORTD |= (1<<(4));};										
{DDRD |= (1<<(5)); PORTD |= (1<<(5));};										
{DDRD |= (1<<(3)); PORTD |= (1<<(3));};										

{DDRD |= (1<<(6)); PORTD &= ~(1<<(6));};											
{DDRD |= (1<<(7))  ; PORTD &= ~(1<<(7));};											
}

void TFTReset(void) 																			
{
(0 ? (PORTD |= (1<<(6))) : (PORTD &= ~(1<<(6))));
delay_ms(200);
(1 ? (PORTD |= (1<<(6))) : (PORTD &= ~(1<<(6))));
delay_ms(500);
} 

void TFTOutCmd(unsigned short ins) 												
{
PORTC = 0x00;
(0 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));
(0 ? (PORTD |= (1<<(4))) : (PORTD &= ~(1<<(4))));

PORTC = ins >> 8;
(0 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));
(1 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));			

PORTC = ins;
(0 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));
(1 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));

(1 ? (PORTD |= (1<<(4))) : (PORTD &= ~(1<<(4))));
(1 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));
} 

void TFTOutDat(unsigned short dat) 												
{
PORTC = 0x00;
(0 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));

PORTC = dat >> 8;
(0 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));
(1 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));

PORTC = dat;
(0 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));
(1 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));

(1 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));
} 

void TFTOutDat2(unsigned char dath, unsigned char datl) 	
{
unsigned short 		dat = 0x0000;

PORTC = 0x00;
(0 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));

PORTC = dath;
(0 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));
(1 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));

PORTC = datl;
(0 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));
(1 ? (PORTD |= (1<<(3))) : (PORTD &= ~(1<<(3))));

(1 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));
} 

unsigned short TFTInDat(void) 														
{
unsigned short 		dat = 0x0000;

DDRC			 = 0x00;
(0 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));

(0 ? (PORTD |= (1<<(5))) : (PORTD &= ~(1<<(5))));
delay200ns(1);
dat = PINC;
(1 ? (PORTD |= (1<<(5))) : (PORTD &= ~(1<<(5))));

(0 ? (PORTD |= (1<<(5))) : (PORTD &= ~(1<<(5))));
dat <<= 8;

delay200ns(1);
dat |= PINC;
(1 ? (PORTD |= (1<<(5))) : (PORTD &= ~(1<<(5))));

(1 ? (PORTD |= (1<<(2))) : (PORTD &= ~(1<<(2))));
DDRC			 = 0xFF;

return(dat);
} 

void TFTSetReg(unsigned short index, unsigned short val)	
{
TFTOutCmd(index);
TFTOutDat(val);
}	

unsigned short TFTGetReg(unsigned short index)						
{
TFTOutCmd(index);
return(TFTInDat());
}	

void TFTInit(void) 																				
{
TFTPortInit();
delay_ms(100);
TFTReset();

TFT_ID_code = TFTGetReg(0x0000 );

if (TFT_ID_code == 0x9325) 		
{

TFTSetReg(0x00E3, 										0x3008);							
TFTSetReg(0x00E7, 										0x0012);							
TFTSetReg(0x00EF, 										0x1231);							
TFTSetReg(0x0000 , 					0x0001);							

delay_ms(100);                 		
TFTSetReg(0x0001, 			0x0100);							
TFTSetReg(0x0002,			0x0700);							
TFTSetReg(0x0003,					0x0030);		
TFTSetReg(0x0004,				0x0000);							
TFTSetReg(0x0008, 				0x0202);							
TFTSetReg(0x0009,					0x0000);							
TFTSetReg(0x000A,					0x0000);							
TFTSetReg(0x000C,	0x0000);							
TFTSetReg(0x000D, 		0x0000);							
TFTSetReg(0x000F, 	0x0000);							

TFTSetReg(0x0010,					0x0000);							
TFTSetReg(0x0011,					0x0007);							
TFTSetReg(0x0012,					0x0000);							
TFTSetReg(0x0013,					0x0013);							

delay_ms(500);																						

TFTSetReg(0x0010,					0x1290);							
TFTSetReg(0x0011,					0x0527);							

delay_ms(100);
TFTSetReg(0x0012,					0x0018);							

delay_ms(100);
TFTSetReg(0x0013,					0x1000);							
TFTSetReg(0x0029,					0x001E);							
TFTSetReg(0x002B,	0x000D);							

delay_ms(100);
TFTSetReg(0x0020, 				0x0000);
TFTSetReg(0x0021, 				0x0000);

TFTSetReg(0x0030, 				0x0007);
TFTSetReg(0x0031, 				0x0605);
TFTSetReg(0x0032, 				0x0106);
TFTSetReg(0x0035 , 				0x0206);
TFTSetReg(0x0036, 				0x0808);
TFTSetReg(0x0037, 				0x0007);
TFTSetReg(0x0038, 				0x0201);
TFTSetReg(0x0039, 				0x0007);
TFTSetReg(0x003C, 				0x0602);
TFTSetReg(0x003D, 			0x0808);

TFTSetReg(0x0050, 			0x0000);							
TFTSetReg(0x0051, 				0x00EF);							
TFTSetReg(0x0052, 			0x0000);							
TFTSetReg(0x0053, 				0x013F);							
TFTSetReg(0x0060, 		0xA700);							
TFTSetReg(0x0061, 		0x0001);							
TFTSetReg(0x006A, 		0x0000);							

TFTSetReg(0x0080, 0x0000);
TFTSetReg(0x0081, 0x0000);
TFTSetReg(0x0082, 	0x0000);
TFTSetReg(0x0083, 0x0000);
TFTSetReg(0x0084, 0x0000);
TFTSetReg(0x0085, 	0x0000);

TFTSetReg(0x0090, 		0x0010);
TFTSetReg(0x0092, 		0x0000);
TFTSetReg(0x0093, 		0x0003);
TFTSetReg(0x0095, 		0x0110);
TFTSetReg(0x0097, 		0x0000);
TFTSetReg(0x0098, 		0x0000);

TFTSetReg(0x0007, 				0x0133);							
} 

else if (TFT_ID_code == 0x9320) 		
{

TFTSetReg(0x00E5, 										0x8000);
TFTSetReg(0x0000 , 					0x0001);

delay_ms(100);                 		
TFTSetReg(0x0001, 			0x0100);
TFTSetReg(0x0002,			0x0700);
TFTSetReg(0x0003,					0x0030);
TFTSetReg(0x0004,				0x0000);
TFTSetReg(0x0008, 				0x0202);
TFTSetReg(0x0009,					0x0000);
TFTSetReg(0x000A,					0x0000);
TFTSetReg(0x000C,	0x0000);
TFTSetReg(0x000D, 		0x0000);
TFTSetReg(0x000F, 	0x0000);

TFTSetReg(0x0010,					0x0000);
TFTSetReg(0x0011,					0x0000);
TFTSetReg(0x0012,					0x0000);
TFTSetReg(0x0013,					0x0000);

delay_ms(500);

TFTSetReg(0x0010,					0x17B0);
TFTSetReg(0x0011,					0x0137);

delay_ms(100);
TFTSetReg(0x0012,					0x013C);

delay_ms(100);
TFTSetReg(0x0013,					0x1400);
TFTSetReg(0x0029,					0x0007);

delay_ms(100);
TFTSetReg(0x0020, 				0x0000);
TFTSetReg(0x0021, 				0x0000);

TFTSetReg(0x0030, 				0x0007);
TFTSetReg(0x0031, 				0x0504);
TFTSetReg(0x0032, 				0x0703);
TFTSetReg(0x0035 , 				0x0002);
TFTSetReg(0x0036, 				0x0707);
TFTSetReg(0x0037, 				0x0406);
TFTSetReg(0x0038, 				0x0006);
TFTSetReg(0x0039, 				0x0404);
TFTSetReg(0x003C, 				0x0700);
TFTSetReg(0x003D, 			0x0A08);

TFTSetReg(0x0050, 			0x0000);
TFTSetReg(0x0051, 				0x00EF);
TFTSetReg(0x0052, 			0x0000);
TFTSetReg(0x0053, 				0x013F);
TFTSetReg(0x0060, 		0x2700);
TFTSetReg(0x0061, 		0x0001);
TFTSetReg(0x006A, 		0x0000);

TFTSetReg(0x0080, 0x0000);
TFTSetReg(0x0081, 0x0000);
TFTSetReg(0x0082, 	0x0000);
TFTSetReg(0x0083, 0x0000);
TFTSetReg(0x0084, 0x0000);
TFTSetReg(0x0085, 	0x0000);

TFTSetReg(0x0090, 		0x0010);
TFTSetReg(0x0092, 		0x0000);
TFTSetReg(0x0093, 		0x0003);
TFTSetReg(0x0095, 		0x0110);
TFTSetReg(0x0097, 		0x0000);
TFTSetReg(0x0098, 		0x0000);

TFTSetReg(0x0007, 				0x0173);
} 

else if (TFT_ID_code == 0x9328) 		
{

TFTSetReg(0x00E5, 										0x8000);
TFTSetReg(0x0000 , 					0x0001);

delay_ms(100);                 		
TFTSetReg(0x0001, 			0x0100);
TFTSetReg(0x0002,			0x0700);
TFTSetReg(0x0003,					0x0030);
TFTSetReg(0x0004,				0x0000);
TFTSetReg(0x0008, 				0x0202);
TFTSetReg(0x0009,					0x0000);
TFTSetReg(0x000A,					0x0000);
TFTSetReg(0x000C,	0x0000);
TFTSetReg(0x000D, 		0x0000);
TFTSetReg(0x000F, 	0x0000);

TFTSetReg(0x0010,					0x0000);
TFTSetReg(0x0011,					0x0000);
TFTSetReg(0x0012,					0x0000);
TFTSetReg(0x0013,					0x0000);

delay_ms(500);

TFTSetReg(0x0010,					0x17B0);
TFTSetReg(0x0011,					0x0137);

delay_ms(100);
TFTSetReg(0x0012,					0x013C);

delay_ms(100);
TFTSetReg(0x0013,					0x1400);
TFTSetReg(0x0029,					0x0007);

delay_ms(100);
TFTSetReg(0x0020, 				0x0000);
TFTSetReg(0x0021, 				0x0000);

TFTSetReg(0x0030, 				0x0007);
TFTSetReg(0x0031, 				0x0504);
TFTSetReg(0x0032, 				0x0703);
TFTSetReg(0x0035 , 				0x0002);
TFTSetReg(0x0036, 				0x0707);
TFTSetReg(0x0037, 				0x0406);
TFTSetReg(0x0038, 				0x0006);
TFTSetReg(0x0039, 				0x0404);
TFTSetReg(0x003C, 				0x0700);
TFTSetReg(0x003D, 			0x0A08);

TFTSetReg(0x0050, 			0x0000);
TFTSetReg(0x0051, 				0x00EF);
TFTSetReg(0x0052, 			0x0000);
TFTSetReg(0x0053, 				0x013F);
TFTSetReg(0x0060, 		0x2700);
TFTSetReg(0x0061, 		0x0001);
TFTSetReg(0x006A, 		0x0000);

TFTSetReg(0x0080, 0x0000);
TFTSetReg(0x0081, 0x0000);
TFTSetReg(0x0082, 	0x0000);
TFTSetReg(0x0083, 0x0000);
TFTSetReg(0x0084, 0x0000);
TFTSetReg(0x0085, 	0x0000);

TFTSetReg(0x0090, 		0x0010);
TFTSetReg(0x0092, 		0x0000);
TFTSetReg(0x0093, 		0x0003);
TFTSetReg(0x0095, 		0x0110);
TFTSetReg(0x0097, 		0x0000);
TFTSetReg(0x0098, 		0x0000);

TFTSetReg(0x0007, 				0x0173);
} 

else														 		
{

TFTSetReg(0x00E3, 										0x3008);
TFTSetReg(0x00E7, 										0x0012);
TFTSetReg(0x00EF, 										0x1231);
TFTSetReg(0x0000 , 					0x0001);

delay_ms(100);                 		
TFTSetReg(0x0001, 			0x0100);
TFTSetReg(0x0002,			0x0700);
TFTSetReg(0x0003,					0x0030);
TFTSetReg(0x0004,				0x0000);
TFTSetReg(0x0008, 				0x0202);
TFTSetReg(0x0009,					0x0000);
TFTSetReg(0x000A,					0x0000);
TFTSetReg(0x000C,	0x0000);
TFTSetReg(0x000D, 		0x0000);
TFTSetReg(0x000F, 	0x0000);

TFTSetReg(0x0010,					0x0000);
TFTSetReg(0x0011,					0x0007);
TFTSetReg(0x0012,					0x0000);
TFTSetReg(0x0013,					0x0000);

delay_ms(500);

TFTSetReg(0x0010,					0x1690);
TFTSetReg(0x0011,					0x0007);

delay_ms(100);
TFTSetReg(0x0012,					0x001A);

delay_ms(100);
TFTSetReg(0x0013,					0x1800);
TFTSetReg(0x0029,					0x002A);

delay_ms(100);
TFTSetReg(0x0020, 				0x0000);
TFTSetReg(0x0021, 				0x0000);

TFTSetReg(0x0030, 				0x0000);
TFTSetReg(0x0031, 				0x0000);
TFTSetReg(0x0032, 				0x0000);
TFTSetReg(0x0035 , 				0x0000);
TFTSetReg(0x0036, 				0x0000);
TFTSetReg(0x0037, 				0x0406);
TFTSetReg(0x0038, 				0x0006);
TFTSetReg(0x0039, 				0x0404);
TFTSetReg(0x003C, 				0x0700);
TFTSetReg(0x003D, 			0x0A08);

TFTSetReg(0x0050, 			0x0000);
TFTSetReg(0x0051, 				0x00EF);
TFTSetReg(0x0052, 			0x0000);
TFTSetReg(0x0053, 				0x013F);
TFTSetReg(0x0060, 		0x2700);
TFTSetReg(0x0061, 		0x0001);
TFTSetReg(0x006A, 		0x0000);

TFTSetReg(0x0080, 0x0000);
TFTSetReg(0x0081, 0x0000);
TFTSetReg(0x0082, 	0x0000);
TFTSetReg(0x0083, 0x0000);
TFTSetReg(0x0084, 0x0000);
TFTSetReg(0x0085, 	0x0000);

TFTSetReg(0x0090, 		0x0010);
TFTSetReg(0x0092, 		0x0000);
TFTSetReg(0x0093, 		0x0003);
TFTSetReg(0x0095, 		0x0110);
TFTSetReg(0x0097, 		0x0000);
TFTSetReg(0x0098, 		0x0000);

TFTSetReg(0x0007, 				0x0133);

TFTSetReg(0x002B, 	0x000D);
} 
} 

unsigned short TFTGetID(void)
{
return(TFT_ID_code);
}	

void TFTBacklight(unsigned char x)
{
(x ? (PORTD |= (1<<(7)))   : (PORTD &= ~(1<<(7))));
}	

void TFTSetArea(int sx,int ex,int sy,int ey)
{
if (sx < TFT_margin_xl)    				sx = TFT_margin_xl;
if (ex > TFT_margin_xr)    				ex = TFT_margin_xr;
if (sy < TFT_margin_yu)    				sy = TFT_margin_yu;
if (ey > TFT_margin_yl)    				ey = TFT_margin_yl;
newX = ex - sx + 1;

TFTSetReg(0x0050,	sx);
TFTSetReg(0x0051,		ex);
TFTSetReg(0x0020,		sx);

newY = ey - sy + 1;

TFTSetReg(0x0052,	sy);
TFTSetReg(0x0053,		ey);
TFTSetReg(0x0021,		sy);

TFTOutCmd(0x0022);
} 

void TFTResetArea(void)
{
TFTSetReg(0x0050,	0x0000);
TFTSetReg(0x0051,		((unsigned int)240-1));

TFTSetReg(0x0052,	0x0000);
TFTSetReg(0x0053,		((unsigned int)320-1));
}	

void TFTGotoXY(int x,int y)
{
TFTSetReg(0x0020, x); 
TFTSetReg(0x0021, y); 

TFTOutCmd(0x0022);
}	

void TFTPutPixel(int x,int y,unsigned short color,TFT_mode_t mode)
{
TFTGotoXY(x, y);

if ((mode == TFT_MODE_NORMAL) || (mode == TFT_MODE_FULL))
{
TFTOutDat(color);
}
else if (mode == TFT_MODE_INVERSE)
{
color = TFTInDat();     															
color = TFTInDat();
TFTOutDat(~color);
}
}	

void TFTFillRect(int sx,int ex,int sy,int ey,unsigned short color,TFT_mode_t mode) 		
{
unsigned int 		i, j;

TFTSetArea(sx, ex, sy, ey);

if ((mode == TFT_MODE_NORMAL) || (mode == TFT_MODE_FULL))
{
for (j=0; j<newY; j++)
for (i=0; i<newX; i++)
{
TFTOutDat(color);
}
}
else if (mode == TFT_MODE_INVERSE)
{
for (j=0; j<newY; j++)
for (i=0; i<newX; i++)
{
color = TFTInDat();                 						
color = TFTInDat();
TFTOutDat(~color);
}
}

TFTResetArea();
} 

void TFTShowPic(int sx,int ex,int sy,int ey,const unsigned short *pic,TFT_mode_t mode)
{
unsigned long 	k = 0;
unsigned short 	color;
unsigned int 		i, j;

TFTSetArea(sx, ex, sy, ey);

if (mode == TFT_MODE_FULL)
{
for (j=0; j<newY; j++)
for (i=0; i<newX; i++)
{
TFTOutDat(((uint16)(pic[k])));
k++;
}
}
else if (mode == TFT_MODE_NORMAL)
{
for (j=0; j<newY; j++)
for (i=0; i<newX; i++)
{
if (((uint16)(pic[k])) == 0xFFFF)
{
color = TFTInDat();                 					
color = TFTInDat();
TFTOutDat(color);
}
else
{
TFTOutDat(((uint16)(pic[k])));
}
k++;
}
}

TFTResetArea();
} 
