
#ifndef _APP_CONFIG_H_
	#define _APP_CONFIG_H_

	#define WinAVR																	0			// WinAVR compliler used
	#define CodeVision															1			// CodeVision compiler used
	
	
	#if WinAVR
		#include <stdio.h>			//for fprintf using!
		#include <avr/io.h>
		#include <compat/deprecated.h>
		#include <avr/pgmspace.h>
		#include <util/delay.h>

		#define _NOP()                         	        asm volatile("nop\n\t")
		#define _SEI()                       	          asm volatile("sei\n\t")
		#define _CLI()                     	            asm volatile("cli\n\t")

		#define _const																	const
		
		#define _pgm_read_byte(x)                  			pgm_read_byte(&x)
		#define _pgm_read_word(x)                    		pgm_read_word(&x)
	
	#elif CodeVision
		#include <mega32a.h>		//Include your uC file!
		#include <stdlib.h>
		#include <stdio.h>
		#include <string.h>
		#include <delay.h>
        #include <ff.h>
        #include <stdio.h>
        #include <stdlib.h>
        #include <ctype.h>    
        #include <string.h>    
            
		//----------------------------------------------------------------
		typedef signed char             								int8;
		typedef unsigned char           								uint8;
		typedef signed int              								int16;
		typedef unsigned int            								uint16;
		typedef signed long int         								int32;
		typedef unsigned long int       								uint32;
	
		//----------------------------------------------------------------
		#define PGM_P                                  	char flash *
		#define PROGMEM                                	flash
		#define _const																	flash
		#define PSTR(x)                                	x
		#define _pgm_read_byte(x)                     	((uint8)(x))//(*((uint8 flash *)(x)))
		#define _pgm_read_word(x)                       ((uint16)(x))//(*((uint16 flash *)(x)))
		#define EEMEM                                 	eeprom
		#define eeprom_read_byte(ads)               	  (*((uint8 eeprom *)(ads)))
		#define eeprom_write_byte(ads,x)          	    (*((uint8 eeprom *)(ads))) = x
		#define eeprom_write_word(ads,x)        	      (*((uint16 eeprom *)(ads))) = x
		#define _NOP()                         	        #asm("nop")
		#define _SEI()                       	          #asm("sei")
		#define _CLI()                     	            #asm("cli")
		#define _delay_ms               	              delay_ms
		#define ISR(vec)              	                interrupt [vec] void isr##vec(void)
		#define _BV(pin)            	                  (1<<(pin))
		#define sbi(port,pin)      	                    port |= _BV(pin)
		#define cbi(port,pin)  		                      port &= ~_BV(pin)
		#define bit_is_set(port,pin)		        				(port & _BV(pin))
		#define loop_until_bit_is_set( port, pin)      	while (!bit_is_set(port,pin));
	 
  	#define strncpy_P(a, b, c)											strncpy(a, b, c)
		#define strnlen_P(a, b)													strlen(a)
	#endif
	
	//----------------------------------------------------------------
	#define True																			1
	#define False																			0
	
	#define ON																				1
	#define OFF																				0
	
	#define HIGH																			1
	#define LOW																				0

#endif	//_APP_CONFIG_H_
