//-----------------------------------------------------------------------------
// Copyright:      RAD Electronic Co. LTD,
// Author:         Sh. Nourbakhsh Rad
// Remarks:        
// known Problems: none
// Version:        06.09.2011
// Description:    TFT-LCD & Graphic & English-Persian, Arabic Font ....
//								 for ATmega128 interface ( for WinAVR and CodeVision 2.04a)
//-----------------------------------------------------------------------------

//	Include Headers
//*****************************************************************************
#include "app_config.h"

//--------------------------------------------------
#include "TFT\ili9325.h"
#include "Graphic\Graphic.h"

#include "FONT\font\f9x14.h"
#include "FONT\font\AF12x16.h"

#include "FONT\Font.h"

// DEFINE TIMER
#define T1_OVF_FREQ 10
#define T1_PRESC 1024L
#define T1_INIT (0x10000L-(_MCU_CLOCK_FREQUENCY_/(T1_PRESC*T1_OVF_FREQ)))
//
  
//-------------------------FAT------------------------------------
        FRESULT res;
        FATFS drive;
        FIL fil;
        
        flash char * flash error_msg[]=
        {
        "  ", /* not used */
        "FR_DISK_ERR",
        "FR_INT_ERR",
        "FR_INT_ERR",
        "FR_NOT_READY",
        "FR_NO_FILE",
        "FR_NO_PATH",
        "FR_INVALID_NAME",
        "FR_DENIED",
        "FR_EXIST",
        "FR_INVALID_OBJECT",
        "FR_WRITE_PROTECTED",
        "FR_INVALID_DRIVE",
        "FR_NOT_ENABLED",
        "FR_NO_FILESYSTEM",
        "FR_MKFS_ABORTED",
        "FR_TIMEOUT"
        };  
        
//---------------------------sim 900----------------------------------------------       
char Enter=13;
char double_quote=34;
char Ctrlz=26;
char Escap=27;
char Line_Feed=10;
char single_quote=39;

//-----------------------bmp----------------------------------------------------
#include "BMP\sdbmp.c"
//------------------------------------------------------------------------------

          
//	Constants and Varables
//*****************************************************************************

//Temp Const.
char Ctemp[50];
int  Itemp;
char      path[20];
int  xt,yt,n,n2;
char i,d,nk,exit,bsn,bnun;
char v1=5;
char n1;
char j=0;
bit s,nu,b,;
char ATH[3]={'A','T','H'};
char ATA[3]={'A','T','A'};
char number[13];//={'+','9','8','9','3','8','4','9','8','5','6','0','3'};
char kibord[50];
char atcmgs[8]={'a','t','+','c','m','g','s','='};
char buffer[50];
char ATD[4]={'A','T','D','+'};
char noghte[1]={';'};
char a[50];
char text[50];//="ali";
//	Functions Prototype
//*****************************************************************************

            /* recursively scan directory entries and display them */
            FRESULT directory_scan(char *path)
            {
            /* will hold file/directory information returned by f_readdir*/
            FILINFO file_info;
            /* will hold the directory information */
            DIR directory;
            int i;
            char y=3;
            if ((res=f_opendir(&directory,path))==FR_OK)
               {
               while (((res=f_readdir(&directory,&file_info))==FR_OK) && file_info.fname[0])
                     {
                     /* display file/directory name and associated information */  
            //         
            //         printf("%s/%s\r\n",
            //               path,file_info.fname);  
                        SetLetter(E_LETTER);
                      DrawStringAt(y,0,path,GetFgColor(),GetBkColor());          
          
                       DrawStringAt(y,0,file_info.fname,GetFgColor(),GetBkColor());  
                   
                     y++;      
                     if (file_info.fattrib & AM_DIR)
                        {
                        /* it's a subdirectory */
                        /* make sure to skip past "." and ".." when recursing */
                        if (file_info.fname[0]!='.')
                           {
                           i=strlen(path);
                           /* append the subdirectory name to the path */
                         if (path[i-1]!='/') strcatf(path,"/");
                           strcat(path,file_info.fname);
                           /* scan subdirectory */
                           res=directory_scan(path);
                           /* restore the old path name */
                           path[i]=0;
                           /* remove any eventual '/' from the end of the path */
                           --i;
                           if (path[i]=='/') path[i]=0;
                           /* stop if an error occured */
                           if (res!=FR_OK) break;
                           }
                        }
                     }
               }
            return res;
            }
                
axka(){
bmpFile("ka.BMP");
bmpShow(0,160); 
}

axk3(){
bmpFile("k3.BMP");
bmpShow(0,160); 
}              
 
callt(){
 bmpFile("call.BMP");
  bmpShow(0,110); 


}  
         
void wait_to_get(char ch) 
{ 
    while(ch != getchar());    
} 
            
sms(){
printf("AT+CMGF=1%c",Enter);
 delay_ms(500);   
printf("%s%",atcmgs);
putchar(double_quote);
printf("%s%",number);
putchar(double_quote);
putchar(Enter);
//printf("at+cmgs=%c09384985603%c%c",double_quote,double_quote,Enter);

//wait_to_get('>');
for(i=0;i<17;i++)a[i]=getchar();
////  
 sprintf(buffer,"%s",a);    
 SetLetter(E_LETTER);
 DrawStringAt(5,0,a,YELLOW,GetBkColor());                                                 
delay_ms(700); 
printf("%s",text);
putchar(Ctrlz);
SetLetter(P_LETTER);
DrawStringAt(2,0,"  ",YELLOW,GetBkColor());
for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
_delay_ms(4000); 
SetLetter(E_LETTER);
RectangleFill(0,35,240,50,BLACK);

for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
for (i=0;i<50;i++)text[i]=0;  //clear kibord
for (i=0;i<12;i++)number[i]=0;  //clear kibord
/////////////////////////////////////////////////////////////////////////
}   

call(){


LcdFontXScale(1);
SetLetter(P_LETTER);

DrawStringAt(1,0," ",RED ,GetBkColor());
 DrawStringAt(2,0,"  ",GREEN ,GetBkColor());

printf("%s",ATD);
printf("%s",number);
putchar(';');
putchar(Enter);
//
//for(i=0;i<16;i++)a[i]=getchar();
//  
// sprintf(buffer,"%s",a);    
// SetLetter(E_LETTER);
// DrawStringAt(5,0,a,YELLOW,GetBkColor()); 
for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
for (i=0;i<12;i++)number[i]=0;  //clear kibord

}



callregect(){

printf("%s",ATH);
putchar(Enter);


}



callconect(){
printf("%s",ATA);
putchar(Enter);
} 



void test01(void);

#define ADC_VREF_TYPE 0x40

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(500);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}




tuch(){
      
 
      DDRA.0=1;        //-x
      DDRA.1=0;        //y
      DDRA.2=1;        //x
      DDRA.3=0;        //-y
      PORTA.0=0;
      PORTA.1=0;
      PORTA.2=1;
      PORTA.3=0;
       
      yt=read_adc(1);  
      yt=yt/4.26;   
      itoa(yt,path); 
     
      SetLetter(E_LETTER);
      RectangleFill(0,0,130,50,BLACK);   
      DrawStringAt(1,0,"y=",WHITE,GetBkColor());  
      DrawStringAt(1,2,path,WHITE,GetBkColor());
      
      DDRA.0=0;
      DDRA.1=1;
      DDRA.2=0;
      DDRA.3=1;
      PORTA.0=0;
      PORTA.1=1;
      PORTA.2=0;
      PORTA.3=0; 
      xt=read_adc(2);
      xt=xt/3.19;   
      itoa(xt,path);    
      DrawStringAt(0,0,"x=",WHITE,GetBkColor());  
      DrawStringAt(0,2,path,WHITE,GetBkColor()); 
     
    
}   

key(){
           
                                              if(nk==1){
            if (xt>=144 && xt<=162){
            if (yt>=24 && yt<=35)kibord[n]=0x31; //1
            if (yt>=40 && yt<=53)kibord[n]=0x32; //2
            if (yt>=59 && yt<=71)kibord[n]=0x33;  //3
            if (yt>=74 && yt<=89)kibord[n]=0x2b;  //+
            if (yt>=91 && yt<=105)kibord[n]=0x70; //p
            if (yt>=110 && yt<=123)kibord[n]=0x2c; //, 
            if (yt>=129 && yt<=138)kibord[n]=0x2e; //.
            if (yt>=143 && yt<=157)kibord[n]=0x3a; //:
            if (yt>=161 && yt<=174)kibord[n]=0x3b; //;
            if (yt>=178 && yt<=190)kibord[n]=0x3f; //?
              } 
                
            if (xt>=170 && xt<=185){
            if (yt>=24 && yt<=35)kibord[n]=0x34;//4 
            if (yt>=40 && yt<=53)kibord[n]=0x35;//5 
            if (yt>=59 && yt<=71)kibord[n]=0x36;//6 
            if (yt>=74 && yt<=89)kibord[n]=0x23;//#
            if (yt>=91 && yt<=105)kibord[n]=0x77;//w 
            if (yt>=110 && yt<=123)kibord[n]=0x2d;//- 
            if (yt>=129 && yt<=138)kibord[n]=0x5f;//_ 
            if (yt>=143 && yt<=157)kibord[n]=0x28;//( 
            if (yt>=161 && yt<=174)kibord[n]=0x29;//) 
            if (yt>=178 && yt<=190)kibord[n]=0x21;//! 
              }            
            
            if (xt>=194 && xt<=212){
            if (yt>=24 && yt<=35)kibord[n]=0x37;//7 
            if (yt>=40 && yt<=53)kibord[n]=0x38;//8 
            if (yt>=59 && yt<=71)kibord[n]=0x39;//9 
            if (yt>=74 && yt<=89)kibord[n]=0x30;//0 
            if (yt>=91 && yt<=105)kibord[n]=0x2a;//* 
            if (yt>=110 && yt<=123)kibord[n]=0x40;//@ 
            if (yt>=129 && yt<=138)kibord[n]=0x2f;// / 
            if (yt>=143 && yt<=157)kibord[n]=0x5c;//\
            if (yt>=161 && yt<=174)kibord[n]=0x60;//' 
            if (yt>=178 && yt<=190)kibord[n]=0x26;//& 
             }   
               }
        if(nk==0)
        {
             
                if (xt>=144 && xt<=162){
                    if (yt>=24 && yt<=35)kibord[n]=0x51; //Q
                    if (yt>=40 && yt<=53)kibord[n]=0x57; //W
                    if (yt>=59 && yt<=71)kibord[n]=0x45;  //E
                    if (yt>=74 && yt<=89)kibord[n]=0x52;  //R
                    if (yt>=91 && yt<=105)kibord[n]=0x54; //T
                    if (yt>=110 && yt<=123)kibord[n]=0x59;//Y 
                    if (yt>=129 && yt<=138)kibord[n]=0x55; //U
                    if (yt>=143 && yt<=157)kibord[n]=0x49; //I
                    if (yt>=161 && yt<=174)kibord[n]=0x4f; //O
                    if (yt>=178 && yt<=190)kibord[n]=0x50; //P
              } 
                
            if (xt>=170 && xt<=185){
                    if (yt>=24 && yt<=35)kibord[n]=0x41;//A 
                    if (yt>=40 && yt<=53)kibord[n]=0x53;//S 
                    if (yt>=59 && yt<=71)kibord[n]=0x44;//D 
                    if (yt>=74 && yt<=89)kibord[n]=0x46;//F 
                    if (yt>=91 && yt<=105)kibord[n]=0x47;//G 
                    if (yt>=110 && yt<=123)kibord[n]=0x48;//H 
                    if (yt>=129 && yt<=138)kibord[n]=0x4a;//J 
                    if (yt>=143 && yt<=157)kibord[n]=0x4b;//K 
                    if (yt>=161 && yt<=174)kibord[n]=0x4c;//L 
                    if (yt>=178 && yt<=190)kibord[n]=0x22;//" 
              }            
            
            if (xt>=194 && xt<=212){
                    if (yt>=24 && yt<=35)kibord[n]=0x5a;//Z 
                    if (yt>=40 && yt<=53)kibord[n]=0x58;//X 
                    if (yt>=59 && yt<=71)kibord[n]=0x43;//C 
                    if (yt>=74 && yt<=89)kibord[n]=0x56;//kibord 
                    if (yt>=91 && yt<=105)kibord[n]=0x42;//B 
                    if (yt>=110 && yt<=123)kibord[n]=0x4e;//N 
                    if (yt>=129 && yt<=138)kibord[n]=0x4d;//M 
                    if (yt>=143 && yt<=157)kibord[n]=0x3f;//? 
                    if (yt>=161 && yt<=174)kibord[n]=0x21;//! 
                    if (yt>=178 && yt<=190)kibord[n]=0x2f;/// 
             }   
             
             
             
             }
             
             
             if (xt>=215 && xt<=234){
//             if (yt>=24 && yt<=35)kibord[n]=0x5a;//Z 
             if (yt>=40 && yt<=157){
             kibord[n]=0x20;// spase 
             b=0;
             }
             if (yt>=161 && yt<=190)kibord[n]=0x7f;//delet
             }     
                
             if (xt>=240 && xt<=260){  
                    if (yt>=24 && yt<=46)exit=1; 
                              
                       if (yt>=53 && yt<=76){
                     if(nk==0) axka();
                     if(nk==1) axk3();  
                      nk=!nk;
                     }  
                            
                   if (yt>=172 && yt<=198)v1++;//enter 
//                         d=30-n;
//                         for(i=0;i<=d;i++){
//                         text[i]=0x20;
//                         kibord[i]=0x20;}
//                         n=30;
//                         }  
                         
                   if (yt>=24 && yt<=35)b=0;//upper font    
                   }   
               
              



             
           _delay_ms(200);
}

void error(FRESULT res)
{
if ((res>=FR_DISK_ERR) && (res<=FR_TIMEOUT)){
  sprintf( path,"%p",error_msg[res]);
   SetLetter(E_LETTER);
      DrawStringAt(1,1, path,GetFgColor(),GetBkColor());
     }
//     printf("%s",lcd_buf); 
   _delay_ms(2000);
}



interrupt [TIM1_OVF] void timer_comp_isr(void)
{
/* re-initialize Timer1 */
TCNT1H=T1_INIT>>8;
TCNT1L=T1_INIT&0xFF;
/* card access low level timing function */
disk_timerproc();
}

callky(){

  if(xt>=240 && xt<=260)if(yt>=26 && yt<=187)call();
  
  if(yt>=29 && yt<=78){
  if(xt>=132 && xt<=152)kibord[n]=0x31; //1
  if(xt>=157 && xt<=180)kibord[n]=0x34;//4 
  if(xt>=182 && xt<=205)kibord[n]=0x37;//7 
  if(xt>=208 && xt<=232)kibord[n]=0x2b;  //+
//  kibord[n]=0x2a;//* 
  } 
   
  if(yt>=82 && yt<=136){
  if(xt>=132 && xt<=152)kibord[n]=0x32; //2
  if(xt>=157 && xt<=180)kibord[n]=0x35;//5 
  if(xt>=182 && xt<=205)kibord[n]=0x38;//8 
  if(xt>=208 && xt<=232)kibord[n]=0x30;//0 
  } 
   
  if(yt>=138 && yt<=183){
  if(xt>=132 && xt<=152)kibord[n]=0x33;  //3
  if(xt>=157 && xt<=180)kibord[n]=0x36;//6 
  if(xt>=182 && xt<=205)kibord[n]=0x39;//9 
  if(xt>=208 && xt<=232)kibord[n]=0x23;//#
  } 
  
  if(yt>=160 && yt<=181)if(xt>=110 && xt<=135)kibord[n]=0x7f;
 
 if(yt>=127 && yt<=180){
 if(xt>=38 && xt<=49) callregect(); 
  if(xt>=50 && xt<=60) callconect(); 
 }
 
 
  if (xt>=255 && xt<=273)if(yt>=34 && yt<=45)exit=1;
 
 
 _delay_ms(100);
  
  //
  
  
 }

givecode(){


        while(1){
        

                        while(kibord[n]==0){
                        tuch();
                        if(n1==3)key();
                        if(n1==8)callky(); 
                        
                       

                                if(kibord[n]==0x7f){
                                kibord[n]=0;
                                kibord[n-1]=0;
                                 if(nu==1){
                                 number[n]=0; 
                                 number[n-1]=0;
                                 }  
                                 
                                 if(s==1){
                                  text[n]=0; 
                                  text[n-1]=0;
                                  }
                                n--; 
                                
                                
                                   if(s==1)RectangleFill(0,65,220,80,BLACK); 
                                   if(nu==1){
                                   if(j==0)RectangleFill(0,50,150,70,BLACK);  
                                   if(j==1)RectangleFill(9,128,190,145,BLACK); 
                                   } 
                                
                                if(s==1)DrawStringAt(v1,0,kibord,WHITE, WHITE); 
                                if(nu==1)DrawStringAt(n1,j,kibord,GREEN, WHITE);
                                } 
                                
                                 if(exit==1)break;
                    }  
                    
                    
                    
                      if(exit==1){
                        if(s==1)bsn=n; //backup place x sms
                        if(nu==1)bnun=n; //backup place x phone number
                        s=0;   //disable sms
                        nu=0;  //disabel phone number
                        nk=0;  //chenge kibord
                      
                          TFT_CLS(BLACK );
                           exit=0;     //disabel break
                           n=0;        //place alefba reset
                           for (i=0;i<50;i++)kibord[i]=0;  //clear kibord                  
                        break;   
                                            
                                        
                        }  
                                       

                    if(s==1 && exit==0){ 
                    if(b==1)kibord[n]=tolower(kibord[n]); // A to a , .....
                    if(kibord[n]==0x20)b=0;
                    else 
                    b=1; 
                    text[n]=kibord[n];
                    DrawStringAt(v1,0,kibord,WHITE, WHITE);
                    n++;
                    }  
                    
                   if(nu==1 && exit==0){ 
                    number[n]=kibord[n];
                    DrawStringAt(n1,j,kibord,GREEN, WHITE);
                    n++; 
                    }         
                           
                
                    
                    
            };  
 
}           






kd(){

   if(xt>=32 && xt<=48)if(yt>=146 && yt<=180)sms();//send sms
  if (xt>=60 && xt<=80)if(yt>=23 && yt<=190){
  axka(); 
  nk=1;  //chenge kibord 0=alefba 1=adad
  s=0;   //disable sms
  n=bnun; // copy backup x to n
  nu=1;   //enabel phone nuber
  for (i=0;i<50;i++)kibord[i]=0;  //clear kibord 
  for (i=0;i<12;i++)kibord[i]=number[i];  //copy number to kibord
  kibord[n]=0; 
  RectangleFill(0,30,150,60,BLACK);
  DrawStringAt(n1,j,number,GREEN, WHITE); 
  } 
               
  if (xt>=80 && xt<=134)if(yt>=23 && yt<=190){
  axk3();  
  nk=0;  //chenge kibord 0=alefba 1=adad
  nu=0;  //disabel phone number
  n=bsn;// copy backup x to n   
  s=1;   //enable sms
  for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
  for (i=0;i<50;i++)kibord[i]=text[i];  //copy text to kibord
  kibord[n]=0;                 
  RectangleFill(0,65,220,80,BLACK);
  DrawStringAt(v1,0,text,WHITE, WHITE);
  } 
    
   if (xt>=255 && xt<=273)if(yt>=34 && yt<=45)exit=1;
  
         
}              
              


maincall(){
TFT_CLS(BLACK );
 SetLetter(P_LETTER);
                 DrawStringAt(0,0," ",WHITE, WHITE);
s=0;
nu=1;
nk=1;  
 
  callt();

  

           
                             j=1;      
                             n1=8; 
            while(1){
                            
                             
                             
                          
                              tuch();  
                              givecode();
                              callky();
             if(exit==1){
             exit=0; 
             nu==0;
             nk==0;
             n1=3; 
             j=0;
             for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
             for (i=0;i<12;i++)number[i]=0;  //clear kibord
             break;
             }                  
           
            };
         
            
 
}




mainsms(){
TFT_CLS(BLACK );
         n1=3; 

           while(1){  
                 SetLetter(P_LETTER);
                
                 DrawStringAt(0,0," ",WHITE, WHITE); 
                 DrawStringAt(1,0," ",GREEN, WHITE); 
                 DrawStringAt(3,0,"",YELLOW,GetBkColor()); 
                 DrawStringAt(4,0," ",YELLOW,GetBkColor()); 
                 
       if(s==1 || nu==1)givecode();  ////trxt sms 
        tuch();  
        kd();  
       
         if(exit==1){
             TFT_CLS(BLACK );
             nu=0;
             s=0;
             exit=0; 
             for (i=0;i<12;i++)number[i]=0;  //clear number
             for (i=0;i<50;i++)text[i]=0;  //clear text
             for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
             break;
             }  
       
       
       SetLetter(E_LETTER);
       DrawStringAt(n1,j,number,GREEN,GetBkColor());  
       DrawStringAt(v1,0,text,WHITE,GetBkColor());
     
      

};
}

   
desktop(){
if (xt>=255 && xt<=273){
  if(yt>=34 && yt<=45)exit=1;
  if(yt>=67 && yt<=87)mainsms();
//  if (yt>=99 && yt<=119)
  if (yt>=131 && yt<=151)maincall(); 
//  if (yt>=185 && yt<=165)
  
   }

}  






//	<<< main function >>>
//*****************************************************************************
void main (void)
{
	TFTInit();					//*** ili9325 TFT-LCD initiation
       
    //////////////////usart////////////////////
        // USART initialization 16 MHZ
        // Communication Parameters: 8 Data, 1 Stop, No Parity
        // USART Receiver: On
        // USART Transmitter: On
        // USART Mode: Asynchronous
        // USART Baud Rate: 9600
        UCSRA=0x00;
        UCSRB=0x18;
        UCSRC=0x06;
        UBRRH=0x00;
        UBRRL=0x67;

    ///////////////////adc///////////////////////
        // ADC initialization
        // ADC Clock frequency: 1000/000 kHz
        // ADC Voltage Reference: AVCC pin
        ADMUX=ADC_VREF_TYPE & 0xff;
        ADCSRA=0x83;
    /////////////////////////////////////////////
    
    /////////////////TIMER FOR SD////////////////
    TCCR1A=0x00;
    TCCR1B=(1<<CS12)|(1<<CS10);
    TCNT1H=T1_INIT>>8;
    TCNT1L=T1_INIT&0xFF;
    TIMSK=1<<TOIE1;	
    ////////////////////////////////////////////
    #asm("sei")

//    TFTReset();

	TFTBacklight(ON);
   
    LcdHorizontal(1); //(TFT_ORN_PORTRAIT);
    LcdFont(AF12x16);
    LcdFontSpace(1);
    LcdFontXScale(1);
    LcdFontYScale(1);
    SetFgColor(WHITE);
    SetBkColor(WHITE);
   SetLetter(P_LETTER);
 
// 
//		test01(); 
TFT_CLS(BLACK );
        
         
       
       // ////////////////////////////////////start sim 900
        DDRB.0=1;
        PORTB.0=1;
        _delay_ms(2000);
        PORTB.0=0;
       _delay_ms(2000);
        PORTB.0=1;
       ///////////////////////////////////////////////////    
       
          
      
            
//----------------------------------------------------------------------   
                
                // mount logical drive 0: 
                if ((res=f_mount(0,&drive))==FR_OK)
                {DrawStringAt(0,0,"  ",WHITE, WHITE);}
                //   printf(Logical drive 0: mounted OK\r\n); 
                else
                /* an error occured, display it and stop */
                error(res); 
                
                 bmpFile("vv.BMP");
            bmpShow(0,0);
                   _delay_ms(4000); 
         TFT_CLS(BLACK );	 
                
         
               ////
//                /* repeateadly read directory entries and display them */
//                if ((res=directory_scan(path))!=FR_OK)
//                   /* if an error occured, display it and stop */
//                   error(res);        
//------------------------------------------------------------------------               

             
 while(1){ 
           SetLetter(P_LETTER);
         {DrawStringAt(0,0," ",WHITE, WHITE);}   
         
         tuch();  
         desktop();
          
        
        };  
       
     
} //main





//---------------------------------------------------------//
//---------------------------------------------------------//
//
//void test01(void)
//{
//	unsigned int 			y  = 0;
//	unsigned char			yp = (GetMaxY()+1)/20;
//	
//	TFT_CLS(WHITE);	
//
//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_BLUE);					y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  BLUE);							y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_BLUE);				y += yp;
//	
//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_GREEN);				y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  GREEN);							y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_GREEN);				y += yp;
//	
//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_YELLOW);				y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  YELLOW);						y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_YELLOW);			y += yp;
//	
//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_RED);					y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  RED);								y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_RED);					y += yp;
//	
//	RectangleFill(0, y, GetMaxX(), y+yp,  MAGENTA);						y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  CYAN);							y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  BROWN);							y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  SILVER);						y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  GOLD);							y += yp;
//	
//	RectangleFill(0, y, GetMaxX(), y+yp,  BLACK);							y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  GRAY);							y += yp;
//	RectangleFill(0, y, GetMaxX(), y+yp,  WHITE);							y += yp;
//}	//test01
//
//
//
