
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADCSR=6;     
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

typedef unsigned char DSTATUS;

typedef enum {
RES_OK = 0,		
RES_ERROR,		
RES_WRPRT,		
RES_NOTRDY,		
RES_PARERR		
} DRESULT;

DSTATUS disk_initialize (unsigned char drv);
DSTATUS disk_status (unsigned char drv);
DRESULT disk_read (unsigned char drv, unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_write (unsigned char drv, const unsigned char* buff, unsigned long sector, unsigned char count);
DRESULT disk_ioctl (unsigned char drv, unsigned char ctrl, void* buff);
void disk_timerproc (void);

#pragma library sdcard.lib

typedef char XCHAR;		

typedef struct _FATFS_ {
unsigned char	fs_type;	
unsigned char	drive;		
unsigned char	csize;		
unsigned char	n_fats;		
unsigned char	wflag;		
unsigned char	fsi_flag;	
unsigned short	id;		
unsigned short	n_rootdir;	
unsigned long	last_clust;	
unsigned long	free_clust;	
unsigned long	fsi_sector;	
unsigned long	cdir;		
unsigned long	sects_fat;	
unsigned long	max_clust;	
unsigned long	fatbase;	
unsigned long	dirbase;	
unsigned long	database;	
unsigned long	winsect;	
unsigned char	win[512];
} FATFS;

typedef struct _DIR_ {
FATFS*	fs;			
unsigned short	id;		
unsigned short	index;	
unsigned long	sclust;	
unsigned long	clust;	
unsigned long	sect;	
unsigned char*	dir;		
unsigned char*	fn;		
} DIR;

typedef struct _FIL_ {
FATFS*	fs;			
unsigned short	id;		
unsigned char	flag;	
unsigned char	csect;	
unsigned long	fptr;		
unsigned long	fsize;		
unsigned long	org_clust;	
unsigned long	curr_clust;	
unsigned long	dsect;		
unsigned long	dir_sect;	
unsigned char*	dir_ptr;	
unsigned char	buf[512];
} FIL;

typedef struct _FILINFO_ {
unsigned long	fsize;	
unsigned short	fdate;	
unsigned short	ftime;	
unsigned char	fattrib;	
char	fname[13];	
} FILINFO;

typedef enum {
FR_OK = 0,		
FR_DISK_ERR,		
FR_INT_ERR,		
FR_NOT_READY,		
FR_NO_FILE,		
FR_NO_PATH,		
FR_INVALID_NAME,	
FR_DENIED,		
FR_EXIST,			
FR_INVALID_OBJECT,	
FR_WRITE_PROTECTED,	
FR_INVALID_DRIVE,	
FR_NOT_ENABLED,	
FR_NO_FILESYSTEM,	
FR_MKFS_ABORTED,	
FR_TIMEOUT		
} FRESULT;

FRESULT f_mount (unsigned char vol , FATFS* fs);

FRESULT f_open (FIL* fp, const XCHAR* path, unsigned char mode);

FRESULT f_read (FIL* fp, void* buff, unsigned int btr, unsigned int* br);

FRESULT f_write (FIL* fp, const void* buff, unsigned int btw, unsigned int* bw);

FRESULT f_lseek (FIL* fp, unsigned long ofs);

FRESULT f_close (FIL* fp);

FRESULT f_opendir (DIR* dj, const XCHAR* path);

FRESULT f_readdir (DIR* dj, FILINFO* fno);

FRESULT f_stat (const XCHAR* path, FILINFO* fno);

FRESULT f_getfree (const XCHAR* path, unsigned long* nclst, FATFS** fatfs);

FRESULT f_truncate (FIL* fp);

FRESULT f_sync (FIL* fp);

FRESULT f_unlink (const XCHAR* path);

FRESULT f_mkdir (const XCHAR* path);

FRESULT f_chmod (const XCHAR* path, unsigned char value, unsigned char mask);

FRESULT f_utime (const XCHAR* path, const FILINFO* fno);

FRESULT f_rename (const XCHAR* path_old, const XCHAR* path_new);

FRESULT f_chdir (const XCHAR* path);

FRESULT f_chdrive (unsigned char drv);

extern void (*prtc_get_time) (unsigned char *hour, unsigned char *min, unsigned char *sec);

extern void (*prtc_get_date) (unsigned char *date, unsigned char *month, unsigned *year);

#pragma library ff.lib

int fgetc(FIL *fp);
char *fgets(char *str,unsigned int len,FIL *fp);
int fputc(char k,FIL* fp);
int fputs(char *str,FIL* fp);
int fputsf(char flash *str,FIL* fp);
int fprintf(FIL *fp, char flash *fmtstr,...);
int fscanf(FIL *fp, char flash *fmtstr,...);
unsigned char feof(FIL* fp);
unsigned char ferror(FIL *fp);

#pragma used-

#pragma library stdio.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned char strlcpy(char *dest,char *src,unsigned char n);	
unsigned char strlcpyf(char *dest,char flash *src,unsigned char n); 
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-

#pragma library ctype.lib

typedef signed char             								int8;
typedef unsigned char           								uint8;
typedef signed int              								int16;
typedef unsigned int            								uint16;
typedef signed long int         								int32;
typedef unsigned long int       								uint32;

typedef enum {
TFT_MODE_NORMAL,
TFT_MODE_INVERSE,
TFT_MODE_FULL
} TFT_mode_t;

extern int 																	TFT_margin_xl;
extern int 																	TFT_margin_xr;
extern int 																	TFT_margin_yu;
extern int 																	TFT_margin_yl;

void TFTOutCmd(unsigned short ins);
void TFTOutDat(unsigned short dat); 											
void TFTOutDat2(unsigned char dath, unsigned char datl); 	

unsigned short TFTInDat(void); 														

void TFTSetReg(unsigned short index,unsigned short val); 	
unsigned short TFTGetReg(unsigned short index); 					

void TFTInit(void); 

void TFTBacklight(unsigned char x);
unsigned short TFTGetID(void);

void TFTSetArea(int sx,int ex,int sy,int ey);
void TFTResetArea(void);

void TFTGotoXY(int x,int y);

void TFTPutPixel(int x,int y,unsigned short color,TFT_mode_t mode);
void TFTFillRect(int sx,int ex,int sy,int ey,unsigned short color,TFT_mode_t mode); 

void TFTShowPic(int sx,int ex,int sy,int ey,const unsigned short *pic,TFT_mode_t mode);

extern void Line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color);
extern void Rectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color);
extern void RoundRectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned int radius, unsigned char fill, unsigned short color);
extern void Circle_Fill(unsigned int x, unsigned int y, unsigned int radius, unsigned char fill, unsigned short color);

flash unsigned char f9x14[] = {
0x05, 0xFE, 0x09, 0x0E, 0x01, 0x20, 0xFC,
0x04, 0x02, 0x05, 0x08, 0x07, 0x07, 0x07, 0x02, 0x04, 0x04, 0x05, 0x05, 0x02, 0x05, 0x02, 0x06, 
0x07, 0x06, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x02, 0x02, 0x06, 0x06, 0x06, 0x05, 
0x08, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07, 0x08, 0x08, 0x04, 0x06, 0x07, 0x07, 0x08, 0x08, 0x08, 
0x07, 0x08, 0x08, 0x07, 0x08, 0x08, 0x07, 0x08, 0x07, 0x08, 0x06, 0x03, 0x06, 0x03, 0x08, 0x08, 
0x03, 0x06, 0x06, 0x06, 0x06, 0x06, 0x05, 0x06, 0x06, 0x02, 0x04, 0x07, 0x02, 0x08, 0x06, 0x06, 
0x06, 0x06, 0x05, 0x05, 0x05, 0x06, 0x06, 0x07, 0x06, 0x06, 0x05, 0x05, 0x02, 0x05, 0x08, 0x00, 
0x08, 0x00, 0x03, 0x00, 0x06, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x03, 0x03, 0x05, 0x05, 0x07, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x06, 0x06, 0x06, 0x00, 0x07, 0x08, 0x00, 0x00, 0x07, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x06, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x08, 
0x00, 0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0x07, 0x07, 0x00, 0x00, 0x00, 0x07, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x0D, 0x7E, 0xC3, 0x01, 0x70, 0x00, 0x00, 0x00, 
0x07, 0xC0, 0x01, 0x00, 0x0C, 0x60, 0x0F, 0xF8, 0x80, 0x37, 0x80, 0x3D, 0xE0, 0x03, 0xDE, 0x00, 
0x06, 0x80, 0x13, 0xF0, 0x09, 0x64, 0xC2, 0xFF, 0x43, 0x26, 0x90, 0x0F, 0xC8, 0xF1, 0xC0, 0x24, 
0x3C, 0xCF, 0x03, 0x3C, 0xC0, 0xF3, 0x3C, 0x24, 0x03, 0x0F, 0xDC, 0x81, 0xFF, 0x20, 0x22, 0xF8, 
0x09, 0xDC, 0x02, 0x60, 0x00, 0x34, 0x1C, 0x00, 0x07, 0x00, 0x7E, 0xE0, 0x7F, 0x1C, 0x38, 0x01, 
0x48, 0x00, 0x72, 0xE0, 0xF8, 0x1F, 0xF8, 0x01, 0x12, 0x00, 0x03, 0xF0, 0x03, 0x30, 0x00, 0x12, 
0x00, 0x02, 0x80, 0x00, 0xF8, 0x00, 0x08, 0x00, 0x02, 0x00, 0x3C, 0x00, 0x07, 0x08, 0x00, 0x02, 
0x80, 0x00, 0x20, 0x00, 0x08, 0x00, 0x30, 0x00, 0x0C, 0x00, 0x0C, 0xE0, 0x03, 0x3E, 0xF0, 0x01, 
0x1F, 0xC0, 0x00, 0xC0, 0x1F, 0xF8, 0x0F, 0x82, 0x82, 0x9C, 0xA0, 0x20, 0xF8, 0x0F, 0xFC, 0x01, 
0x81, 0x40, 0x20, 0xF8, 0x0F, 0xFE, 0x03, 0x80, 0x00, 0x20, 0x10, 0x08, 0x06, 0x83, 0xE0, 0x20, 
0x2C, 0x88, 0x09, 0x3E, 0x02, 0x87, 0x40, 0x10, 0x18, 0x0C, 0x22, 0x82, 0x88, 0x20, 0x22, 0xF8, 
0x0F, 0xDC, 0x01, 0x30, 0x00, 0x0A, 0x60, 0x02, 0x84, 0x80, 0xFF, 0xE0, 0x3F, 0x00, 0x02, 0x00, 
0x81, 0xC7, 0xE0, 0x21, 0x48, 0x08, 0x12, 0x82, 0xFC, 0x20, 0x1E, 0xE0, 0x07, 0xFC, 0x83, 0x85, 
0x20, 0x21, 0x48, 0x08, 0xF2, 0x03, 0x78, 0x20, 0x00, 0x08, 0x08, 0x82, 0x83, 0x78, 0xA0, 0x07, 
0x78, 0x00, 0x06, 0x00, 0x77, 0xE0, 0x3F, 0x88, 0x08, 0x22, 0x82, 0x88, 0xE0, 0x3F, 0x70, 0x07, 
0x3C, 0x80, 0x9F, 0x20, 0x24, 0x08, 0x09, 0x42, 0x83, 0x7F, 0xC0, 0x0F, 0x60, 0x0C, 0x18, 0x03, 
0xC6, 0x83, 0x71, 0x80, 0x01, 0x60, 0x00, 0x24, 0x00, 0x09, 0x20, 0x04, 0x08, 0x01, 0x24, 0x00, 
0x09, 0x40, 0x02, 0x90, 0x00, 0x24, 0x00, 0x09, 0x20, 0x04, 0x08, 0x01, 0x24, 0x00, 0x09, 0x80, 
0x01, 0x60, 0x00, 0x01, 0x20, 0x36, 0xC8, 0x0D, 0x1E, 0x00, 0x03, 0x00, 0x1F, 0x20, 0x08, 0xE4, 
0x04, 0x45, 0x41, 0x51, 0x90, 0x13, 0x08, 0x01, 0x3C, 0x00, 0x38, 0xE0, 0x0F, 0xFE, 0x80, 0x21, 
0xE0, 0x0F, 0xE0, 0x0F, 0x80, 0x83, 0xFF, 0xE0, 0x3F, 0x88, 0x08, 0x22, 0x82, 0x8F, 0xC0, 0x3F, 
0x00, 0x07, 0xF8, 0x00, 0x7F, 0x60, 0x30, 0x08, 0x08, 0x02, 0x82, 0x80, 0x40, 0x10, 0xF8, 0x0F, 
0xFE, 0x83, 0x80, 0x20, 0x20, 0x18, 0x0C, 0xFC, 0x01, 0x3E, 0xE0, 0x3F, 0xF8, 0x0F, 0x22, 0x82, 
0x88, 0x20, 0x22, 0x08, 0x08, 0x02, 0x82, 0xFF, 0xE0, 0x3F, 0x88, 0x00, 0x22, 0x80, 0x08, 0x20, 
0x00, 0x08, 0x00, 0xF8, 0x00, 0x7F, 0x60, 0x30, 0x08, 0x08, 0x42, 0x82, 0x90, 0x20, 0x3C, 0x10, 
0x0F, 0xFE, 0x83, 0xFF, 0x00, 0x02, 0x80, 0x00, 0x20, 0x00, 0x08, 0xE0, 0x3F, 0xF8, 0x0F, 0x02, 
0x82, 0xFF, 0xE0, 0x3F, 0x08, 0x08, 0x00, 0x82, 0x80, 0x20, 0x20, 0x08, 0x08, 0xFE, 0x83, 0x7F, 
0xE0, 0x3F, 0xF8, 0x0F, 0x70, 0x00, 0x36, 0xC0, 0x18, 0x18, 0x0C, 0x02, 0x82, 0xFF, 0xE0, 0x3F, 
0x00, 0x08, 0x00, 0x02, 0x80, 0x00, 0x20, 0x00, 0x08, 0xFE, 0x83, 0xFF, 0xC0, 0x03, 0xE0, 0x03, 
0xF8, 0x00, 0x0F, 0xE0, 0x3F, 0xF8, 0x0F, 0xFE, 0x83, 0xFF, 0xC0, 0x01, 0xE0, 0x01, 0xF0, 0x00, 
0x70, 0xE0, 0x3F, 0xF8, 0x0F, 0xF8, 0x00, 0x7F, 0x60, 0x30, 0x08, 0x08, 0x02, 0x82, 0xC1, 0xC0, 
0x1F, 0xE0, 0x03, 0xFE, 0x83, 0xFF, 0x20, 0x04, 0x08, 0x01, 0x42, 0x80, 0x1F, 0xC0, 0x03, 0xE0, 
0x03, 0xFC, 0x81, 0xC1, 0x20, 0x20, 0x08, 0x0E, 0x86, 0x07, 0xFF, 0x81, 0x4F, 0xF8, 0x0F, 0xFE, 
0x83, 0x08, 0x20, 0x06, 0x88, 0x03, 0xBE, 0x01, 0xC7, 0x00, 0x20, 0x70, 0x04, 0x3E, 0x82, 0x8C, 
0x20, 0x22, 0x88, 0x09, 0xE2, 0x03, 0x71, 0x20, 0x00, 0x08, 0x00, 0x02, 0x80, 0xFF, 0xE0, 0x3F, 
0x08, 0x00, 0x02, 0x80, 0x00, 0xE0, 0x1F, 0xF8, 0x0F, 0x00, 0x02, 0x80, 0x00, 0x20, 0x00, 0x08, 
0xFE, 0x83, 0x7F, 0xE0, 0x00, 0xF8, 0x01, 0xF0, 0x03, 0xE0, 0x00, 0x3F, 0xF8, 0x01, 0x0E, 0x80, 
0xFF, 0xE0, 0x3F, 0x80, 0x03, 0x3E, 0x80, 0x0F, 0x00, 0x0E, 0xF8, 0x0F, 0xFE, 0x83, 0xC1, 0xE0, 
0x38, 0xE0, 0x03, 0x70, 0x00, 0x3E, 0xE0, 0x38, 0x18, 0x0C, 0x06, 0x80, 0x03, 0x80, 0x01, 0xC0, 
0x0F, 0xF0, 0x03, 0x06, 0xE0, 0x00, 0x18, 0x00, 0x02, 0x83, 0xF0, 0x20, 0x2F, 0xF8, 0x08, 0x0E, 
0x82, 0x80, 0xF0, 0xFF, 0xFC, 0x3F, 0x01, 0xC8, 0x00, 0xF0, 0x01, 0xF0, 0x01, 0xE0, 0x03, 0xE0, 
0x03, 0xC0, 0x04, 0x20, 0xFF, 0xCF, 0xFF, 0x03, 0x01, 0x60, 0x00, 0x0C, 0x80, 0x01, 0x60, 0x00, 
0x30, 0x00, 0x18, 0x00, 0x04, 0x00, 0x80, 0x00, 0x20, 0x00, 0x08, 0x00, 0x02, 0x80, 0x00, 0x20, 
0x00, 0x08, 0x00, 0x12, 0x00, 0x0C, 0x00, 0x02, 0x00, 0x70, 0x80, 0x3E, 0xA0, 0x08, 0x28, 0x02, 
0xFE, 0x00, 0x3F, 0xFC, 0x0F, 0xFF, 0x03, 0x82, 0x80, 0x20, 0xE0, 0x0F, 0xF0, 0x01, 0x7C, 0x80, 
0x3F, 0x20, 0x08, 0x08, 0x02, 0x82, 0x00, 0x11, 0xC0, 0x07, 0xF8, 0x03, 0x82, 0x80, 0x20, 0xFC, 
0x0F, 0xFF, 0x03, 0x7C, 0x80, 0x3F, 0x20, 0x09, 0x48, 0x02, 0x9E, 0x00, 0x17, 0x20, 0x00, 0xFE, 
0xC3, 0xFF, 0x90, 0x00, 0x24, 0x00, 0xF0, 0x01, 0xFE, 0x82, 0xA0, 0x20, 0x28, 0xF8, 0x0F, 0xFE, 
0xF1, 0x3F, 0xFC, 0x0F, 0x08, 0x00, 0x02, 0x80, 0x3F, 0xC0, 0x0F, 0xFB, 0xC3, 0xFE, 0x00, 0x80, 
0x20, 0x20, 0xFB, 0xCF, 0xFE, 0xF1, 0x3F, 0xFC, 0x0F, 0x60, 0x00, 0x3C, 0x80, 0x19, 0x20, 0x0C, 
0x00, 0xC2, 0xFF, 0xF0, 0x3F, 0xE0, 0x0F, 0xF0, 0x03, 0x02, 0x80, 0x3F, 0xC0, 0x0F, 0x08, 0x00, 
0xFE, 0x00, 0x3F, 0xE0, 0x0F, 0xF8, 0x03, 0x02, 0x80, 0x00, 0xE0, 0x0F, 0xF0, 0x03, 0x7C, 0x80, 
0x3F, 0x20, 0x08, 0x08, 0x02, 0xFE, 0x00, 0x1F, 0xE0, 0x3F, 0xF8, 0x0F, 0x82, 0x80, 0x20, 0xE0, 
0x0F, 0xF0, 0x01, 0x7C, 0x80, 0x3F, 0x20, 0x08, 0x08, 0x02, 0xFE, 0x83, 0xFF, 0xE0, 0x0F, 0xF8, 
0x03, 0x04, 0x80, 0x01, 0x60, 0x00, 0x30, 0x02, 0x9E, 0x80, 0x24, 0x20, 0x0F, 0x88, 0x01, 0x02, 
0xE0, 0x1F, 0xF8, 0x0F, 0x08, 0x02, 0x82, 0x80, 0x1F, 0xE0, 0x0F, 0x00, 0x02, 0x80, 0x80, 0x3F, 
0xE0, 0x0F, 0x38, 0x00, 0x7E, 0x00, 0x3C, 0x00, 0x0F, 0xF8, 0x01, 0x0E, 0x80, 0x3F, 0xE0, 0x07, 
0xC0, 0x00, 0x1E, 0x00, 0x0C, 0xE0, 0x07, 0xF8, 0x03, 0xC6, 0x80, 0x3B, 0x80, 0x03, 0xE0, 0x00, 
0xEE, 0x80, 0x31, 0xE0, 0x00, 0xF8, 0x09, 0xF0, 0x03, 0x7C, 0xE0, 0x07, 0x38, 0x00, 0xC2, 0x80, 
0x3C, 0xA0, 0x0B, 0x78, 0x02, 0x86, 0x00, 0x02, 0xF8, 0x1F, 0xDF, 0x4F, 0x00, 0x12, 0x80, 0xFC, 
0x3F, 0xFF, 0x4F, 0x00, 0x12, 0x80, 0x7C, 0x3F, 0xFE, 0x07, 0x08, 0x00, 0x0E, 0x40, 0x00, 0x10, 
0x00, 0x08, 0x00, 0x04, 0x00, 0x02, 0x80, 0x00, 0x1C, 0x00, 0x05, 0xE0, 0x03, 0xFC, 0x81, 0xD5, 
0x20, 0x21, 0x08, 0x08, 0x04, 0x01, 0x00, 0x00, 0x70, 0x00, 0x0C, 0x00, 0x00, 0xC0, 0x01, 0x30, 
0x00, 0x00, 0x00, 0x07, 0xC0, 0x00, 0x00, 0x08, 0x00, 0x03, 0x60, 0x00, 0x30, 0x00, 0x08, 0x00, 
0x00, 0x60, 0x00, 0x38, 0x00, 0x00, 0x80, 0x03, 0x60, 0x00, 0x00, 0x00, 0x06, 0x80, 0x03, 0x00, 
0x00, 0x18, 0x00, 0x0E, 0x80, 0x03, 0x60, 0x00, 0x00, 0x00, 0x0E, 0x80, 0x01, 0x00, 0x1E, 0xC0, 
0x0F, 0xF0, 0x03, 0xFC, 0x00, 0x3F, 0x80, 0x07, 0x00, 0x00, 0x01, 0x20, 0x00, 0x10, 0x00, 0x02, 
0x00, 0x01, 0x20, 0x00, 0xF0, 0xF9, 0x7C, 0x3E, 0x00, 0x80, 0x9D, 0xF0, 0x4F, 0x24, 0x12, 0x89, 
0x44, 0x22, 0x91, 0x7F, 0xC8, 0x0D, 0x00, 0x00, 0x88, 0x00, 0x22, 0xE0, 0x0B, 0x20, 0x02, 0x88, 
0x00, 0x00, 0x00, 0x00, 0x31, 0x40, 0x0E, 0xF0, 0x02, 0x98, 0x00, 0x00, 0x00, 0x00, 0x10, 0x02, 
0x94, 0x00, 0x3F, 0x80, 0x06, 0x00, 0x00, 0xE0, 0x3F, 0xF8, 0x0F, 0x80, 0x00, 0x20, 0xE0, 0x0F, 
0xF8, 0x03, 0x00, 0xC0, 0x01, 0xF8, 0x00, 0x3E, 0x80, 0x0F, 0xE0, 0xFF, 0x08, 0x00, 0xFE, 0x0F, 
0x00, 0x00, 0x00, 0x00, 0x00, 0x22, 0xC0, 0x0F, 0xF0, 0x03, 0x80, 0x00, 0x00, 0x00, 0x00, 0xE0, 
0x01, 0xFC, 0x00, 0x21, 0xC0, 0x0F, 0xE0, 0x01, 0x00, 0x00, 0x80, 0x33, 0xFE, 0xE0, 0x0F, 0x18, 
0x02, 0xFE, 0x30, 0xFE, 0x00, 0x38, 0x00, 0x00, 0xF8, 0x00, 0x7F, 0x6C, 0x30, 0x08, 0xC8, 0x06, 
0x03, 0x7F, 0x80, 0x0F, 0x00, 0x00, 0x88, 0x00, 0x14, 0x00, 0x02, 0x40, 0x01, 0x88, 0x00, 0x00, 
0xE0, 0x1F, 0xF8, 0xCF, 0x00, 0x02, 0x80, 0x0C, 0x20, 0xF8, 0x0F, 0xFE, 0x01, 0x00, 0xE0, 0x3F, 
0xFC, 0x0F, 0x01, 0x40, 0x84, 0xF0, 0x23, 0xB8, 0x0F, 0xC0, 0x01, 0x00, 0x00, 0x1C, 0xAC, 0x0F, 
0x28, 0x02, 0x8A, 0xB0, 0x3F, 0xC0, 0x0F, 0x00, 0x00, 0x7C, 0xB0, 0x3F, 0x20, 0x08, 0x08, 0xC2, 
0xFE, 0x00, 0x1F, 0x00, 0x00, 0x20, 0x00, 0x08, 0xC0, 0x1A, 0xB0, 0x06, 0x20, 0x00, 0x08, 0x00, 
0x00, 0xC0, 0x17, 0xF8, 0x03, 0xA2, 0x80, 0x26, 0xE0, 0x0F, 0xF4, 0x01, 0x00, 0x80, 0x1F, 0xEC, 
0x0F, 0x00, 0x02, 0x80, 0xB0, 0x3F, 0xE0, 0x0F, 0x00, 0x00
};

flash unsigned char AF12x16[] = {
0x0E, 0x84, 0x0C, 0x10, 0x01, 0x00, 0xFF,
0x05, 0x06, 0x06, 0x06, 0x04, 0x04, 0x04, 0x08, 0x09, 0x08, 0x09, 0x08, 0x09, 0x09, 0x09, 0x0B, 
0x03, 0x02, 0x05, 0x06, 0x07, 0x07, 0x06, 0x07, 0x07, 0x05, 0x0B, 0x06, 0x04, 0x04, 0x04, 0x04, 
0x02, 0x01, 0x03, 0x08, 0x07, 0x05, 0x08, 0x01, 0x03, 0x03, 0x07, 0x07, 0x04, 0x06, 0x02, 0x09, 
0x06, 0x05, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x02, 0x04, 0x05, 0x06, 0x05, 0x06, 
0x08, 0x09, 0x07, 0x07, 0x07, 0x07, 0x07, 0x08, 0x09, 0x05, 0x08, 0x08, 0x07, 0x09, 0x09, 0x07, 
0x07, 0x07, 0x08, 0x07, 0x09, 0x09, 0x09, 0x09, 0x09, 0x09, 0x07, 0x03, 0x08, 0x03, 0x07, 0x09, 
0x02, 0x07, 0x07, 0x07, 0x07, 0x07, 0x06, 0x07, 0x07, 0x05, 0x05, 0x07, 0x05, 0x09, 0x07, 0x07, 
0x07, 0x07, 0x08, 0x07, 0x07, 0x07, 0x09, 0x09, 0x07, 0x09, 0x07, 0x05, 0x01, 0x04, 0x07, 0x07, 
0x05, 0x08, 0x06, 0x05, 0x09, 0x09, 0x07, 0x07, 0x07, 0x09, 0x09, 0x06, 0x05, 0x08, 0x06, 0x04, 
0x09, 0x06, 0x06, 0x08, 0x09, 0x08, 0x08, 0x09, 0x04, 0x08, 0x04, 0x06, 0x08, 0x08, 0x09, 0x08, 
0x08, 0x04, 0x04, 0x08, 0x08, 0x07, 0x05, 0x08, 0x06, 0x09, 0x04, 0x08, 0x04, 0x04, 0x09, 0x04, 
0x06, 0x08, 0x08, 0x09, 0x08, 0x09, 0x09, 0x04, 0x05, 0x09, 0x04, 0x08, 0x09, 0x09, 0x09, 0x08, 
0x04, 0x04, 0x06, 0x04, 0x07, 0x03, 0x09, 0x01, 0x08, 0x06, 0x08, 0x08, 0x08, 0x08, 0x08, 0x04, 
0x04, 0x06, 0x06, 0x0E, 0x0E, 0x0F, 0x0F, 0x08, 0x08, 0x08, 0x07, 0x07, 0x03, 0x0A, 0x08, 0x08, 
0x08, 0x07, 0x08, 0x06, 0x08, 0x05, 0x06, 0x08, 0x08, 0x08, 0x08, 0x08, 0x09, 0x09, 0x07, 0x07, 
0x06, 0x07, 0x04, 0x04, 0x08, 0x06, 0x06, 0x08, 0x07, 0x08, 0x05, 0x08, 0x07, 0x04, 0x09, 0x04, 

0x00, 0x00, 0x00, 0x00, 0xF8, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x0A, 0x00, 0x05, 0x00, 
0xF5, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x04, 0x00, 0x02, 0x00, 0xFA, 0x03, 0x02, 0x04, 
0x01, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xF8, 0x53, 0x00, 0x54, 0x00, 0x04, 0x00, 0x04, 
0x00, 0x04, 0x80, 0x24, 0x00, 0x03, 0x00, 0x04, 0x10, 0x04, 0x80, 0x04, 0x10, 0x03, 0x00, 0x04, 
0x10, 0x04, 0x84, 0x04, 0x10, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x05, 0x80, 0x04, 0x80, 0x24, 
0x00, 0x05, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x80, 0x1C, 0x40, 0x22, 0x40, 0x41, 0x40, 0x41, 
0x80, 0x48, 0x80, 0x41, 0x80, 0x42, 0x80, 0x24, 0x00, 0x04, 0x00, 0x04, 0x00, 0x05, 0x80, 0x04, 
0x80, 0x04, 0x00, 0x05, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x80, 0x1C, 0x40, 0x22, 0x40, 0x41, 
0x40, 0x41, 0x80, 0x40, 0x80, 0x41, 0x80, 0x42, 0x80, 0x24, 0x00, 0x04, 0x00, 0x04, 0x00, 0x05, 
0x90, 0x04, 0x80, 0x04, 0x00, 0x05, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x80, 0x1C, 0x40, 0x22, 
0x48, 0x41, 0x40, 0x41, 0x80, 0x40, 0x80, 0x41, 0x80, 0x42, 0x80, 0x24, 0x00, 0x04, 0x00, 0x04, 
0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x04, 
0x00, 0x04, 0x00, 0x03, 0x00, 0x04, 0x20, 0x04, 0x08, 0x03, 0x20, 0x04, 0x00, 0x04, 0x00, 0x03, 
0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x06, 0x00, 0x05, 0x80, 0x04, 
0x80, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x01, 0x80, 0x03, 0x00, 0x01, 0x30, 0x00, 0xC0, 0x1F, 
0x30, 0x00, 0xE0, 0x00, 0x40, 0x1F, 0x40, 0x00, 0x30, 0x00, 0x30, 0x00, 0xE0, 0x00, 0x40, 0x1F, 
0x30, 0x00, 0x40, 0x00, 0x30, 0x00, 0x20, 0x00, 0xF0, 0x00, 0xE0, 0x1F, 0x60, 0x00, 0x90, 0x00, 
0x90, 0x00, 0x40, 0x00, 0x00, 0x0E, 0x80, 0x11, 0x50, 0x10, 0x20, 0x0C, 0x40, 0x10, 0x80, 0x11, 
0x00, 0x0E, 0xC0, 0x10, 0x20, 0x09, 0x10, 0x05, 0x10, 0x03, 0x20, 0x01, 0x80, 0x00, 0x30, 0x00, 
0xC0, 0x00, 0x00, 0x03, 0x00, 0x1C, 0x00, 0x03, 0xC0, 0x00, 0x30, 0x00, 0x00, 0x18, 0x00, 0x06, 
0x80, 0x01, 0x70, 0x00, 0x80, 0x01, 0x00, 0x06, 0x00, 0x18, 0x60, 0x00, 0x90, 0x00, 0x90, 0x00, 
0xE0, 0x07, 0x00, 0x18, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x06, 
0x10, 0x05, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x04, 0x80, 0x05, 0x40, 0x06, 
0x40, 0x04, 0x80, 0x04, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x80, 0x01, 0x80, 0x01, 0x00, 0x00, 
0x00, 0x00, 0x80, 0x03, 0x40, 0x03, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x02, 0xC0, 0x01, 0x00, 0x00, 
0x00, 0x00, 0xE0, 0x04, 0x90, 0x04, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x05, 0x78, 0x00, 0x00, 0x00, 
0x78, 0x00, 0x00, 0x02, 0x40, 0x1E, 0xC0, 0x03, 0x78, 0x02, 0x40, 0x1E, 0xC0, 0x03, 0x78, 0x02, 
0x40, 0x00, 0xC0, 0x11, 0x20, 0x22, 0x20, 0x22, 0x30, 0x62, 0x20, 0x22, 0x20, 0x22, 0x40, 0x1C, 
0x06, 0x06, 0x80, 0x01, 0x60, 0x00, 0x18, 0x00, 0x06, 0x06, 0x00, 0x0E, 0x70, 0x11, 0x88, 0x10, 
0x08, 0x11, 0x08, 0x12, 0x10, 0x0C, 0x00, 0x0C, 0x00, 0x12, 0x78, 0x00, 0xC0, 0x1F, 0x30, 0x60, 
0x08, 0x80, 0x08, 0x80, 0x30, 0x60, 0xC0, 0x1F, 0x80, 0x00, 0xA0, 0x02, 0xE0, 0x03, 0xC0, 0x01, 
0xE0, 0x03, 0xA0, 0x02, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0xF0, 0x07, 0x80, 0x00, 
0x80, 0x00, 0x80, 0x00, 0x00, 0x20, 0x00, 0x38, 0x00, 0x18, 0x00, 0x08, 0x00, 0x01, 0x00, 0x01, 
0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x18, 0x00, 0x18, 0x00, 0x08, 0x00, 0x04, 
0x00, 0x02, 0x00, 0x01, 0x80, 0x00, 0x40, 0x00, 0x20, 0x00, 0x10, 0x00, 0x08, 0x00, 0xF0, 0x0F, 
0x08, 0x10, 0x08, 0x10, 0x08, 0x10, 0x08, 0x10, 0xF0, 0x0F, 0x10, 0x10, 0x10, 0x10, 0xF8, 0x1F, 
0x00, 0x10, 0x00, 0x10, 0x10, 0x18, 0x08, 0x14, 0x08, 0x12, 0x08, 0x11, 0x88, 0x10, 0x70, 0x10, 
0x10, 0x08, 0x08, 0x10, 0x88, 0x10, 0x88, 0x10, 0x88, 0x10, 0x70, 0x0F, 0x00, 0x03, 0x80, 0x02, 
0x60, 0x02, 0x10, 0x12, 0xF8, 0x1F, 0x00, 0x12, 0xF8, 0x08, 0x88, 0x10, 0x88, 0x10, 0x88, 0x10, 
0x88, 0x10, 0x08, 0x0F, 0xE0, 0x0F, 0x10, 0x11, 0x88, 0x10, 0x88, 0x10, 0x88, 0x10, 0x00, 0x0F, 
0x18, 0x00, 0x08, 0x18, 0x08, 0x06, 0x88, 0x01, 0x68, 0x00, 0x18, 0x00, 0x70, 0x0F, 0x88, 0x10, 
0x88, 0x10, 0x88, 0x10, 0x88, 0x10, 0x70, 0x0F, 0xF0, 0x00, 0x08, 0x11, 0x08, 0x11, 0x08, 0x11, 
0x88, 0x08, 0xF0, 0x07, 0xC0, 0x18, 0xC0, 0x18, 0x00, 0x20, 0xC0, 0x38, 0xC0, 0x18, 0x00, 0x08, 
0x00, 0x01, 0x80, 0x02, 0x40, 0x04, 0x20, 0x08, 0x10, 0x10, 0x80, 0x02, 0x80, 0x02, 0x80, 0x02, 
0x80, 0x02, 0x80, 0x02, 0x80, 0x02, 0x10, 0x10, 0x20, 0x08, 0x40, 0x04, 0x80, 0x02, 0x00, 0x01, 
0x10, 0x00, 0x08, 0x00, 0x08, 0x16, 0x08, 0x01, 0x88, 0x00, 0x70, 0x00, 0xE0, 0x0F, 0x10, 0x10, 
0x88, 0x23, 0x48, 0x24, 0x48, 0x24, 0xC8, 0x23, 0x10, 0x24, 0xE0, 0x03, 0x00, 0x10, 0x00, 0x1C, 
0x88, 0x13, 0x68, 0x02, 0x18, 0x02, 0x60, 0x02, 0x80, 0x13, 0x00, 0x1C, 0x00, 0x10, 0x08, 0x10, 
0xF8, 0x1F, 0x88, 0x10, 0x88, 0x10, 0x88, 0x10, 0x88, 0x10, 0x70, 0x0F, 0xE0, 0x07, 0x10, 0x08, 
0x08, 0x10, 0x08, 0x10, 0x08, 0x10, 0x10, 0x10, 0x78, 0x08, 0x08, 0x10, 0xF8, 0x1F, 0x08, 0x10, 
0x08, 0x10, 0x08, 0x10, 0x10, 0x08, 0xE0, 0x07, 0x08, 0x10, 0xF8, 0x1F, 0x88, 0x10, 0x88, 0x10, 
0xC8, 0x11, 0x08, 0x10, 0x18, 0x18, 0x08, 0x10, 0xF8, 0x1F, 0x88, 0x10, 0x88, 0x10, 0xC8, 0x01, 
0x08, 0x00, 0x18, 0x00, 0xE0, 0x07, 0x10, 0x08, 0x08, 0x10, 0x08, 0x10, 0x08, 0x11, 0x10, 0x11, 
0x78, 0x0F, 0x00, 0x01, 0x08, 0x10, 0xF8, 0x1F, 0x88, 0x10, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 
0x88, 0x10, 0xF8, 0x1F, 0x08, 0x10, 0x08, 0x10, 0x08, 0x10, 0xF8, 0x1F, 0x08, 0x10, 0x08, 0x10, 
0x00, 0x0C, 0x00, 0x10, 0x00, 0x10, 0x08, 0x10, 0x08, 0x10, 0xF8, 0x0F, 0x08, 0x00, 0x08, 0x00, 
0x08, 0x10, 0xF8, 0x1F, 0x08, 0x11, 0x80, 0x01, 0x68, 0x02, 0x18, 0x04, 0x08, 0x18, 0x00, 0x10, 
0x08, 0x10, 0xF8, 0x1F, 0x08, 0x10, 0x08, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x18, 0x08, 0x10, 
0xF8, 0x1F, 0x60, 0x10, 0x80, 0x01, 0x00, 0x06, 0x80, 0x01, 0x60, 0x10, 0xF8, 0x1F, 0x08, 0x10, 
0x08, 0x10, 0xF8, 0x1F, 0x20, 0x10, 0xC0, 0x10, 0x00, 0x01, 0x08, 0x06, 0x08, 0x08, 0xF8, 0x1F, 
0x08, 0x00, 0xE0, 0x07, 0x10, 0x08, 0x08, 0x10, 0x08, 0x10, 0x08, 0x10, 0x10, 0x08, 0xE0, 0x07, 
0x08, 0x10, 0xF8, 0x1F, 0x08, 0x11, 0x08, 0x11, 0x08, 0x01, 0x08, 0x01, 0xF0, 0x00, 0xE0, 0x07, 
0x10, 0x48, 0x08, 0x50, 0x08, 0x30, 0x08, 0x30, 0x10, 0x48, 0xE0, 0x47, 0x08, 0x10, 0xF8, 0x1F, 
0x08, 0x11, 0x08, 0x01, 0x08, 0x03, 0x08, 0x05, 0xF0, 0x18, 0x00, 0x10, 0x70, 0x1C, 0x88, 0x08, 
0x88, 0x10, 0x88, 0x10, 0x08, 0x11, 0x10, 0x11, 0x38, 0x0E, 0x18, 0x00, 0x08, 0x00, 0x08, 0x10, 
0x08, 0x10, 0xF8, 0x1F, 0x08, 0x10, 0x08, 0x10, 0x08, 0x00, 0x18, 0x00, 0x08, 0x00, 0xF8, 0x0F, 
0x08, 0x08, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x08, 0x08, 0xF8, 0x0F, 0x08, 0x00, 0x08, 0x00, 
0x38, 0x00, 0xC8, 0x01, 0x00, 0x06, 0x00, 0x18, 0x00, 0x06, 0xC8, 0x01, 0x38, 0x00, 0x08, 0x00, 
0x78, 0x00, 0x88, 0x03, 0x00, 0x1C, 0x80, 0x03, 0x60, 0x00, 0x80, 0x03, 0x00, 0x1C, 0x88, 0x03, 
0x78, 0x00, 0x08, 0x10, 0x18, 0x18, 0x28, 0x14, 0x40, 0x02, 0x80, 0x01, 0x40, 0x02, 0x28, 0x14, 
0x18, 0x18, 0x08, 0x10, 0x08, 0x00, 0x18, 0x00, 0x68, 0x10, 0x80, 0x10, 0x00, 0x1F, 0x80, 0x10, 
0x68, 0x10, 0x18, 0x00, 0x08, 0x00, 0x18, 0x18, 0x08, 0x14, 0x08, 0x12, 0x88, 0x11, 0x48, 0x10, 
0x28, 0x10, 0x18, 0x18, 0xFE, 0x3F, 0x02, 0x20, 0x02, 0x20, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 
0x80, 0x00, 0x00, 0x01, 0x00, 0x02, 0x00, 0x04, 0x00, 0x08, 0x02, 0x20, 0x02, 0x20, 0xFE, 0x3F, 
0x40, 0x00, 0x20, 0x00, 0x10, 0x00, 0x08, 0x00, 0x10, 0x00, 0x20, 0x00, 0x40, 0x00, 0x00, 0x40, 
0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 
0x08, 0x00, 0x10, 0x00, 0x00, 0x0E, 0x40, 0x11, 0x40, 0x11, 0x40, 0x11, 0x40, 0x11, 0x80, 0x0F, 
0x00, 0x10, 0x08, 0x10, 0xF8, 0x1F, 0x80, 0x08, 0x40, 0x10, 0x40, 0x10, 0x80, 0x08, 0x00, 0x07, 
0x00, 0x07, 0x80, 0x08, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x80, 0x08, 0xC0, 0x08, 0x00, 0x07, 
0x80, 0x08, 0x40, 0x10, 0x40, 0x10, 0x88, 0x08, 0xF8, 0x1F, 0x00, 0x10, 0x00, 0x07, 0x80, 0x0A, 
0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x80, 0x0A, 0x00, 0x0B, 0x80, 0x10, 0xF0, 0x1F, 0x88, 0x10, 
0x88, 0x10, 0x08, 0x00, 0x10, 0x00, 0x00, 0x63, 0x80, 0x84, 0x40, 0x88, 0x40, 0x88, 0x80, 0x84, 
0xC0, 0x7F, 0x40, 0x00, 0x08, 0x10, 0xF8, 0x1F, 0x80, 0x10, 0x40, 0x00, 0x40, 0x10, 0x80, 0x1F, 
0x00, 0x10, 0x40, 0x10, 0x40, 0x10, 0xC8, 0x1F, 0x00, 0x10, 0x00, 0x10, 0x00, 0x40, 0x00, 0x80, 
0x40, 0x80, 0x40, 0x80, 0xC8, 0x7F, 0x08, 0x10, 0xF8, 0x1F, 0x08, 0x12, 0x08, 0x03, 0xC0, 0x14, 
0x40, 0x18, 0x40, 0x10, 0x08, 0x10, 0x08, 0x10, 0xF8, 0x1F, 0x00, 0x10, 0x00, 0x10, 0x40, 0x10, 
0xC0, 0x1F, 0x80, 0x10, 0x40, 0x00, 0xC0, 0x1F, 0x80, 0x10, 0x40, 0x00, 0xC0, 0x1F, 0x00, 0x10, 
0x40, 0x10, 0xC0, 0x1F, 0x80, 0x10, 0x40, 0x00, 0x40, 0x10, 0x80, 0x1F, 0x00, 0x10, 0x00, 0x07, 
0x80, 0x08, 0x40, 0x10, 0x40, 0x10, 0x40, 0x10, 0x80, 0x08, 0x00, 0x07, 0x40, 0x80, 0xC0, 0xFF, 
0x80, 0x88, 0x40, 0x90, 0x40, 0x10, 0x80, 0x08, 0x00, 0x07, 0x00, 0x07, 0x80, 0x08, 0x40, 0x10, 
0x40, 0x90, 0x80, 0x88, 0xC0, 0xFF, 0x40, 0x80, 0x40, 0x10, 0x40, 0x10, 0xC0, 0x1F, 0x80, 0x10, 
0x40, 0x10, 0x40, 0x00, 0x40, 0x00, 0x80, 0x00, 0x80, 0x09, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 
0x40, 0x12, 0x40, 0x12, 0x80, 0x0C, 0x40, 0x00, 0x40, 0x00, 0xF0, 0x0F, 0x40, 0x10, 0x40, 0x10, 
0x40, 0x10, 0x00, 0x08, 0x40, 0x00, 0xC0, 0x0F, 0x00, 0x10, 0x00, 0x10, 0x40, 0x08, 0xC0, 0x1F, 
0x00, 0x10, 0x40, 0x00, 0xC0, 0x00, 0x40, 0x03, 0x00, 0x0C, 0x00, 0x10, 0x00, 0x0C, 0x40, 0x03, 
0xC0, 0x00, 0x40, 0x00, 0x40, 0x00, 0xC0, 0x0F, 0x40, 0x18, 0x00, 0x07, 0xC0, 0x00, 0x00, 0x07, 
0x40, 0x18, 0xC0, 0x07, 0x40, 0x00, 0x40, 0x10, 0xC0, 0x18, 0x40, 0x15, 0x00, 0x02, 0x40, 0x15, 
0xC0, 0x18, 0x40, 0x10, 0x40, 0x00, 0xC0, 0x80, 0x40, 0x83, 0x00, 0x4C, 0x00, 0x30, 0x00, 0x0C, 
0x40, 0x03, 0xC0, 0x00, 0x40, 0x00, 0xC0, 0x10, 0x40, 0x18, 0x40, 0x14, 0x40, 0x12, 0x40, 0x11, 
0xC0, 0x10, 0x40, 0x18, 0x00, 0x02, 0x00, 0x02, 0xF0, 0x7D, 0x08, 0x80, 0x08, 0x80, 0xF8, 0xFF, 
0x08, 0x80, 0x08, 0x80, 0xF0, 0x7D, 0x00, 0x02, 0x30, 0x00, 0x08, 0x00, 0x08, 0x00, 0x10, 0x00, 
0x20, 0x00, 0x20, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x1C, 0x80, 0x22, 0x48, 0x41, 0x40, 0x41, 
0xC0, 0x42, 0x00, 0x44, 0x00, 0x04, 0x80, 0x04, 0x48, 0x05, 0x40, 0x06, 0x80, 0x03, 0x00, 0x03, 
0x80, 0x04, 0x00, 0x14, 0x00, 0x44, 0x00, 0x14, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x20, 0x00, 0x38, 0x00, 0x18, 0x00, 0x08, 0x00, 0x04, 0x88, 0x04, 0x40, 0x05, 
0x48, 0x06, 0x80, 0x03, 0x00, 0x00, 0x00, 0x20, 0x00, 0x38, 0x00, 0x18, 0x00, 0x08, 0x00, 0x20, 
0x00, 0x38, 0x00, 0x18, 0x00, 0x08, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x18, 
0x00, 0x18, 0x00, 0x00, 0x00, 0x18, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x20, 0x00, 
0xF8, 0x3F, 0x20, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x08, 0x20, 0x08, 0xF8, 0x3F, 
0x20, 0x08, 0x20, 0x08, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 0x08, 0x00, 0x04, 0x00, 0x08, 0x00, 
0x10, 0x00, 0x30, 0x0C, 0x48, 0x02, 0x30, 0x01, 0x80, 0x0C, 0x40, 0x12, 0x20, 0x0C, 0x18, 0x0C, 
0x00, 0x12, 0x00, 0x0C, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 
0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x02, 0x40, 0x04, 
0x20, 0x08, 0x00, 0x04, 0x60, 0x04, 0x50, 0x04, 0x90, 0x04, 0x08, 0x03, 0x80, 0x1C, 0x40, 0x22, 
0x40, 0x41, 0x40, 0x45, 0x80, 0x50, 0x80, 0x44, 0x80, 0x40, 0x80, 0x20, 0x00, 0x20, 0x00, 0x20, 
0x00, 0x10, 0x20, 0x10, 0x08, 0x08, 0x20, 0x07, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x10, 0x00, 
0x00, 0x00, 0x00, 0x03, 0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x64, 0x04, 0x52, 0x04, 0x92, 0x04, 
0x09, 0x03, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x30, 0x00, 0x38, 0x00, 0x08, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x20, 0x00, 0x38, 0x00, 0x18, 0x00, 0x08, 0x00, 0x20, 0x00, 0x30, 0x00, 0x38, 0x00, 
0x08, 0x00, 0x20, 0x00, 0x30, 0x00, 0x38, 0x00, 0x08, 0x00, 0x00, 0x00, 0x20, 0x00, 0x38, 0x00, 
0x18, 0x00, 0x08, 0x00, 0x20, 0x00, 0x38, 0x00, 0x18, 0x00, 0x08, 0x00, 0x00, 0x04, 0x00, 0x04, 
0x00, 0x04, 0x00, 0x0F, 0x80, 0x14, 0x40, 0x32, 0x80, 0x29, 0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 
0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 0x00, 0x01, 
0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x00, 0x00, 
0x00, 0x00, 0x08, 0x00, 0x10, 0x00, 0x00, 0x00, 0x08, 0x00, 0x38, 0x00, 0x08, 0x00, 0x38, 0x00, 
0x10, 0x00, 0x10, 0x00, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x10, 0x00, 0x00, 0x00, 
0x00, 0x00, 0x20, 0x08, 0x40, 0x04, 0x80, 0x02, 0x00, 0x01, 0x00, 0x38, 0x00, 0x44, 0x00, 0x40, 
0x00, 0x40, 0x00, 0x48, 0x00, 0x54, 0x00, 0x54, 0x00, 0x34, 0x00, 0x04, 0x00, 0x04, 0x00, 0x15, 
0x80, 0x44, 0x80, 0x14, 0x00, 0x05, 0x00, 0x06, 0x00, 0x04, 0x00, 0x00, 0x80, 0x1C, 0x40, 0x22, 
0x40, 0x41, 0x40, 0x45, 0x80, 0x50, 0x80, 0x45, 0x80, 0x42, 0x80, 0x24, 0x00, 0x00, 0x08, 0x00, 
0x10, 0x04, 0x20, 0x04, 0x40, 0x02, 0x80, 0x01, 0xF8, 0x03, 0x00, 0x04, 0x00, 0x38, 0x00, 0x44, 
0x00, 0x40, 0x00, 0xC0, 0x00, 0x48, 0x00, 0xD4, 0x00, 0x54, 0x00, 0x34, 0x00, 0x00, 0x00, 0x00, 
0x80, 0x03, 0x40, 0x03, 0x00, 0x04, 0x14, 0x04, 0x8A, 0x04, 0x0A, 0x03, 0x00, 0x00, 0x00, 0x00, 
0x70, 0x11, 0x88, 0x1F, 0x08, 0x11, 0x08, 0x11, 0x30, 0x10, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 
0x08, 0x01, 0xF0, 0x00, 0x90, 0x00, 0x90, 0x00, 0xF0, 0x00, 0x08, 0x01, 0x00, 0x00, 0x08, 0x00, 
0x10, 0x00, 0x20, 0x0C, 0x40, 0x0A, 0x80, 0x09, 0xF8, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
0x00, 0x00, 0xF8, 0xF8, 0x00, 0x00, 0xC0, 0x30, 0x30, 0x21, 0x28, 0x22, 0x48, 0x24, 0x88, 0x28, 
0x08, 0x19, 0x18, 0x06, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 
0x00, 0x00, 0xF0, 0x03, 0x08, 0x04, 0xE4, 0x09, 0x14, 0x0A, 0x14, 0x0A, 0x24, 0x09, 0x08, 0x04, 
0xF0, 0x03, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x10, 0x00, 0x00, 0x00, 0x40, 0x00, 0xA0, 0x00, 
0x10, 0x01, 0x48, 0x02, 0xA0, 0x00, 0x10, 0x01, 0x08, 0x02, 0x18, 0x00, 0x12, 0x00, 0x09, 0x00, 
0x0C, 0x00, 0x1A, 0x00, 0x13, 0x00, 0x09, 0x00, 0x0C, 0x00, 0x00, 0x00, 0xF0, 0x03, 0x08, 0x04, 
0xF4, 0x0B, 0x94, 0x08, 0x94, 0x08, 0x64, 0x0B, 0x08, 0x04, 0xF0, 0x03, 0x06, 0x00, 0x14, 0x00, 
0x0A, 0x00, 0x0B, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x48, 0x00, 0x48, 0x00, 0x30, 0x00, 
0x00, 0x00, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 0xF0, 0x17, 0x80, 0x10, 0x80, 0x10, 0x80, 0x10, 
0x00, 0x00, 0x0A, 0x00, 0x05, 0x00, 0x15, 0x00, 0x24, 0x0C, 0x40, 0x0A, 0x80, 0x09, 0xF8, 0x0E, 
0x00, 0x00, 0x0A, 0x00, 0x05, 0x00, 0x15, 0x04, 0x24, 0x04, 0x40, 0x02, 0x80, 0x01, 0xF8, 0x03, 
0x00, 0x04, 0x04, 0x00, 0x02, 0x00, 0x0A, 0x00, 0x12, 0x00, 0x21, 0x0C, 0x40, 0x0A, 0x80, 0x09, 
0xFC, 0x0E, 0x00, 0x00, 0x00, 0x38, 0x80, 0x44, 0x60, 0x40, 0x50, 0x40, 0x50, 0x48, 0x00, 0x54, 
0x00, 0x54, 0x00, 0x34, 0x00, 0x00, 0xF0, 0x00, 0xF8, 0x01, 0x18, 0x01, 0x18, 0x10, 0xF8, 0x1F, 
0x18, 0x00, 0xF8, 0x1F, 0x18, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x03, 0x00, 0x00, 
0x00, 0x00, 0x00, 0x80, 0x00, 0xA0, 0x00, 0x40, 0x04, 0x00, 0x02, 0x00, 0x0A, 0x00, 0x12, 0x04, 
0x21, 0x04, 0x40, 0x02, 0x80, 0x01, 0xF8, 0x03, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0xE0, 0x04, 
0x90, 0x04, 0x00, 0x00, 0x08, 0x02, 0x10, 0x01, 0xA0, 0x00, 0x48, 0x02, 0x10, 0x01, 0xA0, 0x00, 
0x40, 0x00, 0x00, 0x00, 0x10, 0x08, 0xF8, 0x05, 0x00, 0x02, 0x00, 0x0D, 0x80, 0x0A, 0x40, 0x09, 
0xA0, 0x1F, 0x10, 0x08, 0x00, 0x00, 0x10, 0x08, 0xF8, 0x05, 0x00, 0x02, 0x00, 0x01, 0x80, 0x11, 
0xC0, 0x18, 0xA0, 0x14, 0x10, 0x13, 0x00, 0x00, 0x90, 0x08, 0x08, 0x05, 0x28, 0x03, 0xD0, 0x0D, 
0x80, 0x0A, 0x40, 0x09, 0xA0, 0x1F, 0x10, 0x08, 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x88, 0x00, 
0x08, 0x01, 0x08, 0x16, 0x08, 0x00, 0x30, 0x00, 0x00, 0x04, 0x00, 0x24, 0x80, 0x04, 0x00, 0x23, 
0x00, 0x05, 0x80, 0x06, 0x80, 0x02, 0x00, 0x02, 0x00, 0x00, 0x04, 0x00, 0x02, 0x00, 0xFA, 0x07, 
0x02, 0x00, 0x01, 0x00, 0x00, 0x00, 0x0A, 0x00, 0x05, 0x00, 0xF5, 0x07, 0x00, 0x00, 0x00, 0x40, 
0x50, 0x40, 0x28, 0x23, 0xA8, 0x24, 0x80, 0x14, 0x00, 0x0F, 0x00, 0xA0, 0xF8, 0x57, 0x00, 0x50, 
0x00, 0x1E, 0x28, 0x21, 0x14, 0x20, 0x14, 0x20, 0x00, 0x20, 0x00, 0x26, 0x00, 0x15, 0x80, 0x0C, 
0x80, 0x00, 0xF8, 0x07, 0x00, 0x03, 0x80, 0x04, 0x00, 0x04, 0x00, 0x24, 0x00, 0x04, 0x00, 0x04, 
0x00, 0x04, 0x00, 0x03, 0x00, 0x00, 0x88, 0x03, 0x40, 0x04, 0x48, 0x04, 0x80, 0x04, 0x00, 0x03, 
0x00, 0x03, 0x80, 0x04, 0x00, 0x04, 0x20, 0x04, 0x00, 0x04, 0x20, 0x04, 0x00, 0x04, 0x00, 0x03, 
0x00, 0x03, 0x80, 0x04, 0x00, 0x04, 0x20, 0x04, 0x08, 0x04, 0x20, 0x04, 0x00, 0x04, 0x00, 0x03, 
0x80, 0x1C, 0x40, 0x22, 0x40, 0x41, 0x40, 0x41, 0x80, 0x48, 0x80, 0x40, 0x80, 0x40, 0x80, 0x20, 
0x80, 0x1C, 0x40, 0x22, 0x40, 0x41, 0x40, 0x41, 0x80, 0x40, 0x80, 0x40, 0x80, 0x40, 0x80, 0x20, 
0x80, 0x1C, 0x40, 0x22, 0x48, 0x41, 0x40, 0x41, 0x80, 0x40, 0x80, 0x40, 0x80, 0x40, 0x80, 0x20, 
0x00, 0x04, 0x40, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x04, 0x48, 0x04, 0x80, 0x04, 0x00, 0x03, 
0x00, 0x20, 0x00, 0x20, 0x00, 0x10, 0x00, 0x10, 0x00, 0x08, 0x00, 0x07, 0x00, 0x20, 0x00, 0x20, 
0x00, 0x10, 0x00, 0x10, 0x20, 0x08, 0x00, 0x07, 0x00, 0x1C, 0x00, 0x22, 0x00, 0x40, 0x00, 0x40, 
0x00, 0x40, 0x00, 0x40, 0x00, 0x23, 0x00, 0x1C, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 0x00, 0x04, 
0x00, 0x04, 0x00, 0x03, 0x00, 0x1C, 0x00, 0x22, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 
0x00, 0x23, 0x00, 0x1C, 0x00, 0x04, 0x20, 0x04, 0x08, 0x03, 0x20, 0x04, 0x00, 0x04, 0x00, 0x03, 
0x00, 0x1C, 0x00, 0x22, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x23, 0x00, 0x1C, 
0x00, 0x04, 0x00, 0x06, 0x00, 0x05, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x1C, 
0x00, 0x22, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x23, 0x00, 0x1C, 0x00, 0x04, 
0x00, 0x06, 0x10, 0x05, 0x80, 0x04, 0x80, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x00, 0x20, 0x08, 
0x40, 0x04, 0x80, 0x02, 0x00, 0x01, 0x80, 0x02, 0x40, 0x04, 0x20, 0x08, 0x00, 0x04, 0x00, 0x04, 
0xF8, 0x07, 0x00, 0x06, 0x00, 0x05, 0x80, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 
0xF8, 0x07, 0x00, 0x06, 0x00, 0x05, 0x90, 0x04, 0x80, 0x04, 0x00, 0x03, 0xC0, 0x1C, 0x20, 0x23, 
0x20, 0x41, 0x00, 0x41, 0x80, 0x40, 0x00, 0x40, 0x00, 0x20, 0xC0, 0x1C, 0x24, 0x23, 0x20, 0x41, 
0x00, 0x41, 0x80, 0x40, 0x00, 0x40, 0x00, 0x20, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x03, 
0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x80, 0x04, 0x48, 0x05, 0x40, 0x06, 
0x80, 0x03, 0x00, 0x1C, 0x00, 0x22, 0x00, 0x40, 0x00, 0x40, 0x10, 0x43, 0x80, 0x44, 0x90, 0x24, 
0x00, 0x1F, 0x00, 0x03, 0x80, 0x04, 0x00, 0x04, 0x00, 0x04, 0x60, 0x04, 0x50, 0x04, 0x90, 0x04, 
0x08, 0x03, 0x00, 0x00, 0x00, 0x0E, 0x40, 0x11, 0x48, 0x11, 0x50, 0x11, 0x40, 0x11, 0x80, 0x0F, 
0x00, 0x10, 0x00, 0x0E, 0x00, 0x11, 0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x08, 0xF8, 0x07, 
0x00, 0x00, 0x00, 0x0E, 0x40, 0x11, 0x50, 0x11, 0x48, 0x11, 0x50, 0x11, 0x80, 0x0F, 0x00, 0x10, 
0x00, 0xF8, 0x00, 0x04, 0x00, 0x07, 0x80, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x1C, 0x00, 0x22, 
0x00, 0x40, 0x40, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x21, 0x00, 0x1E, 0x80, 0x03, 0x40, 0x04, 
0x40, 0x04, 0x80, 0x04, 0x00, 0x03, 0x00, 0x40, 0x00, 0x40, 0x00, 0x23, 0x80, 0x24, 0x80, 0x14, 
0x00, 0x0F, 0x00, 0x00, 0x00, 0x01, 0x80, 0x02, 0x80, 0x02, 0x60, 0x02, 0x80, 0x01, 0x00, 0x02, 
0x00, 0x04, 0x00, 0x00, 0x14, 0x01, 0x8A, 0x02, 0x8A, 0x02, 0x68, 0x02, 0x80, 0x01, 0x00, 0x02, 
0x00, 0x04, 0x00, 0x00, 0x00, 0x01, 0x84, 0x02, 0x80, 0x02, 0x64, 0x02, 0x80, 0x01, 0x00, 0x02, 
0x00, 0x04, 0x00, 0x00, 0x00, 0x07, 0x80, 0x0A, 0x50, 0x12, 0x48, 0x12, 0x50, 0x12, 0x80, 0x0A, 
0x00, 0x0B, 0x00, 0x00, 0x00, 0x07, 0x88, 0x0A, 0x40, 0x12, 0x40, 0x12, 0x40, 0x12, 0x88, 0x0A, 
0x00, 0x0B, 0x00, 0x1E, 0x00, 0x21, 0x00, 0xA0, 0x00, 0x20, 0x00, 0xA0, 0x00, 0x26, 0x00, 0x15, 
0x80, 0x0C, 0x80, 0x00, 0x00, 0x1E, 0x00, 0x21, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x26, 
0x00, 0x15, 0x80, 0x0C, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x10, 0x50, 0x10, 0xC8, 0x1F, 
0x10, 0x10, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x48, 0x10, 0x40, 0x10, 0xC0, 0x1F, 0x08, 0x10, 
0x00, 0x10, 0x00, 0x04, 0x00, 0x04, 0x00, 0x05, 0x80, 0x06, 0x80, 0x06, 0x80, 0x05, 0x00, 0x00, 
0x00, 0x1C, 0x80, 0x22, 0x40, 0x41, 0x40, 0x41, 0xC0, 0x42, 0x00, 0x44, 0x00, 0x04, 0x00, 0x04, 
0x90, 0x04, 0x00, 0x03, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0xF8, 0x03, 0x00, 0x00, 0x00, 0x07, 
0x80, 0x08, 0x50, 0x10, 0x48, 0x10, 0x50, 0x10, 0x80, 0x08, 0x00, 0x07, 0x00, 0x04, 0x80, 0x05, 
0x48, 0x06, 0x40, 0x04, 0x80, 0x04, 0x00, 0x02, 0x00, 0x04, 0x00, 0x04, 0x00, 0x05, 0x80, 0x06, 
0x90, 0x06, 0x80, 0x05, 0x00, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x48, 0x02, 0x40, 0x00, 
0x40, 0x00, 0x40, 0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x02, 0x00, 0x03, 0x80, 0x04, 0x80, 0x04, 
0x00, 0x03, 0x00, 0x00, 0x40, 0x00, 0xC0, 0x0F, 0x08, 0x10, 0x10, 0x10, 0x40, 0x08, 0xC0, 0x1F, 
0x00, 0x10, 0x00, 0x04, 0x64, 0x04, 0x52, 0x04, 0x92, 0x04, 0x09, 0x03, 0x00, 0x00, 0x40, 0x00, 
0xC0, 0x0F, 0x10, 0x10, 0x08, 0x10, 0x50, 0x08, 0xC0, 0x1F, 0x00, 0x10, 0x00, 0x00, 0x08, 0xA0, 
0x10, 0x50, 0x20, 0x5C, 0x40, 0x4A, 0x80, 0x09, 0xF8, 0x0E, 0x00, 0x04, 0x00, 0x14, 0x80, 0x44, 
0x00, 0x13, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x80, 0x05, 0x50, 0x06, 0x20, 0x03, 0xC0, 0x04, 
0x80, 0x04, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x10, 0x00, 0x00
};

typedef enum {
E_LETTER,
P_LETTER
} Lt_Mode;

extern void LcdFont(flash unsigned char *pointer);

extern void LcdRot(unsigned char r);
extern void LcdReverse(unsigned char rv);
extern void LcdHorizontal(unsigned char hv);

extern void LcdFontFixed(unsigned char typ);
extern void	LcdNonTransparence(unsigned char nt);

extern void	LcdFgColor(unsigned short color);
extern void	LcdBkColor(unsigned short color);

extern void SetLine(unsigned char line,unsigned char column);

extern unsigned int CalcTextWidth(char *Text);
extern unsigned int CalcTextHeight(char *Text);

extern void PutChar(unsigned char c);
extern void Puts(char *Text);
extern void PutsP(char *Text);

extern void PutLong(unsigned long src, unsigned char digit, unsigned char decimal, unsigned char Parameter);
extern void PutInt(unsigned short src, unsigned char digit, unsigned char decimal, unsigned char Parameter);
extern void PutByte(unsigned char src, unsigned char digit, unsigned char decimal, unsigned char Parameter);

extern void PutText(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, char *str, unsigned char style);
extern void PutTextP(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, const char *str, unsigned char style);
extern void TextBox(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style);
extern void TextBoxP(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style);

extern void SetLetter(Lt_Mode L);
extern void PutsPE(char *str);

extern void PutCharPE(unsigned char c);
extern void PutCharEN(unsigned char c);

extern unsigned int CalcTextWidthEN(char *str);
extern unsigned int CalcTextWidthPE(char *str);

extern unsigned char 							rot;
extern unsigned char 							Reverse;
extern unsigned char							Horizontal;

extern unsigned short							FgColor;
extern unsigned short							BkColor;
extern unsigned char							FontFixed;
extern unsigned char							NonTransparence;

extern unsigned char 							FontWidth;
extern unsigned char 							FontHeight;
extern unsigned char 							FontXScale;
extern unsigned char 							FontYScale;
extern unsigned char 							FontSpace;

extern unsigned int 							cursorX;		
extern unsigned int 							cursorY;		

extern Lt_Mode										peLETTER;		

FRESULT res;
FATFS drive;
FIL fil;

flash char * flash error_msg[]=
{
"  ", 
"FR_DISK_ERR",
"FR_INT_ERR",
"FR_INT_ERR",
"FR_NOT_READY",
"FR_NO_FILE",
"FR_NO_PATH",
"FR_INVALID_NAME",
"FR_DENIED",
"FR_EXIST",
"FR_INVALID_OBJECT",
"FR_WRITE_PROTECTED",
"FR_INVALID_DRIVE",
"FR_NOT_ENABLED",
"FR_NO_FILESYSTEM",
"FR_MKFS_ABORTED",
"FR_TIMEOUT"
};  

char Enter=13;
char double_quote=34;
char Ctrlz=26;
char Escap=27;
char Line_Feed=10;
char single_quote=39;

typedef struct BMIH { 
unsigned long biSize;            
unsigned long biWidth;           
unsigned long biHeight;          
unsigned short biPlanes;         
unsigned short biBitCount;       
unsigned long biCompression;     
unsigned long biSizeImage;       
unsigned long biXPelsPerMeter;   
unsigned long biYPelsPerMeter;   
unsigned long biClrUsed;         
unsigned long biClrImportant;    
}BMP_INFO;

typedef struct BMFH { 
unsigned short bfType;           
unsigned long  bfSize;           
unsigned short bfReserved1;      
unsigned short bfReserved2;      
unsigned long  bfOffBits;        
}BMP_HEADER;

unsigned long bmpWidth;           
unsigned long bmpHeight;          

FRESULT bmpFile(const char* fname)
{
BMP_HEADER BMPHeader;
BMP_INFO BMPInfo;

int br;

if (f_open(&fil,fname,0x01) != FR_OK)                        return 1; 
if (f_read(&fil,&BMPHeader, sizeof(BMPHeader), &br) != FR_OK)   return 2; 
if (BMPHeader.bfType != 0x4d42 )                                return 3; 
if (f_read(&fil,&BMPInfo, sizeof(BMPInfo), &br) != FR_OK)       return 4; 
if (BMPInfo.biSize        !=  40)                               return 5; 
if (BMPInfo.biPlanes      !=   1)                               return 6; 
if (BMPInfo.biWidth       >  240)                               return 7; 
if (BMPInfo.biHeight      >  320)                               return 8; 
if (BMPInfo.biCompression !=   0)                               return 9; 

bmpWidth  = BMPInfo.biWidth;
bmpHeight = BMPInfo.biHeight;

if (f_lseek(&fil,BMPHeader.bfOffBits)!= FR_OK)            	return 10; 
return FR_OK;
}

void RGB(unsigned char B,unsigned char  G,unsigned char R)
{
B = B >> 3; 
G = G >> 2;
R = R >> 3;
TFTOutDat2((R << 3) | (G >> 3), (G << 5) | B );
}

unsigned char bmpShow(unsigned int sx, unsigned int sy)    
{

unsigned int x,y;
unsigned int i,j;
unsigned int ex,ey;
unsigned char  res,buffer[256];
unsigned int br;

ex = sx + bmpWidth-1;
ey = sy + bmpHeight-1;
if (sx < TFT_margin_xl)sx = TFT_margin_xl;
if (ex > TFT_margin_xr)ex = TFT_margin_xr;
if (sy < TFT_margin_yu)sy = TFT_margin_yu;
if (ey > TFT_margin_yl)ey = TFT_margin_yl;

TFTOutCmd(0x0003);
TFTOutDat(0x10);

TFTOutCmd(0x0050);
TFTOutDat(sx);
TFTOutCmd(0x0051);
TFTOutDat(ex);
TFTOutCmd(0x0020);
TFTOutDat(sx);
x = (ex - sx + 1);

TFTOutCmd(0x0052);
TFTOutDat(sy);
TFTOutCmd(0x0053);
TFTOutDat(ey);
TFTOutCmd(0x0021);
TFTOutDat(sy);
y = ey - sy;        
TFTOutCmd(0x0022);
for (;;)                      
{ 
res =  f_read(&fil,buffer,x,&br);
if(res || !br)break;
for (i=0; i<x; i+=3)
{
RGB(buffer[i+2],buffer[i+1],buffer[i]); 
}

} 
TFTOutCmd(0x0003);
TFTOutDat(0x0030); 
return res;            
}

char Ctemp[50];
int  Itemp;
char      path[20];
int  xt,yt,n,n2;
char i,d,nk,exit,bsn,bnun;
char v1=5;
char n1;
char j=0;
bit s,nu,b,;
char ATH[3]={'A','T','H'};
char ATA[3]={'A','T','A'};
char number[13];
char kibord[50];
char atcmgs[8]={'a','t','+','c','m','g','s','='};
char buffer[50];
char ATD[4]={'A','T','D','+'};
char noghte[1]={';'};
char a[50];
char text[50];

FRESULT directory_scan(char *path)
{

FILINFO file_info;

DIR directory;
int i;
char y=3;
if ((res=f_opendir(&directory,path))==FR_OK)
{
while (((res=f_readdir(&directory,&file_info))==FR_OK) && file_info.fname[0])
{

SetLetter(E_LETTER);
{SetLine(y,0); FgColor = FgColor; BkColor = BkColor; Puts(path);};          

{SetLine(y,0); FgColor = FgColor; BkColor = BkColor; Puts(file_info.fname);};  

y++;      
if (file_info.fattrib & 0x10	)
{

if (file_info.fname[0]!='.')
{
i=strlen(path);

if (path[i-1]!='/') strcatf(path,"/");
strcat(path,file_info.fname);

res=directory_scan(path);

path[i]=0;

--i;
if (path[i]=='/') path[i]=0;

if (res!=FR_OK) break;
}
}
}
}
return res;
}

axka(){
bmpFile("ka.BMP");
bmpShow(0,160); 
}

axk3(){
bmpFile("k3.BMP");
bmpShow(0,160); 
}              

callt(){
bmpFile("call.BMP");
bmpShow(0,110); 

}  

void wait_to_get(char ch) 
{ 
while(ch != getchar());    
} 

sms(){
printf("AT+CMGF=1%c",Enter);
delay_ms(500);   
printf("%s%",atcmgs);
putchar(double_quote);
printf("%s%",number);
putchar(double_quote);
putchar(Enter);

for(i=0;i<17;i++)a[i]=getchar();

sprintf(buffer,"%s",a);    
SetLetter(E_LETTER);
{SetLine(5,0); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts(a);};                                                 
delay_ms(700); 
printf("%s",text);
putchar(Ctrlz);
SetLetter(P_LETTER);
{SetLine(2,0); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts("  ");};
for (i=0;i<50;i++)kibord[i]=0;  
delay_ms(4000); 
SetLetter(E_LETTER);
TFTFillRect(0, 240, 35, 50, ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);

for (i=0;i<50;i++)kibord[i]=0;  
for (i=0;i<50;i++)text[i]=0;  
for (i=0;i<12;i++)number[i]=0;  

}   

call(){

FontXScale = 1;
SetLetter(P_LETTER);

{SetLine(1,0); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts(" ");};
{SetLine(2,0); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))); BkColor = BkColor; Puts("  ");};

printf("%s",ATD);
printf("%s",number);
putchar(';');
putchar(Enter);

for (i=0;i<50;i++)kibord[i]=0;  
for (i=0;i<12;i++)number[i]=0;  

}

callregect(){

printf("%s",ATH);
putchar(Enter);

}

callconect(){
printf("%s",ATA);
putchar(Enter);
} 

void test01(void);

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (0x40 & 0xff);

delay_us(500);

ADCSRA|=0x40;

while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

tuch(){

DDRA.0=1;        
DDRA.1=0;        
DDRA.2=1;        
DDRA.3=0;        
PORTA.0=0;
PORTA.1=0;
PORTA.2=1;
PORTA.3=0;

yt=read_adc(1);  
yt=yt/4.26;   
itoa(yt,path); 

SetLetter(E_LETTER);
TFTFillRect(0, 130, 0, 50, ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);   
{SetLine(1,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts("y=");};  
{SetLine(1,2); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts(path);};

DDRA.0=0;
DDRA.1=1;
DDRA.2=0;
DDRA.3=1;
PORTA.0=0;
PORTA.1=1;
PORTA.2=0;
PORTA.3=0; 
xt=read_adc(2);
xt=xt/3.19;   
itoa(xt,path);    
{SetLine(0,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts("x=");};  
{SetLine(0,2); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts(path);}; 

}   

key(){

if(nk==1){
if (xt>=144 && xt<=162){
if (yt>=24 && yt<=35)kibord[n]=0x31; 
if (yt>=40 && yt<=53)kibord[n]=0x32; 
if (yt>=59 && yt<=71)kibord[n]=0x33;  
if (yt>=74 && yt<=89)kibord[n]=0x2b;  
if (yt>=91 && yt<=105)kibord[n]=0x70; 
if (yt>=110 && yt<=123)kibord[n]=0x2c; 
if (yt>=129 && yt<=138)kibord[n]=0x2e; 
if (yt>=143 && yt<=157)kibord[n]=0x3a; 
if (yt>=161 && yt<=174)kibord[n]=0x3b; 
if (yt>=178 && yt<=190)kibord[n]=0x3f; 
} 

if (xt>=170 && xt<=185){
if (yt>=24 && yt<=35)kibord[n]=0x34;
if (yt>=40 && yt<=53)kibord[n]=0x35;
if (yt>=59 && yt<=71)kibord[n]=0x36;
if (yt>=74 && yt<=89)kibord[n]=0x23;
if (yt>=91 && yt<=105)kibord[n]=0x77;
if (yt>=110 && yt<=123)kibord[n]=0x2d;
if (yt>=129 && yt<=138)kibord[n]=0x5f;
if (yt>=143 && yt<=157)kibord[n]=0x28;
if (yt>=161 && yt<=174)kibord[n]=0x29;
if (yt>=178 && yt<=190)kibord[n]=0x21;
}            

if (xt>=194 && xt<=212){
if (yt>=24 && yt<=35)kibord[n]=0x37;
if (yt>=40 && yt<=53)kibord[n]=0x38;
if (yt>=59 && yt<=71)kibord[n]=0x39;
if (yt>=74 && yt<=89)kibord[n]=0x30;
if (yt>=91 && yt<=105)kibord[n]=0x2a;
if (yt>=110 && yt<=123)kibord[n]=0x40;
if (yt>=129 && yt<=138)kibord[n]=0x2f;
if (yt>=143 && yt<=157)kibord[n]=0x5c;
if (yt>=161 && yt<=174)kibord[n]=0x60;
if (yt>=178 && yt<=190)kibord[n]=0x26;
}   
}
if(nk==0)
{

if (xt>=144 && xt<=162){
if (yt>=24 && yt<=35)kibord[n]=0x51; 
if (yt>=40 && yt<=53)kibord[n]=0x57; 
if (yt>=59 && yt<=71)kibord[n]=0x45;  
if (yt>=74 && yt<=89)kibord[n]=0x52;  
if (yt>=91 && yt<=105)kibord[n]=0x54; 
if (yt>=110 && yt<=123)kibord[n]=0x59;
if (yt>=129 && yt<=138)kibord[n]=0x55; 
if (yt>=143 && yt<=157)kibord[n]=0x49; 
if (yt>=161 && yt<=174)kibord[n]=0x4f; 
if (yt>=178 && yt<=190)kibord[n]=0x50; 
} 

if (xt>=170 && xt<=185){
if (yt>=24 && yt<=35)kibord[n]=0x41;
if (yt>=40 && yt<=53)kibord[n]=0x53;
if (yt>=59 && yt<=71)kibord[n]=0x44;
if (yt>=74 && yt<=89)kibord[n]=0x46;
if (yt>=91 && yt<=105)kibord[n]=0x47;
if (yt>=110 && yt<=123)kibord[n]=0x48;
if (yt>=129 && yt<=138)kibord[n]=0x4a;
if (yt>=143 && yt<=157)kibord[n]=0x4b;
if (yt>=161 && yt<=174)kibord[n]=0x4c;
if (yt>=178 && yt<=190)kibord[n]=0x22;
}            

if (xt>=194 && xt<=212){
if (yt>=24 && yt<=35)kibord[n]=0x5a;
if (yt>=40 && yt<=53)kibord[n]=0x58;
if (yt>=59 && yt<=71)kibord[n]=0x43;
if (yt>=74 && yt<=89)kibord[n]=0x56;
if (yt>=91 && yt<=105)kibord[n]=0x42;
if (yt>=110 && yt<=123)kibord[n]=0x4e;
if (yt>=129 && yt<=138)kibord[n]=0x4d;
if (yt>=143 && yt<=157)kibord[n]=0x3f;
if (yt>=161 && yt<=174)kibord[n]=0x21;
if (yt>=178 && yt<=190)kibord[n]=0x2f;
}   

}

if (xt>=215 && xt<=234){

if (yt>=40 && yt<=157){
kibord[n]=0x20;
b=0;
}
if (yt>=161 && yt<=190)kibord[n]=0x7f;
}     

if (xt>=240 && xt<=260){  
if (yt>=24 && yt<=46)exit=1; 

if (yt>=53 && yt<=76){
if(nk==0) axka();
if(nk==1) axk3();  
nk=!nk;
}  

if (yt>=172 && yt<=198)v1++;

if (yt>=24 && yt<=35)b=0;
}   

delay_ms(200);
}

void error(FRESULT res)
{
if ((res>=FR_DISK_ERR) && (res<=FR_TIMEOUT)){
sprintf( path,"%p",error_msg[res]);
SetLetter(E_LETTER);
{SetLine(1,1); FgColor = FgColor; BkColor = BkColor; Puts(path);};
}

delay_ms(2000);
}

interrupt [10] void timer_comp_isr(void)
{

TCNT1H=(0x10000L-(16000000/(1024L*10)))>>8;
TCNT1L=(0x10000L-(16000000/(1024L*10)))&0xFF;

disk_timerproc();
}

callky(){

if(xt>=240 && xt<=260)if(yt>=26 && yt<=187)call();

if(yt>=29 && yt<=78){
if(xt>=132 && xt<=152)kibord[n]=0x31; 
if(xt>=157 && xt<=180)kibord[n]=0x34;
if(xt>=182 && xt<=205)kibord[n]=0x37;
if(xt>=208 && xt<=232)kibord[n]=0x2b;  

} 

if(yt>=82 && yt<=136){
if(xt>=132 && xt<=152)kibord[n]=0x32; 
if(xt>=157 && xt<=180)kibord[n]=0x35;
if(xt>=182 && xt<=205)kibord[n]=0x38;
if(xt>=208 && xt<=232)kibord[n]=0x30;
} 

if(yt>=138 && yt<=183){
if(xt>=132 && xt<=152)kibord[n]=0x33;  
if(xt>=157 && xt<=180)kibord[n]=0x36;
if(xt>=182 && xt<=205)kibord[n]=0x39;
if(xt>=208 && xt<=232)kibord[n]=0x23;
} 

if(yt>=160 && yt<=181)if(xt>=110 && xt<=135)kibord[n]=0x7f;

if(yt>=127 && yt<=180){
if(xt>=38 && xt<=49) callregect(); 
if(xt>=50 && xt<=60) callconect(); 
}

if (xt>=255 && xt<=273)if(yt>=34 && yt<=45)exit=1;

delay_ms(100);

}

givecode(){

while(1){

while(kibord[n]==0){
tuch();
if(n1==3)key();
if(n1==8)callky(); 

if(kibord[n]==0x7f){
kibord[n]=0;
kibord[n-1]=0;
if(nu==1){
number[n]=0; 
number[n-1]=0;
}  

if(s==1){
text[n]=0; 
text[n-1]=0;
}
n--; 

if(s==1)TFTFillRect(0, 220, 65, 80, ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL); 
if(nu==1){
if(j==0)TFTFillRect(0, 150, 50, 70, ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);  
if(j==1)TFTFillRect(9, 190, 128, 145, ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL); 
} 

if(s==1){SetLine(v1,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(kibord);}; 
if(nu==1){SetLine(n1,j); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(kibord);};
} 

if(exit==1)break;
}  

if(exit==1){
if(s==1)bsn=n; 
if(nu==1)bnun=n; 
s=0;   
nu=0;  
nk=0;  

TFTFillRect(0, (240-1), 0, (320-1), ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);
exit=0;     
n=0;        
for (i=0;i<50;i++)kibord[i]=0;  
break;   

}  

if(s==1 && exit==0){ 
if(b==1)kibord[n]=tolower(kibord[n]); 
if(kibord[n]==0x20)b=0;
else 
b=1; 
text[n]=kibord[n];
{SetLine(v1,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(kibord);};
n++;
}  

if(nu==1 && exit==0){ 
number[n]=kibord[n];
{SetLine(n1,j); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(kibord);};
n++; 
}         

};  

}           

kd(){

if(xt>=32 && xt<=48)if(yt>=146 && yt<=180)sms();
if (xt>=60 && xt<=80)if(yt>=23 && yt<=190){
axka(); 
nk=1;  
s=0;   
n=bnun; 
nu=1;   
for (i=0;i<50;i++)kibord[i]=0;  
for (i=0;i<12;i++)kibord[i]=number[i];  
kibord[n]=0; 
TFTFillRect(0, 150, 30, 60, ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);
{SetLine(n1,j); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(number);}; 
} 

if (xt>=80 && xt<=134)if(yt>=23 && yt<=190){
axk3();  
nk=0;  
nu=0;  
n=bsn;
s=1;   
for (i=0;i<50;i++)kibord[i]=0;  
for (i=0;i<50;i++)kibord[i]=text[i];  
kibord[n]=0;                 
TFTFillRect(0, 220, 65, 80, ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);
{SetLine(v1,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(text);};
} 

if (xt>=255 && xt<=273)if(yt>=34 && yt<=45)exit=1;

}              

maincall(){
TFTFillRect(0, (240-1), 0, (320-1), ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);
SetLetter(P_LETTER);
{SetLine(0,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(" ");};
s=0;
nu=1;
nk=1;  

callt();

j=1;      
n1=8; 
while(1){

tuch();  
givecode();
callky();
if(exit==1){
exit=0; 
nu==0;
nk==0;
n1=3; 
j=0;
for (i=0;i<50;i++)kibord[i]=0;  
for (i=0;i<12;i++)number[i]=0;  
break;
}                  

};

}

mainsms(){
TFTFillRect(0, (240-1), 0, (320-1), ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);
n1=3; 

while(1){  
SetLetter(P_LETTER);

{SetLine(0,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(" ");}; 
{SetLine(1,0); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(" ");}; 
{SetLine(3,0); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts("");}; 
{SetLine(4,0); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts(" ");}; 

if(s==1 || nu==1)givecode();  
tuch();  
kd();  

if(exit==1){
TFTFillRect(0, (240-1), 0, (320-1), ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);
nu=0;
s=0;
exit=0; 
for (i=0;i<12;i++)number[i]=0;  
for (i=0;i<50;i++)text[i]=0;  
for (i=0;i<50;i++)kibord[i]=0;  
break;
}  

SetLetter(E_LETTER);
{SetLine(n1,j); FgColor = ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))); BkColor = BkColor; Puts(number);};  
{SetLine(v1,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = BkColor; Puts(text);};

};
}

desktop(){
if (xt>=255 && xt<=273){
if(yt>=34 && yt<=45)exit=1;
if(yt>=67 && yt<=87)mainsms();

if (yt>=131 && yt<=151)maincall(); 

}

}  

void main (void)
{
TFTInit();					

UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x06;
UBRRH=0x00;
UBRRL=0x67;

ADMUX=0x40 & 0xff;
ADCSRA=0x83;

TCCR1A=0x00;
TCCR1B=(1<<2       )|(1<<0       );
TCNT1H=(0x10000L-(16000000/(1024L*10)))>>8;
TCNT1L=(0x10000L-(16000000/(1024L*10)))&0xFF;
TIMSK=1<<2       ;	

#asm("sei")

TFTBacklight(1);

Horizontal = 1; 
LcdFont(AF12x16);
FontSpace  = 1;
FontXScale = 1;
FontYScale = 1;
FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 )));
BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 )));
SetLetter(P_LETTER);

TFTFillRect(0, (240-1), 0, (320-1), ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);

DDRB.0=1;
PORTB.0=1;
delay_ms(2000);
PORTB.0=0;
delay_ms(2000);
PORTB.0=1;

if ((res=f_mount(0,&drive))==FR_OK)
{{SetLine(0,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts("  ");};}

else

error(res); 

bmpFile("vv.BMP");
bmpShow(0,0);
delay_ms(4000); 
TFTFillRect(0, (240-1), 0, (320-1), ((unsigned int)( (( 0x00  >> 3 )   << 11 ) | 																															 (( 0x00 >> 2 )   << 5  ) | 																																( 0x00   >> 3 ))), TFT_MODE_NORMAL);	 

while(1){ 
SetLetter(P_LETTER);
{{SetLine(0,0); FgColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); BkColor = ((unsigned int)( (( 0xFF  >> 3 )   << 11 ) | 																															 (( 0xFF >> 2 )   << 5  ) | 																																( 0xFF   >> 3 ))); Puts(" ");};}   

tuch();  
desktop();

};  

} 

