
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32A
;Program type             : Application
;Clock frequency          : 16/000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 358 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : No
;Global 'const' stored in FLASH     : Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : On
;Automatic register allocation      : On

	#pragma AVRPART ADMIN PART_NAME ATmega32A
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2143
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0166
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _res=R4
	.DEF _Enter=R7
	.DEF _double_quote=R6
	.DEF _Ctrlz=R9
	.DEF _Escap=R8
	.DEF _Line_Feed=R11
	.DEF _single_quote=R10
	.DEF _Itemp=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer_comp_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_AF12x16:
	.DB  0xE,0x84,0xC,0x10,0x1,0x0,0xFF,0x5
	.DB  0x6,0x6,0x6,0x4,0x4,0x4,0x8,0x9
	.DB  0x8,0x9,0x8,0x9,0x9,0x9,0xB,0x3
	.DB  0x2,0x5,0x6,0x7,0x7,0x6,0x7,0x7
	.DB  0x5,0xB,0x6,0x4,0x4,0x4,0x4,0x2
	.DB  0x1,0x3,0x8,0x7,0x5,0x8,0x1,0x3
	.DB  0x3,0x7,0x7,0x4,0x6,0x2,0x9,0x6
	.DB  0x5,0x6,0x6,0x6,0x6,0x6,0x6,0x6
	.DB  0x6,0x2,0x4,0x5,0x6,0x5,0x6,0x8
	.DB  0x9,0x7,0x7,0x7,0x7,0x7,0x8,0x9
	.DB  0x5,0x8,0x8,0x7,0x9,0x9,0x7,0x7
	.DB  0x7,0x8,0x7,0x9,0x9,0x9,0x9,0x9
	.DB  0x9,0x7,0x3,0x8,0x3,0x7,0x9,0x2
	.DB  0x7,0x7,0x7,0x7,0x7,0x6,0x7,0x7
	.DB  0x5,0x5,0x7,0x5,0x9,0x7,0x7,0x7
	.DB  0x7,0x8,0x7,0x7,0x7,0x9,0x9,0x7
	.DB  0x9,0x7,0x5,0x1,0x4,0x7,0x7,0x5
	.DB  0x8,0x6,0x5,0x9,0x9,0x7,0x7,0x7
	.DB  0x9,0x9,0x6,0x5,0x8,0x6,0x4,0x9
	.DB  0x6,0x6,0x8,0x9,0x8,0x8,0x9,0x4
	.DB  0x8,0x4,0x6,0x8,0x8,0x9,0x8,0x8
	.DB  0x4,0x4,0x8,0x8,0x7,0x5,0x8,0x6
	.DB  0x9,0x4,0x8,0x4,0x4,0x9,0x4,0x6
	.DB  0x8,0x8,0x9,0x8,0x9,0x9,0x4,0x5
	.DB  0x9,0x4,0x8,0x9,0x9,0x9,0x8,0x4
	.DB  0x4,0x6,0x4,0x7,0x3,0x9,0x1,0x8
	.DB  0x6,0x8,0x8,0x8,0x8,0x8,0x4,0x4
	.DB  0x6,0x6,0xE,0xE,0xF,0xF,0x8,0x8
	.DB  0x8,0x7,0x7,0x3,0xA,0x8,0x8,0x8
	.DB  0x7,0x8,0x6,0x8,0x5,0x6,0x8,0x8
	.DB  0x8,0x8,0x8,0x9,0x9,0x7,0x7,0x6
	.DB  0x7,0x4,0x4,0x8,0x6,0x6,0x8,0x7
	.DB  0x8,0x5,0x8,0x7,0x4,0x9,0x4,0x0
	.DB  0x0,0x0,0x0,0xF8,0x3,0x0,0x4,0x0
	.DB  0x4,0x0,0x0,0xA,0x0,0x5,0x0,0xF5
	.DB  0x3,0x0,0x4,0x0,0x4,0x0,0x0,0x4
	.DB  0x0,0x2,0x0,0xFA,0x3,0x2,0x4,0x1
	.DB  0x4,0x0,0x0,0x0,0x0,0x0,0xA0,0xF8
	.DB  0x53,0x0,0x54,0x0,0x4,0x0,0x4,0x0
	.DB  0x4,0x80,0x24,0x0,0x3,0x0,0x4,0x10
	.DB  0x4,0x80,0x4,0x10,0x3,0x0,0x4,0x10
	.DB  0x4,0x84,0x4,0x10,0x3,0x0,0x4,0x0
	.DB  0x4,0x0,0x5,0x80,0x4,0x80,0x24,0x0
	.DB  0x5,0x0,0x6,0x0,0x4,0x0,0x0,0x80
	.DB  0x1C,0x40,0x22,0x40,0x41,0x40,0x41,0x80
	.DB  0x48,0x80,0x41,0x80,0x42,0x80,0x24,0x0
	.DB  0x4,0x0,0x4,0x0,0x5,0x80,0x4,0x80
	.DB  0x4,0x0,0x5,0x0,0x6,0x0,0x4,0x0
	.DB  0x0,0x80,0x1C,0x40,0x22,0x40,0x41,0x40
	.DB  0x41,0x80,0x40,0x80,0x41,0x80,0x42,0x80
	.DB  0x24,0x0,0x4,0x0,0x4,0x0,0x5,0x90
	.DB  0x4,0x80,0x4,0x0,0x5,0x0,0x6,0x0
	.DB  0x4,0x0,0x0,0x80,0x1C,0x40,0x22,0x48
	.DB  0x41,0x40,0x41,0x80,0x40,0x80,0x41,0x80
	.DB  0x42,0x80,0x24,0x0,0x4,0x0,0x4,0x0
	.DB  0x3,0x0,0x4,0x0,0x4,0x0,0x3,0x0
	.DB  0x4,0x0,0x4,0x0,0x3,0x0,0x4,0x0
	.DB  0x4,0x0,0x3,0x0,0x4,0x20,0x4,0x8
	.DB  0x3,0x20,0x4,0x0,0x4,0x0,0x3,0x0
	.DB  0x4,0x0,0x4,0x0,0x3,0x0,0x4,0x0
	.DB  0x4,0x0,0x6,0x0,0x5,0x80,0x4,0x80
	.DB  0x4,0x80,0x4,0x0,0x3,0x0,0x1,0x80
	.DB  0x3,0x0,0x1,0x30,0x0,0xC0,0x1F,0x30
	.DB  0x0,0xE0,0x0,0x40,0x1F,0x40,0x0,0x30
	.DB  0x0,0x30,0x0,0xE0,0x0,0x40,0x1F,0x30
	.DB  0x0,0x40,0x0,0x30,0x0,0x20,0x0,0xF0
	.DB  0x0,0xE0,0x1F,0x60,0x0,0x90,0x0,0x90
	.DB  0x0,0x40,0x0,0x0,0xE,0x80,0x11,0x50
	.DB  0x10,0x20,0xC,0x40,0x10,0x80,0x11,0x0
	.DB  0xE,0xC0,0x10,0x20,0x9,0x10,0x5,0x10
	.DB  0x3,0x20,0x1,0x80,0x0,0x30,0x0,0xC0
	.DB  0x0,0x0,0x3,0x0,0x1C,0x0,0x3,0xC0
	.DB  0x0,0x30,0x0,0x0,0x18,0x0,0x6,0x80
	.DB  0x1,0x70,0x0,0x80,0x1,0x0,0x6,0x0
	.DB  0x18,0x60,0x0,0x90,0x0,0x90,0x0,0xE0
	.DB  0x7,0x0,0x18,0x0,0x4,0x0,0x4,0x0
	.DB  0x3,0x0,0x4,0x0,0x4,0x0,0x6,0x10
	.DB  0x5,0x80,0x4,0x80,0x4,0x80,0x4,0x0
	.DB  0x3,0x0,0x4,0x80,0x5,0x40,0x6,0x40
	.DB  0x4,0x80,0x4,0x0,0x2,0x0,0x0,0x0
	.DB  0x0,0x80,0x1,0x80,0x1,0x0,0x0,0x0
	.DB  0x0,0x80,0x3,0x40,0x3,0x0,0x0,0x0
	.DB  0x0,0xC0,0x2,0xC0,0x1,0x0,0x0,0x0
	.DB  0x0,0xE0,0x4,0x90,0x4,0x0,0x0,0x0
	.DB  0x0,0xFE,0x5,0x78,0x0,0x0,0x0,0x78
	.DB  0x0,0x0,0x2,0x40,0x1E,0xC0,0x3,0x78
	.DB  0x2,0x40,0x1E,0xC0,0x3,0x78,0x2,0x40
	.DB  0x0,0xC0,0x11,0x20,0x22,0x20,0x22,0x30
	.DB  0x62,0x20,0x22,0x20,0x22,0x40,0x1C,0x6
	.DB  0x6,0x80,0x1,0x60,0x0,0x18,0x0,0x6
	.DB  0x6,0x0,0xE,0x70,0x11,0x88,0x10,0x8
	.DB  0x11,0x8,0x12,0x10,0xC,0x0,0xC,0x0
	.DB  0x12,0x78,0x0,0xC0,0x1F,0x30,0x60,0x8
	.DB  0x80,0x8,0x80,0x30,0x60,0xC0,0x1F,0x80
	.DB  0x0,0xA0,0x2,0xE0,0x3,0xC0,0x1,0xE0
	.DB  0x3,0xA0,0x2,0x80,0x0,0x80,0x0,0x80
	.DB  0x0,0x80,0x0,0xF0,0x7,0x80,0x0,0x80
	.DB  0x0,0x80,0x0,0x0,0x20,0x0,0x38,0x0
	.DB  0x18,0x0,0x8,0x0,0x1,0x0,0x1,0x0
	.DB  0x1,0x0,0x1,0x0,0x1,0x0,0x1,0x0
	.DB  0x18,0x0,0x18,0x0,0x8,0x0,0x4,0x0
	.DB  0x2,0x0,0x1,0x80,0x0,0x40,0x0,0x20
	.DB  0x0,0x10,0x0,0x8,0x0,0xF0,0xF,0x8
	.DB  0x10,0x8,0x10,0x8,0x10,0x8,0x10,0xF0
	.DB  0xF,0x10,0x10,0x10,0x10,0xF8,0x1F,0x0
	.DB  0x10,0x0,0x10,0x10,0x18,0x8,0x14,0x8
	.DB  0x12,0x8,0x11,0x88,0x10,0x70,0x10,0x10
	.DB  0x8,0x8,0x10,0x88,0x10,0x88,0x10,0x88
	.DB  0x10,0x70,0xF,0x0,0x3,0x80,0x2,0x60
	.DB  0x2,0x10,0x12,0xF8,0x1F,0x0,0x12,0xF8
	.DB  0x8,0x88,0x10,0x88,0x10,0x88,0x10,0x88
	.DB  0x10,0x8,0xF,0xE0,0xF,0x10,0x11,0x88
	.DB  0x10,0x88,0x10,0x88,0x10,0x0,0xF,0x18
	.DB  0x0,0x8,0x18,0x8,0x6,0x88,0x1,0x68
	.DB  0x0,0x18,0x0,0x70,0xF,0x88,0x10,0x88
	.DB  0x10,0x88,0x10,0x88,0x10,0x70,0xF,0xF0
	.DB  0x0,0x8,0x11,0x8,0x11,0x8,0x11,0x88
	.DB  0x8,0xF0,0x7,0xC0,0x18,0xC0,0x18,0x0
	.DB  0x20,0xC0,0x38,0xC0,0x18,0x0,0x8,0x0
	.DB  0x1,0x80,0x2,0x40,0x4,0x20,0x8,0x10
	.DB  0x10,0x80,0x2,0x80,0x2,0x80,0x2,0x80
	.DB  0x2,0x80,0x2,0x80,0x2,0x10,0x10,0x20
	.DB  0x8,0x40,0x4,0x80,0x2,0x0,0x1,0x10
	.DB  0x0,0x8,0x0,0x8,0x16,0x8,0x1,0x88
	.DB  0x0,0x70,0x0,0xE0,0xF,0x10,0x10,0x88
	.DB  0x23,0x48,0x24,0x48,0x24,0xC8,0x23,0x10
	.DB  0x24,0xE0,0x3,0x0,0x10,0x0,0x1C,0x88
	.DB  0x13,0x68,0x2,0x18,0x2,0x60,0x2,0x80
	.DB  0x13,0x0,0x1C,0x0,0x10,0x8,0x10,0xF8
	.DB  0x1F,0x88,0x10,0x88,0x10,0x88,0x10,0x88
	.DB  0x10,0x70,0xF,0xE0,0x7,0x10,0x8,0x8
	.DB  0x10,0x8,0x10,0x8,0x10,0x10,0x10,0x78
	.DB  0x8,0x8,0x10,0xF8,0x1F,0x8,0x10,0x8
	.DB  0x10,0x8,0x10,0x10,0x8,0xE0,0x7,0x8
	.DB  0x10,0xF8,0x1F,0x88,0x10,0x88,0x10,0xC8
	.DB  0x11,0x8,0x10,0x18,0x18,0x8,0x10,0xF8
	.DB  0x1F,0x88,0x10,0x88,0x10,0xC8,0x1,0x8
	.DB  0x0,0x18,0x0,0xE0,0x7,0x10,0x8,0x8
	.DB  0x10,0x8,0x10,0x8,0x11,0x10,0x11,0x78
	.DB  0xF,0x0,0x1,0x8,0x10,0xF8,0x1F,0x88
	.DB  0x10,0x80,0x0,0x80,0x0,0x80,0x0,0x88
	.DB  0x10,0xF8,0x1F,0x8,0x10,0x8,0x10,0x8
	.DB  0x10,0xF8,0x1F,0x8,0x10,0x8,0x10,0x0
	.DB  0xC,0x0,0x10,0x0,0x10,0x8,0x10,0x8
	.DB  0x10,0xF8,0xF,0x8,0x0,0x8,0x0,0x8
	.DB  0x10,0xF8,0x1F,0x8,0x11,0x80,0x1,0x68
	.DB  0x2,0x18,0x4,0x8,0x18,0x0,0x10,0x8
	.DB  0x10,0xF8,0x1F,0x8,0x10,0x8,0x10,0x0
	.DB  0x10,0x0,0x10,0x0,0x18,0x8,0x10,0xF8
	.DB  0x1F,0x60,0x10,0x80,0x1,0x0,0x6,0x80
	.DB  0x1,0x60,0x10,0xF8,0x1F,0x8,0x10,0x8
	.DB  0x10,0xF8,0x1F,0x20,0x10,0xC0,0x10,0x0
	.DB  0x1,0x8,0x6,0x8,0x8,0xF8,0x1F,0x8
	.DB  0x0,0xE0,0x7,0x10,0x8,0x8,0x10,0x8
	.DB  0x10,0x8,0x10,0x10,0x8,0xE0,0x7,0x8
	.DB  0x10,0xF8,0x1F,0x8,0x11,0x8,0x11,0x8
	.DB  0x1,0x8,0x1,0xF0,0x0,0xE0,0x7,0x10
	.DB  0x48,0x8,0x50,0x8,0x30,0x8,0x30,0x10
	.DB  0x48,0xE0,0x47,0x8,0x10,0xF8,0x1F,0x8
	.DB  0x11,0x8,0x1,0x8,0x3,0x8,0x5,0xF0
	.DB  0x18,0x0,0x10,0x70,0x1C,0x88,0x8,0x88
	.DB  0x10,0x88,0x10,0x8,0x11,0x10,0x11,0x38
	.DB  0xE,0x18,0x0,0x8,0x0,0x8,0x10,0x8
	.DB  0x10,0xF8,0x1F,0x8,0x10,0x8,0x10,0x8
	.DB  0x0,0x18,0x0,0x8,0x0,0xF8,0xF,0x8
	.DB  0x8,0x0,0x10,0x0,0x10,0x0,0x10,0x8
	.DB  0x8,0xF8,0xF,0x8,0x0,0x8,0x0,0x38
	.DB  0x0,0xC8,0x1,0x0,0x6,0x0,0x18,0x0
	.DB  0x6,0xC8,0x1,0x38,0x0,0x8,0x0,0x78
	.DB  0x0,0x88,0x3,0x0,0x1C,0x80,0x3,0x60
	.DB  0x0,0x80,0x3,0x0,0x1C,0x88,0x3,0x78
	.DB  0x0,0x8,0x10,0x18,0x18,0x28,0x14,0x40
	.DB  0x2,0x80,0x1,0x40,0x2,0x28,0x14,0x18
	.DB  0x18,0x8,0x10,0x8,0x0,0x18,0x0,0x68
	.DB  0x10,0x80,0x10,0x0,0x1F,0x80,0x10,0x68
	.DB  0x10,0x18,0x0,0x8,0x0,0x18,0x18,0x8
	.DB  0x14,0x8,0x12,0x88,0x11,0x48,0x10,0x28
	.DB  0x10,0x18,0x18,0xFE,0x3F,0x2,0x20,0x2
	.DB  0x20,0x10,0x0,0x20,0x0,0x40,0x0,0x80
	.DB  0x0,0x0,0x1,0x0,0x2,0x0,0x4,0x0
	.DB  0x8,0x2,0x20,0x2,0x20,0xFE,0x3F,0x40
	.DB  0x0,0x20,0x0,0x10,0x0,0x8,0x0,0x10
	.DB  0x0,0x20,0x0,0x40,0x0,0x0,0x40,0x0
	.DB  0x40,0x0,0x40,0x0,0x40,0x0,0x40,0x0
	.DB  0x40,0x0,0x40,0x0,0x40,0x0,0x40,0x8
	.DB  0x0,0x10,0x0,0x0,0xE,0x40,0x11,0x40
	.DB  0x11,0x40,0x11,0x40,0x11,0x80,0xF,0x0
	.DB  0x10,0x8,0x10,0xF8,0x1F,0x80,0x8,0x40
	.DB  0x10,0x40,0x10,0x80,0x8,0x0,0x7,0x0
	.DB  0x7,0x80,0x8,0x40,0x10,0x40,0x10,0x40
	.DB  0x10,0x80,0x8,0xC0,0x8,0x0,0x7,0x80
	.DB  0x8,0x40,0x10,0x40,0x10,0x88,0x8,0xF8
	.DB  0x1F,0x0,0x10,0x0,0x7,0x80,0xA,0x40
	.DB  0x12,0x40,0x12,0x40,0x12,0x80,0xA,0x0
	.DB  0xB,0x80,0x10,0xF0,0x1F,0x88,0x10,0x88
	.DB  0x10,0x8,0x0,0x10,0x0,0x0,0x63,0x80
	.DB  0x84,0x40,0x88,0x40,0x88,0x80,0x84,0xC0
	.DB  0x7F,0x40,0x0,0x8,0x10,0xF8,0x1F,0x80
	.DB  0x10,0x40,0x0,0x40,0x10,0x80,0x1F,0x0
	.DB  0x10,0x40,0x10,0x40,0x10,0xC8,0x1F,0x0
	.DB  0x10,0x0,0x10,0x0,0x40,0x0,0x80,0x40
	.DB  0x80,0x40,0x80,0xC8,0x7F,0x8,0x10,0xF8
	.DB  0x1F,0x8,0x12,0x8,0x3,0xC0,0x14,0x40
	.DB  0x18,0x40,0x10,0x8,0x10,0x8,0x10,0xF8
	.DB  0x1F,0x0,0x10,0x0,0x10,0x40,0x10,0xC0
	.DB  0x1F,0x80,0x10,0x40,0x0,0xC0,0x1F,0x80
	.DB  0x10,0x40,0x0,0xC0,0x1F,0x0,0x10,0x40
	.DB  0x10,0xC0,0x1F,0x80,0x10,0x40,0x0,0x40
	.DB  0x10,0x80,0x1F,0x0,0x10,0x0,0x7,0x80
	.DB  0x8,0x40,0x10,0x40,0x10,0x40,0x10,0x80
	.DB  0x8,0x0,0x7,0x40,0x80,0xC0,0xFF,0x80
	.DB  0x88,0x40,0x90,0x40,0x10,0x80,0x8,0x0
	.DB  0x7,0x0,0x7,0x80,0x8,0x40,0x10,0x40
	.DB  0x90,0x80,0x88,0xC0,0xFF,0x40,0x80,0x40
	.DB  0x10,0x40,0x10,0xC0,0x1F,0x80,0x10,0x40
	.DB  0x10,0x40,0x0,0x40,0x0,0x80,0x0,0x80
	.DB  0x9,0x40,0x12,0x40,0x12,0x40,0x12,0x40
	.DB  0x12,0x40,0x12,0x80,0xC,0x40,0x0,0x40
	.DB  0x0,0xF0,0xF,0x40,0x10,0x40,0x10,0x40
	.DB  0x10,0x0,0x8,0x40,0x0,0xC0,0xF,0x0
	.DB  0x10,0x0,0x10,0x40,0x8,0xC0,0x1F,0x0
	.DB  0x10,0x40,0x0,0xC0,0x0,0x40,0x3,0x0
	.DB  0xC,0x0,0x10,0x0,0xC,0x40,0x3,0xC0
	.DB  0x0,0x40,0x0,0x40,0x0,0xC0,0xF,0x40
	.DB  0x18,0x0,0x7,0xC0,0x0,0x0,0x7,0x40
	.DB  0x18,0xC0,0x7,0x40,0x0,0x40,0x10,0xC0
	.DB  0x18,0x40,0x15,0x0,0x2,0x40,0x15,0xC0
	.DB  0x18,0x40,0x10,0x40,0x0,0xC0,0x80,0x40
	.DB  0x83,0x0,0x4C,0x0,0x30,0x0,0xC,0x40
	.DB  0x3,0xC0,0x0,0x40,0x0,0xC0,0x10,0x40
	.DB  0x18,0x40,0x14,0x40,0x12,0x40,0x11,0xC0
	.DB  0x10,0x40,0x18,0x0,0x2,0x0,0x2,0xF0
	.DB  0x7D,0x8,0x80,0x8,0x80,0xF8,0xFF,0x8
	.DB  0x80,0x8,0x80,0xF0,0x7D,0x0,0x2,0x30
	.DB  0x0,0x8,0x0,0x8,0x0,0x10,0x0,0x20
	.DB  0x0,0x20,0x0,0x18,0x0,0x0,0x0,0x0
	.DB  0x1C,0x80,0x22,0x48,0x41,0x40,0x41,0xC0
	.DB  0x42,0x0,0x44,0x0,0x4,0x80,0x4,0x48
	.DB  0x5,0x40,0x6,0x80,0x3,0x0,0x3,0x80
	.DB  0x4,0x0,0x14,0x0,0x44,0x0,0x14,0x0
	.DB  0x4,0x0,0x4,0x0,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x20,0x0,0x38,0x0,0x18,0x0
	.DB  0x8,0x0,0x4,0x88,0x4,0x40,0x5,0x48
	.DB  0x6,0x80,0x3,0x0,0x0,0x0,0x20,0x0
	.DB  0x38,0x0,0x18,0x0,0x8,0x0,0x20,0x0
	.DB  0x38,0x0,0x18,0x0,0x8,0x0,0x0,0x0
	.DB  0x18,0x0,0x18,0x0,0x0,0x0,0x18,0x0
	.DB  0x18,0x0,0x0,0x0,0x18,0x0,0x18,0x0
	.DB  0x0,0x0,0x0,0x20,0x0,0x20,0x0,0xF8
	.DB  0x3F,0x20,0x0,0x20,0x0,0x0,0x0,0x0
	.DB  0x0,0x20,0x8,0x20,0x8,0xF8,0x3F,0x20
	.DB  0x8,0x20,0x8,0x0,0x0,0x0,0x0,0x10
	.DB  0x0,0x8,0x0,0x4,0x0,0x8,0x0,0x10
	.DB  0x0,0x30,0xC,0x48,0x2,0x30,0x1,0x80
	.DB  0xC,0x40,0x12,0x20,0xC,0x18,0xC,0x0
	.DB  0x12,0x0,0xC,0x0,0x4,0x0,0x4,0x0
	.DB  0x3,0x0,0x4,0x0,0x4,0x0,0x3,0x0
	.DB  0x4,0x0,0x4,0x0,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x1,0x80,0x2,0x40,0x4,0x20
	.DB  0x8,0x0,0x4,0x60,0x4,0x50,0x4,0x90
	.DB  0x4,0x8,0x3,0x80,0x1C,0x40,0x22,0x40
	.DB  0x41,0x40,0x45,0x80,0x50,0x80,0x44,0x80
	.DB  0x40,0x80,0x20,0x0,0x20,0x0,0x20,0x0
	.DB  0x10,0x20,0x10,0x8,0x8,0x20,0x7,0x0
	.DB  0x0,0x0,0x0,0x8,0x0,0x10,0x0,0x0
	.DB  0x0,0x0,0x3,0x80,0x4,0x0,0x4,0x0
	.DB  0x4,0x64,0x4,0x52,0x4,0x92,0x4,0x9
	.DB  0x3,0x0,0x0,0x0,0x0,0x20,0x0,0x30
	.DB  0x0,0x38,0x0,0x8,0x0,0x0,0x0,0x0
	.DB  0x0,0x20,0x0,0x38,0x0,0x18,0x0,0x8
	.DB  0x0,0x20,0x0,0x30,0x0,0x38,0x0,0x8
	.DB  0x0,0x20,0x0,0x30,0x0,0x38,0x0,0x8
	.DB  0x0,0x0,0x0,0x20,0x0,0x38,0x0,0x18
	.DB  0x0,0x8,0x0,0x20,0x0,0x38,0x0,0x18
	.DB  0x0,0x8,0x0,0x0,0x4,0x0,0x4,0x0
	.DB  0x4,0x0,0xF,0x80,0x14,0x40,0x32,0x80
	.DB  0x29,0x0,0x4,0x0,0x0,0x0,0x1,0x0
	.DB  0x1,0x0,0x1,0x0,0x1,0x0,0x1,0x0
	.DB  0x1,0x0,0x1,0x0,0x0,0x0,0x1,0x0
	.DB  0x1,0x0,0x1,0x0,0x1,0x0,0x1,0x0
	.DB  0x1,0x0,0x1,0x0,0x1,0x0,0x0,0x0
	.DB  0x0,0x8,0x0,0x10,0x0,0x0,0x0,0x8
	.DB  0x0,0x38,0x0,0x8,0x0,0x38,0x0,0x10
	.DB  0x0,0x10,0x0,0x38,0x0,0x0,0x0,0x0
	.DB  0x0,0x8,0x0,0x10,0x0,0x0,0x0,0x0
	.DB  0x0,0x20,0x8,0x40,0x4,0x80,0x2,0x0
	.DB  0x1,0x0,0x38,0x0,0x44,0x0,0x40,0x0
	.DB  0x40,0x0,0x48,0x0,0x54,0x0,0x54,0x0
	.DB  0x34,0x0,0x4,0x0,0x4,0x0,0x15,0x80
	.DB  0x44,0x80,0x14,0x0,0x5,0x0,0x6,0x0
	.DB  0x4,0x0,0x0,0x80,0x1C,0x40,0x22,0x40
	.DB  0x41,0x40,0x45,0x80,0x50,0x80,0x45,0x80
	.DB  0x42,0x80,0x24,0x0,0x0,0x8,0x0,0x10
	.DB  0x4,0x20,0x4,0x40,0x2,0x80,0x1,0xF8
	.DB  0x3,0x0,0x4,0x0,0x38,0x0,0x44,0x0
	.DB  0x40,0x0,0xC0,0x0,0x48,0x0,0xD4,0x0
	.DB  0x54,0x0,0x34,0x0,0x0,0x0,0x0,0x80
	.DB  0x3,0x40,0x3,0x0,0x4,0x14,0x4,0x8A
	.DB  0x4,0xA,0x3,0x0,0x0,0x0,0x0,0x70
	.DB  0x11,0x88,0x1F,0x8,0x11,0x8,0x11,0x30
	.DB  0x10,0x0,0x10,0x0,0x0,0x0,0x0,0x8
	.DB  0x1,0xF0,0x0,0x90,0x0,0x90,0x0,0xF0
	.DB  0x0,0x8,0x1,0x0,0x0,0x8,0x0,0x10
	.DB  0x0,0x20,0xC,0x40,0xA,0x80,0x9,0xF8
	.DB  0xE,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0xF8,0xF8,0x0,0x0,0xC0,0x30,0x30
	.DB  0x21,0x28,0x22,0x48,0x24,0x88,0x28,0x8
	.DB  0x19,0x18,0x6,0x0,0x0,0x0,0x0,0x8
	.DB  0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x0
	.DB  0x0,0xF0,0x3,0x8,0x4,0xE4,0x9,0x14
	.DB  0xA,0x14,0xA,0x24,0x9,0x8,0x4,0xF0
	.DB  0x3,0x0,0x0,0x0,0x0,0x8,0x0,0x10
	.DB  0x0,0x0,0x0,0x40,0x0,0xA0,0x0,0x10
	.DB  0x1,0x48,0x2,0xA0,0x0,0x10,0x1,0x8
	.DB  0x2,0x18,0x0,0x12,0x0,0x9,0x0,0xC
	.DB  0x0,0x1A,0x0,0x13,0x0,0x9,0x0,0xC
	.DB  0x0,0x0,0x0,0xF0,0x3,0x8,0x4,0xF4
	.DB  0xB,0x94,0x8,0x94,0x8,0x64,0xB,0x8
	.DB  0x4,0xF0,0x3,0x6,0x0,0x14,0x0,0xA
	.DB  0x0,0xB,0x0,0x0,0x0,0x0,0x0,0x30
	.DB  0x0,0x48,0x0,0x48,0x0,0x30,0x0,0x0
	.DB  0x0,0x80,0x10,0x80,0x10,0x80,0x10,0xF0
	.DB  0x17,0x80,0x10,0x80,0x10,0x80,0x10,0x0
	.DB  0x0,0xA,0x0,0x5,0x0,0x15,0x0,0x24
	.DB  0xC,0x40,0xA,0x80,0x9,0xF8,0xE,0x0
	.DB  0x0,0xA,0x0,0x5,0x0,0x15,0x4,0x24
	.DB  0x4,0x40,0x2,0x80,0x1,0xF8,0x3,0x0
	.DB  0x4,0x4,0x0,0x2,0x0,0xA,0x0,0x12
	.DB  0x0,0x21,0xC,0x40,0xA,0x80,0x9,0xFC
	.DB  0xE,0x0,0x0,0x0,0x38,0x80,0x44,0x60
	.DB  0x40,0x50,0x40,0x50,0x48,0x0,0x54,0x0
	.DB  0x54,0x0,0x34,0x0,0x0,0xF0,0x0,0xF8
	.DB  0x1,0x18,0x1,0x18,0x10,0xF8,0x1F,0x18
	.DB  0x0,0xF8,0x1F,0x18,0x10,0x0,0x0,0x0
	.DB  0x0,0x0,0x3,0x0,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x80,0x0,0xA0,0x0,0x40,0x4
	.DB  0x0,0x2,0x0,0xA,0x0,0x12,0x4,0x21
	.DB  0x4,0x40,0x2,0x80,0x1,0xF8,0x3,0x0
	.DB  0x4,0x0,0x0,0x0,0x0,0xE0,0x4,0x90
	.DB  0x4,0x0,0x0,0x8,0x2,0x10,0x1,0xA0
	.DB  0x0,0x48,0x2,0x10,0x1,0xA0,0x0,0x40
	.DB  0x0,0x0,0x0,0x10,0x8,0xF8,0x5,0x0
	.DB  0x2,0x0,0xD,0x80,0xA,0x40,0x9,0xA0
	.DB  0x1F,0x10,0x8,0x0,0x0,0x10,0x8,0xF8
	.DB  0x5,0x0,0x2,0x0,0x1,0x80,0x11,0xC0
	.DB  0x18,0xA0,0x14,0x10,0x13,0x0,0x0,0x90
	.DB  0x8,0x8,0x5,0x28,0x3,0xD0,0xD,0x80
	.DB  0xA,0x40,0x9,0xA0,0x1F,0x10,0x8,0x0
	.DB  0x0,0x0,0x0,0x70,0x0,0x88,0x0,0x8
	.DB  0x1,0x8,0x16,0x8,0x0,0x30,0x0,0x0
	.DB  0x4,0x0,0x24,0x80,0x4,0x0,0x23,0x0
	.DB  0x5,0x80,0x6,0x80,0x2,0x0,0x2,0x0
	.DB  0x0,0x4,0x0,0x2,0x0,0xFA,0x7,0x2
	.DB  0x0,0x1,0x0,0x0,0x0,0xA,0x0,0x5
	.DB  0x0,0xF5,0x7,0x0,0x0,0x0,0x40,0x50
	.DB  0x40,0x28,0x23,0xA8,0x24,0x80,0x14,0x0
	.DB  0xF,0x0,0xA0,0xF8,0x57,0x0,0x50,0x0
	.DB  0x1E,0x28,0x21,0x14,0x20,0x14,0x20,0x0
	.DB  0x20,0x0,0x26,0x0,0x15,0x80,0xC,0x80
	.DB  0x0,0xF8,0x7,0x0,0x3,0x80,0x4,0x0
	.DB  0x4,0x0,0x24,0x0,0x4,0x0,0x4,0x0
	.DB  0x4,0x0,0x3,0x0,0x0,0x88,0x3,0x40
	.DB  0x4,0x48,0x4,0x80,0x4,0x0,0x3,0x0
	.DB  0x3,0x80,0x4,0x0,0x4,0x20,0x4,0x0
	.DB  0x4,0x20,0x4,0x0,0x4,0x0,0x3,0x0
	.DB  0x3,0x80,0x4,0x0,0x4,0x20,0x4,0x8
	.DB  0x4,0x20,0x4,0x0,0x4,0x0,0x3,0x80
	.DB  0x1C,0x40,0x22,0x40,0x41,0x40,0x41,0x80
	.DB  0x48,0x80,0x40,0x80,0x40,0x80,0x20,0x80
	.DB  0x1C,0x40,0x22,0x40,0x41,0x40,0x41,0x80
	.DB  0x40,0x80,0x40,0x80,0x40,0x80,0x20,0x80
	.DB  0x1C,0x40,0x22,0x48,0x41,0x40,0x41,0x80
	.DB  0x40,0x80,0x40,0x80,0x40,0x80,0x20,0x0
	.DB  0x4,0x40,0x4,0x80,0x4,0x0,0x3,0x0
	.DB  0x4,0x48,0x4,0x80,0x4,0x0,0x3,0x0
	.DB  0x20,0x0,0x20,0x0,0x10,0x0,0x10,0x0
	.DB  0x8,0x0,0x7,0x0,0x20,0x0,0x20,0x0
	.DB  0x10,0x0,0x10,0x20,0x8,0x0,0x7,0x0
	.DB  0x1C,0x0,0x22,0x0,0x40,0x0,0x40,0x0
	.DB  0x40,0x0,0x40,0x0,0x23,0x0,0x1C,0x0
	.DB  0x4,0x0,0x4,0x0,0x3,0x0,0x4,0x0
	.DB  0x4,0x0,0x3,0x0,0x1C,0x0,0x22,0x0
	.DB  0x40,0x0,0x40,0x0,0x40,0x0,0x40,0x0
	.DB  0x23,0x0,0x1C,0x0,0x4,0x20,0x4,0x8
	.DB  0x3,0x20,0x4,0x0,0x4,0x0,0x3,0x0
	.DB  0x1C,0x0,0x22,0x0,0x40,0x0,0x40,0x0
	.DB  0x40,0x0,0x40,0x0,0x23,0x0,0x1C,0x0
	.DB  0x4,0x0,0x6,0x0,0x5,0x80,0x4,0x80
	.DB  0x4,0x80,0x4,0x0,0x3,0x0,0x1C,0x0
	.DB  0x22,0x0,0x40,0x0,0x40,0x0,0x40,0x0
	.DB  0x40,0x0,0x23,0x0,0x1C,0x0,0x4,0x0
	.DB  0x6,0x10,0x5,0x80,0x4,0x80,0x4,0x80
	.DB  0x4,0x0,0x3,0x0,0x0,0x20,0x8,0x40
	.DB  0x4,0x80,0x2,0x0,0x1,0x80,0x2,0x40
	.DB  0x4,0x20,0x8,0x0,0x4,0x0,0x4,0xF8
	.DB  0x7,0x0,0x6,0x0,0x5,0x80,0x4,0x80
	.DB  0x4,0x0,0x3,0x0,0x4,0x0,0x4,0xF8
	.DB  0x7,0x0,0x6,0x0,0x5,0x90,0x4,0x80
	.DB  0x4,0x0,0x3,0xC0,0x1C,0x20,0x23,0x20
	.DB  0x41,0x0,0x41,0x80,0x40,0x0,0x40,0x0
	.DB  0x20,0xC0,0x1C,0x24,0x23,0x20,0x41,0x0
	.DB  0x41,0x80,0x40,0x0,0x40,0x0,0x20,0x0
	.DB  0x4,0x0,0x4,0x0,0x4,0x0,0x3,0x80
	.DB  0x4,0x0,0x4,0x0,0x4,0x0,0x4,0x0
	.DB  0x4,0x80,0x4,0x48,0x5,0x40,0x6,0x80
	.DB  0x3,0x0,0x1C,0x0,0x22,0x0,0x40,0x0
	.DB  0x40,0x10,0x43,0x80,0x44,0x90,0x24,0x0
	.DB  0x1F,0x0,0x3,0x80,0x4,0x0,0x4,0x0
	.DB  0x4,0x60,0x4,0x50,0x4,0x90,0x4,0x8
	.DB  0x3,0x0,0x0,0x0,0xE,0x40,0x11,0x48
	.DB  0x11,0x50,0x11,0x40,0x11,0x80,0xF,0x0
	.DB  0x10,0x0,0xE,0x0,0x11,0x0,0x10,0x0
	.DB  0x10,0x0,0x10,0x0,0x8,0xF8,0x7,0x0
	.DB  0x0,0x0,0xE,0x40,0x11,0x50,0x11,0x48
	.DB  0x11,0x50,0x11,0x80,0xF,0x0,0x10,0x0
	.DB  0xF8,0x0,0x4,0x0,0x7,0x80,0x4,0x80
	.DB  0x4,0x0,0x3,0x0,0x1C,0x0,0x22,0x0
	.DB  0x40,0x40,0x40,0x0,0x40,0x0,0x40,0x0
	.DB  0x21,0x0,0x1E,0x80,0x3,0x40,0x4,0x40
	.DB  0x4,0x80,0x4,0x0,0x3,0x0,0x40,0x0
	.DB  0x40,0x0,0x23,0x80,0x24,0x80,0x14,0x0
	.DB  0xF,0x0,0x0,0x0,0x1,0x80,0x2,0x80
	.DB  0x2,0x60,0x2,0x80,0x1,0x0,0x2,0x0
	.DB  0x4,0x0,0x0,0x14,0x1,0x8A,0x2,0x8A
	.DB  0x2,0x68,0x2,0x80,0x1,0x0,0x2,0x0
	.DB  0x4,0x0,0x0,0x0,0x1,0x84,0x2,0x80
	.DB  0x2,0x64,0x2,0x80,0x1,0x0,0x2,0x0
	.DB  0x4,0x0,0x0,0x0,0x7,0x80,0xA,0x50
	.DB  0x12,0x48,0x12,0x50,0x12,0x80,0xA,0x0
	.DB  0xB,0x0,0x0,0x0,0x7,0x88,0xA,0x40
	.DB  0x12,0x40,0x12,0x40,0x12,0x88,0xA,0x0
	.DB  0xB,0x0,0x1E,0x0,0x21,0x0,0xA0,0x0
	.DB  0x20,0x0,0xA0,0x0,0x26,0x0,0x15,0x80
	.DB  0xC,0x80,0x0,0x0,0x1E,0x0,0x21,0x0
	.DB  0x20,0x0,0x20,0x0,0x20,0x0,0x26,0x0
	.DB  0x15,0x80,0xC,0x80,0x0,0x0,0x0,0x0
	.DB  0x0,0x40,0x10,0x50,0x10,0xC8,0x1F,0x10
	.DB  0x10,0x0,0x10,0x0,0x0,0x0,0x0,0x48
	.DB  0x10,0x40,0x10,0xC0,0x1F,0x8,0x10,0x0
	.DB  0x10,0x0,0x4,0x0,0x4,0x0,0x5,0x80
	.DB  0x6,0x80,0x6,0x80,0x5,0x0,0x0,0x0
	.DB  0x1C,0x80,0x22,0x40,0x41,0x40,0x41,0xC0
	.DB  0x42,0x0,0x44,0x0,0x4,0x0,0x4,0x90
	.DB  0x4,0x0,0x3,0x0,0x4,0x0,0x4,0x0
	.DB  0x4,0xF8,0x3,0x0,0x0,0x0,0x7,0x80
	.DB  0x8,0x50,0x10,0x48,0x10,0x50,0x10,0x80
	.DB  0x8,0x0,0x7,0x0,0x4,0x80,0x5,0x48
	.DB  0x6,0x40,0x4,0x80,0x4,0x0,0x2,0x0
	.DB  0x4,0x0,0x4,0x0,0x5,0x80,0x6,0x90
	.DB  0x6,0x80,0x5,0x0,0x0,0x40,0x0,0x40
	.DB  0x0,0x40,0x0,0x48,0x2,0x40,0x0,0x40
	.DB  0x0,0x40,0x0,0x0,0x4,0x0,0x4,0x0
	.DB  0x2,0x0,0x3,0x80,0x4,0x80,0x4,0x0
	.DB  0x3,0x0,0x0,0x40,0x0,0xC0,0xF,0x8
	.DB  0x10,0x10,0x10,0x40,0x8,0xC0,0x1F,0x0
	.DB  0x10,0x0,0x4,0x64,0x4,0x52,0x4,0x92
	.DB  0x4,0x9,0x3,0x0,0x0,0x40,0x0,0xC0
	.DB  0xF,0x10,0x10,0x8,0x10,0x50,0x8,0xC0
	.DB  0x1F,0x0,0x10,0x0,0x0,0x8,0xA0,0x10
	.DB  0x50,0x20,0x5C,0x40,0x4A,0x80,0x9,0xF8
	.DB  0xE,0x0,0x4,0x0,0x14,0x80,0x44,0x0
	.DB  0x13,0x0,0x4,0x0,0x4,0x0,0x4,0x80
	.DB  0x5,0x50,0x6,0x20,0x3,0xC0,0x4,0x80
	.DB  0x4,0x0,0x3,0x0,0x0,0x0,0x0,0x8
	.DB  0x0,0x10,0x0,0x0
_error_msg:
	.DB  LOW(_0x0*2),HIGH(_0x0*2),LOW(_0x0*2+16),HIGH(_0x0*2+16),LOW(_0x0*2+28),HIGH(_0x0*2+28),LOW(_0x0*2+28),HIGH(_0x0*2+28)
	.DB  LOW(_0x0*2+39),HIGH(_0x0*2+39),LOW(_0x0*2+52),HIGH(_0x0*2+52),LOW(_0x0*2+63),HIGH(_0x0*2+63),LOW(_0x0*2+74),HIGH(_0x0*2+74)
	.DB  LOW(_0x0*2+90),HIGH(_0x0*2+90),LOW(_0x0*2+100),HIGH(_0x0*2+100),LOW(_0x0*2+109),HIGH(_0x0*2+109),LOW(_0x0*2+127),HIGH(_0x0*2+127)
	.DB  LOW(_0x0*2+146),HIGH(_0x0*2+146),LOW(_0x0*2+163),HIGH(_0x0*2+163),LOW(_0x0*2+178),HIGH(_0x0*2+178),LOW(_0x0*2+195),HIGH(_0x0*2+195)
	.DB  LOW(_0x0*2+211),HIGH(_0x0*2+211)
_PEmap:
	.DB  0xC1,0xC1,0xC1,0xC1,0x0,0x0,0xC2,0xC2
	.DB  0x2,0x2,0x1,0x0,0xC3,0xC3,0x1,0x1
	.DB  0x1,0x0,0xC4,0xC4,0xC4,0xC4,0x0,0x0
	.DB  0xC5,0xC5,0x3,0x3,0x1,0x0,0xC6,0xC6
	.DB  0xC6,0xC6,0x0,0x0,0xC7,0xC7,0x0,0x0
	.DB  0x1,0x0,0xC8,0x4,0xC8,0x4,0x1,0x1
	.DB  0xC9,0xFE,0xE9,0x95,0x1,0x1,0xCA,0x5
	.DB  0xCA,0x5,0x1,0x1,0xCB,0x6,0xCB,0x6
	.DB  0x1,0x1,0xCC,0x7,0x8,0x7,0x1,0x1
	.DB  0xCD,0x9,0xA,0x9,0x1,0x1,0xCE,0xB
	.DB  0xC,0xB,0x1,0x1,0xCF,0xCF,0xCF,0xCF
	.DB  0x1,0x0,0xD0,0xD0,0xD0,0xD0,0x1,0x0
	.DB  0xD1,0xD1,0xD1,0xD1,0x1,0x0,0xD2,0xD2
	.DB  0xD2,0xD2,0x1,0x0,0xD3,0x8A,0xD3,0x8A
	.DB  0x1,0x1,0xD4,0xE,0xD4,0xE,0x1,0x1
	.DB  0xD5,0xF,0xD5,0xF,0x1,0x1,0xD6,0x1A
	.DB  0xD6,0x1A,0x1,0x1,0xD7,0xD7,0xD7,0xD7
	.DB  0x0,0x0,0xD8,0xD8,0xD8,0xD8,0x1,0x1
	.DB  0xD9,0xD9,0xD9,0xD9,0x1,0x1,0xDA,0x1B
	.DB  0xF1,0xF0,0x1,0x1,0xDB,0xF5,0x7F,0xF6
	.DB  0x1,0x1,0xDC,0xDC,0xDC,0xDC,0x1,0x1
	.DB  0xDD,0x80,0xDD,0x80,0x1,0x1,0xDE,0x83
	.DB  0xDE,0x83,0x1,0x1,0xDF,0x8C,0xDF,0x8C
	.DB  0x1,0x1,0xE0,0xE0,0xE0,0xE0,0x0,0x0
	.DB  0xE1,0xF3,0xE1,0xF3,0x1,0x1,0xE2,0xE2
	.DB  0xE2,0xE2,0x0,0x0,0xE3,0xF8,0xE3,0xF8
	.DB  0x1,0x1,0xE4,0xF2,0xE4,0xF2,0x1,0x1
	.DB  0xE5,0xFE,0xE7,0x95,0x1,0x1,0xE6,0xE6
	.DB  0xE6,0xE6,0x1,0x0,0xE7,0xE7,0xE7,0xE7
	.DB  0x0,0x0,0xE8,0xE8,0xE8,0xE8,0x0,0x0
	.DB  0xE9,0xE9,0xE9,0xE9,0x0,0x0,0x81,0xFD
	.DB  0x81,0xFD,0x1,0x1,0x8D,0x9D,0x9E,0x9D
	.DB  0x1,0x1,0xEC,0xC0,0xA0,0xC0,0x1,0x1
	.DB  0xED,0xC0,0x9C,0xC0,0x1,0x1,0x8E,0x8E
	.DB  0x8E,0x8E,0x1,0x0,0x90,0xFA,0x90,0xFA
	.DB  0x1,0x1,0xF0,0xF0,0xF0,0xF0,0x0,0x0
	.DB  0xF1,0xF1,0xF1,0xF1,0x0,0x0,0xF2,0xF2
	.DB  0xF2,0xF2,0x0,0x0,0xF3,0xF3,0xF3,0xF3
	.DB  0x0,0x0,0xF4,0xF4,0xF4,0xF4,0x0,0x0
	.DB  0xF5,0xF5,0xF5,0xF5,0x0,0x0,0xF6,0xF6
	.DB  0xF6,0xF6,0x0,0x0,0xF7,0xF7,0xF7,0xF7
	.DB  0x0,0x0,0xF8,0xF8,0xF8,0xF8,0x0,0x0
	.DB  0xF9,0xF9,0xF9,0xF9,0x0,0x0,0xFA,0xFA
	.DB  0xFA,0xFA,0x0,0x0,0xA5,0xA5,0x9F,0x9F
	.DB  0x1,0x0,0xFC,0xFC,0xFC,0xFC,0x0,0x0
	.DB  0xFD,0xFD,0xFD,0xFD,0x0,0x0,0xFE,0xFE
	.DB  0xFE,0xFE,0x0,0x0,0xFF,0xFF,0xFF,0xFF
	.DB  0x0,0x0
_k1:
	.DB  0x20,0x22,0x2A,0x2B,0x2C,0x5B,0x3D,0x5D
	.DB  0x7C,0x7F,0x0
_tbl10_G103:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G103:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x1A:
	.DB  0x5
_0x1B:
	.DB  0x41,0x54,0x48
_0x1C:
	.DB  0x41,0x54,0x41
_0x1D:
	.DB  0x61,0x74,0x2B,0x63,0x6D,0x67,0x73,0x3D
_0x1E:
	.DB  0x41,0x54,0x44,0x2B
_0x1F:
	.DB  0x3B
_0x216:
	.DB  0x22,0xD,0x1B,0x1A,0x27,0xA
_0x0:
	.DB  0xE3,0xE3,0xE6,0xD1,0xED,0x20,0xCF,0xC7
	.DB  0xCE,0xE1,0x20,0xE4,0xED,0xD3,0xCA,0x0
	.DB  0x46,0x52,0x5F,0x44,0x49,0x53,0x4B,0x5F
	.DB  0x45,0x52,0x52,0x0,0x46,0x52,0x5F,0x49
	.DB  0x4E,0x54,0x5F,0x45,0x52,0x52,0x0,0x46
	.DB  0x52,0x5F,0x4E,0x4F,0x54,0x5F,0x52,0x45
	.DB  0x41,0x44,0x59,0x0,0x46,0x52,0x5F,0x4E
	.DB  0x4F,0x5F,0x46,0x49,0x4C,0x45,0x0,0x46
	.DB  0x52,0x5F,0x4E,0x4F,0x5F,0x50,0x41,0x54
	.DB  0x48,0x0,0x46,0x52,0x5F,0x49,0x4E,0x56
	.DB  0x41,0x4C,0x49,0x44,0x5F,0x4E,0x41,0x4D
	.DB  0x45,0x0,0x46,0x52,0x5F,0x44,0x45,0x4E
	.DB  0x49,0x45,0x44,0x0,0x46,0x52,0x5F,0x45
	.DB  0x58,0x49,0x53,0x54,0x0,0x46,0x52,0x5F
	.DB  0x49,0x4E,0x56,0x41,0x4C,0x49,0x44,0x5F
	.DB  0x4F,0x42,0x4A,0x45,0x43,0x54,0x0,0x46
	.DB  0x52,0x5F,0x57,0x52,0x49,0x54,0x45,0x5F
	.DB  0x50,0x52,0x4F,0x54,0x45,0x43,0x54,0x45
	.DB  0x44,0x0,0x46,0x52,0x5F,0x49,0x4E,0x56
	.DB  0x41,0x4C,0x49,0x44,0x5F,0x44,0x52,0x49
	.DB  0x56,0x45,0x0,0x46,0x52,0x5F,0x4E,0x4F
	.DB  0x54,0x5F,0x45,0x4E,0x41,0x42,0x4C,0x45
	.DB  0x44,0x0,0x46,0x52,0x5F,0x4E,0x4F,0x5F
	.DB  0x46,0x49,0x4C,0x45,0x53,0x59,0x53,0x54
	.DB  0x45,0x4D,0x0,0x46,0x52,0x5F,0x4D,0x4B
	.DB  0x46,0x53,0x5F,0x41,0x42,0x4F,0x52,0x54
	.DB  0x45,0x44,0x0,0x46,0x52,0x5F,0x54,0x49
	.DB  0x4D,0x45,0x4F,0x55,0x54,0x0,0x2F,0x0
	.DB  0x6B,0x61,0x2E,0x42,0x4D,0x50,0x0,0x6B
	.DB  0x33,0x2E,0x42,0x4D,0x50,0x0,0x63,0x61
	.DB  0x6C,0x6C,0x2E,0x42,0x4D,0x50,0x0,0x41
	.DB  0x54,0x2B,0x43,0x4D,0x47,0x46,0x3D,0x31
	.DB  0x25,0x63,0x0,0x25,0x73,0x25,0x0,0x25
	.DB  0x73,0x0,0x81,0xED,0xC7,0xE3,0x20,0xC7
	.DB  0xD1,0xD3,0xC7,0xE1,0x20,0xD4,0xCF,0x0
	.DB  0xDE,0xD8,0xDA,0x20,0xCA,0xE3,0xC7,0xD3
	.DB  0x0,0xE6,0xD5,0xE1,0x20,0x98,0xD1,0xCF
	.DB  0xE4,0x20,0xCA,0xE3,0xC7,0xD3,0x0,0x79
	.DB  0x3D,0x0,0x78,0x3D,0x0,0x25,0x70,0x0
	.DB  0xD5,0xDD,0xCD,0xE5,0x20,0xCA,0xE3,0xC7
	.DB  0xD3,0x0,0xD5,0xDD,0xCD,0xE5,0x20,0x81
	.DB  0xED,0xC7,0xE3,0x0,0xC7,0xD1,0xD3,0xC7
	.DB  0xE1,0x20,0x81,0xED,0xC7,0xE3,0x0,0xE3
	.DB  0xCE,0xC7,0xD8,0xC8,0x0,0xE3,0xCA,0xE4
	.DB  0x20,0x81,0xED,0xC7,0xE3,0x0,0xE3,0xE3
	.DB  0xE6,0xD1,0xED,0x20,0xCA,0xC7,0xED,0xED
	.DB  0xCF,0x20,0xD4,0xCF,0x0,0x76,0x76,0x2E
	.DB  0x42,0x4D,0x50,0x0,0xD5,0xDD,0xCD,0xE5
	.DB  0x20,0xC7,0xD5,0xE1,0xED,0x0
_0x20003:
	.DB  0xEF
_0x20004:
	.DB  0x3F,0x1
_0x60003:
	.DB  0x1
_0x60004:
	.DB  0xFF,0xFF
_0x60005:
	.DB  0x1
_0x60006:
	.DB  0x1
_0x60007:
	.DB  0x1
_0x60008:
	.DB  0xFF
_0x60009:
	.DB  0xFF
_0x60070:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
_0x60095:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0
_0x2000060:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2020003:
	.DB  0x1

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  _v1
	.DW  _0x1A*2

	.DW  0x03
	.DW  _ATH
	.DW  _0x1B*2

	.DW  0x03
	.DW  _ATA
	.DW  _0x1C*2

	.DW  0x08
	.DW  _atcmgs
	.DW  _0x1D*2

	.DW  0x04
	.DW  _ATD
	.DW  _0x1E*2

	.DW  0x07
	.DW  _0x2B
	.DW  _0x0*2+224

	.DW  0x07
	.DW  _0x2C
	.DW  _0x0*2+231

	.DW  0x09
	.DW  _0x2D
	.DW  _0x0*2+238

	.DW  0x0E
	.DW  _0x34
	.DW  _0x0*2+266

	.DW  0x09
	.DW  _0x41
	.DW  _0x0*2+280

	.DW  0x0E
	.DW  _0x41+9
	.DW  _0x0*2+289

	.DW  0x03
	.DW  _0x5B
	.DW  _0x0*2+303

	.DW  0x03
	.DW  _0x5B+3
	.DW  _0x0*2+306

	.DW  0x0A
	.DW  _0x1DE
	.DW  _0x0*2+312

	.DW  0x0A
	.DW  _0x1EC
	.DW  _0x0*2+322

	.DW  0x0B
	.DW  _0x1EC+10
	.DW  _0x0*2+332

	.DW  0x06
	.DW  _0x1EC+21
	.DW  _0x0*2+343

	.DW  0x09
	.DW  _0x1EC+27
	.DW  _0x0*2+349

	.DW  0x0F
	.DW  _0x20F
	.DW  _0x0*2+358

	.DW  0x07
	.DW  _0x20F+15
	.DW  _0x0*2+373

	.DW  0x0A
	.DW  _0x20F+22
	.DW  _0x0*2+380

	.DW  0x06
	.DW  0x06
	.DW  _0x216*2

	.DW  0x01
	.DW  _TFT_margin_xr
	.DW  _0x20003*2

	.DW  0x02
	.DW  _TFT_margin_yl
	.DW  _0x20004*2

	.DW  0x01
	.DW  _Horizontal
	.DW  _0x60003*2

	.DW  0x02
	.DW  _BkColor
	.DW  _0x60004*2

	.DW  0x01
	.DW  _FontXScale
	.DW  _0x60005*2

	.DW  0x01
	.DW  _FontYScale
	.DW  _0x60006*2

	.DW  0x01
	.DW  _FontSpace
	.DW  _0x60007*2

	.DW  0x01
	.DW  _prevLet
	.DW  _0x60008*2

	.DW  0x01
	.DW  _nextLet
	.DW  _0x60009*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x2000060*2

	.DW  0x01
	.DW  _status_G101
	.DW  _0x2020003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x1C6

	.CSEG
;//-----------------------------------------------------------------------------
;// Copyright:      RAD Electronic Co. LTD,
;// Author:         Sh. Nourbakhsh Rad
;// Remarks:
;// known Problems: none
;// Version:        06.09.2011
;// Description:    TFT-LCD & Graphic & English-Persian, Arabic Font ....
;//								 for ATmega128 interface ( for WinAVR and CodeVision 2.04a)
;//-----------------------------------------------------------------------------
;
;//	Include Headers
;//*****************************************************************************
;#include "app_config.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;//--------------------------------------------------
;#include "TFT\ili9325.h"
;#include "Graphic\Graphic.h"
;
;#include "FONT\font\f9x14.h"
;#include "FONT\font\AF12x16.h"
;
;#include "FONT\Font.h"
;
;// DEFINE TIMER
;#define T1_OVF_FREQ 10
;#define T1_PRESC 1024L
;#define T1_INIT (0x10000L-(_MCU_CLOCK_FREQUENCY_/(T1_PRESC*T1_OVF_FREQ)))
;//
;
;//-------------------------FAT------------------------------------
;        FRESULT res;
;        FATFS drive;
;        FIL fil;
;
;        flash char * flash error_msg[]=
;        {
;        "  ", /* not used */
;        "FR_DISK_ERR",
;        "FR_INT_ERR",
;        "FR_INT_ERR",
;        "FR_NOT_READY",
;        "FR_NO_FILE",
;        "FR_NO_PATH",
;        "FR_INVALID_NAME",
;        "FR_DENIED",
;        "FR_EXIST",
;        "FR_INVALID_OBJECT",
;        "FR_WRITE_PROTECTED",
;        "FR_INVALID_DRIVE",
;        "FR_NOT_ENABLED",
;        "FR_NO_FILESYSTEM",
;        "FR_MKFS_ABORTED",
;        "FR_TIMEOUT"
;        };
;
;//---------------------------sim 900----------------------------------------------
;char Enter=13;
;char double_quote=34;
;char Ctrlz=26;
;char Escap=27;
;char Line_Feed=10;
;char single_quote=39;
;
;//-----------------------bmp----------------------------------------------------
;#include "BMP\sdbmp.c"
;/************************************************************************************************
;* DESCRIPTION
;* ===========
;* Reading BMP from SD card
;* using : Petit FatFs - FAT file system module  R0.01a (C)ChaN, 2009
;*
;* Display on TFT QVGA circuitidea.com BL-TFT240320PLUS
;* support only bmp 24 bit
;* support BMP padding data. Option for complex BMP (image width devide by 4 giving 0).
;* for small size and fast display.
;*
;* BMP padding
;* -----------
;* in BMP total horizontal bytes must devide by 4. remain is padding 0-3 byte.
;* For fast way to display picture. do this.
;* 1. create picture width can device by 4 give 0
;* 2. using FILL IN AREA mode of QVGA.
;*
;* HISTORY
;* -------
;* 01/10/2009 Using stream mode for faster and smooter.
;* 	         **NOTE**
;*            Becare full to set stream parameter before use function. bmpShow has no link to FATFS (FATFS not public variable).
;*
;*			 fs.flag |= FA_STREAM;	// Set stream mode
;*			 bmpShow((unsigned int)SCREEN_HOR_SIZE/2 - w/2, (unsigned int)SCREEN_VER_SIZE/2 - h/2);
;*			 fs.flag &= ~FA_STREAM;	// Clear stream mode
;*
;************************************************************************************************/
;
;typedef struct BMIH { //declares BitMap Info Header structure
;	unsigned long biSize;            //Length of bitmap information header (40 bytes for Windows V3 bitmaps)
;	unsigned long biWidth;           //Width (pixels)
;	unsigned long biHeight;          //Height (pixels)
;	unsigned short biPlanes;         //Color planes, always 1
;	unsigned short biBitCount;       //Color bits per pixel (1, 4, 8, 16, 24 and 32)
;	unsigned long biCompression;     //Compression method, we only read uncompressed (type 0)
;	unsigned long biSizeImage;       //Image data length
;	unsigned long biXPelsPerMeter;   //Horizontal resolution (pixels per meter)
;	unsigned long biYPelsPerMeter;   //Vertical resolution (pixel per meter)
;	unsigned long biClrUsed;         //Number of colors, ignored.
;	unsigned long biClrImportant;    //Number of important colors, ignored.
;}BMP_INFO;
;
;typedef struct BMFH { //declares BitMap File Header structure
;	unsigned short bfType;           //Always 0x42 0x4D (hex for BM <-- indicating a bitmap)
;	unsigned long  bfSize;           //File size (bytes)
;        unsigned short bfReserved1;      //Reserved, ignored
;        unsigned short bfReserved2;      //Reserved, ignored
;        unsigned long  bfOffBits;        //Location in file of the first bitmap data
;}BMP_HEADER;
;
;
;unsigned long bmpWidth;           //Width (pixels)
;unsigned long bmpHeight;          //Height (pixels)
;
;FRESULT bmpFile(const char* fname)
; 0000 0041         {

	.CSEG
_bmpFile:
;        BMP_HEADER BMPHeader;
;        BMP_INFO BMPInfo;
;        //FRESULT res;
;        int br;
;
;        if (f_open(&fil,fname,FA_READ) != FR_OK)                        return 1; // File Open count
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,54
	ST   -Y,R17
	ST   -Y,R16
;	*fname -> Y+56
;	BMPHeader -> Y+42
;	BMPInfo -> Y+2
;	br -> R16,R17
	CALL SUBOPT_0x0
	LDD  R30,Y+58
	LDD  R31,Y+58+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _f_open
	SBIW R30,0
	BREQ _0x3
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0022
;        if (f_read(&fil,&BMPHeader, sizeof(BMPHeader), &br) != FR_OK)   return 2; // read bmp header
_0x3:
	CALL SUBOPT_0x0
	MOVW R30,R28
	ADIW R30,44
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(14)
	LDI  R31,HIGH(14)
	ST   -Y,R31
	ST   -Y,R30
	IN   R26,SPL
	IN   R27,SPH
	SBIW R26,1
	PUSH R17
	PUSH R16
	CALL _f_read
	POP  R16
	POP  R17
	SBIW R30,0
	BREQ _0x4
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0022
;        if (BMPHeader.bfType != 0x4d42 )                                return 3; // type is 'BM'
_0x4:
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	CPI  R26,LOW(0x4D42)
	LDI  R30,HIGH(0x4D42)
	CPC  R27,R30
	BREQ _0x5
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x20E0022
;        if (f_read(&fil,&BMPInfo, sizeof(BMPInfo), &br) != FR_OK)       return 4; // read bmp info
_0x5:
	CALL SUBOPT_0x0
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(40)
	LDI  R31,HIGH(40)
	ST   -Y,R31
	ST   -Y,R30
	IN   R26,SPL
	IN   R27,SPH
	SBIW R26,1
	PUSH R17
	PUSH R16
	CALL _f_read
	POP  R16
	POP  R17
	SBIW R30,0
	BREQ _0x6
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x20E0022
;        if (BMPInfo.biSize        !=  40)                               return 5; //unknown header format/length
_0x6:
	CALL SUBOPT_0x1
	__CPD2N 0x28
	BREQ _0x7
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP _0x20E0022
;        if (BMPInfo.biPlanes      !=   1)                               return 6; //this should be 1
_0x7:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,1
	BREQ _0x8
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x20E0022
;        if (BMPInfo.biWidth       >  240)                               return 7; //image over size
_0x8:
	CALL SUBOPT_0x2
	__CPD2N 0xF1
	BRLO _0x9
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x20E0022
;        if (BMPInfo.biHeight      >  320)                               return 8; //image over size
_0x9:
	CALL SUBOPT_0x3
	__CPD2N 0x141
	BRLO _0xA
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RJMP _0x20E0022
;        if (BMPInfo.biCompression !=   0)                               return 9; //0=no compression
_0xA:
	CALL SUBOPT_0x4
	CALL __CPD10
	BREQ _0xB
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x20E0022
;
;        bmpWidth  = BMPInfo.biWidth;
_0xB:
	CALL SUBOPT_0x5
	STS  _bmpWidth,R30
	STS  _bmpWidth+1,R31
	STS  _bmpWidth+2,R22
	STS  _bmpWidth+3,R23
;        bmpHeight = BMPInfo.biHeight;
	CALL SUBOPT_0x6
	STS  _bmpHeight,R30
	STS  _bmpHeight+1,R31
	STS  _bmpHeight+2,R22
	STS  _bmpHeight+3,R23
;
;        if (f_lseek(&fil,BMPHeader.bfOffBits)!= FR_OK)            	return 10; // move to start of bmp data
	CALL SUBOPT_0x0
	__GETD2S 54
	CALL _f_lseek
	SBIW R30,0
	BREQ _0xC
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x20E0022
;        return FR_OK;
_0xC:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20E0022:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,58
	RET
;        }
;
;void RGB(unsigned char B,unsigned char  G,unsigned char R)
;        {
_RGB:
;        B = B >> 3;
	ST   -Y,R26
;	B -> Y+2
;	G -> Y+1
;	R -> Y+0
	LDD  R30,Y+2
	LSR  R30
	LSR  R30
	LSR  R30
	STD  Y+2,R30
;        G = G >> 2;
	LDD  R30,Y+1
	LSR  R30
	LSR  R30
	STD  Y+1,R30
;        R = R >> 3;
	LD   R30,Y
	LSR  R30
	LSR  R30
	LSR  R30
	ST   Y,R30
;        TFTOutDat2((R << 3) | (G >> 3), (G << 5) | B );
	LSL  R30
	LSL  R30
	LSL  R30
	MOV  R26,R30
	LDD  R30,Y+1
	LSR  R30
	LSR  R30
	LSR  R30
	OR   R30,R26
	ST   -Y,R30
	LDD  R30,Y+2
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LDD  R26,Y+3
	OR   R30,R26
	MOV  R26,R30
	CALL _TFTOutDat2
;        }
	ADIW R28,3
	RET
;
;unsigned char bmpShow(unsigned int sx, unsigned int sy)    // support BMP 24 bit True color only
;        {
_bmpShow:
;        //unsigned short color;
;        unsigned int x,y;
;        unsigned int i,j;
;        unsigned int ex,ey;
;        unsigned char  res,buffer[256];
;        unsigned int br;
;
;        ex = sx + bmpWidth-1;
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,9
	SUBI R29,1
	CALL __SAVELOCR6
;	sx -> Y+273
;	sy -> Y+271
;	x -> R16,R17
;	y -> R18,R19
;	i -> R20,R21
;	j -> Y+269
;	ex -> Y+267
;	ey -> Y+265
;	res -> Y+264
;	buffer -> Y+8
;	br -> Y+6
	LDS  R30,_bmpWidth
	LDS  R31,_bmpWidth+1
	CALL SUBOPT_0x7
	ADD  R26,R30
	ADC  R27,R31
	SBIW R26,1
	__PUTW2SX 267
;        ey = sy + bmpHeight-1;
	LDS  R30,_bmpHeight
	LDS  R31,_bmpHeight+1
	CALL SUBOPT_0x8
	ADD  R26,R30
	ADC  R27,R31
	SBIW R26,1
	__PUTW2SX 265
;        if (sx < TFT_margin_xl)sx = TFT_margin_xl;
	CALL SUBOPT_0x9
	CALL SUBOPT_0x7
	CP   R26,R30
	CPC  R27,R31
	BRSH _0xD
	CALL SUBOPT_0x9
	__PUTW1SX 273
;        if (ex > TFT_margin_xr)ex = TFT_margin_xr;
_0xD:
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
	CP   R30,R26
	CPC  R31,R27
	BRSH _0xE
	CALL SUBOPT_0xA
	__PUTW1SX 267
;        if (sy < TFT_margin_yu)sy = TFT_margin_yu;
_0xE:
	CALL SUBOPT_0xC
	CALL SUBOPT_0x8
	CP   R26,R30
	CPC  R27,R31
	BRSH _0xF
	CALL SUBOPT_0xC
	__PUTW1SX 271
;        if (ey > TFT_margin_yl)ey = TFT_margin_yl;
_0xF:
	CALL SUBOPT_0xD
	CALL SUBOPT_0xE
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x10
	CALL SUBOPT_0xD
	__PUTW1SX 265
;
;        TFTOutCmd(TFT_INS_ENTRY_MOD);
_0x10:
	CALL SUBOPT_0xF
;        TFTOutDat(0x10);
	CALL SUBOPT_0x10
	CALL _TFTOutDat
;
;        TFTOutCmd(TFT_INS_START_ADX);
	LDI  R26,LOW(80)
	CALL SUBOPT_0x11
;        TFTOutDat(sx);
	CALL SUBOPT_0x7
	CALL _TFTOutDat
;        TFTOutCmd(TFT_INS_END_ADX);
	LDI  R26,LOW(81)
	CALL SUBOPT_0x11
;        TFTOutDat(ex);
	CALL SUBOPT_0xB
	CALL _TFTOutDat
;        TFTOutCmd(TFT_INS_GRAM_ADX);
	LDI  R26,LOW(32)
	CALL SUBOPT_0x11
;        TFTOutDat(sx);
	CALL SUBOPT_0x7
	CALL _TFTOutDat
;        x = (ex - sx + 1);
	CALL SUBOPT_0x7
	__GETW1SX 267
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,1
	MOVW R16,R30
;
;#ifndef TFT_ORN_PORTRAIT
;        sy = TFT_SIZE_Y - 1 - sy;
;        ey = TFT_SIZE_Y - 1 - ey;
;        TFTOutCmd(TFT_INS_START_ADY);
;        TFTOutDat(ey);
;        TFTOutCmd(TFT_INS_END_ADY);
;        TFTOutDat(sy);
;        TFTOutCmd(TFT_INS_GRAM_ADY);
;        TFTOutDat(sy);
;        y = sy - ey + 1;
;#else
;        TFTOutCmd(TFT_INS_START_ADY);
	LDI  R26,LOW(82)
	CALL SUBOPT_0x11
;        TFTOutDat(sy);
	CALL SUBOPT_0x8
	CALL _TFTOutDat
;        TFTOutCmd(TFT_INS_END_ADY);
	LDI  R26,LOW(83)
	CALL SUBOPT_0x11
;        TFTOutDat(ey);
	CALL SUBOPT_0xE
	CALL _TFTOutDat
;        TFTOutCmd(TFT_INS_GRAM_ADY);
	LDI  R26,LOW(33)
	CALL SUBOPT_0x11
;        TFTOutDat(sy);
	CALL SUBOPT_0x8
	CALL _TFTOutDat
;        y = ey - sy;
	CALL SUBOPT_0x8
	__GETW1SX 265
	SUB  R30,R26
	SBC  R31,R27
	MOVW R18,R30
;#endif
;        TFTOutCmd(TFT_INS_RW_GRAM);
	LDI  R26,LOW(34)
	CALL SUBOPT_0x11
;        for (;;)
_0x12:
;                {
;                res =  f_read(&fil,buffer,x,&br);
	CALL SUBOPT_0x0
	MOVW R30,R28
	ADIW R30,10
	CALL SUBOPT_0x12
	MOVW R26,R28
	ADIW R26,12
	CALL _f_read
	__PUTB1SX 264
;                if(res || !br)break;
	CPI  R30,0
	BRNE _0x15
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,0
	BRNE _0x14
_0x15:
	RJMP _0x13
;                for (i=0; i<x; i+=3)
_0x14:
	__GETWRN 20,21,0
_0x18:
	__CPWRR 20,21,16,17
	BRSH _0x19
;                        {
;                        RGB(buffer[i+2],buffer[i+1],buffer[i]);
	MOVW R30,R20
	ADIW R30,2
	MOVW R26,R28
	ADIW R26,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	MOVW R30,R20
	ADIW R30,1
	MOVW R26,R28
	ADIW R26,9
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	ADD  R26,R20
	ADC  R27,R21
	LD   R26,X
	RCALL _RGB
;                        }
	__ADDWRN 20,21,3
	RJMP _0x18
_0x19:
;
;                }
	RJMP _0x12
_0x13:
;        TFTOutCmd(TFT_INS_ENTRY_MOD);
	CALL SUBOPT_0xF
;        TFTOutDat(TFT_VAL_ENTRY_MOD);
	CALL SUBOPT_0x13
	CALL _TFTOutDat
;        return res;
	__GETB1SX 264
	CALL __LOADLOCR6
	ADIW R28,19
	SUBI R29,-1
	RET
;        }
;//------------------------------------------------------------------------------
;
;
;//	Constants and Varables
;//*****************************************************************************
;
;//Temp Const.
;char Ctemp[50];
;int  Itemp;
;char      path[20];
;int  xt,yt,n,n2;
;char i,d,nk,exit,bsn,bnun;
;char v1=5;

	.DSEG
;char n1;
;char j=0;
;bit s,nu,b,;
;char ATH[3]={'A','T','H'};
;char ATA[3]={'A','T','A'};
;char number[13];//={'+','9','8','9','3','8','4','9','8','5','6','0','3'};
;char kibord[50];
;char atcmgs[8]={'a','t','+','c','m','g','s','='};
;char buffer[50];
;char ATD[4]={'A','T','D','+'};
;char noghte[1]={';'};
;char a[50];
;char text[50];//="ali";
;//	Functions Prototype
;//*****************************************************************************
;
;            /* recursively scan directory entries and display them */
;            FRESULT directory_scan(char *path)
; 0000 0061             {

	.CSEG
; 0000 0062             /* will hold file/directory information returned by f_readdir*/
; 0000 0063             FILINFO file_info;
; 0000 0064             /* will hold the directory information */
; 0000 0065             DIR directory;
; 0000 0066             int i;
; 0000 0067             char y=3;
; 0000 0068             if ((res=f_opendir(&directory,path))==FR_OK)
;	*path -> Y+48
;	file_info -> Y+26
;	directory -> Y+4
;	i -> R16,R17
;	y -> R19
; 0000 0069                {
; 0000 006A                while (((res=f_readdir(&directory,&file_info))==FR_OK) && file_info.fname[0])
; 0000 006B                      {
; 0000 006C                      /* display file/directory name and associated information */
; 0000 006D             //
; 0000 006E             //         printf("%s/%s\r\n",
; 0000 006F             //               path,file_info.fname);
; 0000 0070                         SetLetter(E_LETTER);
; 0000 0071                       DrawStringAt(y,0,path,GetFgColor(),GetBkColor());
; 0000 0072 
; 0000 0073                        DrawStringAt(y,0,file_info.fname,GetFgColor(),GetBkColor());
; 0000 0074 
; 0000 0075                      y++;
; 0000 0076                      if (file_info.fattrib & AM_DIR)
; 0000 0077                         {
; 0000 0078                         /* it's a subdirectory */
; 0000 0079                         /* make sure to skip past "." and ".." when recursing */
; 0000 007A                         if (file_info.fname[0]!='.')
; 0000 007B                            {
; 0000 007C                            i=strlen(path);
; 0000 007D                            /* append the subdirectory name to the path */
; 0000 007E                          if (path[i-1]!='/') strcatf(path,"/");
; 0000 007F                            strcat(path,file_info.fname);
; 0000 0080                            /* scan subdirectory */
; 0000 0081                            res=directory_scan(path);
; 0000 0082                            /* restore the old path name */
; 0000 0083                            path[i]=0;
; 0000 0084                            /* remove any eventual '/' from the end of the path */
; 0000 0085                            --i;
; 0000 0086                            if (path[i]=='/') path[i]=0;
; 0000 0087                            /* stop if an error occured */
; 0000 0088                            if (res!=FR_OK) break;
; 0000 0089                            }
; 0000 008A                         }
; 0000 008B                      }
; 0000 008C                }
; 0000 008D             return res;
; 0000 008E             }
;
;axka(){
; 0000 0090 axka(){
_axka:
; 0000 0091 bmpFile("ka.BMP");
	__POINTW2MN _0x2B,0
	CALL SUBOPT_0x14
; 0000 0092 bmpShow(0,160);
	RJMP _0x20E0021
; 0000 0093 }

	.DSEG
_0x2B:
	.BYTE 0x7
;
;axk3(){
; 0000 0095 axk3(){

	.CSEG
_axk3:
; 0000 0096 bmpFile("k3.BMP");
	__POINTW2MN _0x2C,0
	CALL SUBOPT_0x14
; 0000 0097 bmpShow(0,160);
	RJMP _0x20E0021
; 0000 0098 }

	.DSEG
_0x2C:
	.BYTE 0x7
;
;callt(){
; 0000 009A callt(){

	.CSEG
_callt:
; 0000 009B  bmpFile("call.BMP");
	__POINTW2MN _0x2D,0
	CALL SUBOPT_0x15
; 0000 009C   bmpShow(0,110);
	LDI  R26,LOW(110)
_0x20E0021:
	LDI  R27,0
	RCALL _bmpShow
; 0000 009D 
; 0000 009E 
; 0000 009F }
	RET

	.DSEG
_0x2D:
	.BYTE 0x9
;
;void wait_to_get(char ch)
; 0000 00A2 {

	.CSEG
; 0000 00A3     while(ch != getchar());
;	ch -> Y+0
; 0000 00A4 }
;
;sms(){
; 0000 00A6 sms(){
_sms:
; 0000 00A7 printf("AT+CMGF=1%c",Enter);
	__POINTW1FN _0x0,247
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R7
	CLR  R31
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x16
; 0000 00A8  delay_ms(500);
	CALL SUBOPT_0x17
; 0000 00A9 printf("%s%",atcmgs);
	__POINTW1FN _0x0,259
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_atcmgs)
	LDI  R31,HIGH(_atcmgs)
	CALL SUBOPT_0x18
; 0000 00AA putchar(double_quote);
	MOV  R26,R6
	CALL _putchar
; 0000 00AB printf("%s%",number);
	__POINTW1FN _0x0,259
	CALL SUBOPT_0x19
; 0000 00AC putchar(double_quote);
	MOV  R26,R6
	CALL SUBOPT_0x1A
; 0000 00AD putchar(Enter);
; 0000 00AE //printf("at+cmgs=%c09384985603%c%c",double_quote,double_quote,Enter);
; 0000 00AF 
; 0000 00B0 //wait_to_get('>');
; 0000 00B1 for(i=0;i<17;i++)a[i]=getchar();
_0x32:
	LDS  R26,_i
	CPI  R26,LOW(0x11)
	BRSH _0x33
	CALL SUBOPT_0x1B
	SUBI R30,LOW(-_a)
	SBCI R31,HIGH(-_a)
	PUSH R31
	PUSH R30
	CALL _getchar
	POP  R26
	POP  R27
	ST   X,R30
	CALL SUBOPT_0x1C
	RJMP _0x32
_0x33:
; 0000 00B3 sprintf(buffer,"%s",a);
	LDI  R30,LOW(_buffer)
	LDI  R31,HIGH(_buffer)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x1D
	LDI  R30,LOW(_a)
	LDI  R31,HIGH(_a)
	CALL SUBOPT_0x1E
; 0000 00B4  SetLetter(E_LETTER);
; 0000 00B5  DrawStringAt(5,0,a,YELLOW,GetBkColor());
	LDI  R30,LOW(5)
	CALL SUBOPT_0x1F
	LDI  R26,LOW(_a)
	LDI  R27,HIGH(_a)
	CALL _Puts
; 0000 00B6 delay_ms(700);
	LDI  R26,LOW(700)
	LDI  R27,HIGH(700)
	CALL _delay_ms
; 0000 00B7 printf("%s",text);
	CALL SUBOPT_0x1D
	LDI  R30,LOW(_text)
	LDI  R31,HIGH(_text)
	CALL SUBOPT_0x18
; 0000 00B8 putchar(Ctrlz);
	MOV  R26,R9
	CALL _putchar
; 0000 00B9 SetLetter(P_LETTER);
	CALL SUBOPT_0x20
; 0000 00BA DrawStringAt(2,0,"  ",YELLOW,GetBkColor());
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1F
	__POINTW2MN _0x34,0
	CALL _Puts
; 0000 00BB for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
	LDI  R30,LOW(0)
	STS  _i,R30
_0x36:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x37
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x36
_0x37:
; 0000 00BC delay_ms(4000);
	LDI  R26,LOW(4000)
	LDI  R27,HIGH(4000)
	CALL _delay_ms
; 0000 00BD SetLetter(E_LETTER);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x23
; 0000 00BE RectangleFill(0,35,240,50,BLACK);
	LDI  R30,LOW(240)
	LDI  R31,HIGH(240)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(35)
	LDI  R31,HIGH(35)
	CALL SUBOPT_0x24
	CALL _TFTFillRect
; 0000 00BF 
; 0000 00C0 for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
	LDI  R30,LOW(0)
	STS  _i,R30
_0x39:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x3A
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x39
_0x3A:
; 0000 00C1 for (i=0;i<50;i++)text[i]=0;
	LDI  R30,LOW(0)
	STS  _i,R30
_0x3C:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x3D
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x25
	CALL SUBOPT_0x1C
	RJMP _0x3C
_0x3D:
; 0000 00C2 for (i=0;i<12;i++)number[i]=0;
	LDI  R30,LOW(0)
	STS  _i,R30
_0x3F:
	LDS  R26,_i
	CPI  R26,LOW(0xC)
	BRSH _0x40
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x26
	CALL SUBOPT_0x1C
	RJMP _0x3F
_0x40:
; 0000 00C4 }
	RET

	.DSEG
_0x34:
	.BYTE 0xE
;
;call(){
; 0000 00C6 call(){

	.CSEG
_call:
; 0000 00C7 
; 0000 00C8 
; 0000 00C9 LcdFontXScale(1);
	LDI  R30,LOW(1)
	STS  _FontXScale,R30
; 0000 00CA SetLetter(P_LETTER);
	CALL SUBOPT_0x20
; 0000 00CB 
; 0000 00CC DrawStringAt(1,0," ",RED ,GetBkColor());
	CALL SUBOPT_0x27
	LDI  R30,LOW(31)
	LDI  R31,HIGH(31)
	CALL SUBOPT_0x28
	__POINTW2MN _0x41,0
	CALL _Puts
; 0000 00CD  DrawStringAt(2,0,"  ",GREEN ,GetBkColor());
	LDI  R30,LOW(2)
	CALL SUBOPT_0x29
	LDI  R30,LOW(2016)
	LDI  R31,HIGH(2016)
	CALL SUBOPT_0x28
	__POINTW2MN _0x41,9
	CALL _Puts
; 0000 00CE 
; 0000 00CF printf("%s",ATD);
	CALL SUBOPT_0x1D
	LDI  R30,LOW(_ATD)
	LDI  R31,HIGH(_ATD)
	CALL SUBOPT_0x18
; 0000 00D0 printf("%s",number);
	__POINTW1FN _0x0,263
	CALL SUBOPT_0x19
; 0000 00D1 putchar(';');
	LDI  R26,LOW(59)
	CALL SUBOPT_0x1A
; 0000 00D2 putchar(Enter);
; 0000 00D3 //
; 0000 00D4 //for(i=0;i<16;i++)a[i]=getchar();
; 0000 00D5 //
; 0000 00D6 // sprintf(buffer,"%s",a);
; 0000 00D7 // SetLetter(E_LETTER);
; 0000 00D8 // DrawStringAt(5,0,a,YELLOW,GetBkColor());
; 0000 00D9 for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
_0x43:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x44
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x43
_0x44:
; 0000 00DA for (i=0;i<12;i++)number[i]=0;
	LDI  R30,LOW(0)
	STS  _i,R30
_0x46:
	LDS  R26,_i
	CPI  R26,LOW(0xC)
	BRSH _0x47
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x26
	CALL SUBOPT_0x1C
	RJMP _0x46
_0x47:
; 0000 00DC }
	RET

	.DSEG
_0x41:
	.BYTE 0x17
;
;
;
;callregect(){
; 0000 00E0 callregect(){

	.CSEG
_callregect:
; 0000 00E1 
; 0000 00E2 printf("%s",ATH);
	CALL SUBOPT_0x1D
	LDI  R30,LOW(_ATH)
	LDI  R31,HIGH(_ATH)
	RJMP _0x20E0020
; 0000 00E3 putchar(Enter);
; 0000 00E4 
; 0000 00E5 
; 0000 00E6 }
;
;
;
;callconect(){
; 0000 00EA callconect(){
_callconect:
; 0000 00EB printf("%s",ATA);
	CALL SUBOPT_0x1D
	LDI  R30,LOW(_ATA)
	LDI  R31,HIGH(_ATA)
_0x20E0020:
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x16
; 0000 00EC putchar(Enter);
	MOV  R26,R7
	CALL _putchar
; 0000 00ED }
	RET
;
;
;
;void test01(void);
;
;#define ADC_VREF_TYPE 0x40
;
;// Read the AD conversion result
;unsigned int read_adc(unsigned char adc_input)
; 0000 00F7 {
_read_adc:
; 0000 00F8 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
	ST   -Y,R26
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x40
	OUT  0x7,R30
; 0000 00F9 // Delay needed for the stabilization of the ADC input voltage
; 0000 00FA delay_us(500);
	__DELAY_USW 2000
; 0000 00FB // Start the AD conversion
; 0000 00FC ADCSRA|=0x40;
	SBI  0x6,6
; 0000 00FD // Wait for the AD conversion to complete
; 0000 00FE while ((ADCSRA & 0x10)==0);
_0x48:
	SBIS 0x6,4
	RJMP _0x48
; 0000 00FF ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0100 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
; 0000 0101 }
;
;
;
;
;tuch(){
; 0000 0106 tuch(){
_tuch:
; 0000 0107 
; 0000 0108 
; 0000 0109       DDRA.0=1;        //-x
	SBI  0x1A,0
; 0000 010A       DDRA.1=0;        //y
	CBI  0x1A,1
; 0000 010B       DDRA.2=1;        //x
	SBI  0x1A,2
; 0000 010C       DDRA.3=0;        //-y
	CBI  0x1A,3
; 0000 010D       PORTA.0=0;
	CBI  0x1B,0
; 0000 010E       PORTA.1=0;
	CBI  0x1B,1
; 0000 010F       PORTA.2=1;
	SBI  0x1B,2
; 0000 0110       PORTA.3=0;
	CBI  0x1B,3
; 0000 0111 
; 0000 0112       yt=read_adc(1);
	LDI  R26,LOW(1)
	RCALL _read_adc
	STS  _yt,R30
	STS  _yt+1,R31
; 0000 0113       yt=yt/4.26;
	CALL SUBOPT_0x2A
	__GETD1N 0x408851EC
	CALL __DIVF21
	LDI  R26,LOW(_yt)
	LDI  R27,HIGH(_yt)
	CALL __CFD1
	ST   X+,R30
	ST   X,R31
; 0000 0114       itoa(yt,path);
	LDS  R30,_yt
	LDS  R31,_yt+1
	CALL SUBOPT_0x2B
; 0000 0115 
; 0000 0116       SetLetter(E_LETTER);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x23
; 0000 0117       RectangleFill(0,0,130,50,BLACK);
	CALL SUBOPT_0x2C
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL SUBOPT_0x24
	CALL _TFTFillRect
; 0000 0118       DrawStringAt(1,0,"y=",WHITE,GetBkColor());
	CALL SUBOPT_0x27
	CALL SUBOPT_0x2D
	__POINTW2MN _0x5B,0
	CALL _Puts
; 0000 0119       DrawStringAt(1,2,path,WHITE,GetBkColor());
	LDI  R30,LOW(1)
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x2F
; 0000 011A 
; 0000 011B       DDRA.0=0;
	CBI  0x1A,0
; 0000 011C       DDRA.1=1;
	SBI  0x1A,1
; 0000 011D       DDRA.2=0;
	CBI  0x1A,2
; 0000 011E       DDRA.3=1;
	SBI  0x1A,3
; 0000 011F       PORTA.0=0;
	CBI  0x1B,0
; 0000 0120       PORTA.1=1;
	SBI  0x1B,1
; 0000 0121       PORTA.2=0;
	CBI  0x1B,2
; 0000 0122       PORTA.3=0;
	CBI  0x1B,3
; 0000 0123       xt=read_adc(2);
	LDI  R26,LOW(2)
	RCALL _read_adc
	STS  _xt,R30
	STS  _xt+1,R31
; 0000 0124       xt=xt/3.19;
	CALL SUBOPT_0x2A
	__GETD1N 0x404C28F6
	CALL __DIVF21
	LDI  R26,LOW(_xt)
	LDI  R27,HIGH(_xt)
	CALL __CFD1
	ST   X+,R30
	ST   X,R31
; 0000 0125       itoa(xt,path);
	LDS  R30,_xt
	LDS  R31,_xt+1
	CALL SUBOPT_0x2B
; 0000 0126       DrawStringAt(0,0,"x=",WHITE,GetBkColor());
	LDI  R30,LOW(0)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x2D
	__POINTW2MN _0x5B,3
	CALL _Puts
; 0000 0127       DrawStringAt(0,2,path,WHITE,GetBkColor());
	LDI  R30,LOW(0)
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x2F
; 0000 0128 
; 0000 0129 
; 0000 012A }
	RET

	.DSEG
_0x5B:
	.BYTE 0x6
;
;key(){
; 0000 012C key(){

	.CSEG
_key:
; 0000 012D 
; 0000 012E                                               if(nk==1){
	LDS  R26,_nk
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0x6C
; 0000 012F             if (xt>=144 && xt<=162){
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x90)
	LDI  R30,HIGH(0x90)
	CPC  R27,R30
	BRLT _0x6E
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xA3)
	LDI  R30,HIGH(0xA3)
	CPC  R27,R30
	BRLT _0x6F
_0x6E:
	RJMP _0x6D
_0x6F:
; 0000 0130             if (yt>=24 && yt<=35)kibord[n]=0x31; //1
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0x71
	CALL SUBOPT_0x31
	SBIW R26,36
	BRLT _0x72
_0x71:
	RJMP _0x70
_0x72:
	CALL SUBOPT_0x32
	LDI  R26,LOW(49)
	STD  Z+0,R26
; 0000 0131             if (yt>=40 && yt<=53)kibord[n]=0x32; //2
_0x70:
	CALL SUBOPT_0x31
	SBIW R26,40
	BRLT _0x74
	CALL SUBOPT_0x31
	SBIW R26,54
	BRLT _0x75
_0x74:
	RJMP _0x73
_0x75:
	CALL SUBOPT_0x32
	LDI  R26,LOW(50)
	STD  Z+0,R26
; 0000 0132             if (yt>=59 && yt<=71)kibord[n]=0x33;  //3
_0x73:
	CALL SUBOPT_0x31
	SBIW R26,59
	BRLT _0x77
	CALL SUBOPT_0x33
	BRLT _0x78
_0x77:
	RJMP _0x76
_0x78:
	CALL SUBOPT_0x32
	LDI  R26,LOW(51)
	STD  Z+0,R26
; 0000 0133             if (yt>=74 && yt<=89)kibord[n]=0x2b;  //+
_0x76:
	CALL SUBOPT_0x34
	BRLT _0x7A
	CALL SUBOPT_0x35
	BRLT _0x7B
_0x7A:
	RJMP _0x79
_0x7B:
	CALL SUBOPT_0x32
	LDI  R26,LOW(43)
	STD  Z+0,R26
; 0000 0134             if (yt>=91 && yt<=105)kibord[n]=0x70; //p
_0x79:
	CALL SUBOPT_0x36
	BRLT _0x7D
	CALL SUBOPT_0x37
	BRLT _0x7E
_0x7D:
	RJMP _0x7C
_0x7E:
	CALL SUBOPT_0x32
	LDI  R26,LOW(112)
	STD  Z+0,R26
; 0000 0135             if (yt>=110 && yt<=123)kibord[n]=0x2c; //,
_0x7C:
	CALL SUBOPT_0x38
	BRLT _0x80
	CALL SUBOPT_0x39
	BRLT _0x81
_0x80:
	RJMP _0x7F
_0x81:
	CALL SUBOPT_0x32
	LDI  R26,LOW(44)
	STD  Z+0,R26
; 0000 0136             if (yt>=129 && yt<=138)kibord[n]=0x2e; //.
_0x7F:
	CALL SUBOPT_0x3A
	BRLT _0x83
	CALL SUBOPT_0x3B
	BRLT _0x84
_0x83:
	RJMP _0x82
_0x84:
	CALL SUBOPT_0x32
	LDI  R26,LOW(46)
	STD  Z+0,R26
; 0000 0137             if (yt>=143 && yt<=157)kibord[n]=0x3a; //:
_0x82:
	CALL SUBOPT_0x3C
	BRLT _0x86
	CALL SUBOPT_0x3D
	BRLT _0x87
_0x86:
	RJMP _0x85
_0x87:
	CALL SUBOPT_0x32
	LDI  R26,LOW(58)
	STD  Z+0,R26
; 0000 0138             if (yt>=161 && yt<=174)kibord[n]=0x3b; //;
_0x85:
	CALL SUBOPT_0x3E
	BRLT _0x89
	CALL SUBOPT_0x3F
	BRLT _0x8A
_0x89:
	RJMP _0x88
_0x8A:
	CALL SUBOPT_0x32
	LDI  R26,LOW(59)
	STD  Z+0,R26
; 0000 0139             if (yt>=178 && yt<=190)kibord[n]=0x3f; //?
_0x88:
	CALL SUBOPT_0x40
	BRLT _0x8C
	CALL SUBOPT_0x41
	BRLT _0x8D
_0x8C:
	RJMP _0x8B
_0x8D:
	CALL SUBOPT_0x32
	LDI  R26,LOW(63)
	STD  Z+0,R26
; 0000 013A               }
_0x8B:
; 0000 013B 
; 0000 013C             if (xt>=170 && xt<=185){
_0x6D:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xAA)
	LDI  R30,HIGH(0xAA)
	CPC  R27,R30
	BRLT _0x8F
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xBA)
	LDI  R30,HIGH(0xBA)
	CPC  R27,R30
	BRLT _0x90
_0x8F:
	RJMP _0x8E
_0x90:
; 0000 013D             if (yt>=24 && yt<=35)kibord[n]=0x34;//4
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0x92
	CALL SUBOPT_0x31
	SBIW R26,36
	BRLT _0x93
_0x92:
	RJMP _0x91
_0x93:
	CALL SUBOPT_0x32
	LDI  R26,LOW(52)
	STD  Z+0,R26
; 0000 013E             if (yt>=40 && yt<=53)kibord[n]=0x35;//5
_0x91:
	CALL SUBOPT_0x31
	SBIW R26,40
	BRLT _0x95
	CALL SUBOPT_0x31
	SBIW R26,54
	BRLT _0x96
_0x95:
	RJMP _0x94
_0x96:
	CALL SUBOPT_0x32
	LDI  R26,LOW(53)
	STD  Z+0,R26
; 0000 013F             if (yt>=59 && yt<=71)kibord[n]=0x36;//6
_0x94:
	CALL SUBOPT_0x31
	SBIW R26,59
	BRLT _0x98
	CALL SUBOPT_0x33
	BRLT _0x99
_0x98:
	RJMP _0x97
_0x99:
	CALL SUBOPT_0x32
	LDI  R26,LOW(54)
	STD  Z+0,R26
; 0000 0140             if (yt>=74 && yt<=89)kibord[n]=0x23;//#
_0x97:
	CALL SUBOPT_0x34
	BRLT _0x9B
	CALL SUBOPT_0x35
	BRLT _0x9C
_0x9B:
	RJMP _0x9A
_0x9C:
	CALL SUBOPT_0x32
	LDI  R26,LOW(35)
	STD  Z+0,R26
; 0000 0141             if (yt>=91 && yt<=105)kibord[n]=0x77;//w
_0x9A:
	CALL SUBOPT_0x36
	BRLT _0x9E
	CALL SUBOPT_0x37
	BRLT _0x9F
_0x9E:
	RJMP _0x9D
_0x9F:
	CALL SUBOPT_0x32
	LDI  R26,LOW(119)
	STD  Z+0,R26
; 0000 0142             if (yt>=110 && yt<=123)kibord[n]=0x2d;//-
_0x9D:
	CALL SUBOPT_0x38
	BRLT _0xA1
	CALL SUBOPT_0x39
	BRLT _0xA2
_0xA1:
	RJMP _0xA0
_0xA2:
	CALL SUBOPT_0x32
	LDI  R26,LOW(45)
	STD  Z+0,R26
; 0000 0143             if (yt>=129 && yt<=138)kibord[n]=0x5f;//_
_0xA0:
	CALL SUBOPT_0x3A
	BRLT _0xA4
	CALL SUBOPT_0x3B
	BRLT _0xA5
_0xA4:
	RJMP _0xA3
_0xA5:
	CALL SUBOPT_0x32
	LDI  R26,LOW(95)
	STD  Z+0,R26
; 0000 0144             if (yt>=143 && yt<=157)kibord[n]=0x28;//(
_0xA3:
	CALL SUBOPT_0x3C
	BRLT _0xA7
	CALL SUBOPT_0x3D
	BRLT _0xA8
_0xA7:
	RJMP _0xA6
_0xA8:
	CALL SUBOPT_0x32
	LDI  R26,LOW(40)
	STD  Z+0,R26
; 0000 0145             if (yt>=161 && yt<=174)kibord[n]=0x29;//)
_0xA6:
	CALL SUBOPT_0x3E
	BRLT _0xAA
	CALL SUBOPT_0x3F
	BRLT _0xAB
_0xAA:
	RJMP _0xA9
_0xAB:
	CALL SUBOPT_0x32
	LDI  R26,LOW(41)
	STD  Z+0,R26
; 0000 0146             if (yt>=178 && yt<=190)kibord[n]=0x21;//!
_0xA9:
	CALL SUBOPT_0x40
	BRLT _0xAD
	CALL SUBOPT_0x41
	BRLT _0xAE
_0xAD:
	RJMP _0xAC
_0xAE:
	CALL SUBOPT_0x32
	LDI  R26,LOW(33)
	STD  Z+0,R26
; 0000 0147               }
_0xAC:
; 0000 0148 
; 0000 0149             if (xt>=194 && xt<=212){
_0x8E:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xC2)
	LDI  R30,HIGH(0xC2)
	CPC  R27,R30
	BRLT _0xB0
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xD5)
	LDI  R30,HIGH(0xD5)
	CPC  R27,R30
	BRLT _0xB1
_0xB0:
	RJMP _0xAF
_0xB1:
; 0000 014A             if (yt>=24 && yt<=35)kibord[n]=0x37;//7
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0xB3
	CALL SUBOPT_0x31
	SBIW R26,36
	BRLT _0xB4
_0xB3:
	RJMP _0xB2
_0xB4:
	CALL SUBOPT_0x32
	LDI  R26,LOW(55)
	STD  Z+0,R26
; 0000 014B             if (yt>=40 && yt<=53)kibord[n]=0x38;//8
_0xB2:
	CALL SUBOPT_0x31
	SBIW R26,40
	BRLT _0xB6
	CALL SUBOPT_0x31
	SBIW R26,54
	BRLT _0xB7
_0xB6:
	RJMP _0xB5
_0xB7:
	CALL SUBOPT_0x32
	LDI  R26,LOW(56)
	STD  Z+0,R26
; 0000 014C             if (yt>=59 && yt<=71)kibord[n]=0x39;//9
_0xB5:
	CALL SUBOPT_0x31
	SBIW R26,59
	BRLT _0xB9
	CALL SUBOPT_0x33
	BRLT _0xBA
_0xB9:
	RJMP _0xB8
_0xBA:
	CALL SUBOPT_0x32
	LDI  R26,LOW(57)
	STD  Z+0,R26
; 0000 014D             if (yt>=74 && yt<=89)kibord[n]=0x30;//0
_0xB8:
	CALL SUBOPT_0x34
	BRLT _0xBC
	CALL SUBOPT_0x35
	BRLT _0xBD
_0xBC:
	RJMP _0xBB
_0xBD:
	CALL SUBOPT_0x32
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 014E             if (yt>=91 && yt<=105)kibord[n]=0x2a;//*
_0xBB:
	CALL SUBOPT_0x36
	BRLT _0xBF
	CALL SUBOPT_0x37
	BRLT _0xC0
_0xBF:
	RJMP _0xBE
_0xC0:
	CALL SUBOPT_0x32
	LDI  R26,LOW(42)
	STD  Z+0,R26
; 0000 014F             if (yt>=110 && yt<=123)kibord[n]=0x40;//@
_0xBE:
	CALL SUBOPT_0x38
	BRLT _0xC2
	CALL SUBOPT_0x39
	BRLT _0xC3
_0xC2:
	RJMP _0xC1
_0xC3:
	CALL SUBOPT_0x32
	LDI  R26,LOW(64)
	STD  Z+0,R26
; 0000 0150             if (yt>=129 && yt<=138)kibord[n]=0x2f;// /
_0xC1:
	CALL SUBOPT_0x3A
	BRLT _0xC5
	CALL SUBOPT_0x3B
	BRLT _0xC6
_0xC5:
	RJMP _0xC4
_0xC6:
	CALL SUBOPT_0x32
	LDI  R26,LOW(47)
	STD  Z+0,R26
; 0000 0151             if (yt>=143 && yt<=157)kibord[n]=0x5c;//\
_0xC4:
	CALL SUBOPT_0x3C
	BRLT _0xC8
	CALL SUBOPT_0x3D
	BRLT _0xC9
_0xC8:
	RJMP _0xC7
_0xC9:
	CALL SUBOPT_0x32
	LDI  R26,LOW(92)
	STD  Z+0,R26
; 0000 0152             if (yt>=161 && yt<=174)kibord[n]=0x60;//'
_0xC7:
	CALL SUBOPT_0x3E
	BRLT _0xCB
	CALL SUBOPT_0x3F
	BRLT _0xCC
_0xCB:
	RJMP _0xCA
_0xCC:
	CALL SUBOPT_0x32
	LDI  R26,LOW(96)
	STD  Z+0,R26
; 0000 0153             if (yt>=178 && yt<=190)kibord[n]=0x26;//&
_0xCA:
	CALL SUBOPT_0x40
	BRLT _0xCE
	CALL SUBOPT_0x41
	BRLT _0xCF
_0xCE:
	RJMP _0xCD
_0xCF:
	CALL SUBOPT_0x32
	LDI  R26,LOW(38)
	STD  Z+0,R26
; 0000 0154              }
_0xCD:
; 0000 0155                }
_0xAF:
; 0000 0156         if(nk==0)
_0x6C:
	LDS  R30,_nk
	CPI  R30,0
	BREQ PC+3
	JMP _0xD0
; 0000 0157         {
; 0000 0158 
; 0000 0159                 if (xt>=144 && xt<=162){
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x90)
	LDI  R30,HIGH(0x90)
	CPC  R27,R30
	BRLT _0xD2
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xA3)
	LDI  R30,HIGH(0xA3)
	CPC  R27,R30
	BRLT _0xD3
_0xD2:
	RJMP _0xD1
_0xD3:
; 0000 015A                     if (yt>=24 && yt<=35)kibord[n]=0x51; //Q
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0xD5
	CALL SUBOPT_0x31
	SBIW R26,36
	BRLT _0xD6
_0xD5:
	RJMP _0xD4
_0xD6:
	CALL SUBOPT_0x32
	LDI  R26,LOW(81)
	STD  Z+0,R26
; 0000 015B                     if (yt>=40 && yt<=53)kibord[n]=0x57; //W
_0xD4:
	CALL SUBOPT_0x31
	SBIW R26,40
	BRLT _0xD8
	CALL SUBOPT_0x31
	SBIW R26,54
	BRLT _0xD9
_0xD8:
	RJMP _0xD7
_0xD9:
	CALL SUBOPT_0x32
	LDI  R26,LOW(87)
	STD  Z+0,R26
; 0000 015C                     if (yt>=59 && yt<=71)kibord[n]=0x45;  //E
_0xD7:
	CALL SUBOPT_0x31
	SBIW R26,59
	BRLT _0xDB
	CALL SUBOPT_0x33
	BRLT _0xDC
_0xDB:
	RJMP _0xDA
_0xDC:
	CALL SUBOPT_0x32
	LDI  R26,LOW(69)
	STD  Z+0,R26
; 0000 015D                     if (yt>=74 && yt<=89)kibord[n]=0x52;  //R
_0xDA:
	CALL SUBOPT_0x34
	BRLT _0xDE
	CALL SUBOPT_0x35
	BRLT _0xDF
_0xDE:
	RJMP _0xDD
_0xDF:
	CALL SUBOPT_0x32
	LDI  R26,LOW(82)
	STD  Z+0,R26
; 0000 015E                     if (yt>=91 && yt<=105)kibord[n]=0x54; //T
_0xDD:
	CALL SUBOPT_0x36
	BRLT _0xE1
	CALL SUBOPT_0x37
	BRLT _0xE2
_0xE1:
	RJMP _0xE0
_0xE2:
	CALL SUBOPT_0x32
	LDI  R26,LOW(84)
	STD  Z+0,R26
; 0000 015F                     if (yt>=110 && yt<=123)kibord[n]=0x59;//Y
_0xE0:
	CALL SUBOPT_0x38
	BRLT _0xE4
	CALL SUBOPT_0x39
	BRLT _0xE5
_0xE4:
	RJMP _0xE3
_0xE5:
	CALL SUBOPT_0x32
	LDI  R26,LOW(89)
	STD  Z+0,R26
; 0000 0160                     if (yt>=129 && yt<=138)kibord[n]=0x55; //U
_0xE3:
	CALL SUBOPT_0x3A
	BRLT _0xE7
	CALL SUBOPT_0x3B
	BRLT _0xE8
_0xE7:
	RJMP _0xE6
_0xE8:
	CALL SUBOPT_0x32
	LDI  R26,LOW(85)
	STD  Z+0,R26
; 0000 0161                     if (yt>=143 && yt<=157)kibord[n]=0x49; //I
_0xE6:
	CALL SUBOPT_0x3C
	BRLT _0xEA
	CALL SUBOPT_0x3D
	BRLT _0xEB
_0xEA:
	RJMP _0xE9
_0xEB:
	CALL SUBOPT_0x32
	LDI  R26,LOW(73)
	STD  Z+0,R26
; 0000 0162                     if (yt>=161 && yt<=174)kibord[n]=0x4f; //O
_0xE9:
	CALL SUBOPT_0x3E
	BRLT _0xED
	CALL SUBOPT_0x3F
	BRLT _0xEE
_0xED:
	RJMP _0xEC
_0xEE:
	CALL SUBOPT_0x32
	LDI  R26,LOW(79)
	STD  Z+0,R26
; 0000 0163                     if (yt>=178 && yt<=190)kibord[n]=0x50; //P
_0xEC:
	CALL SUBOPT_0x40
	BRLT _0xF0
	CALL SUBOPT_0x41
	BRLT _0xF1
_0xF0:
	RJMP _0xEF
_0xF1:
	CALL SUBOPT_0x32
	LDI  R26,LOW(80)
	STD  Z+0,R26
; 0000 0164               }
_0xEF:
; 0000 0165 
; 0000 0166             if (xt>=170 && xt<=185){
_0xD1:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xAA)
	LDI  R30,HIGH(0xAA)
	CPC  R27,R30
	BRLT _0xF3
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xBA)
	LDI  R30,HIGH(0xBA)
	CPC  R27,R30
	BRLT _0xF4
_0xF3:
	RJMP _0xF2
_0xF4:
; 0000 0167                     if (yt>=24 && yt<=35)kibord[n]=0x41;//A
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0xF6
	CALL SUBOPT_0x31
	SBIW R26,36
	BRLT _0xF7
_0xF6:
	RJMP _0xF5
_0xF7:
	CALL SUBOPT_0x32
	LDI  R26,LOW(65)
	STD  Z+0,R26
; 0000 0168                     if (yt>=40 && yt<=53)kibord[n]=0x53;//S
_0xF5:
	CALL SUBOPT_0x31
	SBIW R26,40
	BRLT _0xF9
	CALL SUBOPT_0x31
	SBIW R26,54
	BRLT _0xFA
_0xF9:
	RJMP _0xF8
_0xFA:
	CALL SUBOPT_0x32
	LDI  R26,LOW(83)
	STD  Z+0,R26
; 0000 0169                     if (yt>=59 && yt<=71)kibord[n]=0x44;//D
_0xF8:
	CALL SUBOPT_0x31
	SBIW R26,59
	BRLT _0xFC
	CALL SUBOPT_0x33
	BRLT _0xFD
_0xFC:
	RJMP _0xFB
_0xFD:
	CALL SUBOPT_0x32
	LDI  R26,LOW(68)
	STD  Z+0,R26
; 0000 016A                     if (yt>=74 && yt<=89)kibord[n]=0x46;//F
_0xFB:
	CALL SUBOPT_0x34
	BRLT _0xFF
	CALL SUBOPT_0x35
	BRLT _0x100
_0xFF:
	RJMP _0xFE
_0x100:
	CALL SUBOPT_0x32
	LDI  R26,LOW(70)
	STD  Z+0,R26
; 0000 016B                     if (yt>=91 && yt<=105)kibord[n]=0x47;//G
_0xFE:
	CALL SUBOPT_0x36
	BRLT _0x102
	CALL SUBOPT_0x37
	BRLT _0x103
_0x102:
	RJMP _0x101
_0x103:
	CALL SUBOPT_0x32
	LDI  R26,LOW(71)
	STD  Z+0,R26
; 0000 016C                     if (yt>=110 && yt<=123)kibord[n]=0x48;//H
_0x101:
	CALL SUBOPT_0x38
	BRLT _0x105
	CALL SUBOPT_0x39
	BRLT _0x106
_0x105:
	RJMP _0x104
_0x106:
	CALL SUBOPT_0x32
	LDI  R26,LOW(72)
	STD  Z+0,R26
; 0000 016D                     if (yt>=129 && yt<=138)kibord[n]=0x4a;//J
_0x104:
	CALL SUBOPT_0x3A
	BRLT _0x108
	CALL SUBOPT_0x3B
	BRLT _0x109
_0x108:
	RJMP _0x107
_0x109:
	CALL SUBOPT_0x32
	LDI  R26,LOW(74)
	STD  Z+0,R26
; 0000 016E                     if (yt>=143 && yt<=157)kibord[n]=0x4b;//K
_0x107:
	CALL SUBOPT_0x3C
	BRLT _0x10B
	CALL SUBOPT_0x3D
	BRLT _0x10C
_0x10B:
	RJMP _0x10A
_0x10C:
	CALL SUBOPT_0x32
	LDI  R26,LOW(75)
	STD  Z+0,R26
; 0000 016F                     if (yt>=161 && yt<=174)kibord[n]=0x4c;//L
_0x10A:
	CALL SUBOPT_0x3E
	BRLT _0x10E
	CALL SUBOPT_0x3F
	BRLT _0x10F
_0x10E:
	RJMP _0x10D
_0x10F:
	CALL SUBOPT_0x32
	LDI  R26,LOW(76)
	STD  Z+0,R26
; 0000 0170                     if (yt>=178 && yt<=190)kibord[n]=0x22;//"
_0x10D:
	CALL SUBOPT_0x40
	BRLT _0x111
	CALL SUBOPT_0x41
	BRLT _0x112
_0x111:
	RJMP _0x110
_0x112:
	CALL SUBOPT_0x32
	LDI  R26,LOW(34)
	STD  Z+0,R26
; 0000 0171               }
_0x110:
; 0000 0172 
; 0000 0173             if (xt>=194 && xt<=212){
_0xF2:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xC2)
	LDI  R30,HIGH(0xC2)
	CPC  R27,R30
	BRLT _0x114
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xD5)
	LDI  R30,HIGH(0xD5)
	CPC  R27,R30
	BRLT _0x115
_0x114:
	RJMP _0x113
_0x115:
; 0000 0174                     if (yt>=24 && yt<=35)kibord[n]=0x5a;//Z
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0x117
	CALL SUBOPT_0x31
	SBIW R26,36
	BRLT _0x118
_0x117:
	RJMP _0x116
_0x118:
	CALL SUBOPT_0x32
	LDI  R26,LOW(90)
	STD  Z+0,R26
; 0000 0175                     if (yt>=40 && yt<=53)kibord[n]=0x58;//X
_0x116:
	CALL SUBOPT_0x31
	SBIW R26,40
	BRLT _0x11A
	CALL SUBOPT_0x31
	SBIW R26,54
	BRLT _0x11B
_0x11A:
	RJMP _0x119
_0x11B:
	CALL SUBOPT_0x32
	LDI  R26,LOW(88)
	STD  Z+0,R26
; 0000 0176                     if (yt>=59 && yt<=71)kibord[n]=0x43;//C
_0x119:
	CALL SUBOPT_0x31
	SBIW R26,59
	BRLT _0x11D
	CALL SUBOPT_0x33
	BRLT _0x11E
_0x11D:
	RJMP _0x11C
_0x11E:
	CALL SUBOPT_0x32
	LDI  R26,LOW(67)
	STD  Z+0,R26
; 0000 0177                     if (yt>=74 && yt<=89)kibord[n]=0x56;//kibord
_0x11C:
	CALL SUBOPT_0x34
	BRLT _0x120
	CALL SUBOPT_0x35
	BRLT _0x121
_0x120:
	RJMP _0x11F
_0x121:
	CALL SUBOPT_0x32
	LDI  R26,LOW(86)
	STD  Z+0,R26
; 0000 0178                     if (yt>=91 && yt<=105)kibord[n]=0x42;//B
_0x11F:
	CALL SUBOPT_0x36
	BRLT _0x123
	CALL SUBOPT_0x37
	BRLT _0x124
_0x123:
	RJMP _0x122
_0x124:
	CALL SUBOPT_0x32
	LDI  R26,LOW(66)
	STD  Z+0,R26
; 0000 0179                     if (yt>=110 && yt<=123)kibord[n]=0x4e;//N
_0x122:
	CALL SUBOPT_0x38
	BRLT _0x126
	CALL SUBOPT_0x39
	BRLT _0x127
_0x126:
	RJMP _0x125
_0x127:
	CALL SUBOPT_0x32
	LDI  R26,LOW(78)
	STD  Z+0,R26
; 0000 017A                     if (yt>=129 && yt<=138)kibord[n]=0x4d;//M
_0x125:
	CALL SUBOPT_0x3A
	BRLT _0x129
	CALL SUBOPT_0x3B
	BRLT _0x12A
_0x129:
	RJMP _0x128
_0x12A:
	CALL SUBOPT_0x32
	LDI  R26,LOW(77)
	STD  Z+0,R26
; 0000 017B                     if (yt>=143 && yt<=157)kibord[n]=0x3f;//?
_0x128:
	CALL SUBOPT_0x3C
	BRLT _0x12C
	CALL SUBOPT_0x3D
	BRLT _0x12D
_0x12C:
	RJMP _0x12B
_0x12D:
	CALL SUBOPT_0x32
	LDI  R26,LOW(63)
	STD  Z+0,R26
; 0000 017C                     if (yt>=161 && yt<=174)kibord[n]=0x21;//!
_0x12B:
	CALL SUBOPT_0x3E
	BRLT _0x12F
	CALL SUBOPT_0x3F
	BRLT _0x130
_0x12F:
	RJMP _0x12E
_0x130:
	CALL SUBOPT_0x32
	LDI  R26,LOW(33)
	STD  Z+0,R26
; 0000 017D                     if (yt>=178 && yt<=190)kibord[n]=0x2f;///
_0x12E:
	CALL SUBOPT_0x40
	BRLT _0x132
	CALL SUBOPT_0x41
	BRLT _0x133
_0x132:
	RJMP _0x131
_0x133:
	CALL SUBOPT_0x32
	LDI  R26,LOW(47)
	STD  Z+0,R26
; 0000 017E              }
_0x131:
; 0000 017F 
; 0000 0180 
; 0000 0181 
; 0000 0182              }
_0x113:
; 0000 0183 
; 0000 0184 
; 0000 0185              if (xt>=215 && xt<=234){
_0xD0:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xD7)
	LDI  R30,HIGH(0xD7)
	CPC  R27,R30
	BRLT _0x135
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xEB)
	LDI  R30,HIGH(0xEB)
	CPC  R27,R30
	BRLT _0x136
_0x135:
	RJMP _0x134
_0x136:
; 0000 0186 //             if (yt>=24 && yt<=35)kibord[n]=0x5a;//Z
; 0000 0187              if (yt>=40 && yt<=157){
	CALL SUBOPT_0x31
	SBIW R26,40
	BRLT _0x138
	CALL SUBOPT_0x3D
	BRLT _0x139
_0x138:
	RJMP _0x137
_0x139:
; 0000 0188              kibord[n]=0x20;// spase
	CALL SUBOPT_0x32
	LDI  R26,LOW(32)
	STD  Z+0,R26
; 0000 0189              b=0;
	CLT
	BLD  R2,2
; 0000 018A              }
; 0000 018B              if (yt>=161 && yt<=190)kibord[n]=0x7f;//delet
_0x137:
	CALL SUBOPT_0x3E
	BRLT _0x13B
	CALL SUBOPT_0x41
	BRLT _0x13C
_0x13B:
	RJMP _0x13A
_0x13C:
	CALL SUBOPT_0x32
	LDI  R26,LOW(127)
	STD  Z+0,R26
; 0000 018C              }
_0x13A:
; 0000 018D 
; 0000 018E              if (xt>=240 && xt<=260){
_0x134:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xF0)
	LDI  R30,HIGH(0xF0)
	CPC  R27,R30
	BRLT _0x13E
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x105)
	LDI  R30,HIGH(0x105)
	CPC  R27,R30
	BRLT _0x13F
_0x13E:
	RJMP _0x13D
_0x13F:
; 0000 018F                     if (yt>=24 && yt<=46)exit=1;
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0x141
	CALL SUBOPT_0x31
	SBIW R26,47
	BRLT _0x142
_0x141:
	RJMP _0x140
_0x142:
	LDI  R30,LOW(1)
	STS  _exit,R30
; 0000 0190 
; 0000 0191                        if (yt>=53 && yt<=76){
_0x140:
	CALL SUBOPT_0x31
	SBIW R26,53
	BRLT _0x144
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x4D)
	LDI  R30,HIGH(0x4D)
	CPC  R27,R30
	BRLT _0x145
_0x144:
	RJMP _0x143
_0x145:
; 0000 0192                      if(nk==0) axka();
	LDS  R30,_nk
	CPI  R30,0
	BRNE _0x146
	RCALL _axka
; 0000 0193                      if(nk==1) axk3();
_0x146:
	LDS  R26,_nk
	CPI  R26,LOW(0x1)
	BRNE _0x147
	RCALL _axk3
; 0000 0194                       nk=!nk;
_0x147:
	LDS  R30,_nk
	CALL __LNEGB1
	STS  _nk,R30
; 0000 0195                      }
; 0000 0196 
; 0000 0197                    if (yt>=172 && yt<=198)v1++;//enter
_0x143:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xAC)
	LDI  R30,HIGH(0xAC)
	CPC  R27,R30
	BRLT _0x149
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xC7)
	LDI  R30,HIGH(0xC7)
	CPC  R27,R30
	BRLT _0x14A
_0x149:
	RJMP _0x148
_0x14A:
	LDS  R30,_v1
	SUBI R30,-LOW(1)
	STS  _v1,R30
; 0000 0198 //                         d=30-n;
; 0000 0199 //                         for(i=0;i<=d;i++){
; 0000 019A //                         text[i]=0x20;
; 0000 019B //                         kibord[i]=0x20;}
; 0000 019C //                         n=30;
; 0000 019D //                         }
; 0000 019E 
; 0000 019F                    if (yt>=24 && yt<=35)b=0;//upper font
_0x148:
	CALL SUBOPT_0x31
	SBIW R26,24
	BRLT _0x14C
	CALL SUBOPT_0x31
	SBIW R26,36
	BRLT _0x14D
_0x14C:
	RJMP _0x14B
_0x14D:
	CLT
	BLD  R2,2
; 0000 01A0                    }
_0x14B:
; 0000 01A1 
; 0000 01A2 
; 0000 01A3 
; 0000 01A4 
; 0000 01A5 
; 0000 01A6 
; 0000 01A7            _delay_ms(200);
_0x13D:
	CALL SUBOPT_0x42
; 0000 01A8 }
	RET
;
;void error(FRESULT res)
; 0000 01AB {
_error:
; 0000 01AC if ((res>=FR_DISK_ERR) && (res<=FR_TIMEOUT)){
	ST   -Y,R27
	ST   -Y,R26
;	res -> Y+0
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,1
	BRLT _0x14F
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,16
	BRLT _0x150
_0x14F:
	RJMP _0x14E
_0x150:
; 0000 01AD   sprintf( path,"%p",error_msg[res]);
	LDI  R30,LOW(_path)
	LDI  R31,HIGH(_path)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,309
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDI  R26,LOW(_error_msg*2)
	LDI  R27,HIGH(_error_msg*2)
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	CALL __GETW1PF
	CALL SUBOPT_0x1E
; 0000 01AE    SetLetter(E_LETTER);
; 0000 01AF       DrawStringAt(1,1, path,GetFgColor(),GetBkColor());
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _SetLine
	CALL SUBOPT_0x43
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2F
; 0000 01B0      }
; 0000 01B1 //     printf("%s",lcd_buf);
; 0000 01B2    _delay_ms(2000);
_0x14E:
	CALL SUBOPT_0x44
; 0000 01B3 }
	ADIW R28,2
	RET
;
;
;
;interrupt [TIM1_OVF] void timer_comp_isr(void)
; 0000 01B8 {
_timer_comp_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 01B9 /* re-initialize Timer1 */
; 0000 01BA TCNT1H=T1_INIT>>8;
	LDI  R30,LOW(249)
	OUT  0x2D,R30
; 0000 01BB TCNT1L=T1_INIT&0xFF;
	LDI  R30,LOW(230)
	OUT  0x2C,R30
; 0000 01BC /* card access low level timing function */
; 0000 01BD disk_timerproc();
	CALL _disk_timerproc
; 0000 01BE }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;callky(){
; 0000 01C0 callky(){
_callky:
; 0000 01C1 
; 0000 01C2   if(xt>=240 && xt<=260)if(yt>=26 && yt<=187)call();
	CALL SUBOPT_0x30
	CPI  R26,LOW(0xF0)
	LDI  R30,HIGH(0xF0)
	CPC  R27,R30
	BRLT _0x152
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x105)
	LDI  R30,HIGH(0x105)
	CPC  R27,R30
	BRLT _0x153
_0x152:
	RJMP _0x151
_0x153:
	CALL SUBOPT_0x31
	SBIW R26,26
	BRLT _0x155
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xBC)
	LDI  R30,HIGH(0xBC)
	CPC  R27,R30
	BRLT _0x156
_0x155:
	RJMP _0x154
_0x156:
	RCALL _call
; 0000 01C3 
; 0000 01C4   if(yt>=29 && yt<=78){
_0x154:
_0x151:
	CALL SUBOPT_0x31
	SBIW R26,29
	BRLT _0x158
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x4F)
	LDI  R30,HIGH(0x4F)
	CPC  R27,R30
	BRLT _0x159
_0x158:
	RJMP _0x157
_0x159:
; 0000 01C5   if(xt>=132 && xt<=152)kibord[n]=0x31; //1
	CALL SUBOPT_0x45
	BRLT _0x15B
	CALL SUBOPT_0x46
	BRLT _0x15C
_0x15B:
	RJMP _0x15A
_0x15C:
	CALL SUBOPT_0x32
	LDI  R26,LOW(49)
	STD  Z+0,R26
; 0000 01C6   if(xt>=157 && xt<=180)kibord[n]=0x34;//4
_0x15A:
	CALL SUBOPT_0x47
	BRLT _0x15E
	CALL SUBOPT_0x48
	BRLT _0x15F
_0x15E:
	RJMP _0x15D
_0x15F:
	CALL SUBOPT_0x32
	LDI  R26,LOW(52)
	STD  Z+0,R26
; 0000 01C7   if(xt>=182 && xt<=205)kibord[n]=0x37;//7
_0x15D:
	CALL SUBOPT_0x49
	BRLT _0x161
	CALL SUBOPT_0x4A
	BRLT _0x162
_0x161:
	RJMP _0x160
_0x162:
	CALL SUBOPT_0x32
	LDI  R26,LOW(55)
	STD  Z+0,R26
; 0000 01C8   if(xt>=208 && xt<=232)kibord[n]=0x2b;  //+
_0x160:
	CALL SUBOPT_0x4B
	BRLT _0x164
	CALL SUBOPT_0x4C
	BRLT _0x165
_0x164:
	RJMP _0x163
_0x165:
	CALL SUBOPT_0x32
	LDI  R26,LOW(43)
	STD  Z+0,R26
; 0000 01C9 //  kibord[n]=0x2a;//*
; 0000 01CA   }
_0x163:
; 0000 01CB 
; 0000 01CC   if(yt>=82 && yt<=136){
_0x157:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x52)
	LDI  R30,HIGH(0x52)
	CPC  R27,R30
	BRLT _0x167
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x89)
	LDI  R30,HIGH(0x89)
	CPC  R27,R30
	BRLT _0x168
_0x167:
	RJMP _0x166
_0x168:
; 0000 01CD   if(xt>=132 && xt<=152)kibord[n]=0x32; //2
	CALL SUBOPT_0x45
	BRLT _0x16A
	CALL SUBOPT_0x46
	BRLT _0x16B
_0x16A:
	RJMP _0x169
_0x16B:
	CALL SUBOPT_0x32
	LDI  R26,LOW(50)
	STD  Z+0,R26
; 0000 01CE   if(xt>=157 && xt<=180)kibord[n]=0x35;//5
_0x169:
	CALL SUBOPT_0x47
	BRLT _0x16D
	CALL SUBOPT_0x48
	BRLT _0x16E
_0x16D:
	RJMP _0x16C
_0x16E:
	CALL SUBOPT_0x32
	LDI  R26,LOW(53)
	STD  Z+0,R26
; 0000 01CF   if(xt>=182 && xt<=205)kibord[n]=0x38;//8
_0x16C:
	CALL SUBOPT_0x49
	BRLT _0x170
	CALL SUBOPT_0x4A
	BRLT _0x171
_0x170:
	RJMP _0x16F
_0x171:
	CALL SUBOPT_0x32
	LDI  R26,LOW(56)
	STD  Z+0,R26
; 0000 01D0   if(xt>=208 && xt<=232)kibord[n]=0x30;//0
_0x16F:
	CALL SUBOPT_0x4B
	BRLT _0x173
	CALL SUBOPT_0x4C
	BRLT _0x174
_0x173:
	RJMP _0x172
_0x174:
	CALL SUBOPT_0x32
	LDI  R26,LOW(48)
	STD  Z+0,R26
; 0000 01D1   }
_0x172:
; 0000 01D2 
; 0000 01D3   if(yt>=138 && yt<=183){
_0x166:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x8A)
	LDI  R30,HIGH(0x8A)
	CPC  R27,R30
	BRLT _0x176
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xB8)
	LDI  R30,HIGH(0xB8)
	CPC  R27,R30
	BRLT _0x177
_0x176:
	RJMP _0x175
_0x177:
; 0000 01D4   if(xt>=132 && xt<=152)kibord[n]=0x33;  //3
	CALL SUBOPT_0x45
	BRLT _0x179
	CALL SUBOPT_0x46
	BRLT _0x17A
_0x179:
	RJMP _0x178
_0x17A:
	CALL SUBOPT_0x32
	LDI  R26,LOW(51)
	STD  Z+0,R26
; 0000 01D5   if(xt>=157 && xt<=180)kibord[n]=0x36;//6
_0x178:
	CALL SUBOPT_0x47
	BRLT _0x17C
	CALL SUBOPT_0x48
	BRLT _0x17D
_0x17C:
	RJMP _0x17B
_0x17D:
	CALL SUBOPT_0x32
	LDI  R26,LOW(54)
	STD  Z+0,R26
; 0000 01D6   if(xt>=182 && xt<=205)kibord[n]=0x39;//9
_0x17B:
	CALL SUBOPT_0x49
	BRLT _0x17F
	CALL SUBOPT_0x4A
	BRLT _0x180
_0x17F:
	RJMP _0x17E
_0x180:
	CALL SUBOPT_0x32
	LDI  R26,LOW(57)
	STD  Z+0,R26
; 0000 01D7   if(xt>=208 && xt<=232)kibord[n]=0x23;//#
_0x17E:
	CALL SUBOPT_0x4B
	BRLT _0x182
	CALL SUBOPT_0x4C
	BRLT _0x183
_0x182:
	RJMP _0x181
_0x183:
	CALL SUBOPT_0x32
	LDI  R26,LOW(35)
	STD  Z+0,R26
; 0000 01D8   }
_0x181:
; 0000 01D9 
; 0000 01DA   if(yt>=160 && yt<=181)if(xt>=110 && xt<=135)kibord[n]=0x7f;
_0x175:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xA0)
	LDI  R30,HIGH(0xA0)
	CPC  R27,R30
	BRLT _0x185
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xB6)
	LDI  R30,HIGH(0xB6)
	CPC  R27,R30
	BRLT _0x186
_0x185:
	RJMP _0x184
_0x186:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x6E)
	LDI  R30,HIGH(0x6E)
	CPC  R27,R30
	BRLT _0x188
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x88)
	LDI  R30,HIGH(0x88)
	CPC  R27,R30
	BRLT _0x189
_0x188:
	RJMP _0x187
_0x189:
	CALL SUBOPT_0x32
	LDI  R26,LOW(127)
	STD  Z+0,R26
; 0000 01DB 
; 0000 01DC  if(yt>=127 && yt<=180){
_0x187:
_0x184:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x7F)
	LDI  R30,HIGH(0x7F)
	CPC  R27,R30
	BRLT _0x18B
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xB5)
	LDI  R30,HIGH(0xB5)
	CPC  R27,R30
	BRLT _0x18C
_0x18B:
	RJMP _0x18A
_0x18C:
; 0000 01DD  if(xt>=38 && xt<=49) callregect();
	CALL SUBOPT_0x30
	SBIW R26,38
	BRLT _0x18E
	CALL SUBOPT_0x30
	SBIW R26,50
	BRLT _0x18F
_0x18E:
	RJMP _0x18D
_0x18F:
	RCALL _callregect
; 0000 01DE   if(xt>=50 && xt<=60) callconect();
_0x18D:
	CALL SUBOPT_0x30
	SBIW R26,50
	BRLT _0x191
	CALL SUBOPT_0x30
	SBIW R26,61
	BRLT _0x192
_0x191:
	RJMP _0x190
_0x192:
	RCALL _callconect
; 0000 01DF  }
_0x190:
; 0000 01E0 
; 0000 01E1 
; 0000 01E2   if (xt>=255 && xt<=273)if(yt>=34 && yt<=45)exit=1;
_0x18A:
	CALL SUBOPT_0x4D
	BRLT _0x194
	CALL SUBOPT_0x4E
	BRLT _0x195
_0x194:
	RJMP _0x193
_0x195:
	CALL SUBOPT_0x31
	SBIW R26,34
	BRLT _0x197
	CALL SUBOPT_0x31
	SBIW R26,46
	BRLT _0x198
_0x197:
	RJMP _0x196
_0x198:
	LDI  R30,LOW(1)
	STS  _exit,R30
; 0000 01E3 
; 0000 01E4 
; 0000 01E5  _delay_ms(100);
_0x196:
_0x193:
	CALL SUBOPT_0x4F
	JMP  _0x20E001F
; 0000 01E6 
; 0000 01E7   //
; 0000 01E8 
; 0000 01E9 
; 0000 01EA  }
;
;givecode(){
; 0000 01EC givecode(){
_givecode:
; 0000 01ED 
; 0000 01EE 
; 0000 01EF         while(1){
_0x199:
; 0000 01F0 
; 0000 01F1 
; 0000 01F2                         while(kibord[n]==0){
_0x19C:
	CALL SUBOPT_0x32
	LD   R30,Z
	CPI  R30,0
	BREQ PC+3
	JMP _0x19E
; 0000 01F3                         tuch();
	RCALL _tuch
; 0000 01F4                         if(n1==3)key();
	LDS  R26,_n1
	CPI  R26,LOW(0x3)
	BRNE _0x19F
	RCALL _key
; 0000 01F5                         if(n1==8)callky();
_0x19F:
	LDS  R26,_n1
	CPI  R26,LOW(0x8)
	BRNE _0x1A0
	RCALL _callky
; 0000 01F6 
; 0000 01F7 
; 0000 01F8 
; 0000 01F9                                 if(kibord[n]==0x7f){
_0x1A0:
	CALL SUBOPT_0x32
	LD   R26,Z
	CPI  R26,LOW(0x7F)
	BREQ PC+3
	JMP _0x1A1
; 0000 01FA                                 kibord[n]=0;
	CALL SUBOPT_0x50
	CALL SUBOPT_0x21
; 0000 01FB                                 kibord[n-1]=0;
	CALL SUBOPT_0x50
	SBIW R30,1
	CALL SUBOPT_0x21
; 0000 01FC                                  if(nu==1){
	SBRS R2,1
	RJMP _0x1A2
; 0000 01FD                                  number[n]=0;
	CALL SUBOPT_0x50
	CALL SUBOPT_0x26
; 0000 01FE                                  number[n-1]=0;
	CALL SUBOPT_0x50
	SBIW R30,1
	CALL SUBOPT_0x26
; 0000 01FF                                  }
; 0000 0200 
; 0000 0201                                  if(s==1){
_0x1A2:
	SBRS R2,0
	RJMP _0x1A3
; 0000 0202                                   text[n]=0;
	CALL SUBOPT_0x50
	CALL SUBOPT_0x25
; 0000 0203                                   text[n-1]=0;
	CALL SUBOPT_0x50
	SBIW R30,1
	CALL SUBOPT_0x25
; 0000 0204                                   }
; 0000 0205                                 n--;
_0x1A3:
	CALL SUBOPT_0x51
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0206 
; 0000 0207 
; 0000 0208                                    if(s==1)RectangleFill(0,65,220,80,BLACK);
	SBRS R2,0
	RJMP _0x1A4
	CALL SUBOPT_0x52
	CALL SUBOPT_0x53
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 0209                                    if(nu==1){
_0x1A4:
	SBRS R2,1
	RJMP _0x1A5
; 0000 020A                                    if(j==0)RectangleFill(0,50,150,70,BLACK);
	LDS  R30,_j
	CPI  R30,0
	BRNE _0x1A6
	CALL SUBOPT_0x52
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x54
	LDI  R30,LOW(70)
	LDI  R31,HIGH(70)
	CALL SUBOPT_0x55
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 020B                                    if(j==1)RectangleFill(9,128,190,145,BLACK);
_0x1A6:
	LDS  R26,_j
	CPI  R26,LOW(0x1)
	BRNE _0x1A7
	CALL SUBOPT_0x56
	LDI  R30,LOW(190)
	LDI  R31,HIGH(190)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x57
	LDI  R30,LOW(145)
	LDI  R31,HIGH(145)
	CALL SUBOPT_0x55
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 020C                                    }
_0x1A7:
; 0000 020D 
; 0000 020E                                 if(s==1)DrawStringAt(v1,0,kibord,WHITE, WHITE);
_0x1A5:
	SBRS R2,0
	RJMP _0x1A8
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
_0x1A8:
; 0000 020F                                 if(nu==1)DrawStringAt(n1,j,kibord,GREEN, WHITE);
	SBRS R2,1
	RJMP _0x1A9
	CALL SUBOPT_0x5A
_0x1A9:
; 0000 0210                                 }
; 0000 0211 
; 0000 0212                                  if(exit==1)break;
_0x1A1:
	LDS  R26,_exit
	CPI  R26,LOW(0x1)
	BREQ _0x19E
; 0000 0213                     }
	RJMP _0x19C
_0x19E:
; 0000 0214 
; 0000 0215 
; 0000 0216 
; 0000 0217                       if(exit==1){
	LDS  R26,_exit
	CPI  R26,LOW(0x1)
	BRNE _0x1AB
; 0000 0218                         if(s==1)bsn=n; //backup place x sms
	SBRS R2,0
	RJMP _0x1AC
	LDS  R30,_n
	STS  _bsn,R30
; 0000 0219                         if(nu==1)bnun=n; //backup place x phone number
_0x1AC:
	SBRS R2,1
	RJMP _0x1AD
	LDS  R30,_n
	STS  _bnun,R30
; 0000 021A                         s=0;   //disable sms
_0x1AD:
	CLT
	BLD  R2,0
; 0000 021B                         nu=0;  //disabel phone number
	BLD  R2,1
; 0000 021C                         nk=0;  //chenge kibord
	LDI  R30,LOW(0)
	STS  _nk,R30
; 0000 021D 
; 0000 021E                           TFT_CLS(BLACK );
	CALL SUBOPT_0x52
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 021F                            exit=0;     //disabel break
	LDI  R30,LOW(0)
	STS  _exit,R30
; 0000 0220                            n=0;        //place alefba reset
	STS  _n,R30
	STS  _n+1,R30
; 0000 0221                            for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
	STS  _i,R30
_0x1AF:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x1B0
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x1AF
_0x1B0:
; 0000 0222 break;
	RJMP _0x19B
; 0000 0223 
; 0000 0224 
; 0000 0225                         }
; 0000 0226 
; 0000 0227 
; 0000 0228                     if(s==1 && exit==0){
_0x1AB:
	SBRS R2,0
	RJMP _0x1B2
	LDS  R26,_exit
	CPI  R26,LOW(0x0)
	BREQ _0x1B3
_0x1B2:
	RJMP _0x1B1
_0x1B3:
; 0000 0229                     if(b==1)kibord[n]=tolower(kibord[n]); // A to a , .....
	SBRS R2,2
	RJMP _0x1B4
	CALL SUBOPT_0x32
	PUSH R31
	PUSH R30
	LD   R26,Z
	CALL _tolower
	POP  R26
	POP  R27
	ST   X,R30
; 0000 022A                     if(kibord[n]==0x20)b=0;
_0x1B4:
	CALL SUBOPT_0x32
	LD   R26,Z
	CPI  R26,LOW(0x20)
	BRNE _0x1B5
	CLT
	RJMP _0x215
; 0000 022B                     else
_0x1B5:
; 0000 022C                     b=1;
	SET
_0x215:
	BLD  R2,2
; 0000 022D                     text[n]=kibord[n];
	LDS  R26,_n
	LDS  R27,_n+1
	SUBI R26,LOW(-_text)
	SBCI R27,HIGH(-_text)
	CALL SUBOPT_0x32
	LD   R30,Z
	ST   X,R30
; 0000 022E                     DrawStringAt(v1,0,kibord,WHITE, WHITE);
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
; 0000 022F                     n++;
	CALL SUBOPT_0x51
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0230                     }
; 0000 0231 
; 0000 0232                    if(nu==1 && exit==0){
_0x1B1:
	SBRS R2,1
	RJMP _0x1B8
	LDS  R26,_exit
	CPI  R26,LOW(0x0)
	BREQ _0x1B9
_0x1B8:
	RJMP _0x1B7
_0x1B9:
; 0000 0233                     number[n]=kibord[n];
	LDS  R26,_n
	LDS  R27,_n+1
	SUBI R26,LOW(-_number)
	SBCI R27,HIGH(-_number)
	CALL SUBOPT_0x32
	LD   R30,Z
	ST   X,R30
; 0000 0234                     DrawStringAt(n1,j,kibord,GREEN, WHITE);
	CALL SUBOPT_0x5A
; 0000 0235                     n++;
	CALL SUBOPT_0x51
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 0236                     }
; 0000 0237 
; 0000 0238 
; 0000 0239 
; 0000 023A 
; 0000 023B             };
_0x1B7:
	RJMP _0x199
_0x19B:
; 0000 023C 
; 0000 023D }
	RET
;
;
;
;
;
;
;kd(){
; 0000 0244 kd(){
_kd:
; 0000 0245 
; 0000 0246    if(xt>=32 && xt<=48)if(yt>=146 && yt<=180)sms();//send sms
	CALL SUBOPT_0x30
	SBIW R26,32
	BRLT _0x1BB
	CALL SUBOPT_0x30
	SBIW R26,49
	BRLT _0x1BC
_0x1BB:
	RJMP _0x1BA
_0x1BC:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x92)
	LDI  R30,HIGH(0x92)
	CPC  R27,R30
	BRLT _0x1BE
	CALL SUBOPT_0x31
	CPI  R26,LOW(0xB5)
	LDI  R30,HIGH(0xB5)
	CPC  R27,R30
	BRLT _0x1BF
_0x1BE:
	RJMP _0x1BD
_0x1BF:
	RCALL _sms
; 0000 0247   if (xt>=60 && xt<=80)if(yt>=23 && yt<=190){
_0x1BD:
_0x1BA:
	CALL SUBOPT_0x30
	SBIW R26,60
	BRLT _0x1C1
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x51)
	LDI  R30,HIGH(0x51)
	CPC  R27,R30
	BRLT _0x1C2
_0x1C1:
	RJMP _0x1C0
_0x1C2:
	CALL SUBOPT_0x31
	SBIW R26,23
	BRLT _0x1C4
	CALL SUBOPT_0x41
	BRLT _0x1C5
_0x1C4:
	RJMP _0x1C3
_0x1C5:
; 0000 0248   axka();
	RCALL _axka
; 0000 0249   nk=1;  //chenge kibord 0=alefba 1=adad
	LDI  R30,LOW(1)
	STS  _nk,R30
; 0000 024A   s=0;   //disable sms
	CLT
	BLD  R2,0
; 0000 024B   n=bnun; // copy backup x to n
	LDS  R30,_bnun
	CALL SUBOPT_0x5D
; 0000 024C   nu=1;   //enabel phone nuber
	BLD  R2,1
; 0000 024D   for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
	LDI  R30,LOW(0)
	STS  _i,R30
_0x1C7:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x1C8
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x1C7
_0x1C8:
; 0000 024E for (i=0;i<12;i++)kibord[i]=number[i];
	LDI  R30,LOW(0)
	STS  _i,R30
_0x1CA:
	LDS  R26,_i
	CPI  R26,LOW(0xC)
	BRSH _0x1CB
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_number)
	SBCI R31,HIGH(-_number)
	LD   R30,Z
	ST   X,R30
	CALL SUBOPT_0x1C
	RJMP _0x1CA
_0x1CB:
; 0000 024F kibord[n]=0;
	CALL SUBOPT_0x50
	CALL SUBOPT_0x21
; 0000 0250   RectangleFill(0,30,150,60,BLACK);
	CALL SUBOPT_0x52
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(30)
	LDI  R31,HIGH(30)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL SUBOPT_0x55
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 0251   DrawStringAt(n1,j,number,GREEN, WHITE);
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x60
	LDI  R26,LOW(_number)
	LDI  R27,HIGH(_number)
	CALL _Puts
; 0000 0252   }
; 0000 0253 
; 0000 0254   if (xt>=80 && xt<=134)if(yt>=23 && yt<=190){
_0x1C3:
_0x1C0:
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x50)
	LDI  R30,HIGH(0x50)
	CPC  R27,R30
	BRLT _0x1CD
	CALL SUBOPT_0x30
	CPI  R26,LOW(0x87)
	LDI  R30,HIGH(0x87)
	CPC  R27,R30
	BRLT _0x1CE
_0x1CD:
	RJMP _0x1CC
_0x1CE:
	CALL SUBOPT_0x31
	SBIW R26,23
	BRLT _0x1D0
	CALL SUBOPT_0x41
	BRLT _0x1D1
_0x1D0:
	RJMP _0x1CF
_0x1D1:
; 0000 0255   axk3();
	RCALL _axk3
; 0000 0256   nk=0;  //chenge kibord 0=alefba 1=adad
	LDI  R30,LOW(0)
	STS  _nk,R30
; 0000 0257   nu=0;  //disabel phone number
	CLT
	BLD  R2,1
; 0000 0258   n=bsn;// copy backup x to n
	LDS  R30,_bsn
	CALL SUBOPT_0x5D
; 0000 0259   s=1;   //enable sms
	BLD  R2,0
; 0000 025A   for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
	LDI  R30,LOW(0)
	STS  _i,R30
_0x1D3:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x1D4
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x1D3
_0x1D4:
; 0000 025B for (i=0;i<50;i++)kibord[i]=text[i];
	LDI  R30,LOW(0)
	STS  _i,R30
_0x1D6:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x1D7
	CALL SUBOPT_0x5E
	SUBI R30,LOW(-_text)
	SBCI R31,HIGH(-_text)
	LD   R30,Z
	ST   X,R30
	CALL SUBOPT_0x1C
	RJMP _0x1D6
_0x1D7:
; 0000 025C kibord[n]=0;
	CALL SUBOPT_0x50
	CALL SUBOPT_0x21
; 0000 025D   RectangleFill(0,65,220,80,BLACK);
	CALL SUBOPT_0x52
	CALL SUBOPT_0x53
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 025E   DrawStringAt(v1,0,text,WHITE, WHITE);
	CALL SUBOPT_0x58
	CALL SUBOPT_0x61
	LDI  R26,LOW(_text)
	LDI  R27,HIGH(_text)
	CALL _Puts
; 0000 025F   }
; 0000 0260 
; 0000 0261    if (xt>=255 && xt<=273)if(yt>=34 && yt<=45)exit=1;
_0x1CF:
_0x1CC:
	CALL SUBOPT_0x4D
	BRLT _0x1D9
	CALL SUBOPT_0x4E
	BRLT _0x1DA
_0x1D9:
	RJMP _0x1D8
_0x1DA:
	CALL SUBOPT_0x31
	SBIW R26,34
	BRLT _0x1DC
	CALL SUBOPT_0x31
	SBIW R26,46
	BRLT _0x1DD
_0x1DC:
	RJMP _0x1DB
_0x1DD:
	LDI  R30,LOW(1)
	STS  _exit,R30
; 0000 0262 
; 0000 0263 
; 0000 0264 }
_0x1DB:
_0x1D8:
	RET
;
;
;
;maincall(){
; 0000 0268 maincall(){
_maincall:
; 0000 0269 TFT_CLS(BLACK );
	CALL SUBOPT_0x52
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 026A  SetLetter(P_LETTER);
	CALL SUBOPT_0x20
; 0000 026B                  DrawStringAt(0,0," ",WHITE, WHITE);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x61
	__POINTW2MN _0x1DE,0
	CALL _Puts
; 0000 026C s=0;
	CLT
	BLD  R2,0
; 0000 026D nu=1;
	SET
	BLD  R2,1
; 0000 026E nk=1;
	LDI  R30,LOW(1)
	STS  _nk,R30
; 0000 026F 
; 0000 0270   callt();
	CALL _callt
; 0000 0271 
; 0000 0272 
; 0000 0273 
; 0000 0274 
; 0000 0275                              j=1;
	LDI  R30,LOW(1)
	STS  _j,R30
; 0000 0276                              n1=8;
	LDI  R30,LOW(8)
	STS  _n1,R30
; 0000 0277             while(1){
_0x1DF:
; 0000 0278 
; 0000 0279 
; 0000 027A 
; 0000 027B 
; 0000 027C                               tuch();
	RCALL _tuch
; 0000 027D                               givecode();
	RCALL _givecode
; 0000 027E                               callky();
	RCALL _callky
; 0000 027F              if(exit==1){
	LDS  R26,_exit
	CPI  R26,LOW(0x1)
	BRNE _0x1E2
; 0000 0280              exit=0;
	LDI  R30,LOW(0)
	STS  _exit,R30
; 0000 0281              nu==0;
	LDI  R26,0
	SBRC R2,1
	LDI  R26,1
	CALL __EQB12
; 0000 0282              nk==0;
	LDS  R26,_nk
	LDI  R30,LOW(0)
	CALL __EQB12
; 0000 0283              n1=3;
	LDI  R30,LOW(3)
	STS  _n1,R30
; 0000 0284              j=0;
	LDI  R30,LOW(0)
	STS  _j,R30
; 0000 0285              for (i=0;i<50;i++)kibord[i]=0;  //clear kibord
	STS  _i,R30
_0x1E4:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x1E5
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x1E4
_0x1E5:
; 0000 0286 for (i=0;i<12;i++)number[i]=0;
	LDI  R30,LOW(0)
	STS  _i,R30
_0x1E7:
	LDS  R26,_i
	CPI  R26,LOW(0xC)
	BRSH _0x1E8
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x26
	CALL SUBOPT_0x1C
	RJMP _0x1E7
_0x1E8:
; 0000 0287 break;
	RJMP _0x1E1
; 0000 0288              }
; 0000 0289 
; 0000 028A             };
_0x1E2:
	RJMP _0x1DF
_0x1E1:
; 0000 028B 
; 0000 028C 
; 0000 028D 
; 0000 028E }
	RET

	.DSEG
_0x1DE:
	.BYTE 0xA
;
;
;
;
;mainsms(){
; 0000 0293 mainsms(){

	.CSEG
_mainsms:
; 0000 0294 TFT_CLS(BLACK );
	CALL SUBOPT_0x52
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 0295          n1=3;
	LDI  R30,LOW(3)
	STS  _n1,R30
; 0000 0296 
; 0000 0297            while(1){
_0x1E9:
; 0000 0298                  SetLetter(P_LETTER);
	CALL SUBOPT_0x20
; 0000 0299 
; 0000 029A                  DrawStringAt(0,0," ",WHITE, WHITE);
	LDI  R30,LOW(0)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x61
	__POINTW2MN _0x1EC,0
	CALL _Puts
; 0000 029B                  DrawStringAt(1,0," ",GREEN, WHITE);
	CALL SUBOPT_0x27
	LDI  R30,LOW(2016)
	LDI  R31,HIGH(2016)
	CALL SUBOPT_0x60
	__POINTW2MN _0x1EC,10
	CALL _Puts
; 0000 029C                  DrawStringAt(3,0,"",YELLOW,GetBkColor());
	LDI  R30,LOW(3)
	CALL SUBOPT_0x1F
	__POINTW2MN _0x1EC,21
	CALL _Puts
; 0000 029D                  DrawStringAt(4,0," ",YELLOW,GetBkColor());
	LDI  R30,LOW(4)
	CALL SUBOPT_0x1F
	__POINTW2MN _0x1EC,27
	CALL _Puts
; 0000 029E 
; 0000 029F        if(s==1 || nu==1)givecode();  ////trxt sms
	SBRC R2,0
	RJMP _0x1EE
	SBRS R2,1
	RJMP _0x1ED
_0x1EE:
	RCALL _givecode
; 0000 02A0         tuch();
_0x1ED:
	RCALL _tuch
; 0000 02A1         kd();
	RCALL _kd
; 0000 02A2 
; 0000 02A3          if(exit==1){
	LDS  R26,_exit
	CPI  R26,LOW(0x1)
	BRNE _0x1F0
; 0000 02A4              TFT_CLS(BLACK );
	CALL SUBOPT_0x52
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 02A5              nu=0;
	CLT
	BLD  R2,1
; 0000 02A6              s=0;
	BLD  R2,0
; 0000 02A7              exit=0;
	LDI  R30,LOW(0)
	STS  _exit,R30
; 0000 02A8              for (i=0;i<12;i++)number[i]=0;  //clear number
	STS  _i,R30
_0x1F2:
	LDS  R26,_i
	CPI  R26,LOW(0xC)
	BRSH _0x1F3
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x26
	CALL SUBOPT_0x1C
	RJMP _0x1F2
_0x1F3:
; 0000 02A9 for (i=0;i<50;i++)text[i]=0;
	LDI  R30,LOW(0)
	STS  _i,R30
_0x1F5:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x1F6
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x25
	CALL SUBOPT_0x1C
	RJMP _0x1F5
_0x1F6:
; 0000 02AA for (i=0;i<50;i++)kibord[i]=0;
	LDI  R30,LOW(0)
	STS  _i,R30
_0x1F8:
	LDS  R26,_i
	CPI  R26,LOW(0x32)
	BRSH _0x1F9
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x1C
	RJMP _0x1F8
_0x1F9:
; 0000 02AB break;
	RJMP _0x1EB
; 0000 02AC              }
; 0000 02AD 
; 0000 02AE 
; 0000 02AF        SetLetter(E_LETTER);
_0x1F0:
	CALL SUBOPT_0x22
	CALL _SetLetter
; 0000 02B0        DrawStringAt(n1,j,number,GREEN,GetBkColor());
	CALL SUBOPT_0x5F
	CALL SUBOPT_0x28
	LDI  R26,LOW(_number)
	LDI  R27,HIGH(_number)
	CALL _Puts
; 0000 02B1        DrawStringAt(v1,0,text,WHITE,GetBkColor());
	CALL SUBOPT_0x58
	CALL SUBOPT_0x2D
	LDI  R26,LOW(_text)
	LDI  R27,HIGH(_text)
	CALL _Puts
; 0000 02B2 
; 0000 02B3 
; 0000 02B4 
; 0000 02B5 };
	RJMP _0x1E9
_0x1EB:
; 0000 02B6 }
	RET

	.DSEG
_0x1EC:
	.BYTE 0x24
;
;
;desktop(){
; 0000 02B9 desktop(){

	.CSEG
_desktop:
; 0000 02BA if (xt>=255 && xt<=273){
	CALL SUBOPT_0x4D
	BRLT _0x1FB
	CALL SUBOPT_0x4E
	BRLT _0x1FC
_0x1FB:
	RJMP _0x1FA
_0x1FC:
; 0000 02BB   if(yt>=34 && yt<=45)exit=1;
	CALL SUBOPT_0x31
	SBIW R26,34
	BRLT _0x1FE
	CALL SUBOPT_0x31
	SBIW R26,46
	BRLT _0x1FF
_0x1FE:
	RJMP _0x1FD
_0x1FF:
	LDI  R30,LOW(1)
	STS  _exit,R30
; 0000 02BC   if(yt>=67 && yt<=87)mainsms();
_0x1FD:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x43)
	LDI  R30,HIGH(0x43)
	CPC  R27,R30
	BRLT _0x201
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x58)
	LDI  R30,HIGH(0x58)
	CPC  R27,R30
	BRLT _0x202
_0x201:
	RJMP _0x200
_0x202:
	RCALL _mainsms
; 0000 02BD //  if (yt>=99 && yt<=119)
; 0000 02BE   if (yt>=131 && yt<=151)maincall();
_0x200:
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x83)
	LDI  R30,HIGH(0x83)
	CPC  R27,R30
	BRLT _0x204
	CALL SUBOPT_0x31
	CPI  R26,LOW(0x98)
	LDI  R30,HIGH(0x98)
	CPC  R27,R30
	BRLT _0x205
_0x204:
	RJMP _0x203
_0x205:
	RCALL _maincall
; 0000 02BF //  if (yt>=185 && yt<=165)
; 0000 02C0 
; 0000 02C1    }
_0x203:
; 0000 02C2 
; 0000 02C3 }
_0x1FA:
	RET
;
;
;
;
;
;
;//	<<< main function >>>
;//*****************************************************************************
;void main (void)
; 0000 02CD {
_main:
; 0000 02CE 	TFTInit();					//*** ili9325 TFT-LCD initiation
	RCALL _TFTInit
; 0000 02CF 
; 0000 02D0     //////////////////usart////////////////////
; 0000 02D1         // USART initialization 16 MHZ
; 0000 02D2         // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 02D3         // USART Receiver: On
; 0000 02D4         // USART Transmitter: On
; 0000 02D5         // USART Mode: Asynchronous
; 0000 02D6         // USART Baud Rate: 9600
; 0000 02D7         UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 02D8         UCSRB=0x18;
	LDI  R30,LOW(24)
	OUT  0xA,R30
; 0000 02D9         UCSRC=0x06;
	LDI  R30,LOW(6)
	OUT  0x20,R30
; 0000 02DA         UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 02DB         UBRRL=0x67;
	LDI  R30,LOW(103)
	OUT  0x9,R30
; 0000 02DC 
; 0000 02DD     ///////////////////adc///////////////////////
; 0000 02DE         // ADC initialization
; 0000 02DF         // ADC Clock frequency: 1000/000 kHz
; 0000 02E0         // ADC Voltage Reference: AVCC pin
; 0000 02E1         ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(64)
	OUT  0x7,R30
; 0000 02E2         ADCSRA=0x83;
	LDI  R30,LOW(131)
	OUT  0x6,R30
; 0000 02E3     /////////////////////////////////////////////
; 0000 02E4 
; 0000 02E5     /////////////////TIMER FOR SD////////////////
; 0000 02E6     TCCR1A=0x00;
	LDI  R30,LOW(0)
	OUT  0x2F,R30
; 0000 02E7     TCCR1B=(1<<CS12)|(1<<CS10);
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 02E8     TCNT1H=T1_INIT>>8;
	LDI  R30,LOW(249)
	OUT  0x2D,R30
; 0000 02E9     TCNT1L=T1_INIT&0xFF;
	LDI  R30,LOW(230)
	OUT  0x2C,R30
; 0000 02EA     TIMSK=1<<TOIE1;
	LDI  R30,LOW(4)
	OUT  0x39,R30
; 0000 02EB     ////////////////////////////////////////////
; 0000 02EC     #asm("sei")
	sei
; 0000 02ED 
; 0000 02EE //    TFTReset();
; 0000 02EF 
; 0000 02F0 	TFTBacklight(ON);
	LDI  R26,LOW(1)
	CALL _TFTBacklight
; 0000 02F1 
; 0000 02F2     LcdHorizontal(1); //(TFT_ORN_PORTRAIT);
	LDI  R30,LOW(1)
	STS  _Horizontal,R30
; 0000 02F3     LcdFont(AF12x16);
	LDI  R26,LOW(_AF12x16*2)
	LDI  R27,HIGH(_AF12x16*2)
	CALL _LcdFont
; 0000 02F4     LcdFontSpace(1);
	LDI  R30,LOW(1)
	STS  _FontSpace,R30
; 0000 02F5     LcdFontXScale(1);
	STS  _FontXScale,R30
; 0000 02F6     LcdFontYScale(1);
	STS  _FontYScale,R30
; 0000 02F7     SetFgColor(WHITE);
	CALL SUBOPT_0x61
; 0000 02F8     SetBkColor(WHITE);
; 0000 02F9    SetLetter(P_LETTER);
	CALL SUBOPT_0x20
; 0000 02FA 
; 0000 02FB //
; 0000 02FC //		test01();
; 0000 02FD TFT_CLS(BLACK );
	CALL SUBOPT_0x52
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 02FE 
; 0000 02FF 
; 0000 0300 
; 0000 0301        // ////////////////////////////////////start sim 900
; 0000 0302         DDRB.0=1;
	SBI  0x17,0
; 0000 0303         PORTB.0=1;
	SBI  0x18,0
; 0000 0304         _delay_ms(2000);
	CALL SUBOPT_0x44
; 0000 0305         PORTB.0=0;
	CBI  0x18,0
; 0000 0306        _delay_ms(2000);
	CALL SUBOPT_0x44
; 0000 0307         PORTB.0=1;
	SBI  0x18,0
; 0000 0308        ///////////////////////////////////////////////////
; 0000 0309 
; 0000 030A 
; 0000 030B 
; 0000 030C 
; 0000 030D //----------------------------------------------------------------------
; 0000 030E 
; 0000 030F                 // mount logical drive 0:
; 0000 0310                 if ((res=f_mount(0,&drive))==FR_OK)
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(_drive)
	LDI  R27,HIGH(_drive)
	CALL _f_mount
	MOVW R4,R30
	SBIW R30,0
	BRNE _0x20E
; 0000 0311                 {DrawStringAt(0,0,"  ",WHITE, WHITE);}
	LDI  R30,LOW(0)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x61
	__POINTW2MN _0x20F,0
	CALL _Puts
; 0000 0312                 //   printf(Logical drive 0: mounted OK\r\n);
; 0000 0313                 else
	RJMP _0x210
_0x20E:
; 0000 0314                 /* an error occured, display it and stop */
; 0000 0315                 error(res);
	MOVW R26,R4
	RCALL _error
; 0000 0316 
; 0000 0317                  bmpFile("vv.BMP");
_0x210:
	__POINTW2MN _0x20F,15
	CALL SUBOPT_0x15
; 0000 0318             bmpShow(0,0);
	CALL SUBOPT_0x22
	CALL _bmpShow
; 0000 0319                    _delay_ms(4000);
	LDI  R26,LOW(4000)
	LDI  R27,HIGH(4000)
	CALL _delay_ms
; 0000 031A          TFT_CLS(BLACK );
	CALL SUBOPT_0x52
	CALL SUBOPT_0x5B
	CALL SUBOPT_0x5C
	CALL SUBOPT_0x22
	CALL _TFTFillRect
; 0000 031B 
; 0000 031C 
; 0000 031D                ////
; 0000 031E //                /* repeateadly read directory entries and display them */
; 0000 031F //                if ((res=directory_scan(path))!=FR_OK)
; 0000 0320 //                   /* if an error occured, display it and stop */
; 0000 0321 //                   error(res);
; 0000 0322 //------------------------------------------------------------------------
; 0000 0323 
; 0000 0324 
; 0000 0325  while(1){
_0x211:
; 0000 0326            SetLetter(P_LETTER);
	CALL SUBOPT_0x20
; 0000 0327          {DrawStringAt(0,0," ",WHITE, WHITE);}
	LDI  R30,LOW(0)
	CALL SUBOPT_0x29
	CALL SUBOPT_0x61
	__POINTW2MN _0x20F,22
	CALL _Puts
; 0000 0328 
; 0000 0329          tuch();
	CALL _tuch
; 0000 032A          desktop();
	RCALL _desktop
; 0000 032B 
; 0000 032C 
; 0000 032D         };
	RJMP _0x211
; 0000 032E 
; 0000 032F 
; 0000 0330 } //main
_0x214:
	RJMP _0x214

	.DSEG
_0x20F:
	.BYTE 0x20
;
;
;
;
;
;//---------------------------------------------------------//
;//---------------------------------------------------------//
;//
;//void test01(void)
;//{
;//	unsigned int 			y  = 0;
;//	unsigned char			yp = (GetMaxY()+1)/20;
;//
;//	TFT_CLS(WHITE);
;//
;//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_BLUE);					y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  BLUE);							y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_BLUE);				y += yp;
;//
;//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_GREEN);				y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  GREEN);							y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_GREEN);				y += yp;
;//
;//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_YELLOW);				y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  YELLOW);						y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_YELLOW);			y += yp;
;//
;//	RectangleFill(0, y, GetMaxX(), y+yp,  DARK_RED);					y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  RED);								y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  LIGHT_RED);					y += yp;
;//
;//	RectangleFill(0, y, GetMaxX(), y+yp,  MAGENTA);						y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  CYAN);							y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  BROWN);							y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  SILVER);						y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  GOLD);							y += yp;
;//
;//	RectangleFill(0, y, GetMaxX(), y+yp,  BLACK);							y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  GRAY);							y += yp;
;//	RectangleFill(0, y, GetMaxX(), y+yp,  WHITE);							y += yp;
;//}	//test01
;//
;//
;//
;//-----------------------------------------------------------------------------
;// Copyright:      RAD Electronic Co. LTD,
;// Author:         Sh. Nourbakhsh Rad
;// Remarks:
;// known Problems: none
;// Version:        2.5.0
;// Description:    N96 TFT-LCD display driver == 8bit & 16bit mode!
;//-----------------------------------------------------------------------------
;
;#include "ili9325.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;//******************* Constants
;unsigned short							TFT_ID_code				= 0x0000;
;
;int 												TFT_margin_xl 		= 0;
;int 												TFT_margin_xr 		= TFT_SIZE_X - 1;

	.DSEG
;int 												TFT_margin_yu 		= 0;
;int 												TFT_margin_yl 		= TFT_SIZE_Y - 1;
;
;unsigned int 								newX							= 0;
;unsigned int 								newY							= 0;
;
;//*************************************************
;//******************* Functions *******************
;//*************************************************
;void delay200ns(unsigned char n)													//simple delay, about 200ns
; 0001 001B {

	.CSEG
_delay200ns:
; 0001 001C 	while(n--)
	ST   -Y,R26
;	n -> Y+0
_0x20005:
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
	SUBI R30,-LOW(1)
	BREQ _0x20007
; 0001 001D 	{
; 0001 001E 		//---  3 NOPs for about 200ns at 16MHz?  ---//
; 0001 001F 		_NOP();
	nop
; 0001 0020 		_NOP();
	nop
; 0001 0021 		_NOP();
	nop
; 0001 0022 	}
	RJMP _0x20005
_0x20007:
; 0001 0023 } //delay200ns
	ADIW R28,1
	RET
;
;void TFTPortInit(void)																		//initial LCD hardware connections
; 0001 0026 {
_TFTPortInit:
; 0001 0027 	#if TFT_PORT_INTERFACE
; 0001 0028 		TFT_DB_init();										//Output & non-pullup
	LDI  R30,LOW(255)
	OUT  0x14,R30
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0001 0029 
; 0001 002A 		TFT_CS_init();										//Output & high
	SBI  0x11,2
	SBI  0x12,2
; 0001 002B 		TFT_RS_init();										//Output & high
	SBI  0x11,4
	SBI  0x12,4
; 0001 002C 		TFT_RD_init();										//Output & high
	SBI  0x11,5
	SBI  0x12,5
; 0001 002D 		TFT_WR_init();										//Output & high
	SBI  0x11,3
	SBI  0x12,3
; 0001 002E 	#else
; 0001 002F     MCUCR = _BV(SRE) | _BV(SRW);			// enable external SRAM (memory mapped TFT) and one wait state
; 0001 0030 	#endif
; 0001 0031 
; 0001 0032 	TFT_RST_init();											//Output & low
	SBI  0x11,6
	CBI  0x12,6
; 0001 0033 	TFT_BKL_init();											//Output & low
	SBI  0x11,7
	CBI  0x12,7
; 0001 0034 }//TFTPortInit
	RET
;
;void TFTReset(void) 																			//pulse reset signal to LCD
; 0001 0037 {
_TFTReset:
; 0001 0038 	TFT_RST(LOW);
	CBI  0x12,6
; 0001 0039 		_delay_ms(200);
	CALL SUBOPT_0x42
; 0001 003A 	TFT_RST(HIGH);
	SBI  0x12,6
; 0001 003B 		_delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
_0x20E001F:
	CALL _delay_ms
; 0001 003C } //TFTReset
	RET
;
;//----------------------------------------------------------------------------
;void TFTOutCmd(unsigned short ins) 												//write command to LCD
; 0001 0040 {
_TFTOutCmd:
; 0001 0041 	#if TFT_PORT_INTERFACE
; 0001 0042 		TFT_DB_CLR();
	ST   -Y,R27
	ST   -Y,R26
;	ins -> Y+0
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0001 0043 		TFT_CS(LOW);
	CBI  0x12,2
; 0001 0044 		TFT_RS(LOW);
	CBI  0x12,4
; 0001 0045 
; 0001 0046 		#if TFT_8bit_INTERFACE
; 0001 0047 			TFT_DB_WR(ins >> 8);
	CALL SUBOPT_0x62
; 0001 0048 			TFT_WR(LOW);
; 0001 0049 			TFT_WR(HIGH);
; 0001 004A 			//TFT_DB_CLR();
; 0001 004B 		#endif
; 0001 004C 
; 0001 004D 		TFT_DB_WR(ins);
; 0001 004E 		TFT_WR(LOW);
; 0001 004F 		TFT_WR(HIGH);
; 0001 0050 
; 0001 0051 		TFT_RS(HIGH);
	SBI  0x12,4
; 0001 0052 		TFT_CS(HIGH);
	SBI  0x12,2
; 0001 0053 	#else
; 0001 0054 		*(volatile unsigned char *)(TFT_CTRL_ADDR) = (ins >> 8);
; 0001 0055 		*(volatile unsigned char *)(TFT_CTRL_ADDR) =  ins;
; 0001 0056 	#endif
; 0001 0057 } //TFTOutCmd
	RJMP _0x20E001D
;
;
;
;
;
;
;
;void TFTOutDat(unsigned short dat) 												//write data to LCD
; 0001 0060 {
_TFTOutDat:
; 0001 0061 	#if TFT_PORT_INTERFACE
; 0001 0062 		TFT_DB_CLR();
	ST   -Y,R27
	ST   -Y,R26
;	dat -> Y+0
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0001 0063 		TFT_CS(LOW);
	CBI  0x12,2
; 0001 0064 
; 0001 0065 		#if TFT_8bit_INTERFACE
; 0001 0066 			TFT_DB_WR(dat >> 8);
	CALL SUBOPT_0x62
; 0001 0067 			TFT_WR(LOW);
; 0001 0068 			TFT_WR(HIGH);
; 0001 0069 			//TFT_DB_CLR();
; 0001 006A 		#endif
; 0001 006B 
; 0001 006C 		TFT_DB_WR(dat);
; 0001 006D 		TFT_WR(LOW);
; 0001 006E 		TFT_WR(HIGH);
; 0001 006F 
; 0001 0070 		TFT_CS(HIGH);
	SBI  0x12,2
; 0001 0071 	#else
; 0001 0072 		*(volatile unsigned char *)(TFT_DATA_ADDR) = (dat >> 8);
; 0001 0073 		*(volatile unsigned char *)(TFT_DATA_ADDR) =  dat;
; 0001 0074 	#endif
; 0001 0075 } //TFTOutDat
	RJMP _0x20E001D
;
;void TFTOutDat2(unsigned char dath, unsigned char datl) 	//write data to LCD
; 0001 0078 {
_TFTOutDat2:
; 0001 0079 	#if TFT_PORT_INTERFACE
; 0001 007A 		unsigned short 		dat = 0x0000;
; 0001 007B 
; 0001 007C 		TFT_DB_CLR();
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
;	dath -> Y+3
;	datl -> Y+2
;	dat -> R16,R17
	__GETWRN 16,17,0
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0001 007D 		TFT_CS(LOW);
	CBI  0x12,2
; 0001 007E 
; 0001 007F 		#if TFT_8bit_INTERFACE
; 0001 0080 			TFT_DB_WR(dath);
	LDD  R30,Y+3
	OUT  0x15,R30
; 0001 0081 			TFT_WR(LOW);
	CBI  0x12,3
; 0001 0082 			TFT_WR(HIGH);
	SBI  0x12,3
; 0001 0083 
; 0001 0084 			//TFT_DB_CLR();
; 0001 0085 
; 0001 0086 			TFT_DB_WR(datl);
	LDD  R30,Y+2
	OUT  0x15,R30
; 0001 0087 			TFT_WR(LOW);
	CBI  0x12,3
; 0001 0088 			TFT_WR(HIGH);
	SBI  0x12,3
; 0001 0089  		#else
; 0001 008A  			dat  = dath << 8;
; 0001 008B  			dat |= datl;
; 0001 008C 
; 0001 008D 			TFT_DB_WR(dat);
; 0001 008E 			TFT_WR(LOW);
; 0001 008F 			TFT_WR(HIGH);
; 0001 0090  		#endif
; 0001 0091 
; 0001 0092 		TFT_CS(HIGH);
	SBI  0x12,2
; 0001 0093 	#else
; 0001 0094 		*(volatile unsigned char *)(TFT_DATA_ADDR) = dath;
; 0001 0095 		*(volatile unsigned char *)(TFT_DATA_ADDR) = datl;
; 0001 0096 	#endif
; 0001 0097 } //TFTOutDat2
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20E001E
;
;unsigned short TFTInDat(void) 														//read data from LCD
; 0001 009A {
_TFTInDat:
; 0001 009B 	unsigned short 		dat = 0x0000;
; 0001 009C 
; 0001 009D 	#if TFT_PORT_INTERFACE
; 0001 009E 		TFT_DB_IN();
	ST   -Y,R17
	ST   -Y,R16
;	dat -> R16,R17
	__GETWRN 16,17,0
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0001 009F 		TFT_CS(LOW);
	CBI  0x12,2
; 0001 00A0 
; 0001 00A1 		TFT_RD(LOW);
	CBI  0x12,5
; 0001 00A2 			delay200ns(1);
	LDI  R26,LOW(1)
	RCALL _delay200ns
; 0001 00A3 			dat = TFT_DB_RD();
	IN   R16,19
	CLR  R17
; 0001 00A4 		TFT_RD(HIGH);
	SBI  0x12,5
; 0001 00A5 
; 0001 00A6 		#if TFT_8bit_INTERFACE
; 0001 00A7 			TFT_RD(LOW);
	CBI  0x12,5
; 0001 00A8 				dat <<= 8;
	MOV  R17,R16
	CLR  R16
; 0001 00A9 
; 0001 00AA 				delay200ns(1);
	LDI  R26,LOW(1)
	RCALL _delay200ns
; 0001 00AB 				dat |= TFT_DB_RD();
	IN   R30,0x13
	LDI  R31,0
	__ORWRR 16,17,30,31
; 0001 00AC 			TFT_RD(HIGH);
	SBI  0x12,5
; 0001 00AD 		#endif
; 0001 00AE 
; 0001 00AF 		TFT_CS(HIGH);
	SBI  0x12,2
; 0001 00B0   	TFT_DB_OUT();
	LDI  R30,LOW(255)
	OUT  0x14,R30
; 0001 00B1 	#else
; 0001 00B2 		dat	= *(volatile unsigned char *)(TFT_DATA_ADDR);
; 0001 00B3 		dat <<= 8;
; 0001 00B4 		dat |= *(volatile unsigned char *)(TFT_DATA_ADDR);
; 0001 00B5 	#endif
; 0001 00B6 
; 0001 00B7 	return(dat);
	MOVW R30,R16
	LD   R16,Y+
	LD   R17,Y+
	RET
; 0001 00B8 } //TFTInDat
;
;void TFTSetReg(unsigned short index, unsigned short val)	//set LCD instruction register
; 0001 00BB {
_TFTSetReg:
; 0001 00BC 	TFTOutCmd(index);
	ST   -Y,R27
	ST   -Y,R26
;	index -> Y+2
;	val -> Y+0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL _TFTOutCmd
; 0001 00BD 	TFTOutDat(val);
	LD   R26,Y
	LDD  R27,Y+1
	RCALL _TFTOutDat
; 0001 00BE }	//TFTSetReg
_0x20E001E:
	ADIW R28,4
	RET
;
;unsigned short TFTGetReg(unsigned short index)						//Get LCD instruction register
; 0001 00C1 {
_TFTGetReg:
; 0001 00C2 	TFTOutCmd(index);
	ST   -Y,R27
	ST   -Y,R26
;	index -> Y+0
	LD   R26,Y
	LDD  R27,Y+1
	RCALL _TFTOutCmd
; 0001 00C3 	return(TFTInDat());
	RCALL _TFTInDat
_0x20E001D:
	ADIW R28,2
	RET
; 0001 00C4 }	//TFTGetReg
;
;//----------------------------------------------------------------------------
;//----------------------------------------------------------------------------
;void TFTInit(void) 																				//initial LCD
; 0001 00C9 {
_TFTInit:
; 0001 00CA 	TFTPortInit();
	RCALL _TFTPortInit
; 0001 00CB 		_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL _delay_ms
; 0001 00CC 	TFTReset();
	RCALL _TFTReset
; 0001 00CD 
; 0001 00CE 	TFT_ID_code = TFTGetReg(TFT_INS_START_OSC);
	CALL SUBOPT_0x22
	RCALL _TFTGetReg
	STS  _TFT_ID_code,R30
	STS  _TFT_ID_code+1,R31
; 0001 00CF 	//TFT_ID_code = 0x9325;
; 0001 00D0 
; 0001 00D1 	if (TFT_ID_code == 0x9325) 		//-----  ILI9325
	CALL SUBOPT_0x63
	CPI  R26,LOW(0x9325)
	LDI  R30,HIGH(0x9325)
	CPC  R27,R30
	BREQ PC+3
	JMP _0x20008
; 0001 00D2 	{
; 0001 00D3 
; 0001 00D4 		TFTSetReg(0x00E3, 										0x3008);							//set the internal timing
	CALL SUBOPT_0x64
; 0001 00D5 		TFTSetReg(0x00E7, 										0x0012);							//set the internal timing
; 0001 00D6 		TFTSetReg(0x00EF, 										0x1231);							//set the internal timing
; 0001 00D7 		TFTSetReg(TFT_INS_START_OSC, 					0x0001);							//start oscillator
	CALL SUBOPT_0x65
; 0001 00D8 
; 0001 00D9 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x66
; 0001 00DA 		TFTSetReg(TFT_INS_DRIV_OUT_CTRL, 			0x0100);							//set SS, SM
; 0001 00DB 		TFTSetReg(TFT_INS_DRIV_WAV_CTRL,			0x0700);							//set 1 line inversion
; 0001 00DC 		TFTSetReg(TFT_INS_ENTRY_MOD,					TFT_VAL_ENTRY_MOD);		//set GRAM write direction, BGR=0
	CALL SUBOPT_0x67
; 0001 00DD 		TFTSetReg(TFT_INS_RESIZE_CTRL,				0x0000);							//resize register, no resizing
	CALL SUBOPT_0x68
; 0001 00DE 		TFTSetReg(TFT_INS_DISP_CTRL2, 				0x0202);							//set the back porch and front porch, periods = 2
; 0001 00DF 		TFTSetReg(TFT_INS_DISP_CTRL3,					0x0000);							//set non-display area refresh cycle ISC[3:0]
	CALL SUBOPT_0x22
	CALL SUBOPT_0x69
; 0001 00E0 		TFTSetReg(TFT_INS_DISP_CTRL4,					0x0000);							//FMARK function
	CALL SUBOPT_0x6A
; 0001 00E1 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL1,	0x0000);							//RGB interface setting, select system interface
	CALL SUBOPT_0x6B
; 0001 00E2 		TFTSetReg(TFT_INS_FRM_MARKER_POS, 		0x0000);							//frame marker position
	CALL SUBOPT_0x6C
; 0001 00E3 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL2, 	0x0000);							//RGB interface polarity
	CALL SUBOPT_0x6D
; 0001 00E4 
; 0001 00E5 		// ----------- Power On sequence ----------//
; 0001 00E6 		TFTSetReg(TFT_INS_POW_CTRL1,					0x0000);							//SAP, BT[3:0], AP, DSTB, SLP, STB
	CALL SUBOPT_0x6E
; 0001 00E7 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0007);							//DC1[2:0], DC0[2:0], VC[2:0]
	CALL SUBOPT_0x6F
; 0001 00E8 		TFTSetReg(TFT_INS_POW_CTRL3,					0x0000);							//VREG1OUT voltage
	CALL SUBOPT_0x70
	CALL SUBOPT_0x22
	CALL SUBOPT_0x71
; 0001 00E9 		TFTSetReg(TFT_INS_POW_CTRL4,					0x0013);							//VDV[4:0] for VCOM amplitude
	LDI  R26,LOW(19)
	CALL SUBOPT_0x72
; 0001 00EA 
; 0001 00EB 			_delay_ms(500);																						//dis-charge capacitor power voltage
	CALL SUBOPT_0x17
; 0001 00EC 
; 0001 00ED 		TFTSetReg(TFT_INS_POW_CTRL1,					0x1290);							//SAP, BT[3:0], AP, DSTB, SLP, STB
	CALL SUBOPT_0x73
	LDI  R26,LOW(4752)
	LDI  R27,HIGH(4752)
	CALL SUBOPT_0x6E
; 0001 00EE 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0527);							//DC1[2:0], DC0[2:0], VC[2:0]
	LDI  R26,LOW(1319)
	LDI  R27,HIGH(1319)
	CALL SUBOPT_0x74
; 0001 00EF 
; 0001 00F0 			_delay_ms(100);
	CALL SUBOPT_0x75
; 0001 00F1 		TFTSetReg(TFT_INS_POW_CTRL3,					0x0018);							//internal reference voltage= Vci;
	LDI  R26,LOW(24)
	CALL SUBOPT_0x72
; 0001 00F2 
; 0001 00F3 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x76
; 0001 00F4 		TFTSetReg(TFT_INS_POW_CTRL4,					0x1000);							//set VDV[4:0] for VCOM amplitude
	LDI  R26,LOW(4096)
	LDI  R27,HIGH(4096)
	CALL SUBOPT_0x77
; 0001 00F5 		TFTSetReg(TFT_INS_POW_CTRL7,					0x001E);							//set VCM[5:0] for VCOMH
	LDI  R26,LOW(30)
	CALL SUBOPT_0x72
; 0001 00F6 		TFTSetReg(TFT_INS_FRM_RATE_COL_CTRL,	0x000D);							//set Frame Rate
	LDI  R30,LOW(43)
	LDI  R31,HIGH(43)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(13)
	CALL SUBOPT_0x72
; 0001 00F7 
; 0001 00F8 		// ----------- Adjust GRAM ----------//
; 0001 00F9 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x78
; 0001 00FA 		TFTSetReg(TFT_INS_GRAM_HOR_AD, 				0x0000);
	CALL SUBOPT_0x79
; 0001 00FB 		TFTSetReg(TFT_INS_GRAM_VER_AD, 				0x0000);
	CALL SUBOPT_0x7A
; 0001 00FC 
; 0001 00FD 		// ----------- Adjust the Gamma Curve ----------//
; 0001 00FE 		TFTSetReg(TFT_INS_GAMMA_CTRL1, 				0x0007);
; 0001 00FF 		TFTSetReg(TFT_INS_GAMMA_CTRL2, 				0x0605);
	CALL SUBOPT_0x7B
	LDI  R26,LOW(1541)
	LDI  R27,HIGH(1541)
	CALL SUBOPT_0x7C
; 0001 0100 		TFTSetReg(TFT_INS_GAMMA_CTRL3, 				0x0106);
	LDI  R26,LOW(262)
	LDI  R27,HIGH(262)
	CALL SUBOPT_0x7D
; 0001 0101 		TFTSetReg(TFT_INS_GAMMA_CTRL4, 				0x0206);
	LDI  R26,LOW(518)
	LDI  R27,HIGH(518)
	CALL SUBOPT_0x7E
; 0001 0102 		TFTSetReg(TFT_INS_GAMMA_CTRL5, 				0x0808);
	LDI  R26,LOW(2056)
	LDI  R27,HIGH(2056)
	CALL SUBOPT_0x7F
; 0001 0103 		TFTSetReg(TFT_INS_GAMMA_CTRL6, 				0x0007);
	CALL SUBOPT_0x6F
; 0001 0104 		TFTSetReg(TFT_INS_GAMMA_CTRL7, 				0x0201);
	CALL SUBOPT_0x80
	LDI  R26,LOW(513)
	LDI  R27,HIGH(513)
	RCALL _TFTSetReg
; 0001 0105 		TFTSetReg(TFT_INS_GAMMA_CTRL8, 				0x0007);
	CALL SUBOPT_0x81
	CALL SUBOPT_0x6F
; 0001 0106 		TFTSetReg(TFT_INS_GAMMA_CTRL9, 				0x0602);
	CALL SUBOPT_0x82
	LDI  R26,LOW(1538)
	LDI  R27,HIGH(1538)
	CALL SUBOPT_0x83
; 0001 0107 		TFTSetReg(TFT_INS_GAMMA_CTRL10, 			0x0808);
	LDI  R26,LOW(2056)
	LDI  R27,HIGH(2056)
	CALL SUBOPT_0x84
; 0001 0108 
; 0001 0109 		//------------------ Set GRAM area ---------------//
; 0001 010A 		TFTSetReg(TFT_INS_HOR_START_AD, 			0x0000);							// Horizontal GRAM Start Address
	CALL SUBOPT_0x85
; 0001 010B 		TFTSetReg(TFT_INS_HOR_END_AD, 				0x00EF);							// Horizontal GRAM End Address
; 0001 010C 		TFTSetReg(TFT_INS_VER_START_AD, 			0x0000);							// Vertical GRAM Start Address
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0001 010D 		TFTSetReg(TFT_INS_VER_END_AD, 				0x013F);							// Vertical GRAM Start Address
; 0001 010E 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL1, 		0xA700);							// Gate Scan Line  A700
	LDI  R26,LOW(42752)
	LDI  R27,HIGH(42752)
	CALL SUBOPT_0x88
; 0001 010F 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL2, 		0x0001);							// NDL, VLE, REV
; 0001 0110 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL3, 		0x0000);							// set scrolling line
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
; 0001 0111 
; 0001 0112 		//-------------- Partial Display Control ---------//
; 0001 0113 		TFTSetReg(TFT_INS_PART_IMG1_DISP_POS, 0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8B
; 0001 0114 		TFTSetReg(TFT_INS_PART_IMG1_START_AD, 0x0000);
	CALL SUBOPT_0x8C
; 0001 0115 		TFTSetReg(TFT_INS_PART_IMG1_END_AD, 	0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8D
; 0001 0116 		TFTSetReg(TFT_INS_PART_IMG2_DISP_POS, 0x0000);
	CALL SUBOPT_0x8E
; 0001 0117 		TFTSetReg(TFT_INS_PART_IMG2_START_AD, 0x0000);
	CALL SUBOPT_0x8F
; 0001 0118 		TFTSetReg(TFT_INS_PART_IMG2_END_AD, 	0x0000);
	CALL SUBOPT_0x90
; 0001 0119 
; 0001 011A 		//-------------- Panel Control -------------------//
; 0001 011B 		TFTSetReg(TFT_INS_PANEL_IF_CTRL1, 		0x0010);
	CALL SUBOPT_0x91
; 0001 011C 		TFTSetReg(TFT_INS_PANEL_IF_CTRL2, 		0x0000);
	CALL SUBOPT_0x92
; 0001 011D 		TFTSetReg(TFT_INS_PANEL_IF_CTRL3, 		0x0003);
; 0001 011E 		TFTSetReg(TFT_INS_PANEL_IF_CTRL4, 		0x0110);
	CALL SUBOPT_0x93
; 0001 011F 		TFTSetReg(TFT_INS_PANEL_IF_CTRL5, 		0x0000);
	CALL SUBOPT_0x94
; 0001 0120 		TFTSetReg(TFT_INS_PANEL_IF_CTRL6, 		0x0000);
	CALL SUBOPT_0x95
; 0001 0121 
; 0001 0122 		TFTSetReg(TFT_INS_DISP_CTRL1, 				0x0133);							//262K color, normal display, base image display oprate and turns off partial image
	LDI  R26,LOW(307)
	LDI  R27,HIGH(307)
	RJMP _0x2003C
; 0001 0123 	} //-----  ILI9325
; 0001 0124 
; 0001 0125 	else if (TFT_ID_code == 0x9320) 		//-----  ILI9320
_0x20008:
	CALL SUBOPT_0x63
	CPI  R26,LOW(0x9320)
	LDI  R30,HIGH(0x9320)
	CPC  R27,R30
	BREQ PC+3
	JMP _0x2000A
; 0001 0126 	{
; 0001 0127 
; 0001 0128 		TFTSetReg(0x00E5, 										0x8000);
	CALL SUBOPT_0x96
; 0001 0129 		TFTSetReg(TFT_INS_START_OSC, 					0x0001);
	CALL SUBOPT_0x65
; 0001 012A 
; 0001 012B 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x66
; 0001 012C 		TFTSetReg(TFT_INS_DRIV_OUT_CTRL, 			0x0100);
; 0001 012D 		TFTSetReg(TFT_INS_DRIV_WAV_CTRL,			0x0700);
; 0001 012E 		TFTSetReg(TFT_INS_ENTRY_MOD,					TFT_VAL_ENTRY_MOD);
	CALL SUBOPT_0x67
; 0001 012F 		TFTSetReg(TFT_INS_RESIZE_CTRL,				0x0000);
	CALL SUBOPT_0x68
; 0001 0130 		TFTSetReg(TFT_INS_DISP_CTRL2, 				0x0202);
; 0001 0131 		TFTSetReg(TFT_INS_DISP_CTRL3,					0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x69
; 0001 0132 		TFTSetReg(TFT_INS_DISP_CTRL4,					0x0000);
	CALL SUBOPT_0x6A
; 0001 0133 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL1,	0x0000);
	CALL SUBOPT_0x6B
; 0001 0134 		TFTSetReg(TFT_INS_FRM_MARKER_POS, 		0x0000);
	CALL SUBOPT_0x6C
; 0001 0135 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL2, 	0x0000);
	CALL SUBOPT_0x6D
; 0001 0136 
; 0001 0137 		// ----------- Power On sequence ----------//
; 0001 0138 		TFTSetReg(TFT_INS_POW_CTRL1,					0x0000);
	CALL SUBOPT_0x6E
; 0001 0139 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0000);
	CALL SUBOPT_0x22
	RCALL _TFTSetReg
; 0001 013A 		TFTSetReg(TFT_INS_POW_CTRL3,					0x0000);
	CALL SUBOPT_0x70
	CALL SUBOPT_0x22
	CALL SUBOPT_0x71
; 0001 013B 		TFTSetReg(TFT_INS_POW_CTRL4,					0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x97
; 0001 013C 
; 0001 013D 			_delay_ms(500);
; 0001 013E 
; 0001 013F 		TFTSetReg(TFT_INS_POW_CTRL1,					0x17B0);
	CALL SUBOPT_0x73
	LDI  R26,LOW(6064)
	LDI  R27,HIGH(6064)
	CALL SUBOPT_0x6E
; 0001 0140 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0137);
	LDI  R26,LOW(311)
	LDI  R27,HIGH(311)
	CALL SUBOPT_0x74
; 0001 0141 
; 0001 0142 			_delay_ms(100);
	CALL SUBOPT_0x75
; 0001 0143 		TFTSetReg(TFT_INS_POW_CTRL3,					0x013C);
	LDI  R26,LOW(316)
	LDI  R27,HIGH(316)
	CALL SUBOPT_0x74
; 0001 0144 
; 0001 0145 			_delay_ms(100);
	CALL SUBOPT_0x76
; 0001 0146 		TFTSetReg(TFT_INS_POW_CTRL4,					0x1400);
	LDI  R26,LOW(5120)
	LDI  R27,HIGH(5120)
	CALL SUBOPT_0x77
; 0001 0147 		TFTSetReg(TFT_INS_POW_CTRL7,					0x0007);
	CALL SUBOPT_0x6F
; 0001 0148 
; 0001 0149 		// ----------- Adjust GRAM ----------//
; 0001 014A 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x78
; 0001 014B 		TFTSetReg(TFT_INS_GRAM_HOR_AD, 				0x0000);
	CALL SUBOPT_0x79
; 0001 014C 		TFTSetReg(TFT_INS_GRAM_VER_AD, 				0x0000);
	CALL SUBOPT_0x7A
; 0001 014D 
; 0001 014E 		// ----------- Adjust the Gamma Curve ----------//
; 0001 014F 		TFTSetReg(TFT_INS_GAMMA_CTRL1, 				0x0007);
; 0001 0150 		TFTSetReg(TFT_INS_GAMMA_CTRL2, 				0x0504);
	CALL SUBOPT_0x7B
	LDI  R26,LOW(1284)
	LDI  R27,HIGH(1284)
	CALL SUBOPT_0x7C
; 0001 0151 		TFTSetReg(TFT_INS_GAMMA_CTRL3, 				0x0703);
	LDI  R26,LOW(1795)
	LDI  R27,HIGH(1795)
	CALL SUBOPT_0x7D
; 0001 0152 		TFTSetReg(TFT_INS_GAMMA_CTRL4, 				0x0002);
	LDI  R26,LOW(2)
	CALL SUBOPT_0x72
; 0001 0153 		TFTSetReg(TFT_INS_GAMMA_CTRL5, 				0x0707);
	CALL SUBOPT_0x98
; 0001 0154 		TFTSetReg(TFT_INS_GAMMA_CTRL6, 				0x0406);
	CALL SUBOPT_0x99
; 0001 0155 		TFTSetReg(TFT_INS_GAMMA_CTRL7, 				0x0006);
	LDI  R26,LOW(6)
	CALL SUBOPT_0x72
; 0001 0156 		TFTSetReg(TFT_INS_GAMMA_CTRL8, 				0x0404);
	CALL SUBOPT_0x81
	CALL SUBOPT_0x9A
; 0001 0157 		TFTSetReg(TFT_INS_GAMMA_CTRL9, 				0x0700);
	CALL SUBOPT_0x9B
; 0001 0158 		TFTSetReg(TFT_INS_GAMMA_CTRL10, 			0x0A08);
	CALL SUBOPT_0x9C
; 0001 0159 
; 0001 015A 		//------------------ Set GRAM area ---------------//
; 0001 015B 		TFTSetReg(TFT_INS_HOR_START_AD, 			0x0000);
	CALL SUBOPT_0x85
; 0001 015C 		TFTSetReg(TFT_INS_HOR_END_AD, 				0x00EF);
; 0001 015D 		TFTSetReg(TFT_INS_VER_START_AD, 			0x0000);
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0001 015E 		TFTSetReg(TFT_INS_VER_END_AD, 				0x013F);
; 0001 015F 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL1, 		0x2700);
	CALL SUBOPT_0x9D
; 0001 0160 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL2, 		0x0001);
; 0001 0161 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL3, 		0x0000);
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
; 0001 0162 
; 0001 0163 		//-------------- Partial Display Control ---------//
; 0001 0164 		TFTSetReg(TFT_INS_PART_IMG1_DISP_POS, 0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8B
; 0001 0165 		TFTSetReg(TFT_INS_PART_IMG1_START_AD, 0x0000);
	CALL SUBOPT_0x8C
; 0001 0166 		TFTSetReg(TFT_INS_PART_IMG1_END_AD, 	0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8D
; 0001 0167 		TFTSetReg(TFT_INS_PART_IMG2_DISP_POS, 0x0000);
	CALL SUBOPT_0x8E
; 0001 0168 		TFTSetReg(TFT_INS_PART_IMG2_START_AD, 0x0000);
	CALL SUBOPT_0x8F
; 0001 0169 		TFTSetReg(TFT_INS_PART_IMG2_END_AD, 	0x0000);
	CALL SUBOPT_0x90
; 0001 016A 
; 0001 016B 		//-------------- Panel Control -------------------//
; 0001 016C 		TFTSetReg(TFT_INS_PANEL_IF_CTRL1, 		0x0010);
	CALL SUBOPT_0x91
; 0001 016D 		TFTSetReg(TFT_INS_PANEL_IF_CTRL2, 		0x0000);
	CALL SUBOPT_0x92
; 0001 016E 		TFTSetReg(TFT_INS_PANEL_IF_CTRL3, 		0x0003);
; 0001 016F 		TFTSetReg(TFT_INS_PANEL_IF_CTRL4, 		0x0110);
	CALL SUBOPT_0x93
; 0001 0170 		TFTSetReg(TFT_INS_PANEL_IF_CTRL5, 		0x0000);
	CALL SUBOPT_0x94
; 0001 0171 		TFTSetReg(TFT_INS_PANEL_IF_CTRL6, 		0x0000);
	CALL SUBOPT_0x95
; 0001 0172 
; 0001 0173 		TFTSetReg(TFT_INS_DISP_CTRL1, 				0x0173);
	LDI  R26,LOW(371)
	LDI  R27,HIGH(371)
	RJMP _0x2003C
; 0001 0174 	} //-----  ILI9320
; 0001 0175 
; 0001 0176 	else if (TFT_ID_code == 0x9328) 		//-----  ILI9328
_0x2000A:
	CALL SUBOPT_0x63
	CPI  R26,LOW(0x9328)
	LDI  R30,HIGH(0x9328)
	CPC  R27,R30
	BREQ PC+3
	JMP _0x2000C
; 0001 0177 	{
; 0001 0178 
; 0001 0179 		TFTSetReg(0x00E5, 										0x8000);
	CALL SUBOPT_0x96
; 0001 017A 		TFTSetReg(TFT_INS_START_OSC, 					0x0001);
	CALL SUBOPT_0x65
; 0001 017B 
; 0001 017C 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x66
; 0001 017D 		TFTSetReg(TFT_INS_DRIV_OUT_CTRL, 			0x0100);
; 0001 017E 		TFTSetReg(TFT_INS_DRIV_WAV_CTRL,			0x0700);
; 0001 017F 		TFTSetReg(TFT_INS_ENTRY_MOD,					TFT_VAL_ENTRY_MOD);
	CALL SUBOPT_0x67
; 0001 0180 		TFTSetReg(TFT_INS_RESIZE_CTRL,				0x0000);
	CALL SUBOPT_0x68
; 0001 0181 		TFTSetReg(TFT_INS_DISP_CTRL2, 				0x0202);
; 0001 0182 		TFTSetReg(TFT_INS_DISP_CTRL3,					0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x69
; 0001 0183 		TFTSetReg(TFT_INS_DISP_CTRL4,					0x0000);
	CALL SUBOPT_0x6A
; 0001 0184 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL1,	0x0000);
	CALL SUBOPT_0x6B
; 0001 0185 		TFTSetReg(TFT_INS_FRM_MARKER_POS, 		0x0000);
	CALL SUBOPT_0x6C
; 0001 0186 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL2, 	0x0000);
	CALL SUBOPT_0x6D
; 0001 0187 
; 0001 0188 		// ----------- Power On sequence ----------//
; 0001 0189 		TFTSetReg(TFT_INS_POW_CTRL1,					0x0000);
	CALL SUBOPT_0x6E
; 0001 018A 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0000);
	CALL SUBOPT_0x22
	RCALL _TFTSetReg
; 0001 018B 		TFTSetReg(TFT_INS_POW_CTRL3,					0x0000);
	CALL SUBOPT_0x70
	CALL SUBOPT_0x22
	CALL SUBOPT_0x71
; 0001 018C 		TFTSetReg(TFT_INS_POW_CTRL4,					0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x97
; 0001 018D 
; 0001 018E 			_delay_ms(500);
; 0001 018F 
; 0001 0190 		TFTSetReg(TFT_INS_POW_CTRL1,					0x17B0);
	CALL SUBOPT_0x73
	LDI  R26,LOW(6064)
	LDI  R27,HIGH(6064)
	CALL SUBOPT_0x6E
; 0001 0191 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0137);
	LDI  R26,LOW(311)
	LDI  R27,HIGH(311)
	CALL SUBOPT_0x74
; 0001 0192 
; 0001 0193 			_delay_ms(100);
	CALL SUBOPT_0x75
; 0001 0194 		TFTSetReg(TFT_INS_POW_CTRL3,					0x013C);
	LDI  R26,LOW(316)
	LDI  R27,HIGH(316)
	CALL SUBOPT_0x74
; 0001 0195 
; 0001 0196 			_delay_ms(100);
	CALL SUBOPT_0x76
; 0001 0197 		TFTSetReg(TFT_INS_POW_CTRL4,					0x1400);
	LDI  R26,LOW(5120)
	LDI  R27,HIGH(5120)
	CALL SUBOPT_0x77
; 0001 0198 		TFTSetReg(TFT_INS_POW_CTRL7,					0x0007);
	CALL SUBOPT_0x6F
; 0001 0199 
; 0001 019A 		// ----------- Adjust GRAM ----------//
; 0001 019B 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x78
; 0001 019C 		TFTSetReg(TFT_INS_GRAM_HOR_AD, 				0x0000);
	CALL SUBOPT_0x79
; 0001 019D 		TFTSetReg(TFT_INS_GRAM_VER_AD, 				0x0000);
	CALL SUBOPT_0x7A
; 0001 019E 
; 0001 019F 		// ----------- Adjust the Gamma Curve ----------//
; 0001 01A0 		TFTSetReg(TFT_INS_GAMMA_CTRL1, 				0x0007);
; 0001 01A1 		TFTSetReg(TFT_INS_GAMMA_CTRL2, 				0x0504);
	CALL SUBOPT_0x7B
	LDI  R26,LOW(1284)
	LDI  R27,HIGH(1284)
	CALL SUBOPT_0x7C
; 0001 01A2 		TFTSetReg(TFT_INS_GAMMA_CTRL3, 				0x0703);
	LDI  R26,LOW(1795)
	LDI  R27,HIGH(1795)
	CALL SUBOPT_0x7D
; 0001 01A3 		TFTSetReg(TFT_INS_GAMMA_CTRL4, 				0x0002);
	LDI  R26,LOW(2)
	CALL SUBOPT_0x72
; 0001 01A4 		TFTSetReg(TFT_INS_GAMMA_CTRL5, 				0x0707);
	CALL SUBOPT_0x98
; 0001 01A5 		TFTSetReg(TFT_INS_GAMMA_CTRL6, 				0x0406);
	CALL SUBOPT_0x99
; 0001 01A6 		TFTSetReg(TFT_INS_GAMMA_CTRL7, 				0x0006);
	LDI  R26,LOW(6)
	CALL SUBOPT_0x72
; 0001 01A7 		TFTSetReg(TFT_INS_GAMMA_CTRL8, 				0x0404);
	CALL SUBOPT_0x81
	CALL SUBOPT_0x9A
; 0001 01A8 		TFTSetReg(TFT_INS_GAMMA_CTRL9, 				0x0700);
	CALL SUBOPT_0x9B
; 0001 01A9 		TFTSetReg(TFT_INS_GAMMA_CTRL10, 			0x0A08);
	CALL SUBOPT_0x9C
; 0001 01AA 
; 0001 01AB 		//------------------ Set GRAM area ---------------//
; 0001 01AC 		TFTSetReg(TFT_INS_HOR_START_AD, 			0x0000);
	CALL SUBOPT_0x85
; 0001 01AD 		TFTSetReg(TFT_INS_HOR_END_AD, 				0x00EF);
; 0001 01AE 		TFTSetReg(TFT_INS_VER_START_AD, 			0x0000);
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0001 01AF 		TFTSetReg(TFT_INS_VER_END_AD, 				0x013F);
; 0001 01B0 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL1, 		0x2700);
	CALL SUBOPT_0x9D
; 0001 01B1 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL2, 		0x0001);
; 0001 01B2 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL3, 		0x0000);
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
; 0001 01B3 
; 0001 01B4 		//-------------- Partial Display Control ---------//
; 0001 01B5 		TFTSetReg(TFT_INS_PART_IMG1_DISP_POS, 0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8B
; 0001 01B6 		TFTSetReg(TFT_INS_PART_IMG1_START_AD, 0x0000);
	CALL SUBOPT_0x8C
; 0001 01B7 		TFTSetReg(TFT_INS_PART_IMG1_END_AD, 	0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8D
; 0001 01B8 		TFTSetReg(TFT_INS_PART_IMG2_DISP_POS, 0x0000);
	CALL SUBOPT_0x8E
; 0001 01B9 		TFTSetReg(TFT_INS_PART_IMG2_START_AD, 0x0000);
	CALL SUBOPT_0x8F
; 0001 01BA 		TFTSetReg(TFT_INS_PART_IMG2_END_AD, 	0x0000);
	CALL SUBOPT_0x90
; 0001 01BB 
; 0001 01BC 		//-------------- Panel Control -------------------//
; 0001 01BD 		TFTSetReg(TFT_INS_PANEL_IF_CTRL1, 		0x0010);
	CALL SUBOPT_0x91
; 0001 01BE 		TFTSetReg(TFT_INS_PANEL_IF_CTRL2, 		0x0000);
	CALL SUBOPT_0x92
; 0001 01BF 		TFTSetReg(TFT_INS_PANEL_IF_CTRL3, 		0x0003);
; 0001 01C0 		TFTSetReg(TFT_INS_PANEL_IF_CTRL4, 		0x0110);
	CALL SUBOPT_0x93
; 0001 01C1 		TFTSetReg(TFT_INS_PANEL_IF_CTRL5, 		0x0000);
	CALL SUBOPT_0x94
; 0001 01C2 		TFTSetReg(TFT_INS_PANEL_IF_CTRL6, 		0x0000);
	CALL SUBOPT_0x95
; 0001 01C3 
; 0001 01C4 		TFTSetReg(TFT_INS_DISP_CTRL1, 				0x0173);
	LDI  R26,LOW(371)
	LDI  R27,HIGH(371)
	RJMP _0x2003C
; 0001 01C5 	} //-----  ILI9328
; 0001 01C6 
; 0001 01C7 	else														 		//-----  Others!
_0x2000C:
; 0001 01C8 	{
; 0001 01C9 
; 0001 01CA 		TFTSetReg(0x00E3, 										0x3008);
	CALL SUBOPT_0x64
; 0001 01CB 		TFTSetReg(0x00E7, 										0x0012);
; 0001 01CC 		TFTSetReg(0x00EF, 										0x1231);
; 0001 01CD 		TFTSetReg(TFT_INS_START_OSC, 					0x0001);
	CALL SUBOPT_0x65
; 0001 01CE 
; 0001 01CF 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x66
; 0001 01D0 		TFTSetReg(TFT_INS_DRIV_OUT_CTRL, 			0x0100);
; 0001 01D1 		TFTSetReg(TFT_INS_DRIV_WAV_CTRL,			0x0700);
; 0001 01D2 		TFTSetReg(TFT_INS_ENTRY_MOD,					TFT_VAL_ENTRY_MOD);
	CALL SUBOPT_0x67
; 0001 01D3 		TFTSetReg(TFT_INS_RESIZE_CTRL,				0x0000);
	CALL SUBOPT_0x68
; 0001 01D4 		TFTSetReg(TFT_INS_DISP_CTRL2, 				0x0202);
; 0001 01D5 		TFTSetReg(TFT_INS_DISP_CTRL3,					0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x69
; 0001 01D6 		TFTSetReg(TFT_INS_DISP_CTRL4,					0x0000);
	CALL SUBOPT_0x6A
; 0001 01D7 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL1,	0x0000);
	CALL SUBOPT_0x6B
; 0001 01D8 		TFTSetReg(TFT_INS_FRM_MARKER_POS, 		0x0000);
	CALL SUBOPT_0x6C
; 0001 01D9 		TFTSetReg(TFT_INS_RGB_DISP_IF_CTRL2, 	0x0000);
	CALL SUBOPT_0x6D
; 0001 01DA 
; 0001 01DB 		// ----------- Power On sequence ----------//
; 0001 01DC 		TFTSetReg(TFT_INS_POW_CTRL1,					0x0000);
	CALL SUBOPT_0x6E
; 0001 01DD 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0007);
	CALL SUBOPT_0x6F
; 0001 01DE 		TFTSetReg(TFT_INS_POW_CTRL3,					0x0000);
	CALL SUBOPT_0x70
	CALL SUBOPT_0x22
	CALL SUBOPT_0x71
; 0001 01DF 		TFTSetReg(TFT_INS_POW_CTRL4,					0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x97
; 0001 01E0 
; 0001 01E1 			_delay_ms(500);
; 0001 01E2 
; 0001 01E3 		TFTSetReg(TFT_INS_POW_CTRL1,					0x1690);
	CALL SUBOPT_0x73
	LDI  R26,LOW(5776)
	LDI  R27,HIGH(5776)
	CALL SUBOPT_0x6E
; 0001 01E4 		TFTSetReg(TFT_INS_POW_CTRL2,					0x0007);
	CALL SUBOPT_0x6F
; 0001 01E5 
; 0001 01E6 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x75
; 0001 01E7 		TFTSetReg(TFT_INS_POW_CTRL3,					0x001A);
	LDI  R26,LOW(26)
	CALL SUBOPT_0x72
; 0001 01E8 
; 0001 01E9 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x76
; 0001 01EA 		TFTSetReg(TFT_INS_POW_CTRL4,					0x1800);
	LDI  R26,LOW(6144)
	LDI  R27,HIGH(6144)
	CALL SUBOPT_0x77
; 0001 01EB 		TFTSetReg(TFT_INS_POW_CTRL7,					0x002A);
	LDI  R26,LOW(42)
	CALL SUBOPT_0x72
; 0001 01EC 
; 0001 01ED 		// ----------- Adjust GRAM ----------//
; 0001 01EE 			_delay_ms(100);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x78
; 0001 01EF 		TFTSetReg(TFT_INS_GRAM_HOR_AD, 				0x0000);
	CALL SUBOPT_0x79
; 0001 01F0 		TFTSetReg(TFT_INS_GRAM_VER_AD, 				0x0000);
	RCALL _TFTSetReg
; 0001 01F1 
; 0001 01F2 		// ----------- Adjust the Gamma Curve ----------//
; 0001 01F3 		TFTSetReg(TFT_INS_GAMMA_CTRL1, 				0x0000);
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	CALL SUBOPT_0x9E
	RCALL _TFTSetReg
; 0001 01F4 		TFTSetReg(TFT_INS_GAMMA_CTRL2, 				0x0000);
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x22
	CALL SUBOPT_0x7C
; 0001 01F5 		TFTSetReg(TFT_INS_GAMMA_CTRL3, 				0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x7D
; 0001 01F6 		TFTSetReg(TFT_INS_GAMMA_CTRL4, 				0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x7E
; 0001 01F7 		TFTSetReg(TFT_INS_GAMMA_CTRL5, 				0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x7F
; 0001 01F8 		TFTSetReg(TFT_INS_GAMMA_CTRL6, 				0x0406);
	CALL SUBOPT_0x99
; 0001 01F9 		TFTSetReg(TFT_INS_GAMMA_CTRL7, 				0x0006);
	LDI  R26,LOW(6)
	CALL SUBOPT_0x72
; 0001 01FA 		TFTSetReg(TFT_INS_GAMMA_CTRL8, 				0x0404);
	CALL SUBOPT_0x81
	CALL SUBOPT_0x9A
; 0001 01FB 		TFTSetReg(TFT_INS_GAMMA_CTRL9, 				0x0700);
	CALL SUBOPT_0x9B
; 0001 01FC 		TFTSetReg(TFT_INS_GAMMA_CTRL10, 			0x0A08);
	CALL SUBOPT_0x9C
; 0001 01FD 
; 0001 01FE 		//------------------ Set GRAM area ---------------//
; 0001 01FF 		TFTSetReg(TFT_INS_HOR_START_AD, 			0x0000);
	CALL SUBOPT_0x85
; 0001 0200 		TFTSetReg(TFT_INS_HOR_END_AD, 				0x00EF);
; 0001 0201 		TFTSetReg(TFT_INS_VER_START_AD, 			0x0000);
	CALL SUBOPT_0x86
	CALL SUBOPT_0x87
; 0001 0202 		TFTSetReg(TFT_INS_VER_END_AD, 				0x013F);
; 0001 0203 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL1, 		0x2700);
	CALL SUBOPT_0x9D
; 0001 0204 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL2, 		0x0001);
; 0001 0205 		TFTSetReg(TFT_INS_GATE_SCAN_CTRL3, 		0x0000);
	CALL SUBOPT_0x89
	CALL SUBOPT_0x8A
; 0001 0206 
; 0001 0207 		//-------------- Partial Display Control ---------//
; 0001 0208 		TFTSetReg(TFT_INS_PART_IMG1_DISP_POS, 0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8B
; 0001 0209 		TFTSetReg(TFT_INS_PART_IMG1_START_AD, 0x0000);
	CALL SUBOPT_0x8C
; 0001 020A 		TFTSetReg(TFT_INS_PART_IMG1_END_AD, 	0x0000);
	CALL SUBOPT_0x22
	CALL SUBOPT_0x8D
; 0001 020B 		TFTSetReg(TFT_INS_PART_IMG2_DISP_POS, 0x0000);
	CALL SUBOPT_0x8E
; 0001 020C 		TFTSetReg(TFT_INS_PART_IMG2_START_AD, 0x0000);
	CALL SUBOPT_0x8F
; 0001 020D 		TFTSetReg(TFT_INS_PART_IMG2_END_AD, 	0x0000);
	CALL SUBOPT_0x90
; 0001 020E 
; 0001 020F 		//-------------- Panel Control -------------------//
; 0001 0210 		TFTSetReg(TFT_INS_PANEL_IF_CTRL1, 		0x0010);
	CALL SUBOPT_0x91
; 0001 0211 		TFTSetReg(TFT_INS_PANEL_IF_CTRL2, 		0x0000);
	CALL SUBOPT_0x92
; 0001 0212 		TFTSetReg(TFT_INS_PANEL_IF_CTRL3, 		0x0003);
; 0001 0213 		TFTSetReg(TFT_INS_PANEL_IF_CTRL4, 		0x0110);
	CALL SUBOPT_0x93
; 0001 0214 		TFTSetReg(TFT_INS_PANEL_IF_CTRL5, 		0x0000);
	CALL SUBOPT_0x94
; 0001 0215 		TFTSetReg(TFT_INS_PANEL_IF_CTRL6, 		0x0000);
	CALL SUBOPT_0x95
; 0001 0216 
; 0001 0217 		TFTSetReg(TFT_INS_DISP_CTRL1, 				0x0133);
	LDI  R26,LOW(307)
	LDI  R27,HIGH(307)
	RCALL _TFTSetReg
; 0001 0218 
; 0001 0219 		TFTSetReg(TFT_INS_FRM_RATE_COL_CTRL, 	0x000D);
	LDI  R30,LOW(43)
	LDI  R31,HIGH(43)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(13)
	LDI  R27,0
_0x2003C:
	RCALL _TFTSetReg
; 0001 021A 	} //-----  Others!
; 0001 021B } //TFTInit
	RET
;
;unsigned short TFTGetID(void)
; 0001 021E {
; 0001 021F 	return(TFT_ID_code);
; 0001 0220 }	//TFTGetID
;
;void TFTBacklight(unsigned char x)
; 0001 0223 {
_TFTBacklight:
; 0001 0224 	TFT_BKL(x);
	ST   -Y,R26
;	x -> Y+0
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2000E
	IN   R30,0x12
	ORI  R30,0x80
	RJMP _0x2003D
_0x2000E:
	IN   R30,0x12
	ANDI R30,0x7F
_0x2003D:
	OUT  0x12,R30
; 0001 0225 }	//TFTBacklight
	ADIW R28,1
	RET
;
;void TFTSetArea(int sx,int ex,int sy,int ey)
; 0001 0228 {
_TFTSetArea:
; 0001 0229 	if (sx < TFT_margin_xl)    				sx = TFT_margin_xl;
	ST   -Y,R27
	ST   -Y,R26
;	sx -> Y+6
;	ex -> Y+4
;	sy -> Y+2
;	ey -> Y+0
	CALL SUBOPT_0x9
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x20011
	CALL SUBOPT_0x9
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0001 022A 	if (ex > TFT_margin_xr)    				ex = TFT_margin_xr;
_0x20011:
	CALL SUBOPT_0xA
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x20012
	CALL SUBOPT_0xA
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0001 022B 	if (sy < TFT_margin_yu)    				sy = TFT_margin_yu;
_0x20012:
	CALL SUBOPT_0xC
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CP   R26,R30
	CPC  R27,R31
	BRGE _0x20013
	CALL SUBOPT_0xC
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0001 022C 	if (ey > TFT_margin_yl)    				ey = TFT_margin_yl;
_0x20013:
	CALL SUBOPT_0xD
	LD   R26,Y
	LDD  R27,Y+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x20014
	CALL SUBOPT_0xD
	ST   Y,R30
	STD  Y+1,R31
; 0001 022D 	newX = ex - sx + 1;
_0x20014:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,1
	STS  _newX,R30
	STS  _newX+1,R31
; 0001 022E 
; 0001 022F 	TFTSetReg(TFT_INS_START_ADX,	sx);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	CALL SUBOPT_0x9F
; 0001 0230 	TFTSetReg(TFT_INS_END_ADX,		ex);
	LDI  R30,LOW(81)
	LDI  R31,HIGH(81)
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _TFTSetReg
; 0001 0231 	TFTSetReg(TFT_INS_GRAM_ADX,		sx);
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CALL SUBOPT_0x9F
; 0001 0232 
; 0001 0233 	#if !TFT_ORN_PORTRAIT
; 0001 0234 		sy = TFT_SIZE_Y - 1 - sy;       										// mirror start y address
; 0001 0235 		ey = TFT_SIZE_Y - 1 - ey;       										// mirror end 	y address
; 0001 0236 		newY = sy - ey + 1;
; 0001 0237 
; 0001 0238 		TFTSetReg(TFT_INS_START_ADY,	ey);
; 0001 0239 		TFTSetReg(TFT_INS_END_ADY,		sy);
; 0001 023A 		TFTSetReg(TFT_INS_GRAM_ADY,		sy);
; 0001 023B 	#else
; 0001 023C 		newY = ey - sy + 1;
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,Y
	LDD  R31,Y+1
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,1
	STS  _newY,R30
	STS  _newY+1,R31
; 0001 023D 
; 0001 023E 		TFTSetReg(TFT_INS_START_ADY,	sy);
	LDI  R30,LOW(82)
	LDI  R31,HIGH(82)
	CALL SUBOPT_0xA0
; 0001 023F 		TFTSetReg(TFT_INS_END_ADY,		ey);
	LDI  R30,LOW(83)
	LDI  R31,HIGH(83)
	CALL SUBOPT_0xA1
; 0001 0240 		TFTSetReg(TFT_INS_GRAM_ADY,		sy);
	LDI  R30,LOW(33)
	LDI  R31,HIGH(33)
	CALL SUBOPT_0xA0
; 0001 0241 	#endif
; 0001 0242 
; 0001 0243 	TFTOutCmd(TFT_INS_RW_GRAM);
	LDI  R26,LOW(34)
	CALL SUBOPT_0x11
; 0001 0244 } //TFTSetArea
	RJMP _0x20E001C
;
;void TFTResetArea(void)
; 0001 0247 {
_TFTResetArea:
; 0001 0248    TFTSetReg(TFT_INS_START_ADX,	0x0000);
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	CALL SUBOPT_0x9E
	CALL SUBOPT_0x85
; 0001 0249    TFTSetReg(TFT_INS_END_ADX,		GetMaxX());
; 0001 024A 
; 0001 024B    TFTSetReg(TFT_INS_START_ADY,	0x0000);
	CALL SUBOPT_0x86
	RCALL _TFTSetReg
; 0001 024C    TFTSetReg(TFT_INS_END_ADY,		GetMaxY());
	LDI  R30,LOW(83)
	LDI  R31,HIGH(83)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(319)
	LDI  R27,HIGH(319)
	RCALL _TFTSetReg
; 0001 024D }	//TFTResetArea
	RET
;
;//----------------------------------------------------------------------------
;//----------------------------------------------------------------------------
;void TFTGotoXY(int x,int y)
; 0001 0252 {
_TFTGotoXY:
; 0001 0253 	TFTSetReg(TFT_INS_GRAM_ADX, x); // initial settings for the GDDRAM X address in the address counter (AC).
	ST   -Y,R27
	ST   -Y,R26
;	x -> Y+2
;	y -> Y+0
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CALL SUBOPT_0xA0
; 0001 0254 	TFTSetReg(TFT_INS_GRAM_ADY, y); // initial settings for the GDDRAM Y address in the address counter (AC).
	LDI  R30,LOW(33)
	LDI  R31,HIGH(33)
	CALL SUBOPT_0xA1
; 0001 0255 
; 0001 0256 	TFTOutCmd(TFT_INS_RW_GRAM);
	LDI  R26,LOW(34)
	CALL SUBOPT_0x11
; 0001 0257 }	//TFTGotoXY
	ADIW R28,4
	RET
;
;void TFTPutPixel(int x,int y,unsigned short color,TFT_mode_t mode)
; 0001 025A {
_TFTPutPixel:
; 0001 025B 	TFTGotoXY(x, y);
	ST   -Y,R27
	ST   -Y,R26
;	x -> Y+6
;	y -> Y+4
;	color -> Y+2
;	mode -> Y+0
	CALL SUBOPT_0xA2
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _TFTGotoXY
; 0001 025C 
; 0001 025D 	if ((mode == TFT_MODE_NORMAL) || (mode == TFT_MODE_FULL))
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,0
	BREQ _0x20016
	SBIW R26,2
	BRNE _0x20015
_0x20016:
; 0001 025E 	{
; 0001 025F 		TFTOutDat(color);
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RJMP _0x2003E
; 0001 0260 	}
; 0001 0261 	else if (mode == TFT_MODE_INVERSE)
_0x20015:
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,1
	BRNE _0x20019
; 0001 0262   {
; 0001 0263    color = TFTInDat();     															// ignore invalid data
	RCALL _TFTInDat
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0001 0264    color = TFTInDat();
	RCALL _TFTInDat
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0001 0265    TFTOutDat(~color);
	COM  R30
	COM  R31
	MOVW R26,R30
_0x2003E:
	RCALL _TFTOutDat
; 0001 0266 	}
; 0001 0267 }	//TFTPutPixel
_0x20019:
_0x20E001C:
	ADIW R28,8
	RET
;
;void TFTFillRect(int sx,int ex,int sy,int ey,unsigned short color,TFT_mode_t mode) 		//draw a rectangular
; 0001 026A {
_TFTFillRect:
; 0001 026B 	unsigned int 		i, j;
; 0001 026C 
; 0001 026D 	TFTSetArea(sx, ex, sy, ey);
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
;	sx -> Y+14
;	ex -> Y+12
;	sy -> Y+10
;	ey -> Y+8
;	color -> Y+6
;	mode -> Y+4
;	i -> R16,R17
;	j -> R18,R19
	CALL SUBOPT_0xA3
	CALL SUBOPT_0xA3
	CALL SUBOPT_0xA3
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	RCALL _TFTSetArea
; 0001 026E 
; 0001 026F 	if ((mode == TFT_MODE_NORMAL) || (mode == TFT_MODE_FULL))
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,0
	BREQ _0x2001B
	SBIW R26,2
	BRNE _0x2001A
_0x2001B:
; 0001 0270 	{
; 0001 0271 		for (j=0; j<newY; j++)
	__GETWRN 18,19,0
_0x2001E:
	CALL SUBOPT_0xA4
	BRSH _0x2001F
; 0001 0272 	  	for (i=0; i<newX; i++)
	__GETWRN 16,17,0
_0x20021:
	CALL SUBOPT_0xA5
	BRSH _0x20022
; 0001 0273 			{
; 0001 0274 				TFTOutDat(color);
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL _TFTOutDat
; 0001 0275 			}
	__ADDWRN 16,17,1
	RJMP _0x20021
_0x20022:
	__ADDWRN 18,19,1
	RJMP _0x2001E
_0x2001F:
; 0001 0276 	}
; 0001 0277 	else if (mode == TFT_MODE_INVERSE)
	RJMP _0x20023
_0x2001A:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,1
	BRNE _0x20024
; 0001 0278   {
; 0001 0279   	for (j=0; j<newY; j++)
	__GETWRN 18,19,0
_0x20026:
	CALL SUBOPT_0xA4
	BRSH _0x20027
; 0001 027A     	for (i=0; i<newX; i++)
	__GETWRN 16,17,0
_0x20029:
	CALL SUBOPT_0xA5
	BRSH _0x2002A
; 0001 027B       {
; 0001 027C       	color = TFTInDat();                 						// ignore invalid data
	RCALL _TFTInDat
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0001 027D       	color = TFTInDat();
	RCALL _TFTInDat
	STD  Y+6,R30
	STD  Y+6+1,R31
; 0001 027E       	TFTOutDat(~color);
	COM  R30
	COM  R31
	MOVW R26,R30
	RCALL _TFTOutDat
; 0001 027F       }
	__ADDWRN 16,17,1
	RJMP _0x20029
_0x2002A:
	__ADDWRN 18,19,1
	RJMP _0x20026
_0x20027:
; 0001 0280 	}
; 0001 0281 
; 0001 0282 	TFTResetArea();
_0x20024:
_0x20023:
	RCALL _TFTResetArea
; 0001 0283 } //TFTFillRect
	CALL __LOADLOCR4
	ADIW R28,16
	RET
;
;//----------------------------------------------------------------------------
;//show picture from code memory with specific size
;void TFTShowPic(int sx,int ex,int sy,int ey,const unsigned short *pic,TFT_mode_t mode)
; 0001 0288 {
; 0001 0289 	unsigned long 	k = 0;
; 0001 028A 	unsigned short 	color;
; 0001 028B 	unsigned int 		i, j;
; 0001 028C 
; 0001 028D 	TFTSetArea(sx, ex, sy, ey);
;	sx -> Y+20
;	ex -> Y+18
;	sy -> Y+16
;	ey -> Y+14
;	*pic -> Y+12
;	mode -> Y+10
;	k -> Y+6
;	color -> R16,R17
;	i -> R18,R19
;	j -> R20,R21
; 0001 028E 
; 0001 028F   if (mode == TFT_MODE_FULL)
; 0001 0290   {
; 0001 0291 		for (j=0; j<newY; j++)
; 0001 0292 			for (i=0; i<newX; i++)
; 0001 0293 			{
; 0001 0294 				TFTOutDat(_pgm_read_word(pic[k]));
; 0001 0295 				k++;
; 0001 0296 			}
; 0001 0297 	}
; 0001 0298 	else if (mode == TFT_MODE_NORMAL)
; 0001 0299 	{
; 0001 029A 		for (j=0; j<newY; j++)
; 0001 029B 			for (i=0; i<newX; i++)
; 0001 029C 			{
; 0001 029D 				if (_pgm_read_word(pic[k]) == TFT_COL_WHITE)
; 0001 029E 				{
; 0001 029F 					color = TFTInDat();                 					// ignore invalid data
; 0001 02A0 					color = TFTInDat();
; 0001 02A1 					TFTOutDat(color);
; 0001 02A2 				}
; 0001 02A3 				else
; 0001 02A4 				{
; 0001 02A5 					TFTOutDat(_pgm_read_word(pic[k]));
; 0001 02A6 				}
; 0001 02A7 				k++;
; 0001 02A8 			}
; 0001 02A9   }
; 0001 02AA 
; 0001 02AB   TFTResetArea();
; 0001 02AC } //TFTShowPic
;//-----------------------------------------------------------------------------
;// Copyright:      RAD Electronic Co. LTD,
;// Author:         Sh. Nourbakhsh Rad
;// Remarks:
;// known Problems: none
;// Version:        1.5.0
;// Description:    GLCD's graphic founctions
;//-----------------------------------------------------------------------------
;
;#include "graphic.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;// Description	: Draw a line on a graphic LCD using Bresenham's
;// Input        : x1,y1 - starting coordinates
;//              : x2,y2 - ending coordinates
;//********************************************************************
;void Line(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color)
; 0002 0011 {

	.CSEG
; 0002 0012 	signed int  	x, y, addx, addy, dx, dy;
; 0002 0013 	signed long 	P;
; 0002 0014 	int 					i;
; 0002 0015 
; 0002 0016 	dx = abs((signed int)(x2 - x1));
;	x1 -> Y+26
;	y1 -> Y+24
;	x2 -> Y+22
;	y2 -> Y+20
;	color -> Y+18
;	x -> R16,R17
;	y -> R18,R19
;	addx -> R20,R21
;	addy -> Y+16
;	dx -> Y+14
;	dy -> Y+12
;	P -> Y+8
;	i -> Y+6
; 0002 0017 	dy = abs((signed int)(y2 - y1));
; 0002 0018 	x  = x1;
; 0002 0019 	y  = y1;
; 0002 001A 
; 0002 001B 	addx = addy = 1;
; 0002 001C 	if(x1 > x2)		addx = -1;
; 0002 001D 	if(y1 > y2)		addy = -1;
; 0002 001E 
; 0002 001F 	if (dx >= dy)
; 0002 0020 	{
; 0002 0021 		P = 2L*dy - dx;
; 0002 0022 		for (i=0; i<=dx; ++i)
; 0002 0023 		{
; 0002 0024 	  	PutPixel(x, y, color);
; 0002 0025 			if(P < 0)
; 0002 0026 	  	{
; 0002 0027 	    	P += 2*dy;
; 0002 0028 	    	x += addx;
; 0002 0029 	  	}
; 0002 002A 			else
; 0002 002B 			{
; 0002 002C 	    	P += 2*dy - 2*dx;
; 0002 002D 	    	x += addx;
; 0002 002E 	    	y += addy;
; 0002 002F 	  	}
; 0002 0030 		}
; 0002 0031 	}
; 0002 0032 	else
; 0002 0033 	{
; 0002 0034 		P = 2L*dx - dy;
; 0002 0035 		for(i=0; i<=dy; ++i)
; 0002 0036 		{
; 0002 0037 	  	PutPixel(x, y, color);
; 0002 0038 	  	if(P < 0)
; 0002 0039 	  	{
; 0002 003A 	    	P += 2*dx;
; 0002 003B 	    	y += addy;
; 0002 003C 	  	}
; 0002 003D 	  	else
; 0002 003E 	  	{
; 0002 003F 	    	P += 2*dx - 2*dy;
; 0002 0040 	    	x += addx;
; 0002 0041 	    	y += addy;
; 0002 0042 	  	}
; 0002 0043 		}
; 0002 0044 	}
; 0002 0045 }	//Line
;
;// Description  : Draw a rectangle on a graphic LCD
;// Input        : x1,y1 - starting coordinates
;//              : x2,y2 - ending coordinates
;//********************************************************************
;void Rectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned short color)
; 0002 004C {
; 0002 004D 		RectangleFill(x1, y1, x2, y1, color);    // top
;	x1 -> Y+8
;	y1 -> Y+6
;	x2 -> Y+4
;	y2 -> Y+2
;	color -> Y+0
; 0002 004E     RectangleFill(x1, y2, x2, y2, color);    // bottom
; 0002 004F     RectangleFill(x1, y1, x1, y2, color);    // left
; 0002 0050     RectangleFill(x2, y1, x2, y2, color);    // right
; 0002 0051 }	//Rectangle
;
;// Description	: Draws a beveled figure on the screen.
;// Input       	: x1, y1 - coordinate position of the upper left center
;//		      		: x2, y2 - coordinate position of the lower right center
;//             	: rad    - defines the redius of the circle,
;//             	: fill   - fill yes or no
;//********************************************************************
;void RoundRectangle(unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, unsigned int radius, unsigned char fill, unsigned short color)
; 0002 005A {
; 0002 005B 	signed int 		a, b, P;
; 0002 005C 
; 0002 005D 	a  = 0;       				// increment by 1
;	x1 -> Y+17
;	y1 -> Y+15
;	x2 -> Y+13
;	y2 -> Y+11
;	radius -> Y+9
;	fill -> Y+8
;	color -> Y+6
;	a -> R16,R17
;	b -> R18,R19
;	P -> R20,R21
; 0002 005E 	b  = radius;  				// decrement by 1 using P
; 0002 005F 	P  = 1 - radius;
; 0002 0060 
; 0002 0061 	if (fill)
; 0002 0062 	{
; 0002 0063 		RectangleFill(x1, y1+radius, x2, y2-radius, color);
; 0002 0064 
; 0002 0065 		do
; 0002 0066 		{
; 0002 0067       RectangleFill(x1-a+radius, y1-b+radius, a+x2-radius, y1-b+radius, color);	// 8 --> 1
; 0002 0068       RectangleFill(x1-b+radius, y1-a+radius, b+x2-radius, y1-a+radius, color);	// 7 --> 2
; 0002 0069       RectangleFill(x1-b+radius, a+y2-radius, b+x2-radius, a+y2-radius, color);	// 6 --> 3
; 0002 006A 			RectangleFill(x1-a+radius, b+y2-radius, a+x2-radius, b+y2-radius, color);	// 5 --> 4
; 0002 006B 
; 0002 006C 			if(P < 0)		P+= 3 + 2*a++;
; 0002 006D 			else				P+= 5 + 2*(a++ - b--);
; 0002 006E 		} while(a <= b);
; 0002 006F 	} //fill
; 0002 0070 	else
; 0002 0071 	{
; 0002 0072 		RectangleFill(x1+radius, y1       , x2-radius, y1       , color);	// top
; 0002 0073 		RectangleFill(x1+radius, y2       , x2-radius, y2       , color);	// bottom
; 0002 0074 		RectangleFill(x1       , y1+radius, x1       , y2-radius, color);	// left
; 0002 0075 		RectangleFill(x2       , y1+radius, x2       , y2-radius, color);	// right
; 0002 0076 
; 0002 0077 		do
; 0002 0078 		{
; 0002 0079 			PutPixel(a+x2-radius, y1-b+radius, color);	// `````` Segment 1
; 0002 007A 			PutPixel(b+x2-radius, y1-a+radius, color);	// `````` Segment 2
; 0002 007B 
; 0002 007C 			PutPixel(b+x2-radius, a+y2-radius, color);	// `````` Segment 3
; 0002 007D 			PutPixel(a+x2-radius, b+y2-radius, color);	// `````` Segment 4
; 0002 007E 
; 0002 007F 			PutPixel(x1-a+radius, b+y2-radius, color);	// `````` Segment 5
; 0002 0080 			PutPixel(x1-b+radius, a+y2-radius, color);	// `````` Segment 6
; 0002 0081 
; 0002 0082 			PutPixel(x1-b+radius, y1-a+radius, color);	// `````` Segment 7
; 0002 0083 			PutPixel(x1-a+radius, y1-b+radius, color);	// `````` Segment 8
; 0002 0084 
; 0002 0085 			if(P < 0)		P+= 3 + 2*a++;
; 0002 0086 			else				P+= 5 + 2*(a++ - b--);
; 0002 0087 		} while(a <= b);
; 0002 0088 	} //no fill
; 0002 0089 }	//RoundRectangle
;
;// Description	: Draw a circle on the screen.
;// Input       	: x,y  - the center of the circle
;//             	: rad  - defines the redius of the circle,
;//             	: fill - fill yes or no
;//********************************************************************
;void Circle_Fill(unsigned int x, unsigned int y, unsigned int radius, unsigned char fill, unsigned short color)
; 0002 0091 {
; 0002 0092    signed int 	a, b, P;
; 0002 0093 
; 0002 0094    a = 0;
;	x -> Y+13
;	y -> Y+11
;	radius -> Y+9
;	fill -> Y+8
;	color -> Y+6
;	a -> R16,R17
;	b -> R18,R19
;	P -> R20,R21
; 0002 0095    b = radius;
; 0002 0096    P = 1 - radius;
; 0002 0097 
; 0002 0098    do
; 0002 0099    {
; 0002 009A    		if(fill)
; 0002 009B      	{
; 0002 009C       	RectangleFill(x-a, y+b, x+a, y+b, color);	// 5 --> 4
; 0002 009D         RectangleFill(x-a, y-b, x+a, y-b, color);	// 8 --> 1
; 0002 009E         RectangleFill(x-b, y+a, x+b, y+a, color);	// 6 --> 3
; 0002 009F         RectangleFill(x-b, y-a, x+b, y-a, color);	// 7 --> 2
; 0002 00A0      	}
; 0002 00A1      	else
; 0002 00A2      	{
; 0002 00A3 																		//       		8	1
; 0002 00A4 																		//       	7			2
; 0002 00A5 																		//       	6			3
; 0002 00A6 																		//       		5	4
; 0002 00A7 																		//
; 0002 00A8        	PutPixel(a+x, b+y, color);	// `````` Segment 4
; 0002 00A9         PutPixel(b+x, a+y, color);	// `````` Segment 3
; 0002 00AA         PutPixel(x-a, b+y, color);	// `````` Segment 5
; 0002 00AB         PutPixel(x-b, a+y, color);	// `````` Segment 6
; 0002 00AC         PutPixel(b+x, y-a, color);	// `````` Segment 2
; 0002 00AD         PutPixel(a+x, y-b, color);	// `````` Segment 1
; 0002 00AE         PutPixel(x-a, y-b, color);	// `````` Segment 8
; 0002 00AF         PutPixel(x-b, y-a, color);	// `````` Segment 7
; 0002 00B0       }
; 0002 00B1 
; 0002 00B2       if(P < 0)    P+= 3 + 2*a++;
; 0002 00B3       else         P+= 5 + 2*(a++ - b--);
; 0002 00B4     } while(a <= b);
; 0002 00B5 }	//Circle_Fill
;//-----------------------------------------------------------------------------
;// Copyright:      RAD Electronic Co. LTD,
;// Author:         jaruwit supa, Base on FontEditor written by H. Reddmann
;//								 Modified by Sh. Nourbakhsh Rad for Persian and Arabic font
;//								 and fixed some errors
;// Remarks:
;// known Problems: none
;// Version:        1.8.0  01.09.2011
;// Description:    Font Library
;//-----------------------------------------------------------------------------
;
;#include "Font.h"
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include "PE_Map.h"
;
;
;const unsigned char 	   *FontPointer; 									// Font	Pointer
;unsigned char 						rot 						= 0;					// Rot 0=0, 1=90
;unsigned char 						Reverse					= 0;					// Reverse text direction on the display
;unsigned char							Horizontal			=	1;					// 1: Portrait - 240x320 ,   2: Landscape - 320x240

	.DSEG
;
;unsigned short 						FgColor 				= BLACK;			// Text fg color, 5-6-5 RGB
;unsigned short 						BkColor 				= WHITE;			// Text bk color, 5-6-5 RGB
;unsigned char 						FontFixed				= 0;					// Text type 0=Proportional , 1=Fixed
;unsigned char							NonTransparence = 0;					// Transparent 0=No, 1=Yes
;
;unsigned short 						fontSize;											// size of current font
;unsigned char 						firstchar;										// first character noumber of current font
;unsigned char 						lastchar;											// last character noumber of current font
;unsigned char 						charwidth;										// current character width register
;
;unsigned char							FontWidth;										// max width of font
;unsigned char							FontHeight;										// max height of font
;unsigned char 						FontXScale 			= 1;					// X size of font
;unsigned char 						FontYScale 			= 1;					// Y size of font
;unsigned char 						FontSpace 			= 1;					// space between char
;
;unsigned int 							cursorX 				= 0;					// x position
;unsigned int 							cursorY 				= 0;					// y position
;
;Lt_Mode										peLETTER				= E_LETTER;		// English or Persian letter
;
;unsigned char 						prevLet 				= 0xFF;				// previous persian character register
;unsigned char	 						nextLet 				= 0xFF; 			// next persian character register
;
;#define 									FONT_HEADER_SIZE  7 					// header size of fonts
;
;//********************************************
;//********************************************
;
;//**** select font
;void LcdFont(_const unsigned char *pointer)
; 0003 0034 {

	.CSEG
_LcdFont:
; 0003 0035 	FontPointer 			= pointer;
	ST   -Y,R27
	ST   -Y,R26
;	*pointer -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	STS  _FontPointer,R30
	STS  _FontPointer+1,R31
; 0003 0036 
; 0003 0037 	FontWidth 				= _pgm_read_byte(FontPointer[2]);
	CALL SUBOPT_0xA6
	ADIW R30,2
	LPM  R0,Z
	STS  _FontWidth,R0
; 0003 0038 	FontHeight				= _pgm_read_byte(FontPointer[3]);
	CALL SUBOPT_0xA6
	ADIW R30,3
	LPM  R0,Z
	STS  _FontHeight,R0
; 0003 0039 
; 0003 003A 	//fontSize				=	_pgm_read_word(FontPointer[0]);
; 0003 003B 	fontSize					=	_pgm_read_byte(FontPointer[1]) << 8;
	CALL SUBOPT_0xA6
	ADIW R30,1
	LPM  R26,Z
	LDI  R30,LOW(8)
	CALL __LSLB12
	LDI  R31,0
	CALL SUBOPT_0xA7
; 0003 003C 	fontSize				 += _pgm_read_byte(FontPointer[0]);
	LPM  R30,Z
	CALL SUBOPT_0xA8
	CALL SUBOPT_0xA9
	CALL SUBOPT_0xA7
; 0003 003D 	firstchar 				=	_pgm_read_byte(FontPointer[5]);
	ADIW R30,5
	LPM  R0,Z
	STS  _firstchar,R0
; 0003 003E 	lastchar 					=	_pgm_read_byte(FontPointer[6]);
	CALL SUBOPT_0xA6
	ADIW R30,6
	LPM  R0,Z
	STS  _lastchar,R0
; 0003 003F }	//LcdFont
	RJMP _0x20E001B
;
;//**** draw char
;void PutChar(unsigned char c)
; 0003 0043 {
; 0003 0044   if(peLETTER == P_LETTER)
;	c -> Y+0
; 0003 0045 		PutCharPE(c);
; 0003 0046 	else
; 0003 0047 			PutCharEN(c);
; 0003 0048 }	//PutChar
;
;void SetLine(unsigned char line,unsigned char column)
; 0003 004B {
_SetLine:
; 0003 004C 	if(peLETTER == P_LETTER)
	ST   -Y,R26
;	line -> Y+1
;	column -> Y+0
	LDS  R26,_peLETTER
	LDS  R27,_peLETTER+1
	SBIW R26,1
	BRNE _0x6000C
; 0003 004D 		cursorX =GetMaxX() - (unsigned int)FontWidth  * FontXScale * column;
	CALL SUBOPT_0xAA
	CALL SUBOPT_0xAB
; 0003 004E 	else
	RJMP _0x6000D
_0x6000C:
; 0003 004F 		cursorX =(unsigned int)FontWidth  * FontXScale * column;
	CALL SUBOPT_0xAA
	CALL SUBOPT_0xAC
; 0003 0050 
; 0003 0051 	cursorY =(unsigned int)FontHeight * FontYScale * line;
_0x6000D:
	CALL SUBOPT_0xAD
	MOVW R26,R30
	LDD  R30,Y+1
	CALL SUBOPT_0xAE
	CALL SUBOPT_0xAF
; 0003 0052 }	//SetCursor
	RJMP _0x20E001B
;
;unsigned int CalcTextWidth(char *Text)
; 0003 0055 {
; 0003 0056 	if(peLETTER == E_LETTER)
;	*Text -> Y+0
; 0003 0057 		return CalcTextWidthEN(Text);
; 0003 0058 	else
; 0003 0059 		return CalcTextWidthPE(Text);
; 0003 005A }	//CalcTextWidth
;
;unsigned int CalcTextHeight(char *Text)
; 0003 005D {
; 0003 005E 	return FontHeight * FontYScale;
;	*Text -> Y+0
; 0003 005F }	//CalcTextHeight
;
;//**** draw string
;void Puts(char *Text)
; 0003 0063 {
_Puts:
; 0003 0064 	unsigned char 	c;
; 0003 0065 
; 0003 0066   if(peLETTER == P_LETTER)
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
;	*Text -> Y+1
;	c -> R17
	LDS  R26,_peLETTER
	LDS  R27,_peLETTER+1
	SBIW R26,1
	BRNE _0x60010
; 0003 0067 		PutsPE(Text);
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL _PutsPE
; 0003 0068 	else
	RJMP _0x60011
_0x60010:
; 0003 0069 	{
; 0003 006A 		while((c = *Text++))
_0x60012:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x60014
; 0003 006B 			PutCharEN(c);
	MOV  R26,R17
	RCALL _PutCharEN
	RJMP _0x60012
_0x60014:
; 0003 006C }
_0x60011:
; 0003 006D }	//Puts
	JMP  _0x20E0019
;
;void PutsP(char *Text)
; 0003 0070 {
; 0003 0071 	unsigned char 	c;
; 0003 0072 
; 0003 0073 	while((c = _pgm_read_byte(*(Text++))))
;	*Text -> Y+1
;	c -> R17
; 0003 0074 	{
; 0003 0075 		PutChar(c);
; 0003 0076 	}
; 0003 0077 }	//PutsP
;
;void PutLong(unsigned long src, unsigned char digit, unsigned char decimal, unsigned char Parameter)
; 0003 007A {
; 0003 007B 	char 			text[10+1];
; 0003 007C 	unsigned char 	i;
; 0003 007D 	Lt_Mode		cMode;
; 0003 007E 
; 0003 007F 	cMode = peLETTER;
;	src -> Y+18
;	digit -> Y+17
;	decimal -> Y+16
;	Parameter -> Y+15
;	text -> Y+4
;	i -> R17
;	cMode -> R18,R19
; 0003 0080 	SetLetter(E_LETTER);
; 0003 0081 
; 0003 0082 	text[digit] = 0;
; 0003 0083 	for(i = digit; i >0; i--)
; 0003 0084 	{
; 0003 0085 		text[i-1] =(src % 10) + 48;
; 0003 0086 		src = src/10;
; 0003 0087 	}//for digit
; 0003 0088 
; 0003 0089 	if (Parameter & (STYLE_NO_ZERO | STYLE_NO_SPACE))
; 0003 008A 	{
; 0003 008B 		while(text[i] == '0')
; 0003 008C 		{
; 0003 008D 
; 0003 008E 			if (Parameter & (STYLE_NO_ZERO))
; 0003 008F 				PutChar(' ');
; 0003 0090 
; 0003 0091 			i++;
; 0003 0092 			if (i > digit - decimal -1 -1) // include lead 0.xx
; 0003 0093 				break;
; 0003 0094 		}
; 0003 0095 	}
; 0003 0096 
; 0003 0097 	while(text[i])
; 0003 0098 	{
; 0003 0099 		if (i == digit - decimal) // include lead 0.xx
; 0003 009A 			PutChar('.');
; 0003 009B 
; 0003 009C 		PutChar(text[i]);
; 0003 009D 		i++;
; 0003 009E 	}
; 0003 009F 
; 0003 00A0 	SetLetter(cMode);
; 0003 00A1 }	//PutLong
;
;void PutInt(unsigned short src, unsigned char digit, unsigned char decimal, unsigned char Parameter)
; 0003 00A4 {
; 0003 00A5 	unsigned long 		n = src;
; 0003 00A6 
; 0003 00A7 	PutLong(n, digit, decimal, Parameter);
;	src -> Y+7
;	digit -> Y+6
;	decimal -> Y+5
;	Parameter -> Y+4
;	n -> Y+0
; 0003 00A8 }	//PutInt
;
;void PutByte(unsigned char src, unsigned char digit, unsigned char decimal, unsigned char Parameter)
; 0003 00AB {
; 0003 00AC 	unsigned long 		n = src;
; 0003 00AD 
; 0003 00AE 	PutLong(n, digit, decimal, Parameter);
;	src -> Y+7
;	digit -> Y+6
;	decimal -> Y+5
;	Parameter -> Y+4
;	n -> Y+0
; 0003 00AF }	//PutByte
;
;void PutText(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, char *str, unsigned char style)
; 0003 00B2 {
; 0003 00B3 	unsigned short 			sizeofstring;
; 0003 00B4 
; 0003 00B5 	sizeofstring = CalcTextWidth(str);
;	left -> Y+11
;	top -> Y+9
;	right -> Y+7
;	bottom -> Y+5
;	*str -> Y+3
;	style -> Y+2
;	sizeofstring -> R16,R17
; 0003 00B6 	top = top + (bottom - top - (FontHeight*FontYScale))/2;
; 0003 00B7 
; 0003 00B8 
; 0003 00B9 	if(peLETTER == E_LETTER)
; 0003 00BA 	{
; 0003 00BB 		switch (style & ALINE_MARK)
; 0003 00BC 		{
; 0003 00BD 			case ALINE_LEFT:
; 0003 00BE 				left = left + FontSpace;
; 0003 00BF 				break;
; 0003 00C0 
; 0003 00C1 			case ALINE_CENTER:
; 0003 00C2 					left = left + (right - left - sizeofstring) / 2;
; 0003 00C3 				break;
; 0003 00C4 
; 0003 00C5 			case ALINE_RIGHT:
; 0003 00C6 				if (right > sizeofstring)
; 0003 00C7 					left = right - sizeofstring;
; 0003 00C8 				break;
; 0003 00C9 		}//switch
; 0003 00CA 
; 0003 00CB 		SetCursorX(left);
; 0003 00CC 	}
; 0003 00CD 	else
; 0003 00CE 	{
; 0003 00CF 		switch (style & ALINE_MARK)
; 0003 00D0 		{
; 0003 00D1 			case ALINE_RIGHT:
; 0003 00D2 				break;
; 0003 00D3 
; 0003 00D4 			case ALINE_CENTER:
; 0003 00D5 					right = right - (right - left - sizeofstring) / 2;
; 0003 00D6 				break;
; 0003 00D7 
; 0003 00D8 			case ALINE_LEFT:
; 0003 00D9 				right = left + sizeofstring;
; 0003 00DA 				right = right + FontSpace;
; 0003 00DB 				break;
; 0003 00DC 		}//switch
; 0003 00DD 
; 0003 00DE 		SetCursorX(right);
; 0003 00DF 	}
; 0003 00E0 
; 0003 00E1 	SetCursorY(top);
; 0003 00E2 	Puts(str);
; 0003 00E3 }	//PutText
;
;void PutTextP(unsigned short left, unsigned short top, unsigned short right, unsigned short bottom, const char *str, unsigned char style)
; 0003 00E6 {
; 0003 00E7 	char 				strP[100+1];
; 0003 00E8 
; 0003 00E9 	strncpy_P(strP, str, strnlen_P(str,100));
;	left -> Y+110
;	top -> Y+108
;	right -> Y+106
;	bottom -> Y+104
;	*str -> Y+102
;	style -> Y+101
;	strP -> Y+0
; 0003 00EA 	strP[100] = 0;	// terminate string
; 0003 00EB 	PutText(left, top, right, bottom, strP, style);
; 0003 00EC }	//PutTextP
;
;void TextBox(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style)
; 0003 00EF {
; 0003 00F0 	unsigned int 			r;
; 0003 00F1 	unsigned short 		temp;
; 0003 00F2 
; 0003 00F3 	if (style & BORDER_RECT)
;	x1 -> Y+13
;	y1 -> Y+11
;	x2 -> Y+9
;	y2 -> Y+7
;	*str -> Y+5
;	style -> Y+4
;	r -> R16,R17
;	temp -> R18,R19
; 0003 00F4 	{
; 0003 00F5 		r = (style & BORDER_BEVEL) >> 4;	// get bevel radius
; 0003 00F6 		if (r)	// bevel
; 0003 00F7 		{
; 0003 00F8 			if (style & BORDER_FILL)
; 0003 00F9 				BevelFill(x1+1, y1+1, x2-1, y2-1, r, BkColor);
; 0003 00FA 
; 0003 00FB 			Bevel(x1, y1, x2, y2, r, FgColor);
; 0003 00FC 		}
; 0003 00FD 		else	// rect
; 0003 00FE 		{
; 0003 00FF 			if (style & BORDER_FILL)
; 0003 0100 				RectangleFill(x1+1, y1+1, x2-1, y2-1, BkColor);
; 0003 0101 
; 0003 0102 			Rectangle(x1, y1, x2, y2, FgColor);
; 0003 0103 		}
; 0003 0104 	}
; 0003 0105 	else if (style & BORDER_FILL)
; 0003 0106 	{
; 0003 0107 		RectangleFill(x1, y1, x2, y2, BkColor);
; 0003 0108 	}
; 0003 0109 
; 0003 010A 	if(rot)
; 0003 010B 	{
; 0003 010C 		temp = x1; 		x1 = y1; 		y1 = temp;
; 0003 010D 		temp = x2; 		x2 = y2; 		y2 = temp;
; 0003 010E 	}
; 0003 010F 
; 0003 0110 	if ((style & BORDER_RECT) || (style & BORDER_FILL))
; 0003 0111 		PutText(x1+1, y1+1, x2-1, y2-1, str, style & ALINE_MARK);
; 0003 0112   else
; 0003 0113 		PutText(x1, y1, x2, y2, str, style & ALINE_MARK);
; 0003 0114 }	//TextBox
;
;void TextBoxP(unsigned short x1, unsigned short y1, unsigned short x2, unsigned short y2, char *str, unsigned char style)
; 0003 0117 {
; 0003 0118 	char 		strP[100+1];
; 0003 0119 
; 0003 011A 	strncpy_P(strP, str, strnlen_P(str,100));
;	x1 -> Y+110
;	y1 -> Y+108
;	x2 -> Y+106
;	y2 -> Y+104
;	*str -> Y+102
;	style -> Y+101
;	strP -> Y+0
; 0003 011B 	strP[100] = 0;	// terminate string
; 0003 011C 	TextBox(x1, y1, x2, y2, strP, style);
; 0003 011D }	//TextBoxP
;
;/////////////////////////////////////
;void SetLetter(Lt_Mode L)
; 0003 0121 {
_SetLetter:
; 0003 0122 	peLETTER = L;
	ST   -Y,R27
	ST   -Y,R26
;	L -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	STS  _peLETTER,R30
	STS  _peLETTER+1,R31
; 0003 0123 
; 0003 0124 	if(L == P_LETTER)
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,1
	BRNE _0x60040
; 0003 0125 		cursorX = GetMaxX();
	LDI  R30,LOW(239)
	LDI  R31,HIGH(239)
	CALL SUBOPT_0xAC
; 0003 0126 	else
	RJMP _0x60041
_0x60040:
; 0003 0127 		cursorX = 0;
	CALL SUBOPT_0xB0
; 0003 0128 }	//SetLetter
_0x60041:
_0x20E001B:
	ADIW R28,2
	RET
;
;void PutsPE(char *str)
; 0003 012B {
_PutsPE:
; 0003 012C 	unsigned char 	curnLet,	dumyLet;
; 0003 012D 	unsigned char 	Pstat, stat, Nstat;
; 0003 012E 
; 0003 012F 	unsigned char		backFontSpace = FontSpace;
; 0003 0130 	char 						strTemp[50];
; 0003 0131 	unsigned char 	i = 0, j = 0;
; 0003 0132 
; 0003 0133  	while((curnLet = *str++))
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,52
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	CALL __SAVELOCR6
;	*str -> Y+58
;	curnLet -> R17
;	dumyLet -> R16
;	Pstat -> R19
;	stat -> R18
;	Nstat -> R21
;	backFontSpace -> R20
;	strTemp -> Y+8
;	i -> Y+7
;	j -> Y+6
	LDS  R20,_FontSpace
_0x60042:
	CALL SUBOPT_0xB1
	MOV  R17,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x60044
; 0003 0134 	{
; 0003 0135  		switch(curnLet)
	MOV  R30,R17
; 0003 0136  		{
; 0003 0137  			case 0x81:				//peh
	CPI  R30,LOW(0x81)
	BRNE _0x60048
; 0003 0138     		curnLet = 0xEA;
	LDI  R17,LOW(234)
; 0003 0139  				break;
	RJMP _0x60047
; 0003 013A  			case 0x8D:				//cheh
_0x60048:
	CPI  R30,LOW(0x8D)
	BRNE _0x60049
; 0003 013B     		curnLet = 0xEB;
	LDI  R17,LOW(235)
; 0003 013C  				break;
	RJMP _0x60047
; 0003 013D  			case 0x8E:				//zheh
_0x60049:
	CPI  R30,LOW(0x8E)
	BRNE _0x6004A
; 0003 013E     		curnLet = 0xEE;
	LDI  R17,LOW(238)
; 0003 013F  				break;
	RJMP _0x60047
; 0003 0140  			case 0x90:				//geh
_0x6004A:
	CPI  R30,LOW(0x90)
	BRNE _0x6004B
; 0003 0141     		curnLet = 0xEF;
	LDI  R17,LOW(239)
; 0003 0142  				break;
	RJMP _0x60047
; 0003 0143  			case 0xE1:				//laa
_0x6004B:
	CPI  R30,LOW(0xE1)
	BRNE _0x6004C
; 0003 0144     		nextLet = *str++;
	CALL SUBOPT_0xB1
	STS  _nextLet,R30
; 0003 0145 
; 0003 0146     		if(nextLet == 0xC7)
	LDS  R26,_nextLet
	CPI  R26,LOW(0xC7)
	BRNE _0x6004D
; 0003 0147     			curnLet = 0xFB;
	LDI  R17,LOW(251)
; 0003 0148     		else
	RJMP _0x6004E
_0x6004D:
; 0003 0149     		{
; 0003 014A     			dumyLet = *str--;
	CALL SUBOPT_0xB2
; 0003 014B     			curnLet = 0xE1;
	LDI  R17,LOW(225)
; 0003 014C     		}
_0x6004E:
; 0003 014D  				break;
	RJMP _0x60047
; 0003 014E  			case 0x3F:				//persian question mark
_0x6004C:
	CPI  R30,LOW(0x3F)
	BRNE _0x6004F
; 0003 014F     		curnLet = 0xBF;
	LDI  R17,LOW(191)
; 0003 0150  				break;
	RJMP _0x60047
; 0003 0151  			case 0x3B:				//persian semicolon
_0x6004F:
	CPI  R30,LOW(0x3B)
	BRNE _0x60050
; 0003 0152     		curnLet = 0x1F;
	LDI  R17,LOW(31)
; 0003 0153  				break;
	RJMP _0x60047
; 0003 0154  			case 0x2C:				//persian comma
_0x60050:
	CPI  R30,LOW(0x2C)
	BRNE _0x60051
; 0003 0155     		curnLet = 0x1D;
	LDI  R17,LOW(29)
; 0003 0156  				break;
	RJMP _0x60047
; 0003 0157  			case 0x2E:				//persian point
_0x60051:
	CPI  R30,LOW(0x2E)
	BRNE _0x60047
; 0003 0158     		curnLet = 0x1C;
	LDI  R17,LOW(28)
; 0003 0159  				break;
; 0003 015A 		}//switch curnLet
_0x60047:
; 0003 015B 
; 0003 015C 		//--------------------------------
; 0003 015D   	nextLet = *str++;
	CALL SUBOPT_0xB1
	STS  _nextLet,R30
; 0003 015E   	dumyLet	= *str--;
	CALL SUBOPT_0xB2
; 0003 015F 
; 0003 0160  		switch(nextLet)
	LDS  R30,_nextLet
; 0003 0161  		{
; 0003 0162  			case 0x81:				//peh
	CPI  R30,LOW(0x81)
	BRNE _0x60056
; 0003 0163     		nextLet = 0xEA;
	LDI  R30,LOW(234)
	RJMP _0x6012A
; 0003 0164  				break;
; 0003 0165  			case 0x8D:				//cheh
_0x60056:
	CPI  R30,LOW(0x8D)
	BRNE _0x60057
; 0003 0166     		nextLet = 0xEB;
	LDI  R30,LOW(235)
	RJMP _0x6012A
; 0003 0167  				break;
; 0003 0168  			case 0x8E:				//zheh
_0x60057:
	CPI  R30,LOW(0x8E)
	BRNE _0x60058
; 0003 0169     		nextLet = 0xEE;
	LDI  R30,LOW(238)
	RJMP _0x6012A
; 0003 016A  				break;
; 0003 016B  			case 0x90:				//geh
_0x60058:
	CPI  R30,LOW(0x90)
	BRNE _0x60059
; 0003 016C     		nextLet = 0xEF;
	LDI  R30,LOW(239)
	RJMP _0x6012A
; 0003 016D  				break;
; 0003 016E  			case 0x3F:				//persian question mark
_0x60059:
	CPI  R30,LOW(0x3F)
	BRNE _0x6005A
; 0003 016F     		nextLet = 0xBF;
	LDI  R30,LOW(191)
	RJMP _0x6012A
; 0003 0170  				break;
; 0003 0171  			case 0x3B:				//persian semicolon
_0x6005A:
	CPI  R30,LOW(0x3B)
	BRNE _0x6005B
; 0003 0172     		nextLet = 0x1F;
	LDI  R30,LOW(31)
	RJMP _0x6012A
; 0003 0173  				break;
; 0003 0174  			case 0x2C:				//persian comma
_0x6005B:
	CPI  R30,LOW(0x2C)
	BRNE _0x6005C
; 0003 0175     		nextLet = 0x1D;
	LDI  R30,LOW(29)
	RJMP _0x6012A
; 0003 0176  				break;
; 0003 0177  			case 0x2E:				//persian point
_0x6005C:
	CPI  R30,LOW(0x2E)
	BRNE _0x60055
; 0003 0178     		nextLet = 0x1C;
	LDI  R30,LOW(28)
_0x6012A:
	STS  _nextLet,R30
; 0003 0179  				break;
; 0003 017A 		}//switch nextLet
_0x60055:
; 0003 017B 
; 0003 017C 		if(curnLet > 0xC0)
	CPI  R17,193
	BRLO _0x6005E
; 0003 017D 		{
; 0003 017E 			if(prevLet > 0xC0)
	LDS  R26,_prevLet
	CPI  R26,LOW(0xC1)
	BRLO _0x6005F
; 0003 017F 				Pstat = (_pgm_read_byte((PEmap[prevLet-0xC1][5])));		// 1: prevLet attach to curnLet -- 0: prevLet don't attach to curnLet
	LDS  R30,_prevLet
	CALL SUBOPT_0xB3
	ADIW R30,5
	LPM  R19,Z
; 0003 0180 			else
	RJMP _0x60060
_0x6005F:
; 0003 0181 				Pstat = 0;
	LDI  R19,LOW(0)
; 0003 0182 
; 0003 0183 			if(nextLet > 0xC0)
_0x60060:
	LDS  R26,_nextLet
	CPI  R26,LOW(0xC1)
	BRLO _0x60061
; 0003 0184 				Nstat = (_pgm_read_byte((PEmap[nextLet-0xC1][4])));		// 1: nextLet attach to curnLet -- 0: nextLet don't attach to curnLet
	LDS  R30,_nextLet
	CALL SUBOPT_0xB3
	ADIW R30,4
	LPM  R21,Z
; 0003 0185 			else
	RJMP _0x60062
_0x60061:
; 0003 0186 				Nstat = 0;
	LDI  R21,LOW(0)
; 0003 0187 
; 0003 0188 			//			Pstat	|	Nstat	|	stat
; 0003 0189 			//		 -------+-------+------
; 0003 018A 			//				0		|		0		|		0				curnLet, don't attach to prevLet and nextLet
; 0003 018B 			//				0		|		1		|		1				curnLet, don't attach to prevLet and attach to nextLet
; 0003 018C 			//				1		|		0		|		2				curnLet, attach to prevLet and don't attach to nextLet
; 0003 018D 			//				1		|		1		|		3				curnLet, attach to prevLet and nextLet
; 0003 018E 
; 0003 018F 			stat = (Pstat<<1) | Nstat;
_0x60062:
	MOV  R30,R19
	LSL  R30
	OR   R30,R21
	MOV  R18,R30
; 0003 0190 
; 0003 0191 			if(stat>1)	FontSpace = 0;
	CPI  R18,2
	BRLO _0x60063
	LDI  R30,LOW(0)
	STS  _FontSpace,R30
; 0003 0192 			else 				FontSpace = backFontSpace;
	RJMP _0x60064
_0x60063:
	STS  _FontSpace,R20
; 0003 0193 
; 0003 0194 			PutCharPE(_pgm_read_byte((PEmap[curnLet-0xC1][stat])));
_0x60064:
	MOV  R30,R17
	CALL SUBOPT_0xB3
	MOVW R26,R30
	MOV  R30,R18
	CALL SUBOPT_0xA9
	LPM  R26,Z
	RCALL _PutCharPE
; 0003 0195 			FontSpace = backFontSpace;
	STS  _FontSpace,R20
; 0003 0196 		}
; 0003 0197 		else	//Original 'curnLet' below 193 without (     )  -- for digits and symbols!
	RJMP _0x60065
_0x6005E:
; 0003 0198 		{
; 0003 0199   		if((curnLet >= '0') && (curnLet <= '9'))		// 0 to 9
	CPI  R17,48
	BRLO _0x60067
	CPI  R17,58
	BRLO _0x60068
_0x60067:
	RJMP _0x60066
_0x60068:
; 0003 019A   		{
; 0003 019B   			i++;
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	STD  Y+7,R30
; 0003 019C   			strTemp[i] 	 = curnLet;
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,8
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
; 0003 019D 
; 0003 019E   			if(!((nextLet >= '0') && (nextLet <= '9')))
	LDS  R26,_nextLet
	CPI  R26,LOW(0x30)
	BRLO _0x6006A
	CPI  R26,LOW(0x3A)
	BRLO _0x60069
_0x6006A:
; 0003 019F 				{
; 0003 01A0 					for(j=i; j>0; j--)
	LDD  R30,Y+7
	STD  Y+6,R30
_0x6006D:
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRLO _0x6006E
; 0003 01A1 						PutCharPE(strTemp[j]-0x20);
	LDD  R30,Y+6
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,8
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	SUBI R30,LOW(32)
	MOV  R26,R30
	RCALL _PutCharPE
	LDD  R30,Y+6
	SUBI R30,LOW(1)
	STD  Y+6,R30
	RJMP _0x6006D
_0x6006E:
; 0003 01A3 i = 0;
	LDI  R30,LOW(0)
	STD  Y+7,R30
; 0003 01A4 				}
; 0003 01A5 			}
_0x60069:
; 0003 01A6 			else
	RJMP _0x6006F
_0x60066:
; 0003 01A7 				PutCharPE(curnLet);
	MOV  R26,R17
	RCALL _PutCharPE
; 0003 01A8 		}
_0x6006F:
_0x60065:
; 0003 01A9 
; 0003 01AA 		prevLet = curnLet;
	STS  _prevLet,R17
; 0003 01AB 	}//while
	RJMP _0x60042
_0x60044:
; 0003 01AC 
; 0003 01AD  	prevLet = 0xFF;
	LDI  R30,LOW(255)
	STS  _prevLet,R30
; 0003 01AE }	//PutsPE
	CALL __LOADLOCR6
	ADIW R28,60
	RET
;
;void PutCharPE(unsigned char c)
; 0003 01B1 {
_PutCharPE:
; 0003 01B2 	unsigned char 			byte 					= 0;
; 0003 01B3 	unsigned char 			bitoffset 		= 0;
; 0003 01B4 	unsigned char 			maske 				= 0;
; 0003 01B5 	unsigned short 			bcounter 			= 0;
; 0003 01B6 	unsigned short 			bitsbischar 	= 0;
; 0003 01B7 	unsigned short 			bytesbischar	= 0;
; 0003 01B8 	unsigned short 			xPos,yPos;
; 0003 01B9 
; 0003 01BA 	unsigned char 			Ccounter 			= 0;
; 0003 01BB 	unsigned char 			xc 						= 0;
; 0003 01BC 	unsigned char 			yc 						= 0;
; 0003 01BD 	unsigned char 			sx 						= 0;
; 0003 01BE 	unsigned char 			sy 						= 0;
; 0003 01BF 
; 0003 01C0 	// get current character width
; 0003 01C1 	charwidth	= _pgm_read_byte(FontPointer[(unsigned int)(c)+FONT_HEADER_SIZE-firstchar]);
	ST   -Y,R26
	SBIW R28,12
	LDI  R24,12
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x60070*2)
	LDI  R31,HIGH(_0x60070*2)
	CALL __INITLOCB
	CALL SUBOPT_0xB4
;	c -> Y+18
;	byte -> R17
;	bitoffset -> R16
;	maske -> R19
;	bcounter -> R20,R21
;	bitsbischar -> Y+16
;	bytesbischar -> Y+14
;	xPos -> Y+12
;	yPos -> Y+10
;	Ccounter -> R18
;	xc -> Y+9
;	yc -> Y+8
;	sx -> Y+7
;	sy -> Y+6
; 0003 01C2 
; 0003 01C3 	// line feed, goto next line
; 0003 01C4 	if(c == '\n')
	BRNE _0x60071
; 0003 01C5 	{
; 0003 01C6 		cursorX = GetMaxX();
	LDI  R30,LOW(239)
	LDI  R31,HIGH(239)
	CALL SUBOPT_0xAC
; 0003 01C7 		cursorY = cursorY + (unsigned int)FontHeight * FontYScale;
	CALL SUBOPT_0xAD
	CALL SUBOPT_0xB5
; 0003 01C8 
; 0003 01C9 		return;
	RJMP _0x20E001A
; 0003 01CA 	}
; 0003 01CB 
; 0003 01CC 	// character out of range.
; 0003 01CD   if( (c < firstchar) || (c > lastchar) || (fontSize == 0))
_0x60071:
	LDS  R30,_firstchar
	LDD  R26,Y+18
	CP   R26,R30
	BRLO _0x60073
	LDS  R30,_lastchar
	CP   R30,R26
	BRLO _0x60073
	CALL SUBOPT_0xA8
	SBIW R26,0
	BRNE _0x60072
_0x60073:
; 0003 01CE   	return;
	RJMP _0x20E001A
; 0003 01CF 
; 0003 01D0 	// character is not in list.
; 0003 01D1 	if (charwidth == 0)
_0x60072:
	LDS  R30,_charwidth
	CPI  R30,0
	BRNE _0x60075
; 0003 01D2 		return;
	RJMP _0x20E001A
; 0003 01D3 
; 0003 01D4 	// sara thai font. line remain at last position
; 0003 01D5 	if(FontFixed)
_0x60075:
	LDS  R30,_FontFixed
	CPI  R30,0
	BREQ _0x60076
; 0003 01D6 		charwidth = FontWidth;
	LDS  R30,_FontWidth
	STS  _charwidth,R30
; 0003 01D7 
; 0003 01D8 	// line adjust
; 0003 01D9 	if(((int)cursorX - charwidth * FontXScale) < 0)
_0x60076:
	CALL SUBOPT_0xB6
	SUB  R26,R30
	SBC  R27,R31
	TST  R27
	BRPL _0x60077
; 0003 01DA   {
; 0003 01DB 		cursorY = cursorY   + (unsigned int)FontHeight * FontYScale;
	CALL SUBOPT_0xAD
	CALL SUBOPT_0xB5
; 0003 01DC 		cursorX = GetMaxX() - (unsigned int)charwidth * FontXScale;
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xAB
; 0003 01DD 	}
; 0003 01DE 
; 0003 01DF 	// adjust cursor to current position - persian
; 0003 01E0 	cursorX	-= (unsigned int)charwidth * FontXScale + FontSpace;
_0x60077:
	CALL SUBOPT_0xB7
	MOVW R26,R30
	LDS  R30,_FontSpace
	CALL SUBOPT_0xA9
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0003 01E1 
; 0003 01E2 	// calculate current character position on the table
; 0003 01E3 	for(Ccounter = 0; Ccounter < c-firstchar; Ccounter++)
	LDI  R18,LOW(0)
_0x60079:
	LDS  R26,_firstchar
	LDD  R30,Y+18
	SUB  R30,R26
	CP   R18,R30
	BRSH _0x6007A
; 0003 01E4 		bitsbischar += (_pgm_read_byte(FontPointer[(unsigned int)(Ccounter)+FONT_HEADER_SIZE]));	//c0_width +...+ cn_width
	CALL SUBOPT_0xBA
	STD  Y+16,R30
	STD  Y+16+1,R31
	SUBI R18,-1
	RJMP _0x60079
_0x6007A:
; 0003 01E7 bitsbischar 		*= FontHeight;
	CALL SUBOPT_0xBB
	CALL SUBOPT_0xBC
; 0003 01E8 	bitsbischar 		+= (((unsigned short)(lastchar)-firstchar)+FONT_HEADER_SIZE)*8;		//plus font headers
; 0003 01E9 	bytesbischar 		 = bitsbischar/8;									//
; 0003 01EA 	bitoffset 			 = bitsbischar % 8;								//
; 0003 01EB 	maske						 = bitoffset % 8;									//
; 0003 01EC 
; 0003 01ED 	// draw character
; 0003 01EE 	for(xc = 0; xc < charwidth; xc++)
_0x6007C:
	LDS  R30,_charwidth
	LDD  R26,Y+9
	CP   R26,R30
	BRLO PC+3
	JMP _0x6007D
; 0003 01EF 	{
; 0003 01F0 		for(yc = 0; yc < FontHeight; yc++)
	LDI  R30,LOW(0)
	STD  Y+8,R30
_0x6007F:
	LDS  R30,_FontHeight
	LDD  R26,Y+8
	CP   R26,R30
	BRLO PC+3
	JMP _0x60080
; 0003 01F1 		{
; 0003 01F2 			if(maske > 7)
	CPI  R19,8
	BRLO _0x60081
; 0003 01F3 			{
; 0003 01F4 				maske = 0;
	LDI  R19,LOW(0)
; 0003 01F5 				bcounter+=1;
	__ADDWRN 20,21,1
; 0003 01F6 			}
; 0003 01F7 			byte = _pgm_read_byte(FontPointer[bytesbischar + bcounter + 1]);
_0x60081:
	CALL SUBOPT_0xBD
; 0003 01F8 
; 0003 01F9 			xPos = (unsigned short)xc*FontXScale + cursorX;
	CALL SUBOPT_0xBE
; 0003 01FA 
; 0003 01FB 			if(Horizontal)	//128x64
	BREQ _0x60082
; 0003 01FC 			{
; 0003 01FD 				if(Reverse)
	LDS  R30,_Reverse
	CPI  R30,0
	BREQ _0x60083
; 0003 01FE 					yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
	CALL SUBOPT_0xBF
	RJMP _0x6012B
; 0003 01FF 				else
_0x60083:
; 0003 0200 					yPos = (((unsigned short)yc)*FontYScale + cursorY);
	LDD  R26,Y+8
	CLR  R27
_0x6012B:
	LDS  R30,_FontYScale
	CALL SUBOPT_0xAE
	CALL SUBOPT_0xC0
; 0003 0201 			}
; 0003 0202 			else						//64x128
	RJMP _0x60085
_0x60082:
; 0003 0203 			{
; 0003 0204 				if(Reverse)
	LDS  R30,_Reverse
	CPI  R30,0
	BREQ _0x60086
; 0003 0205 					yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
	CALL SUBOPT_0xBF
	RJMP _0x6012C
; 0003 0206 				else
_0x60086:
; 0003 0207 					yPos = (((unsigned short)yc)*FontYScale + cursorY);
	LDD  R26,Y+8
	CLR  R27
_0x6012C:
	LDS  R30,_FontYScale
	CALL SUBOPT_0xAE
	CALL SUBOPT_0xC0
; 0003 0208 
; 0003 0209 			}	//Horizontal
_0x60085:
; 0003 020A 
; 0003 020B 			for(sx = 0; sx < FontXScale; sx++)
	LDI  R30,LOW(0)
	STD  Y+7,R30
_0x60089:
	LDS  R30,_FontXScale
	LDD  R26,Y+7
	CP   R26,R30
	BRLO PC+3
	JMP _0x6008A
; 0003 020C 			{
; 0003 020D 				for(sy = 0; sy < FontYScale; sy++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
_0x6008C:
	LDS  R30,_FontYScale
	LDD  R26,Y+6
	CP   R26,R30
	BRSH _0x6008D
; 0003 020E 				{
; 0003 020F 					if(bit_is_set(byte,maske))
	MOV  R30,R19
	LDI  R26,LOW(1)
	CALL __LSLB12
	AND  R30,R17
	BREQ _0x6008E
; 0003 0210 					{
; 0003 0211 						if(rot)		PutPixel(yPos+sy, xPos+sx, FgColor);
	LDS  R30,_rot
	CPI  R30,0
	BREQ _0x6008F
	CALL SUBOPT_0xC1
	CALL SUBOPT_0xC2
	RJMP _0x6012D
; 0003 0212 						else			PutPixel(xPos+sx, yPos+sy, FgColor);
_0x6008F:
	CALL SUBOPT_0xC3
	CALL SUBOPT_0xC4
_0x6012D:
	LDI  R31,0
	CALL SUBOPT_0xC5
	CALL SUBOPT_0x43
	CALL SUBOPT_0x9E
	CALL _TFTPutPixel
; 0003 0213 					}
; 0003 0214 					else
	RJMP _0x60091
_0x6008E:
; 0003 0215 					{
; 0003 0216 						if(NonTransparence)
	LDS  R30,_NonTransparence
	CPI  R30,0
	BREQ _0x60092
; 0003 0217 						{
; 0003 0218 							if(rot)		PutPixel(yPos+sy, xPos+sx, BkColor);
	LDS  R30,_rot
	CPI  R30,0
	BREQ _0x60093
	CALL SUBOPT_0xC1
	CALL SUBOPT_0xC2
	RJMP _0x6012E
; 0003 0219 							else			PutPixel(xPos+sx, yPos+sy, BkColor);
_0x60093:
	CALL SUBOPT_0xC3
	CALL SUBOPT_0xC4
_0x6012E:
	LDI  R31,0
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xC6
	CALL _TFTPutPixel
; 0003 021A 						}
; 0003 021B 					}
_0x60092:
_0x60091:
; 0003 021C 				}//for sy
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RJMP _0x6008C
_0x6008D:
; 0003 021D 			}//for sx
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	STD  Y+7,R30
	RJMP _0x60089
_0x6008A:
; 0003 021E 
; 0003 021F 			maske++;
	SUBI R19,-1
; 0003 0220 		}//for yc
	LDD  R30,Y+8
	SUBI R30,-LOW(1)
	STD  Y+8,R30
	RJMP _0x6007F
_0x60080:
; 0003 0221 	}//for xc
	LDD  R30,Y+9
	SUBI R30,-LOW(1)
	STD  Y+9,R30
	RJMP _0x6007C
_0x6007D:
; 0003 0222 }	//PutCharPE
	RJMP _0x20E001A
;
;void PutCharEN(unsigned char c)
; 0003 0225 {
_PutCharEN:
; 0003 0226 	unsigned char 			byte 					= 0;
; 0003 0227 	unsigned char 			bitoffset 		= 0;
; 0003 0228 	unsigned char 			maske 				= 0;
; 0003 0229 	unsigned short 			bcounter 			= 0;
; 0003 022A 	unsigned short 			bitsbischar 	= 0;
; 0003 022B 	unsigned short 			bytesbischar	= 0;
; 0003 022C 	unsigned short 			xPos,yPos;
; 0003 022D 
; 0003 022E 	unsigned char 			Ccounter 			= 0;
; 0003 022F 	unsigned char 			xc						= 0;
; 0003 0230 	unsigned char 			yc						= 0;
; 0003 0231 	unsigned char 			sx 						= 0;
; 0003 0232 	unsigned char 			sy 						= 0;
; 0003 0233 
; 0003 0234    // get current character width
; 0003 0235 	charwidth	= _pgm_read_byte(FontPointer[(unsigned int)(c)+FONT_HEADER_SIZE-firstchar]);
	ST   -Y,R26
	SBIW R28,12
	LDI  R24,12
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x60095*2)
	LDI  R31,HIGH(_0x60095*2)
	CALL __INITLOCB
	CALL SUBOPT_0xB4
;	c -> Y+18
;	byte -> R17
;	bitoffset -> R16
;	maske -> R19
;	bcounter -> R20,R21
;	bitsbischar -> Y+16
;	bytesbischar -> Y+14
;	xPos -> Y+12
;	yPos -> Y+10
;	Ccounter -> R18
;	xc -> Y+9
;	yc -> Y+8
;	sx -> Y+7
;	sy -> Y+6
; 0003 0236 
; 0003 0237 	// line feed, goto next line
; 0003 0238 	if(c == '\n')
	BRNE _0x60096
; 0003 0239 	{
; 0003 023A 		cursorX = 0;
	CALL SUBOPT_0xB0
; 0003 023B 		cursorY = cursorY + (unsigned int)FontHeight * FontYScale;
	CALL SUBOPT_0xAD
	CALL SUBOPT_0xB5
; 0003 023C 
; 0003 023D 		return;
	RJMP _0x20E001A
; 0003 023E 	}
; 0003 023F 
; 0003 0240 	// character out of range.
; 0003 0241   if( (c < firstchar) || (c > lastchar) || (fontSize == 0))
_0x60096:
	LDS  R30,_firstchar
	LDD  R26,Y+18
	CP   R26,R30
	BRLO _0x60098
	LDS  R30,_lastchar
	CP   R30,R26
	BRLO _0x60098
	CALL SUBOPT_0xA8
	SBIW R26,0
	BRNE _0x60097
_0x60098:
; 0003 0242   	return;
	RJMP _0x20E001A
; 0003 0243 
; 0003 0244 	// character is not in list.
; 0003 0245 	if (charwidth == 0)
_0x60097:
	LDS  R30,_charwidth
	CPI  R30,0
	BRNE _0x6009A
; 0003 0246 		return;
	RJMP _0x20E001A
; 0003 0247 
; 0003 0248 	// sara thai font. line remain at last position
; 0003 0249 	if(FontFixed)
_0x6009A:
	LDS  R30,_FontFixed
	CPI  R30,0
	BREQ _0x6009B
; 0003 024A 		charwidth = FontWidth;
	LDS  R30,_FontWidth
	STS  _charwidth,R30
; 0003 024B 	else
	RJMP _0x6009C
_0x6009B:
; 0003 024C 	{
; 0003 024D 		//english special fonts!
; 0003 024E 		if (((c >= 0xd4) && (c <= 0xda)) ||
; 0003 024F 	  	  ((c >= 0xe7) && (c <= 0xec)) ||
; 0003 0250 				 (c == 0xd1))
	LDD  R26,Y+18
	CPI  R26,LOW(0xD4)
	BRLO _0x6009E
	CPI  R26,LOW(0xDB)
	BRLO _0x600A0
_0x6009E:
	LDD  R26,Y+18
	CPI  R26,LOW(0xE7)
	BRLO _0x600A1
	CPI  R26,LOW(0xED)
	BRLO _0x600A0
_0x600A1:
	LDD  R26,Y+18
	CPI  R26,LOW(0xD1)
	BRNE _0x6009D
_0x600A0:
; 0003 0251 		{
; 0003 0252 			cursorX = cursorX - (unsigned int)charwidth * FontXScale;
	CALL SUBOPT_0xB7
	CALL SUBOPT_0xB8
	CALL SUBOPT_0xB9
; 0003 0253 		}
; 0003 0254 	}
_0x6009D:
_0x6009C:
; 0003 0255 
; 0003 0256 	// fixed width for digit
; 0003 0257  	if((c >= '0') && (c <= '9'))		// english : 0 to 9
	LDD  R26,Y+18
	CPI  R26,LOW(0x30)
	BRLO _0x600A5
	CPI  R26,LOW(0x3A)
	BRLO _0x600A6
_0x600A5:
	RJMP _0x600A4
_0x600A6:
; 0003 0258 		charwidth = _pgm_read_byte(FontPointer[(unsigned int)(FONT_HEADER_SIZE)+'0'-firstchar]);		//width reference = ZERO
	LDS  R26,_firstchar
	LDI  R30,LOW(55)
	SUB  R30,R26
	LDS  R26,_FontPointer
	LDS  R27,_FontPointer+1
	CALL SUBOPT_0xA9
	LPM  R0,Z
	STS  _charwidth,R0
; 0003 0259 
; 0003 025A 	// line adjust
; 0003 025B 	if(((int)cursorX + charwidth * FontXScale) > GetMaxX())
_0x600A4:
	CALL SUBOPT_0xB6
	ADD  R26,R30
	ADC  R27,R31
	CPI  R26,LOW(0xF0)
	LDI  R30,HIGH(0xF0)
	CPC  R27,R30
	BRLT _0x600A7
; 0003 025C 	{
; 0003 025D 		cursorY = cursorY + (unsigned int)FontHeight * FontYScale;
	CALL SUBOPT_0xAD
	CALL SUBOPT_0xB5
; 0003 025E 		cursorX = 0;
	CALL SUBOPT_0xB0
; 0003 025F 	}
; 0003 0260 
; 0003 0261 	// calculate current character position on the table
; 0003 0262 	for(Ccounter = 0; Ccounter < c-firstchar; Ccounter++)
_0x600A7:
	LDI  R18,LOW(0)
_0x600A9:
	LDS  R26,_firstchar
	LDD  R30,Y+18
	SUB  R30,R26
	CP   R18,R30
	BRSH _0x600AA
; 0003 0263 		bitsbischar += (_pgm_read_byte(FontPointer[(unsigned int)(Ccounter)+FONT_HEADER_SIZE]));	//c0_width +...+ cn_width
	CALL SUBOPT_0xBA
	STD  Y+16,R30
	STD  Y+16+1,R31
	SUBI R18,-1
	RJMP _0x600A9
_0x600AA:
; 0003 0266 bitsbischar 		*= FontHeight;
	CALL SUBOPT_0xBB
	CALL SUBOPT_0xBC
; 0003 0267 	bitsbischar 		+= (((unsigned short)(lastchar)-firstchar)+FONT_HEADER_SIZE)*8;		//plus font headers
; 0003 0268 	bytesbischar 		 = bitsbischar/8;																//
; 0003 0269 	bitoffset 			 = bitsbischar % 8;															//
; 0003 026A 	maske						 = bitoffset % 8;																//
; 0003 026B 
; 0003 026C 	// draw character
; 0003 026D 	for(xc = 0; xc < charwidth; xc++)
_0x600AC:
	LDS  R30,_charwidth
	LDD  R26,Y+9
	CP   R26,R30
	BRLO PC+3
	JMP _0x600AD
; 0003 026E 	{
; 0003 026F 		for(yc = 0; yc < FontHeight; yc++)
	LDI  R30,LOW(0)
	STD  Y+8,R30
_0x600AF:
	LDS  R30,_FontHeight
	LDD  R26,Y+8
	CP   R26,R30
	BRLO PC+3
	JMP _0x600B0
; 0003 0270 		{
; 0003 0271 			if(maske > 7)
	CPI  R19,8
	BRLO _0x600B1
; 0003 0272 			{
; 0003 0273 				maske = 0;
	LDI  R19,LOW(0)
; 0003 0274 				bcounter += 1;
	__ADDWRN 20,21,1
; 0003 0275 			}
; 0003 0276 			byte = _pgm_read_byte(FontPointer[bytesbischar + bcounter + 1]);
_0x600B1:
	CALL SUBOPT_0xBD
; 0003 0277 
; 0003 0278 			xPos = (unsigned short)xc*FontXScale + cursorX;
	CALL SUBOPT_0xBE
; 0003 0279 
; 0003 027A 			if(Horizontal)	//128x64
	BREQ _0x600B2
; 0003 027B 			{
; 0003 027C 				if(Reverse)
	LDS  R30,_Reverse
	CPI  R30,0
	BREQ _0x600B3
; 0003 027D 					yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
	CALL SUBOPT_0xBF
	RJMP _0x6012F
; 0003 027E 				else
_0x600B3:
; 0003 027F 					yPos = (((unsigned short)yc)*FontYScale + cursorY);
	LDD  R26,Y+8
	CLR  R27
_0x6012F:
	LDS  R30,_FontYScale
	CALL SUBOPT_0xAE
	CALL SUBOPT_0xC0
; 0003 0280 			}
; 0003 0281 			else						//64x128
	RJMP _0x600B5
_0x600B2:
; 0003 0282 			{
; 0003 0283 				if(Reverse)
	LDS  R30,_Reverse
	CPI  R30,0
	BREQ _0x600B6
; 0003 0284 					yPos = (((unsigned short)FontHeight-yc)*FontYScale + cursorY);
	CALL SUBOPT_0xBF
	RJMP _0x60130
; 0003 0285 				else
_0x600B6:
; 0003 0286 					yPos = (((unsigned short)yc)*FontYScale + cursorY);
	LDD  R26,Y+8
	CLR  R27
_0x60130:
	LDS  R30,_FontYScale
	CALL SUBOPT_0xAE
	CALL SUBOPT_0xC0
; 0003 0287 
; 0003 0288 			}	//Horizontal
_0x600B5:
; 0003 0289 
; 0003 028A 			for(sx = 0; sx < FontXScale; sx++)
	LDI  R30,LOW(0)
	STD  Y+7,R30
_0x600B9:
	LDS  R30,_FontXScale
	LDD  R26,Y+7
	CP   R26,R30
	BRLO PC+3
	JMP _0x600BA
; 0003 028B 			{
; 0003 028C 				for(sy = 0; sy < FontYScale; sy++)
	LDI  R30,LOW(0)
	STD  Y+6,R30
_0x600BC:
	LDS  R30,_FontYScale
	LDD  R26,Y+6
	CP   R26,R30
	BRSH _0x600BD
; 0003 028D 				{
; 0003 028E 					if(bit_is_set(byte, maske))
	MOV  R30,R19
	LDI  R26,LOW(1)
	CALL __LSLB12
	AND  R30,R17
	BREQ _0x600BE
; 0003 028F 					{
; 0003 0290 						if(rot)		PutPixel(yPos+sy, xPos+sx, FgColor);
	LDS  R30,_rot
	CPI  R30,0
	BREQ _0x600BF
	CALL SUBOPT_0xC1
	CALL SUBOPT_0xC2
	RJMP _0x60131
; 0003 0291 						else			PutPixel(xPos+sx, yPos+sy, FgColor);
_0x600BF:
	CALL SUBOPT_0xC3
	CALL SUBOPT_0xC4
_0x60131:
	LDI  R31,0
	CALL SUBOPT_0xC5
	CALL SUBOPT_0x43
	CALL SUBOPT_0x9E
	CALL _TFTPutPixel
; 0003 0292 					}
; 0003 0293 					else
	RJMP _0x600C1
_0x600BE:
; 0003 0294 					{
; 0003 0295 						if(NonTransparence)
	LDS  R30,_NonTransparence
	CPI  R30,0
	BREQ _0x600C2
; 0003 0296 						{
; 0003 0297 							if(rot)		PutPixel(yPos+sy, xPos+sx, BkColor);
	LDS  R30,_rot
	CPI  R30,0
	BREQ _0x600C3
	CALL SUBOPT_0xC1
	CALL SUBOPT_0xC2
	RJMP _0x60132
; 0003 0298 							else			PutPixel(xPos+sx, yPos+sy, BkColor);
_0x600C3:
	CALL SUBOPT_0xC3
	CALL SUBOPT_0xC4
_0x60132:
	LDI  R31,0
	CALL SUBOPT_0xC5
	CALL SUBOPT_0xC6
	CALL _TFTPutPixel
; 0003 0299 						}
; 0003 029A 					}
_0x600C2:
_0x600C1:
; 0003 029B 				};//for sy
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	RJMP _0x600BC
_0x600BD:
; 0003 029C 			};//for sx
	LDD  R30,Y+7
	SUBI R30,-LOW(1)
	STD  Y+7,R30
	RJMP _0x600B9
_0x600BA:
; 0003 029D 
; 0003 029E 			maske++;
	SUBI R19,-1
; 0003 029F 		};//for yc
	LDD  R30,Y+8
	SUBI R30,-LOW(1)
	STD  Y+8,R30
	RJMP _0x600AF
_0x600B0:
; 0003 02A0 	};//for xc
	LDD  R30,Y+9
	SUBI R30,-LOW(1)
	STD  Y+9,R30
	RJMP _0x600AC
_0x600AD:
; 0003 02A1 
; 0003 02A2 	// adjust cursor to next position - english
; 0003 02A3 	cursorX	+= (unsigned int)charwidth * FontXScale + FontSpace;
	CALL SUBOPT_0xB7
	MOVW R26,R30
	LDS  R30,_FontSpace
	CALL SUBOPT_0xA9
	CALL SUBOPT_0xB8
	ADD  R30,R26
	ADC  R31,R27
	CALL SUBOPT_0xAC
; 0003 02A4 }	//PutCharEN
_0x20E001A:
	CALL __LOADLOCR6
	ADIW R28,19
	RET
;
;unsigned int CalcTextWidthEN(char *str)
; 0003 02A7 {
; 0003 02A8 	unsigned int 		strSize = 0;
; 0003 02A9 	unsigned char 	c;
; 0003 02AA 
; 0003 02AB 	while((c = *str++))
;	*str -> Y+4
;	strSize -> R16,R17
;	c -> R19
; 0003 02AC 	{
; 0003 02AD 		if(c == '\n')			continue;
; 0003 02AE 
; 0003 02AF 		if(FontFixed)
; 0003 02B0 			strSize += FontWidth * FontXScale;
; 0003 02B1 		else
; 0003 02B2 		{
; 0003 02B3 		  if((c < firstchar) || (c > lastchar))
; 0003 02B4 				charwidth = FontWidth;
; 0003 02B5 			else
; 0003 02B6 			{
; 0003 02B7 				charwidth = _pgm_read_byte(FontPointer[(unsigned int)(c)+FONT_HEADER_SIZE-firstchar]);
; 0003 02B8 
; 0003 02B9 				//english spesial fonts!
; 0003 02BA 				if (((c >= 0xd4) && (c <= 0xda)) ||
; 0003 02BB 		    		((c >= 0xe7) && (c <= 0xec)) ||
; 0003 02BC 				  	 (c == 0xd1))
; 0003 02BD 
; 0003 02BE 					charwidth = 0;
; 0003 02BF 			}
; 0003 02C0 
; 0003 02C1 			strSize += charwidth * FontXScale;
; 0003 02C2 		}
; 0003 02C3 
; 0003 02C4 		strSize += FontSpace;
; 0003 02C5 	}//while
; 0003 02C6 
; 0003 02C7 	return strSize ;
; 0003 02C8 }	//CalcTextWidthEN
;
;unsigned int CalcTextWidthPE(char *str)
; 0003 02CB {
; 0003 02CC 	unsigned char 	curnLet,	dumyLet;
; 0003 02CD 	unsigned char 	Pstat, stat, Nstat;
; 0003 02CE 
; 0003 02CF 	unsigned char		backFontSpace = FontSpace;
; 0003 02D0 	unsigned int 		strSize = 0;
; 0003 02D1 
; 0003 02D2  	while((curnLet = *str++))
;	*str -> Y+8
;	curnLet -> R17
;	dumyLet -> R16
;	Pstat -> R19
;	stat -> R18
;	Nstat -> R21
;	backFontSpace -> R20
;	strSize -> Y+6
; 0003 02D3 	{
; 0003 02D4 		if(curnLet == '\n')			continue;
; 0003 02D5 
; 0003 02D6 		if(FontFixed)
; 0003 02D7 			strSize += FontWidth * FontXScale;
; 0003 02D8 		else
; 0003 02D9 		{
; 0003 02DA 		 	if((curnLet < firstchar) || (curnLet > lastchar))
; 0003 02DB 				charwidth = FontWidth;
; 0003 02DC 			else
; 0003 02DD 			{
; 0003 02DE 		 		switch(curnLet)
; 0003 02DF 		 		{
; 0003 02E0 		 			case 0x81:				//peh
; 0003 02E1 		    		curnLet = 0xEA;
; 0003 02E2 		 				break;
; 0003 02E3 		 			case 0x8D:				//cheh
; 0003 02E4 		    		curnLet = 0xEB;
; 0003 02E5 		 				break;
; 0003 02E6 		 			case 0x8E:				//zheh
; 0003 02E7 		    		curnLet = 0xEE;
; 0003 02E8 		 				break;
; 0003 02E9 		 			case 0x90:				//geh
; 0003 02EA 		    		curnLet = 0xEF;
; 0003 02EB 		 				break;
; 0003 02EC 		 			case 0xE1:				//laa
; 0003 02ED 		    		nextLet = *str++;
; 0003 02EE 
; 0003 02EF 		    		if(nextLet == 0xC7)
; 0003 02F0 		    			curnLet = 0xFB;
; 0003 02F1 		    		else
; 0003 02F2 		    		{
; 0003 02F3 		    			dumyLet = *str--;
; 0003 02F4 		    			curnLet = 0xE1;
; 0003 02F5 		    		}
; 0003 02F6 		 				break;
; 0003 02F7 		 			case 0x30:				//persian digits 0...9
; 0003 02F8 					case 0x31:
; 0003 02F9 					case 0x32:
; 0003 02FA 					case 0x33:
; 0003 02FB 					case 0x34:
; 0003 02FC 					case 0x35:
; 0003 02FD 					case 0x36:
; 0003 02FE 					case 0x37:
; 0003 02FF 					case 0x38:
; 0003 0300 					case 0x39:
; 0003 0301 						curnLet -= 0x20;
; 0003 0302 		 				break;
; 0003 0303 		 			case 0x3F:				//persian question mark
; 0003 0304 		    		curnLet = 0xBF;
; 0003 0305 		 				break;
; 0003 0306 		 			case 0x3B:				//persian semicolon
; 0003 0307 		    		curnLet = 0x1F;
; 0003 0308 		 				break;
; 0003 0309 		 			case 0x2C:				//persian comma
; 0003 030A 		    		curnLet = 0x1D;
; 0003 030B 		 				break;
; 0003 030C 		 			case 0x2E:				//persian point
; 0003 030D 		    		curnLet = 0x1C;
; 0003 030E 		 				break;
; 0003 030F 				}//switch curnLet
; 0003 0310 
; 0003 0311 				//--------------------------------
; 0003 0312 		  	nextLet = *str++;
; 0003 0313 		  	dumyLet	= *str--;
; 0003 0314 
; 0003 0315 		 		switch(nextLet)
; 0003 0316 		 		{
; 0003 0317 		 			case 0x81:				//peh
; 0003 0318 		    		nextLet = 0xEA;
; 0003 0319 		 				break;
; 0003 031A 		 			case 0x8D:				//cheh
; 0003 031B 		    		nextLet = 0xEB;
; 0003 031C 		 				break;
; 0003 031D 		 			case 0x8E:				//zheh
; 0003 031E 		    		nextLet = 0xEE;
; 0003 031F 		 				break;
; 0003 0320 		 			case 0x90:				//geh
; 0003 0321 		    		nextLet = 0xEF;
; 0003 0322 		 				break;
; 0003 0323 		 			case 0x30:				//0...9
; 0003 0324 					case 0x31:
; 0003 0325 					case 0x32:
; 0003 0326 					case 0x33:
; 0003 0327 					case 0x34:
; 0003 0328 					case 0x35:
; 0003 0329 					case 0x36:
; 0003 032A 					case 0x37:
; 0003 032B 					case 0x38:
; 0003 032C 					case 0x39:
; 0003 032D 						nextLet -= 0x20;
; 0003 032E 		 				break;
; 0003 032F 		 			case 0x3F:				//persian question mark
; 0003 0330 		    		nextLet = 0xBF;
; 0003 0331 		 				break;
; 0003 0332 		 			case 0x3B:				//persian semicolon
; 0003 0333 		    		nextLet = 0x1F;
; 0003 0334 		 				break;
; 0003 0335 		 			case 0x2C:				//persian comma
; 0003 0336 		    		nextLet = 0x1D;
; 0003 0337 		 				break;
; 0003 0338 		 			case 0x2E:				//persian point
; 0003 0339 		    		nextLet = 0x1C;
; 0003 033A 		 				break;
; 0003 033B 				}//switch nextLet
; 0003 033C 
; 0003 033D 				if(curnLet > 0xC0)
; 0003 033E 				{
; 0003 033F 					if(prevLet > 0xC0)
; 0003 0340 						Pstat = (_pgm_read_byte((PEmap[prevLet-0xC1][5])));
; 0003 0341 					else
; 0003 0342 						Pstat = 0;
; 0003 0343 
; 0003 0344 					if(nextLet > 0xC0)
; 0003 0345 						Nstat = (_pgm_read_byte((PEmap[nextLet-0xC1][4])));
; 0003 0346 					else
; 0003 0347 						Nstat = 0;
; 0003 0348 
; 0003 0349 					stat = (Pstat<<1) | Nstat;
; 0003 034A 
; 0003 034B 					if(stat>1)	FontSpace = 0;
; 0003 034C 					else 				FontSpace = backFontSpace;
; 0003 034D 					////////////////
; 0003 034E 					dumyLet = _pgm_read_byte((PEmap[curnLet-0xC1][stat]));
; 0003 034F 
; 0003 0350 					charwidth = _pgm_read_byte(FontPointer[(unsigned int)(dumyLet)+FONT_HEADER_SIZE-firstchar]);
; 0003 0351 					strSize += charwidth * FontXScale;
; 0003 0352 					strSize += FontSpace;
; 0003 0353 					////////////////
; 0003 0354 					FontSpace = backFontSpace;
; 0003 0355 				}
; 0003 0356 				else
; 0003 0357 				{
; 0003 0358 					charwidth = _pgm_read_byte(FontPointer[(unsigned int)(curnLet)+FONT_HEADER_SIZE-firstchar]);
; 0003 0359 					strSize += charwidth * FontXScale;
; 0003 035A 					strSize += FontSpace;
; 0003 035B 				}
; 0003 035C 
; 0003 035D 				prevLet = curnLet;
; 0003 035E 			}
; 0003 035F 		}
; 0003 0360 	}//while
; 0003 0361 
; 0003 0362  	prevLet = 0xFF;
; 0003 0363 	return strSize ;
; 0003 0364 }	//CalcTextWidthPE
;
;#if KeilARM
;	size_t StrNlen (_const char* s, size_t maxlen)
;	{
;		size_t len = 0;
;
;	  while ((len <= maxlen) && (*s))
;	  {
;	  	s++;
;	    len++;
;	  }
;
;	  return len;
;	} //StrNlen
;#endif

	.CSEG
_itoa:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
_wait_ready_G101:
	ST   -Y,R17
	LDI  R30,LOW(50)
	STS  _timer2_G101,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020004:
	SBIS 0xE,7
	RJMP _0x2020004
_0x2020008:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202000A:
	SBIS 0xE,7
	RJMP _0x202000A
	IN   R17,15
	CPI  R17,255
	BREQ _0x202000D
	LDS  R30,_timer2_G101
	CPI  R30,0
	BRNE _0x202000E
_0x202000D:
	RJMP _0x2020009
_0x202000E:
	RJMP _0x2020008
_0x2020009:
	MOV  R30,R17
	LD   R17,Y+
	RET
_release_spi_G101:
	SBI  0x18,4
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202000F:
	SBIS 0xE,7
	RJMP _0x202000F
	RET
_rx_datablock_G101:
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
	LDI  R30,LOW(10)
	STS  _timer1_G101,R30
_0x2020013:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020015:
	SBIS 0xE,7
	RJMP _0x2020015
	IN   R17,15
	CPI  R17,255
	BRNE _0x2020018
	LDS  R30,_timer1_G101
	CPI  R30,0
	BRNE _0x2020019
_0x2020018:
	RJMP _0x2020014
_0x2020019:
	RJMP _0x2020013
_0x2020014:
	CPI  R17,254
	BREQ _0x202001A
	LDI  R30,LOW(0)
	CALL __LOADLOCR4
	RJMP _0x20E0014
_0x202001A:
	__GETWRS 18,19,6
_0x202001C:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202001E:
	SBIS 0xE,7
	RJMP _0x202001E
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020021:
	SBIS 0xE,7
	RJMP _0x2020021
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020024:
	SBIS 0xE,7
	RJMP _0x2020024
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020027:
	SBIS 0xE,7
	RJMP _0x2020027
	PUSH R19
	PUSH R18
	__ADDWRN 18,19,1
	IN   R30,0xF
	POP  R26
	POP  R27
	ST   X,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SBIW R30,4
	STD  Y+4,R30
	STD  Y+4+1,R31
	BRNE _0x202001C
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202002A:
	SBIS 0xE,7
	RJMP _0x202002A
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202002D:
	SBIS 0xE,7
	RJMP _0x202002D
	LDI  R30,LOW(1)
	CALL __LOADLOCR4
	RJMP _0x20E0014
_tx_datablock_G101:
	ST   -Y,R26
	CALL __SAVELOCR4
	RCALL _wait_ready_G101
	CPI  R30,LOW(0xFF)
	BREQ _0x2020030
	LDI  R30,LOW(0)
	CALL __LOADLOCR4
	RJMP _0x20E0015
_0x2020030:
	LDD  R30,Y+4
	OUT  0xF,R30
_0x2020031:
	SBIS 0xE,7
	RJMP _0x2020031
	LDD  R26,Y+4
	CPI  R26,LOW(0xFD)
	BREQ _0x2020034
	LDI  R16,LOW(0)
	__GETWRS 18,19,5
_0x2020036:
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	OUT  0xF,R30
_0x2020038:
	SBIS 0xE,7
	RJMP _0x2020038
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	OUT  0xF,R30
_0x202003B:
	SBIS 0xE,7
	RJMP _0x202003B
	SUBI R16,LOW(1)
	CPI  R16,0
	BRNE _0x2020036
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202003E:
	SBIS 0xE,7
	RJMP _0x202003E
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020041:
	SBIS 0xE,7
	RJMP _0x2020041
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020044:
	SBIS 0xE,7
	RJMP _0x2020044
	IN   R17,15
	MOV  R30,R17
	ANDI R30,LOW(0x1F)
	CPI  R30,LOW(0x5)
	BREQ _0x2020047
	LDI  R30,LOW(0)
	CALL __LOADLOCR4
	RJMP _0x20E0015
_0x2020047:
_0x2020034:
	LDI  R30,LOW(1)
	CALL __LOADLOCR4
	RJMP _0x20E0015
_send_cmd_G101:
	CALL __PUTPARD2
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+6
	ANDI R30,LOW(0x80)
	BREQ _0x2020048
	LDD  R30,Y+6
	ANDI R30,0x7F
	STD  Y+6,R30
	LDI  R30,LOW(119)
	ST   -Y,R30
	__GETD2N 0x0
	RCALL _send_cmd_G101
	MOV  R16,R30
	CPI  R16,2
	BRLO _0x2020049
	MOV  R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20E0015
_0x2020049:
_0x2020048:
	SBI  0x18,4
	CBI  0x18,4
	RCALL _wait_ready_G101
	CPI  R30,LOW(0xFF)
	BREQ _0x202004A
	LDI  R30,LOW(255)
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20E0015
_0x202004A:
	LDD  R30,Y+6
	OUT  0xF,R30
_0x202004B:
	SBIS 0xE,7
	RJMP _0x202004B
	LDD  R30,Y+5
	OUT  0xF,R30
_0x202004E:
	SBIS 0xE,7
	RJMP _0x202004E
	LDD  R30,Y+4
	OUT  0xF,R30
_0x2020051:
	SBIS 0xE,7
	RJMP _0x2020051
	LDD  R30,Y+3
	OUT  0xF,R30
_0x2020054:
	SBIS 0xE,7
	RJMP _0x2020054
	LDD  R30,Y+2
	OUT  0xF,R30
_0x2020057:
	SBIS 0xE,7
	RJMP _0x2020057
	LDI  R17,LOW(1)
	LDD  R26,Y+6
	CPI  R26,LOW(0x40)
	BRNE _0x202005A
	LDI  R17,LOW(149)
	RJMP _0x202005B
_0x202005A:
	LDD  R26,Y+6
	CPI  R26,LOW(0x48)
	BRNE _0x202005C
	LDI  R17,LOW(135)
_0x202005C:
_0x202005B:
	OUT  0xF,R17
_0x202005D:
	SBIS 0xE,7
	RJMP _0x202005D
	LDD  R26,Y+6
	CPI  R26,LOW(0x4C)
	BRNE _0x2020060
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020061:
	SBIS 0xE,7
	RJMP _0x2020061
_0x2020060:
	LDI  R17,LOW(255)
_0x2020065:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x2020067:
	SBIS 0xE,7
	RJMP _0x2020067
	IN   R16,15
	SBRS R16,7
	RJMP _0x202006A
	SUBI R17,LOW(1)
	CPI  R17,0
	BRNE _0x202006B
_0x202006A:
	RJMP _0x2020066
_0x202006B:
	RJMP _0x2020065
_0x2020066:
	MOV  R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20E0015
_rx_spi4_G101:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	LDI  R17,4
_0x202006D:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202006F:
	SBIS 0xE,7
	RJMP _0x202006F
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	ADIW R26,1
	STD  Y+1,R26
	STD  Y+1+1,R27
	SBIW R26,1
	IN   R30,0xF
	ST   X,R30
	SUBI R17,LOW(1)
	CPI  R17,0
	BRNE _0x202006D
_0x20E0019:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_disk_initialize:
	ST   -Y,R26
	SBIW R28,4
	CALL __SAVELOCR4
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x2020072
	LDI  R30,LOW(1)
	RJMP _0x20E0018
_0x2020072:
	CBI  0x17,2
	CBI  0x17,3
	LDI  R30,LOW(10)
	STS  _timer1_G101,R30
_0x2020073:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BRNE _0x2020073
	LDS  R30,_status_G101
	ANDI R30,LOW(0x2)
	BREQ _0x2020076
	RJMP _0x20E0017
_0x2020076:
	SBI  0x17,4
	SBI  0x18,4
	IN   R30,0x18
	ANDI R30,LOW(0x5F)
	OUT  0x18,R30
	SBI  0x18,6
	CBI  0x17,6
	IN   R30,0x17
	ORI  R30,LOW(0xB0)
	OUT  0x17,R30
	LDI  R30,LOW(83)
	OUT  0xD,R30
	LDI  R30,LOW(0)
	OUT  0xE,R30
	LDI  R19,LOW(255)
_0x2020078:
	LDI  R17,LOW(10)
_0x202007B:
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x202007D:
	SBIS 0xE,7
	RJMP _0x202007D
	SUBI R17,LOW(1)
	CPI  R17,0
	BRNE _0x202007B
	LDI  R30,LOW(64)
	ST   -Y,R30
	__GETD2N 0x0
	RCALL _send_cmd_G101
	MOV  R16,R30
	SUBI R19,LOW(1)
	CPI  R16,1
	BREQ _0x2020080
	CPI  R19,0
	BRNE _0x2020081
_0x2020080:
	RJMP _0x2020079
_0x2020081:
	RJMP _0x2020078
_0x2020079:
	LDI  R19,LOW(0)
	CPI  R16,1
	BREQ PC+3
	JMP _0x2020082
	LDI  R30,LOW(100)
	STS  _timer1_G101,R30
	LDI  R30,LOW(72)
	ST   -Y,R30
	__GETD2N 0x1AA
	RCALL _send_cmd_G101
	CPI  R30,LOW(0x1)
	BRNE _0x2020083
	MOVW R26,R28
	ADIW R26,4
	RCALL _rx_spi4_G101
	LDD  R26,Y+6
	CPI  R26,LOW(0x1)
	BRNE _0x2020085
	LDD  R26,Y+7
	CPI  R26,LOW(0xAA)
	BREQ _0x2020086
_0x2020085:
	RJMP _0x2020084
_0x2020086:
_0x2020087:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x202008A
	LDI  R30,LOW(233)
	ST   -Y,R30
	__GETD2N 0x40000000
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x202008B
_0x202008A:
	RJMP _0x2020089
_0x202008B:
	RJMP _0x2020087
_0x2020089:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x202008D
	LDI  R30,LOW(122)
	ST   -Y,R30
	__GETD2N 0x0
	RCALL _send_cmd_G101
	CPI  R30,0
	BREQ _0x202008E
_0x202008D:
	RJMP _0x202008C
_0x202008E:
	MOVW R26,R28
	ADIW R26,4
	RCALL _rx_spi4_G101
	LDD  R30,Y+4
	ANDI R30,LOW(0x40)
	BREQ _0x202008F
	LDI  R30,LOW(12)
	RJMP _0x2020090
_0x202008F:
	LDI  R30,LOW(4)
_0x2020090:
	MOV  R19,R30
_0x202008C:
_0x2020084:
	RJMP _0x2020092
_0x2020083:
	LDI  R30,LOW(233)
	ST   -Y,R30
	__GETD2N 0x0
	RCALL _send_cmd_G101
	CPI  R30,LOW(0x2)
	BRSH _0x2020093
	LDI  R19,LOW(2)
	LDI  R16,LOW(233)
	RJMP _0x2020094
_0x2020093:
	LDI  R19,LOW(1)
	LDI  R16,LOW(65)
_0x2020094:
_0x2020095:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x2020098
	ST   -Y,R16
	__GETD2N 0x0
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x2020099
_0x2020098:
	RJMP _0x2020097
_0x2020099:
	RJMP _0x2020095
_0x2020097:
	LDS  R30,_timer1_G101
	CPI  R30,0
	BREQ _0x202009B
	LDI  R30,LOW(80)
	ST   -Y,R30
	__GETD2N 0x200
	RCALL _send_cmd_G101
	CPI  R30,0
	BREQ _0x202009A
_0x202009B:
	LDI  R19,LOW(0)
_0x202009A:
_0x2020092:
_0x2020082:
	STS  _card_type_G101,R19
	RCALL _release_spi_G101
	CPI  R19,0
	BREQ _0x202009D
	LDS  R30,_status_G101
	ANDI R30,0xFE
	STS  _status_G101,R30
	LDI  R30,LOW(80)
	OUT  0xD,R30
	LDI  R30,LOW(1)
	OUT  0xE,R30
	RJMP _0x202009E
_0x202009D:
	CBI  0x18,4
	RCALL _wait_ready_G101
	RCALL _release_spi_G101
	LDI  R30,LOW(0)
	OUT  0xD,R30
	IN   R30,0x17
	ANDI R30,LOW(0xF)
	OUT  0x17,R30
	IN   R30,0x18
	ANDI R30,LOW(0xF)
	OUT  0x18,R30
	CBI  0x17,4
	LDS  R30,_status_G101
	ORI  R30,1
	STS  _status_G101,R30
_0x202009E:
_0x20E0017:
	LDS  R30,_status_G101
_0x20E0018:
	CALL __LOADLOCR4
	ADIW R28,9
	RET
_disk_status:
	ST   -Y,R26
	LD   R30,Y
	CPI  R30,0
	BREQ _0x202009F
	LDI  R30,LOW(1)
	RJMP _0x20E0016
_0x202009F:
	LDS  R30,_status_G101
_0x20E0016:
	ADIW R28,1
	RET
_disk_read:
	ST   -Y,R26
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x20200A1
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20200A0
_0x20200A1:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x20E0014
_0x20200A0:
	LDS  R30,_status_G101
	ANDI R30,LOW(0x1)
	BREQ _0x20200A3
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x20E0014
_0x20200A3:
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x8)
	BRNE _0x20200A4
	__GETD1S 1
	__GETD2N 0x200
	CALL __MULD12U
	__PUTD1S 1
_0x20200A4:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x20200A5
	LDI  R30,LOW(81)
	ST   -Y,R30
	__GETD2S 2
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200A7
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(512)
	LDI  R27,HIGH(512)
	RCALL _rx_datablock_G101
	CPI  R30,0
	BRNE _0x20200A8
_0x20200A7:
	RJMP _0x20200A6
_0x20200A8:
	LDI  R30,LOW(0)
	ST   Y,R30
_0x20200A6:
	RJMP _0x20200A9
_0x20200A5:
	LDI  R30,LOW(82)
	ST   -Y,R30
	__GETD2S 2
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200AA
_0x20200AC:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(512)
	LDI  R27,HIGH(512)
	RCALL _rx_datablock_G101
	CPI  R30,0
	BREQ _0x20200AD
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SUBI R30,LOW(-512)
	SBCI R31,HIGH(-512)
	STD  Y+5,R30
	STD  Y+5+1,R31
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
	BRNE _0x20200AC
_0x20200AD:
	LDI  R30,LOW(76)
	ST   -Y,R30
	__GETD2N 0x0
	RCALL _send_cmd_G101
_0x20200AA:
_0x20200A9:
	RCALL _release_spi_G101
	LD   R30,Y
	CPI  R30,0
	BREQ _0x20200AF
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20200B0
_0x20200AF:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20200B0:
	RJMP _0x20E0014
_disk_write:
	ST   -Y,R26
	LDD  R30,Y+7
	CPI  R30,0
	BRNE _0x20200B3
	LD   R30,Y
	CPI  R30,0
	BRNE _0x20200B2
_0x20200B3:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x20E0014
_0x20200B2:
	LDS  R30,_status_G101
	ANDI R30,LOW(0x1)
	BREQ _0x20200B5
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x20E0014
_0x20200B5:
	LDS  R30,_status_G101
	ANDI R30,LOW(0x4)
	BREQ _0x20200B6
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0014
_0x20200B6:
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x8)
	BRNE _0x20200B7
	__GETD1S 1
	__GETD2N 0x200
	CALL __MULD12U
	__PUTD1S 1
_0x20200B7:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x20200B8
	LDI  R30,LOW(88)
	ST   -Y,R30
	__GETD2S 2
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200BA
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(254)
	RCALL _tx_datablock_G101
	CPI  R30,0
	BRNE _0x20200BB
_0x20200BA:
	RJMP _0x20200B9
_0x20200BB:
	LDI  R30,LOW(0)
	ST   Y,R30
_0x20200B9:
	RJMP _0x20200BC
_0x20200B8:
	LDS  R30,_card_type_G101
	ANDI R30,LOW(0x6)
	BREQ _0x20200BD
	LDI  R30,LOW(215)
	ST   -Y,R30
	LDD  R26,Y+1
	CLR  R27
	CLR  R24
	CLR  R25
	RCALL _send_cmd_G101
_0x20200BD:
	LDI  R30,LOW(89)
	ST   -Y,R30
	__GETD2S 2
	RCALL _send_cmd_G101
	CPI  R30,0
	BRNE _0x20200BE
_0x20200C0:
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(252)
	RCALL _tx_datablock_G101
	CPI  R30,0
	BREQ _0x20200C1
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	SUBI R30,LOW(-512)
	SBCI R31,HIGH(-512)
	STD  Y+5,R30
	STD  Y+5+1,R31
	LD   R30,Y
	SUBI R30,LOW(1)
	ST   Y,R30
	BRNE _0x20200C0
_0x20200C1:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(253)
	RCALL _tx_datablock_G101
	CPI  R30,0
	BRNE _0x20200C3
	LDI  R30,LOW(1)
	ST   Y,R30
_0x20200C3:
_0x20200BE:
_0x20200BC:
	RCALL _release_spi_G101
	LD   R30,Y
	CPI  R30,0
	BREQ _0x20200C4
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20200C5
_0x20200C4:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20200C5:
	RJMP _0x20E0014
_disk_timerproc:
	ST   -Y,R17
	ST   -Y,R16
	LDS  R17,_timer1_G101
	CPI  R17,0
	BREQ _0x20200FA
	SUBI R17,LOW(1)
	STS  _timer1_G101,R17
_0x20200FA:
	LDS  R17,_timer2_G101
	CPI  R17,0
	BREQ _0x20200FB
	SUBI R17,LOW(1)
	STS  _timer2_G101,R17
_0x20200FB:
	LDS  R17,_pv_S101000B000
	IN   R30,0x16
	ANDI R30,LOW(0x8)
	MOV  R26,R30
	IN   R30,0x16
	ANDI R30,LOW(0x4)
	OR   R30,R26
	STS  _pv_S101000B000,R30
	CP   R30,R17
	BRNE _0x20200FC
	LDS  R16,_status_G101
	ANDI R30,LOW(0x8)
	BREQ _0x20200FD
	ORI  R16,LOW(4)
	RJMP _0x20200FE
_0x20200FD:
	ANDI R16,LOW(251)
_0x20200FE:
	LDS  R30,_pv_S101000B000
	ANDI R30,LOW(0x4)
	BREQ _0x20200FF
	ORI  R16,LOW(3)
	RJMP _0x2020100
_0x20200FF:
	ANDI R16,LOW(253)
_0x2020100:
	STS  _status_G101,R16
_0x20200FC:
	LD   R16,Y+
	LD   R17,Y+
	RET

	.CSEG
_get_fattime:
	SBIW R28,7
	LDS  R26,_prtc_get_time
	LDS  R27,_prtc_get_time+1
	SBIW R26,0
	BREQ _0x2040004
	LDS  R26,_prtc_get_date
	LDS  R27,_prtc_get_date+1
	SBIW R26,0
	BRNE _0x2040003
_0x2040004:
	__GETD1N 0x3A210000
	RJMP _0x20E0015
_0x2040003:
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,7
	CALL SUBOPT_0xC7
	__CALL1MN _prtc_get_time,0
	MOVW R30,R28
	ADIW R30,3
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,4
	__CALL1MN _prtc_get_date,0
	LD   R30,Y
	LDD  R31,Y+1
	SUBI R30,LOW(1980)
	SBCI R31,HIGH(1980)
	CLR  R22
	CLR  R23
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(25)
	CALL __LSLD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+2
	CALL SUBOPT_0xC8
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(21)
	CALL __LSLD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ORD12
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+3
	CALL SUBOPT_0xC8
	CALL __LSLD16
	CALL __ORD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+6
	CALL SUBOPT_0xC8
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(11)
	CALL __LSLD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ORD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R30,Y+5
	CALL SUBOPT_0xC8
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(5)
	CALL __LSLD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ORD12
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+4
	LDI  R31,0
	ASR  R31
	ROR  R30
	CALL __CWD1
	CALL __ORD12
_0x20E0015:
	ADIW R28,7
	RET
_mem_cpy_G102:
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR4
	__GETWRS 16,17,8
	__GETWRS 18,19,6
_0x2040006:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SBIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	ADIW R30,1
	BREQ _0x2040008
	PUSH R17
	PUSH R16
	__ADDWRN 16,17,1
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R30,X
	POP  R26
	POP  R27
	ST   X,R30
	RJMP _0x2040006
_0x2040008:
	CALL __LOADLOCR4
	ADIW R28,10
	RET
_mem_set_G102:
	CALL SUBOPT_0xC9
	__GETWRS 16,17,6
_0x204000C:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	ADIW R30,1
	BREQ _0x204000E
	PUSH R17
	PUSH R16
	__ADDWRN 16,17,1
	LDD  R30,Y+4
	POP  R26
	POP  R27
	ST   X,R30
	RJMP _0x204000C
_0x204000E:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20E0014:
	ADIW R28,8
	RET
_mem_cmp_G102:
	CALL SUBOPT_0xCA
	__GETWRS 16,17,10
	__GETWRS 18,19,8
	__GETWRN 20,21,0
_0x204000F:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	ADIW R30,1
	BREQ _0x2040012
	MOVW R26,R16
	__ADDWRN 16,17,1
	LD   R0,X
	CLR  R1
	MOVW R26,R18
	__ADDWRN 18,19,1
	LD   R26,X
	CLR  R27
	MOVW R30,R0
	SUB  R30,R26
	SBC  R31,R27
	MOVW R20,R30
	SBIW R30,0
	BREQ _0x2040013
_0x2040012:
	RJMP _0x2040011
_0x2040013:
	RJMP _0x204000F
_0x2040011:
	MOVW R30,R20
	CALL __LOADLOCR6
	RJMP _0x20E0012
_chk_chrf_G102:
	ST   -Y,R27
	ST   -Y,R26
_0x2040014:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LPM  R30,Z
	CPI  R30,0
	BREQ _0x2040017
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LPM  R26,Z
	LD   R30,Y
	LDD  R31,Y+1
	LDI  R27,0
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x2040018
_0x2040017:
	RJMP _0x2040016
_0x2040018:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADIW R30,1
	STD  Y+2,R30
	STD  Y+2+1,R31
	RJMP _0x2040014
_0x2040016:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LPM  R30,Z
	LDI  R31,0
	ADIW R28,4
	RET
_move_window_G102:
	CALL __PUTPARD2
	SBIW R28,4
	ST   -Y,R17
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,46
	CALL __GETD1P
	__PUTD1S 1
	CALL SUBOPT_0xCB
	CALL SUBOPT_0xCC
	CALL __CPD12
	BRNE PC+3
	JMP _0x2040019
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	LDD  R30,Z+4
	CPI  R30,0
	BREQ _0x204001A
	CALL SUBOPT_0xCD
	SBIW R30,0
	BREQ _0x204001B
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	LDD  R17,Y+0
	ADIW R28,11
	RET
_0x204001B:
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,4
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL SUBOPT_0xCE
	MOVW R0,R26
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,26
	CALL __GETD1P
	MOVW R26,R0
	CALL __ADDD12
	CALL SUBOPT_0xCC
	CALL __CPD21
	BRSH _0x204001C
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	LDD  R17,Z+3
_0x204001E:
	CPI  R17,2
	BRLO _0x204001F
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,26
	CALL __GETD1P
	CALL SUBOPT_0xCC
	CALL __ADDD12
	__PUTD1S 1
	CALL SUBOPT_0xCD
	SUBI R17,1
	RJMP _0x204001E
_0x204001F:
_0x204001C:
_0x204001A:
	CALL SUBOPT_0xCB
	CALL __CPD10
	BREQ _0x2040020
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,50
	CALL SUBOPT_0xCF
	CALL SUBOPT_0xD0
	BREQ _0x2040021
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	LDD  R17,Y+0
	RJMP _0x20E0010
_0x2040021:
	CALL SUBOPT_0xCB
	__PUTD1SNS 9,46
_0x2040020:
_0x2040019:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	LDD  R17,Y+0
	RJMP _0x20E0010
_get_fat:
	CALL __PUTPARD2
	SBIW R28,4
	CALL __SAVELOCR4
	CALL SUBOPT_0xD1
	CALL SUBOPT_0xD2
	BRLO _0x2040028
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,30
	CALL __GETD1P
	CALL SUBOPT_0xD1
	CALL __CPD21
	BRLO _0x2040027
_0x2040028:
	CALL SUBOPT_0xD3
	RJMP _0x20E0013
_0x2040027:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,34
	CALL SUBOPT_0xD4
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL SUBOPT_0xD5
	BRNE _0x204002D
	__GETWRS 18,19,8
	MOVW R30,R18
	LSR  R31
	ROR  R30
	__ADDWRR 18,19,30,31
	CALL SUBOPT_0xD6
	BREQ _0x204002E
	RJMP _0x204002C
_0x204002E:
	CALL SUBOPT_0xD7
	LD   R16,X
	CLR  R17
	__ADDWRN 18,19,1
	CALL SUBOPT_0xD6
	BRNE _0x204002C
	CALL SUBOPT_0xD7
	LD   R30,X
	MOV  R31,R30
	LDI  R30,0
	__ORWRR 16,17,30,31
	LDD  R30,Y+8
	ANDI R30,LOW(0x1)
	BREQ _0x2040030
	MOVW R30,R16
	CALL __LSRW4
	RJMP _0x204022B
_0x2040030:
	MOVW R30,R16
	ANDI R31,HIGH(0xFFF)
_0x204022B:
	CLR  R22
	CLR  R23
	RJMP _0x20E0013
_0x204002D:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2040033
	CALL SUBOPT_0xD8
	CALL SUBOPT_0xD9
	CALL SUBOPT_0xDA
	BRNE _0x204002C
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(2)
	CALL SUBOPT_0xDB
	CALL SUBOPT_0xDC
	RJMP _0x20E0013
_0x2040033:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x204002C
	CALL SUBOPT_0xD8
	CALL SUBOPT_0xDD
	CALL SUBOPT_0xDA
	BRNE _0x204002C
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(4)
	CALL SUBOPT_0xDB
	CALL __GETD1P
	__ANDD1N 0xFFFFFFF
	RJMP _0x20E0013
_0x204002C:
	CALL SUBOPT_0xDE
_0x20E0013:
	CALL __LOADLOCR4
	ADIW R28,14
	RET
_put_fat:
	CALL __PUTPARD2
	SBIW R28,4
	CALL __SAVELOCR6
	CALL SUBOPT_0xDF
	CALL SUBOPT_0xD2
	BRLO _0x2040038
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,30
	CALL SUBOPT_0xE0
	BRLO _0x2040037
_0x2040038:
	__GETWRN 20,21,2
	RJMP _0x204003A
_0x2040037:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,34
	CALL __GETD1P
	CALL SUBOPT_0xE1
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	CALL SUBOPT_0xD5
	BREQ PC+3
	JMP _0x204003E
	__GETWRS 16,17,14
	MOVW R30,R16
	LSR  R31
	ROR  R30
	__ADDWRR 16,17,30,31
	CALL SUBOPT_0xE2
	BREQ _0x204003F
	RJMP _0x204003D
_0x204003F:
	CALL SUBOPT_0xE3
	BREQ _0x2040040
	MOVW R26,R18
	LD   R30,X
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	LDD  R30,Y+10
	LDI  R31,0
	CALL __LSLW4
	OR   R30,R26
	RJMP _0x2040041
_0x2040040:
	LDD  R30,Y+10
_0x2040041:
	MOVW R26,R18
	ST   X,R30
	__ADDWRN 16,17,1
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
	CALL SUBOPT_0xE2
	BREQ _0x2040043
	RJMP _0x204003D
_0x2040043:
	CALL SUBOPT_0xE3
	BREQ _0x2040044
	CALL SUBOPT_0x3
	LDI  R30,LOW(4)
	CALL __LSRD12
	CLR  R31
	CLR  R22
	CLR  R23
	RJMP _0x2040045
_0x2040044:
	MOVW R26,R18
	LD   R30,X
	ANDI R30,LOW(0xF0)
	MOV  R1,R30
	CALL SUBOPT_0x3
	LDI  R30,LOW(8)
	CALL __LSRD12
	CLR  R31
	CLR  R22
	CLR  R23
	ANDI R30,LOW(0xF)
	OR   R30,R1
_0x2040045:
	MOVW R26,R18
	ST   X,R30
	RJMP _0x204003D
_0x204003E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x2040047
	CALL SUBOPT_0xE4
	CALL SUBOPT_0xD9
	CALL SUBOPT_0xE5
	BRNE _0x204003D
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDI  R30,LOW(2)
	CALL SUBOPT_0xE6
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	STD  Z+0,R26
	STD  Z+1,R27
	RJMP _0x204003D
_0x2040047:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x204004B
	CALL SUBOPT_0xE4
	CALL SUBOPT_0xDD
	CALL SUBOPT_0xE5
	BRNE _0x204003D
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	LDI  R30,LOW(4)
	CALL SUBOPT_0xE6
	CALL SUBOPT_0x3
	CALL __PUTDZ20
	RJMP _0x204003D
_0x204004B:
	__GETWRN 20,21,2
_0x204003D:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
_0x204003A:
	MOVW R30,R20
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_remove_chain_G102:
	CALL __PUTPARD2
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	CALL SUBOPT_0x2
	CALL SUBOPT_0xD2
	BRLO _0x204004D
	CALL SUBOPT_0xE7
	BRLO _0x204004C
_0x204004D:
	__GETWRN 16,17,2
	RJMP _0x204004F
_0x204004C:
	__GETWRN 16,17,0
_0x2040050:
	CALL SUBOPT_0xE7
	BRSH _0x2040052
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xD1
	CALL SUBOPT_0xE8
	CALL SUBOPT_0xE9
	CALL __CPD10
	BREQ _0x2040052
	CALL SUBOPT_0xEA
	BRNE _0x2040054
	__GETWRN 16,17,2
	RJMP _0x2040052
_0x2040054:
	CALL SUBOPT_0xEB
	BRNE _0x2040055
	__GETWRN 16,17,1
	RJMP _0x2040052
_0x2040055:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL SUBOPT_0xCF
	CALL SUBOPT_0xEC
	RCALL _put_fat
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x2040052
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL SUBOPT_0xED
	BREQ _0x2040057
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CALL SUBOPT_0xEE
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,5
	LDI  R30,LOW(1)
	ST   X,R30
_0x2040057:
	CALL SUBOPT_0xE9
	CALL SUBOPT_0xE1
	RJMP _0x2040050
_0x2040052:
_0x204004F:
	MOVW R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20E0012:
	ADIW R28,12
	RET
_create_chain_G102:
	CALL __PUTPARD2
	SBIW R28,16
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,30
	CALL __GETD1P
	CALL SUBOPT_0xEF
	CALL SUBOPT_0xF0
	CALL __CPD10
	BRNE _0x2040058
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,10
	CALL SUBOPT_0xD4
	CALL SUBOPT_0xF1
	CALL __CPD02
	BREQ _0x204005A
	CALL SUBOPT_0xF2
	CALL SUBOPT_0xF1
	CALL __CPD21
	BRLO _0x2040059
_0x204005A:
	CALL SUBOPT_0xD3
	CALL SUBOPT_0xF3
_0x2040059:
	RJMP _0x204005C
_0x2040058:
	CALL SUBOPT_0xF4
	CALL SUBOPT_0xF5
	CALL SUBOPT_0xF6
	CALL SUBOPT_0xF7
	CALL SUBOPT_0xD2
	BRSH _0x204005D
	CALL SUBOPT_0xD3
	RJMP _0x20E0011
_0x204005D:
	CALL SUBOPT_0xF2
	CALL SUBOPT_0xF7
	CALL __CPD21
	BRSH _0x204005E
	CALL SUBOPT_0xF8
	RJMP _0x20E0011
_0x204005E:
	CALL SUBOPT_0xF0
	CALL SUBOPT_0xF3
_0x204005C:
	CALL SUBOPT_0xF9
	CALL SUBOPT_0xFA
_0x2040060:
	CALL SUBOPT_0xFB
	__SUBD1N -1
	CALL SUBOPT_0xFA
	CALL SUBOPT_0xF2
	CALL SUBOPT_0xD1
	CALL __CPD21
	BRLO _0x2040062
	__GETD1N 0x2
	CALL SUBOPT_0xFA
	CALL SUBOPT_0xFC
	BRSH _0x2040063
	CALL SUBOPT_0xFD
	RJMP _0x20E0011
_0x2040063:
_0x2040062:
	CALL SUBOPT_0xF4
	CALL SUBOPT_0x3
	CALL SUBOPT_0xF6
	CALL SUBOPT_0xF8
	CALL __CPD10
	BREQ _0x2040061
	CALL SUBOPT_0xF7
	CALL SUBOPT_0xFE
	BREQ _0x2040066
	CALL SUBOPT_0xF7
	CALL SUBOPT_0xFF
	BRNE _0x2040065
_0x2040066:
	CALL SUBOPT_0xF8
	RJMP _0x20E0011
_0x2040065:
	CALL SUBOPT_0xFC
	BRNE _0x2040068
	CALL SUBOPT_0xFD
	RJMP _0x20E0011
_0x2040068:
	RJMP _0x2040060
_0x2040061:
	CALL SUBOPT_0xF4
	CALL SUBOPT_0x6
	CALL __PUTPARD1
	__GETD2N 0xFFFFFFF
	RCALL _put_fat
	SBIW R30,0
	BREQ _0x2040069
	CALL SUBOPT_0xDE
	RJMP _0x20E0011
_0x2040069:
	CALL SUBOPT_0xF0
	CALL __CPD10
	BREQ _0x204006A
	CALL SUBOPT_0xF4
	CALL SUBOPT_0x4
	CALL __PUTPARD1
	CALL SUBOPT_0xDF
	RCALL _put_fat
	SBIW R30,0
	BREQ _0x204006B
	CALL SUBOPT_0xDE
	RJMP _0x20E0011
_0x204006B:
_0x204006A:
	CALL SUBOPT_0xFB
	__PUTD1SNS 20,10
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	CALL SUBOPT_0xED
	BREQ _0x204006C
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,14
	CALL __GETD1P_INC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	CALL __PUTDP1_DEC
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	ADIW R26,5
	LDI  R30,LOW(1)
	ST   X,R30
_0x204006C:
	CALL SUBOPT_0xFB
_0x20E0011:
	ADIW R28,22
	RET
_clust2sect:
	CALL __PUTPARD2
	CALL SUBOPT_0xF2
	__SUBD1N 2
	CALL SUBOPT_0xEF
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	__GETD2Z 30
	__GETD1N 0x2
	CALL SUBOPT_0x100
	CALL __GETD2S0
	CALL __CPD21
	BRLO _0x204006D
	CALL SUBOPT_0xFD
	RJMP _0x20E000A
_0x204006D:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CALL SUBOPT_0x101
	CALL __GETD2S0
	CALL __CWD1
	CALL __MULD12U
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ADIW R26,42
	CALL __GETD1P
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDD12
	RJMP _0x20E000A
_dir_seek_G102:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	__PUTW1SNS 8,4
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CALL SUBOPT_0x102
	CALL SUBOPT_0xEA
	BREQ _0x204006F
	CALL SUBOPT_0x103
	CALL SUBOPT_0x104
	BRLO _0x204006E
_0x204006F:
	CALL SUBOPT_0x105
	RJMP _0x20E000B
_0x204006E:
	CALL SUBOPT_0xE9
	CALL __CPD10
	BRNE _0x2040072
	CALL SUBOPT_0x103
	LD   R26,Z
	CPI  R26,LOW(0x3)
	BREQ _0x2040073
_0x2040072:
	RJMP _0x2040071
_0x2040073:
	CALL SUBOPT_0x103
	ADIW R30,38
	MOVW R26,R30
	CALL __GETD1P
	__PUTD1S 2
_0x2040071:
	CALL SUBOPT_0xE9
	CALL __CPD10
	BRNE _0x2040074
	CALL SUBOPT_0x106
	ADIW R30,8
	MOVW R26,R30
	CALL __GETW1P
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x2040075
	CALL SUBOPT_0x105
	RJMP _0x20E000B
_0x2040075:
	CALL SUBOPT_0x103
	ADIW R30,38
	MOVW R26,R30
	CALL __GETD1P
	RJMP _0x204022C
_0x2040074:
	CALL SUBOPT_0x103
	LDD  R30,Z+2
	LDI  R26,LOW(16)
	MUL  R30,R26
	MOVW R16,R0
_0x2040077:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R26,R16
	CPC  R27,R17
	BRLO _0x2040079
	CALL SUBOPT_0x103
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xF1
	CALL SUBOPT_0xE8
	CALL SUBOPT_0xEB
	BRNE _0x204007A
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20E000B
_0x204007A:
	CALL SUBOPT_0x1
	CALL SUBOPT_0xD2
	BRLO _0x204007C
	CALL SUBOPT_0x103
	CALL SUBOPT_0x104
	BRLO _0x204007B
_0x204007C:
	CALL SUBOPT_0x105
	RJMP _0x20E000B
_0x204007B:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R16
	SBC  R31,R17
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2040077
_0x2040079:
	CALL SUBOPT_0x106
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xF1
	RCALL _clust2sect
_0x204022C:
	MOVW R26,R30
	MOVW R24,R22
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __LSRW4
	CALL SUBOPT_0x107
	__PUTD1SNS 8,14
	CALL SUBOPT_0x103
	ADIW R30,50
	MOVW R26,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL SUBOPT_0x108
	__PUTW1SNS 8,18
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x20E000B
_dir_next_G102:
	ST   -Y,R26
	SBIW R28,4
	CALL __SAVELOCR4
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,4
	CALL __GETW1P
	ADIW R30,1
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x204007F
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,14
	CALL __GETD1P
	CALL __CPD10
	BRNE _0x204007E
_0x204007F:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x20E000F
_0x204007E:
	MOVW R30,R16
	ANDI R30,LOW(0xF)
	BREQ PC+3
	JMP _0x2040081
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL SUBOPT_0xEE
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	ADIW R26,10
	CALL __GETD1P
	CALL __CPD10
	BRNE _0x2040082
	CALL SUBOPT_0x109
	ADIW R30,8
	MOVW R26,R30
	CALL __GETW1P
	CP   R16,R30
	CPC  R17,R31
	BRLO _0x2040083
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x20E000F
_0x2040083:
	RJMP _0x2040084
_0x2040082:
	MOVW R30,R16
	CALL __LSRW4
	MOVW R0,R30
	CALL SUBOPT_0x109
	CALL SUBOPT_0x101
	SBIW R30,1
	AND  R30,R0
	AND  R31,R1
	SBIW R30,0
	BREQ PC+3
	JMP _0x2040085
	CALL SUBOPT_0x109
	CALL SUBOPT_0x10A
	RCALL _get_fat
	CALL SUBOPT_0xF3
	CALL SUBOPT_0xF1
	CALL SUBOPT_0xD2
	BRSH _0x2040086
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E000F
_0x2040086:
	CALL SUBOPT_0xF1
	CALL SUBOPT_0xFE
	BRNE _0x2040087
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E000F
_0x2040087:
	CALL SUBOPT_0x109
	ADIW R30,30
	MOVW R26,R30
	CALL __GETD1P
	CALL SUBOPT_0xF1
	CALL __CPD21
	BRSH PC+3
	JMP _0x2040088
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x2040089
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x20E000F
_0x2040089:
	CALL SUBOPT_0x109
	CALL SUBOPT_0x10A
	RCALL _create_chain_G102
	CALL SUBOPT_0xF3
	CALL SUBOPT_0xF9
	CALL __CPD10
	BRNE _0x204008A
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x20E000F
_0x204008A:
	CALL SUBOPT_0xF1
	CALL SUBOPT_0xFF
	BRNE _0x204008B
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E000F
_0x204008B:
	CALL SUBOPT_0xF1
	CALL SUBOPT_0xFE
	BRNE _0x204008C
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E000F
_0x204008C:
	CALL SUBOPT_0x109
	CALL SUBOPT_0x10B
	BREQ _0x204008D
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E000F
_0x204008D:
	CALL SUBOPT_0x109
	ADIW R30,50
	CALL SUBOPT_0x55
	LDI  R26,LOW(512)
	LDI  R27,HIGH(512)
	RCALL _mem_set_G102
	CALL SUBOPT_0x109
	MOVW R26,R30
	ADIW R30,46
	PUSH R31
	PUSH R30
	MOVW R30,R26
	CALL SUBOPT_0x10C
	POP  R26
	POP  R27
	CALL __PUTDP1
	LDI  R19,LOW(0)
_0x204008F:
	CALL SUBOPT_0x109
	LDD  R30,Z+2
	CP   R19,R30
	BRSH _0x2040090
	CALL SUBOPT_0x109
	ADIW R30,4
	LDI  R26,LOW(1)
	STD  Z+0,R26
	CALL SUBOPT_0x109
	CALL SUBOPT_0x10B
	BREQ _0x2040091
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E000F
_0x2040091:
	CALL SUBOPT_0x109
	ADIW R30,46
	MOVW R26,R30
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	SUBI R19,-1
	RJMP _0x204008F
_0x2040090:
	CALL SUBOPT_0x109
	ADIW R30,46
	PUSH R31
	PUSH R30
	MOVW R26,R30
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	MOV  R30,R19
	CALL SUBOPT_0xC8
	CALL SUBOPT_0x100
	POP  R26
	POP  R27
	CALL __PUTDP1
_0x2040088:
	CALL SUBOPT_0xF9
	__PUTD1SNS 9,10
	CALL SUBOPT_0x109
	CALL SUBOPT_0x10C
	__PUTD1SNS 9,14
_0x2040085:
_0x2040084:
_0x2040081:
	MOVW R30,R16
	__PUTW1SNS 9,4
	CALL SUBOPT_0x109
	ADIW R30,50
	MOVW R26,R30
	MOVW R30,R16
	CALL SUBOPT_0x108
	__PUTW1SNS 9,18
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20E000F:
	CALL __LOADLOCR4
_0x20E0010:
	ADIW R28,11
	RET
_dir_find_G102:
	CALL SUBOPT_0xCA
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL SUBOPT_0x9E
	RCALL _dir_seek_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040092
	RJMP _0x20E000E
_0x2040092:
_0x2040094:
	CALL SUBOPT_0x10D
	BRNE _0x2040095
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,18
	LD   R20,X+
	LD   R21,X
	MOVW R26,R20
	LD   R19,X
	CPI  R19,0
	BRNE _0x2040097
	__GETWRN 16,17,4
	RJMP _0x2040095
_0x2040097:
	MOVW R30,R20
	LDD  R30,Z+11
	ANDI R30,LOW(0x8)
	BRNE _0x2040099
	CALL SUBOPT_0x10E
	RCALL _mem_cmp_G102
	SBIW R30,0
	BREQ _0x204009A
_0x2040099:
	RJMP _0x2040098
_0x204009A:
	RJMP _0x2040095
_0x2040098:
	CALL SUBOPT_0xA2
	LDI  R26,LOW(0)
	RCALL _dir_next_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040094
_0x2040095:
	RJMP _0x20E000E
_dir_register_G102:
	CALL SUBOPT_0xCA
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL SUBOPT_0x9E
	RCALL _dir_seek_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x20400A7
_0x20400A9:
	CALL SUBOPT_0x10D
	BRNE _0x20400AA
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+18
	LDD  R27,Z+19
	LD   R19,X
	CPI  R19,229
	BREQ _0x20400AD
	CPI  R19,0
	BRNE _0x20400AC
_0x20400AD:
	RJMP _0x20400AA
_0x20400AC:
	CALL SUBOPT_0xA2
	LDI  R26,LOW(1)
	RCALL _dir_next_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x20400A9
_0x20400AA:
_0x20400A7:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x20400AF
	CALL SUBOPT_0x10D
	BRNE _0x20400B0
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,18
	LD   R20,X+
	LD   R21,X
	ST   -Y,R21
	ST   -Y,R20
	CALL SUBOPT_0x52
	LDI  R26,LOW(32)
	LDI  R27,0
	RCALL _mem_set_G102
	CALL SUBOPT_0x10E
	RCALL _mem_cpy_G102
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,20
	CALL __GETW1P
	LDD  R30,Z+11
	ANDI R30,LOW(0x18)
	__PUTB1RNS 20,12
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL __GETW1P
	ADIW R30,4
	LDI  R26,LOW(1)
	STD  Z+0,R26
_0x20400B0:
_0x20400AF:
_0x20E000E:
	MOVW R30,R16
	CALL __LOADLOCR6
	ADIW R28,8
	RET
_create_name_G102:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,5
	CALL __SAVELOCR6
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	ADIW R26,20
	LD   R20,X+
	LD   R21,X
	ST   -Y,R21
	ST   -Y,R20
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(11)
	LDI  R27,0
	RCALL _mem_set_G102
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOV  R17,R30
	MOV  R18,R30
	LDI  R30,LOW(8)
	STD  Y+10,R30
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	CALL SUBOPT_0x10F
	CALL SUBOPT_0x110
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x2E)
	BRNE _0x20400B3
_0x20400B5:
	CALL SUBOPT_0x111
	CPI  R16,46
	BRNE _0x20400B8
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,3
	BRLT _0x20400B7
_0x20400B8:
	RJMP _0x20400B6
_0x20400B7:
	CALL SUBOPT_0x112
	RJMP _0x20400B5
_0x20400B6:
	CPI  R16,47
	BREQ _0x20400BB
	CPI  R16,92
	BREQ _0x20400BB
	CPI  R16,33
	BRSH _0x20400BC
_0x20400BB:
	RJMP _0x20400BA
_0x20400BC:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x20E000C
_0x20400BA:
	CALL SUBOPT_0x110
	CALL SUBOPT_0x113
	BRSH _0x20400BD
	LDI  R30,LOW(36)
	RJMP _0x20400BE
_0x20400BD:
	LDI  R30,LOW(32)
_0x20400BE:
	__PUTB1RNS 20,11
	RJMP _0x20E000D
_0x20400B3:
_0x20400C1:
	CALL SUBOPT_0x111
	CPI  R16,33
	BRLO _0x20400C4
	CPI  R16,47
	BREQ _0x20400C4
	CPI  R16,92
	BRNE _0x20400C3
_0x20400C4:
	RJMP _0x20400C2
_0x20400C3:
	CPI  R16,46
	BREQ _0x20400C7
	LDD  R30,Y+10
	CP   R18,R30
	BRLO _0x20400C6
_0x20400C7:
	LDD  R26,Y+10
	CPI  R26,LOW(0x8)
	BRNE _0x20400CA
	CPI  R16,46
	BREQ _0x20400C9
_0x20400CA:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x20E000C
_0x20400C9:
	LDI  R18,LOW(8)
	LDI  R30,LOW(11)
	STD  Y+10,R30
	LSL  R17
	LSL  R17
	RJMP _0x20400C0
_0x20400C6:
	CPI  R16,128
	BRLO _0x20400CC
	ORI  R17,LOW(3)
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x20E000C
_0x20400CC:
	LDI  R30,LOW(_k1*2)
	LDI  R31,HIGH(_k1*2)
	ST   -Y,R31
	ST   -Y,R30
	MOV  R26,R16
	CLR  R27
	RCALL _chk_chrf_G102
	SBIW R30,0
	BREQ _0x20400D2
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x20E000C
_0x20400D2:
	CPI  R16,65
	BRLO _0x20400D4
	CPI  R16,91
	BRLO _0x20400D5
_0x20400D4:
	RJMP _0x20400D3
_0x20400D5:
	ORI  R17,LOW(2)
	RJMP _0x20400D6
_0x20400D3:
	CPI  R16,97
	BRLO _0x20400D8
	CPI  R16,123
	BRLO _0x20400D9
_0x20400D8:
	RJMP _0x20400D7
_0x20400D9:
	ORI  R17,LOW(1)
	SUBI R16,LOW(32)
_0x20400D7:
_0x20400D6:
	CALL SUBOPT_0x112
_0x20400C0:
	RJMP _0x20400C1
_0x20400C2:
	CALL SUBOPT_0x110
	CALL SUBOPT_0x113
	BRSH _0x20400DA
	LDI  R30,LOW(4)
	RJMP _0x20400DB
_0x20400DA:
	LDI  R30,LOW(0)
_0x20400DB:
	MOV  R16,R30
	CPI  R18,0
	BRNE _0x20400DD
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	RJMP _0x20E000C
_0x20400DD:
	MOVW R26,R20
	LD   R26,X
	CPI  R26,LOW(0xE5)
	BRNE _0x20400DE
	MOVW R26,R20
	LDI  R30,LOW(5)
	ST   X,R30
_0x20400DE:
	LDD  R26,Y+10
	CPI  R26,LOW(0x8)
	BRNE _0x20400DF
	LSL  R17
	LSL  R17
_0x20400DF:
	MOV  R30,R17
	ANDI R30,LOW(0x3)
	CPI  R30,LOW(0x1)
	BRNE _0x20400E0
	ORI  R16,LOW(16)
_0x20400E0:
	MOV  R30,R17
	ANDI R30,LOW(0xC)
	CPI  R30,LOW(0x4)
	BRNE _0x20400E1
	ORI  R16,LOW(8)
_0x20400E1:
	MOVW R30,R20
	__PUTBZR 16,11
_0x20E000D:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20E000C:
	CALL __LOADLOCR6
	ADIW R28,15
	RET
_follow_path_G102:
	CALL SUBOPT_0xCA
_0x20400F7:
	LDI  R30,LOW(1)
	CPI  R30,0
	BREQ _0x20400FA
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R26,X
	CPI  R26,LOW(0x20)
	BREQ _0x20400FB
_0x20400FA:
	RJMP _0x20400F9
_0x20400FB:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x20400F7
_0x20400F9:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R26,X
	CPI  R26,LOW(0x2F)
	BREQ _0x20400FD
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R26,X
	CPI  R26,LOW(0x5C)
	BRNE _0x20400FC
_0x20400FD:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,6
	CALL SUBOPT_0x114
	RJMP _0x20400FF
_0x20400FC:
	CALL SUBOPT_0x103
	ADIW R30,22
	MOVW R26,R30
	CALL __GETD1P
	CALL SUBOPT_0x115
_0x20400FF:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R26,X
	CLR  R27
	SBIW R26,32
	BRSH _0x2040100
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CALL SUBOPT_0x9E
	RCALL _dir_seek_G102
	MOVW R16,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,18
	CALL SUBOPT_0x116
	RJMP _0x2040101
_0x2040100:
_0x2040103:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CALL SUBOPT_0xC7
	RCALL _create_name_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x2040104
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	RCALL _dir_find_G102
	MOVW R16,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,20
	CALL __GETW1P
	LDD  R30,Z+11
	ANDI R30,LOW(0x4)
	MOV  R21,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040106
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x2040108
	CPI  R21,0
	BREQ _0x2040109
_0x2040108:
	RJMP _0x2040107
_0x2040109:
	__GETWRN 16,17,5
_0x2040107:
	RJMP _0x2040104
_0x2040106:
	CPI  R21,0
	BRNE _0x2040104
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADIW R26,18
	LD   R18,X+
	LD   R19,X
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x10)
	BRNE _0x204010B
	__GETWRN 16,17,5
	RJMP _0x2040104
_0x204010B:
	CALL SUBOPT_0x117
	CALL __LSLD16
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x118
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x119
	CALL SUBOPT_0x115
	RJMP _0x2040103
_0x2040104:
_0x2040101:
	MOVW R30,R16
	CALL __LOADLOCR6
_0x20E000B:
	ADIW R28,10
	RET
_check_fs_G102:
	CALL __PUTPARD2
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+5
	LDD  R31,Y+5+1
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 3
	CALL SUBOPT_0x11A
	BREQ _0x204010C
	LDI  R30,LOW(3)
	RJMP _0x20E000A
_0x204010C:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	CALL SUBOPT_0x11B
	BREQ _0x204010D
	LDI  R30,LOW(2)
	RJMP _0x20E000A
_0x204010D:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SUBI R26,LOW(-104)
	SBCI R27,HIGH(-104)
	CALL SUBOPT_0x11C
	BRNE _0x204010E
	LDI  R30,LOW(0)
	RJMP _0x20E000A
_0x204010E:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,50
	SUBI R30,LOW(-82)
	SBCI R31,HIGH(-82)
	MOVW R26,R30
	CALL SUBOPT_0x11C
	BRNE _0x204010F
	LDI  R30,LOW(0)
	RJMP _0x20E000A
_0x204010F:
	LDI  R30,LOW(1)
_0x20E000A:
	ADIW R28,6
	RET
_chk_mounted:
	ST   -Y,R26
	SBIW R28,20
	CALL __SAVELOCR6
	LDD  R26,Y+29
	LDD  R27,Y+29+1
	CALL __GETW1P
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LD   R30,X
	SUBI R30,LOW(48)
	MOV  R16,R30
	CPI  R16,10
	BRSH _0x2040111
	ADIW R26,1
	LD   R26,X
	CPI  R26,LOW(0x3A)
	BREQ _0x2040112
_0x2040111:
	RJMP _0x2040110
_0x2040112:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,2
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R26,Y+29
	LDD  R27,Y+29+1
	ST   X+,R30
	ST   X,R31
	RJMP _0x2040113
_0x2040110:
	LDS  R16,_Drive_G102
_0x2040113:
	CPI  R16,1
	BRLO _0x2040114
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	RJMP _0x20E0008
_0x2040114:
	MOV  R30,R16
	CALL SUBOPT_0x11D
	CALL SUBOPT_0x10F
	LDD  R26,Y+27
	LDD  R27,Y+27+1
	ST   X+,R30
	ST   X,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,0
	BRNE _0x2040115
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RJMP _0x20E0008
_0x2040115:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x2040116
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+1
	CALL _disk_status
	MOV  R21,R30
	SBRC R21,0
	RJMP _0x2040117
	LDD  R30,Y+26
	CPI  R30,0
	BREQ _0x2040119
	SBRC R21,2
	RJMP _0x204011A
_0x2040119:
	RJMP _0x2040118
_0x204011A:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x20E0008
_0x2040118:
	RJMP _0x20E0009
_0x2040117:
_0x2040116:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOV  R30,R16
	__PUTB1SNS 6,1
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+1
	CALL _disk_initialize
	MOV  R21,R30
	SBRS R21,0
	RJMP _0x204011B
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x20E0008
_0x204011B:
	LDD  R30,Y+26
	CPI  R30,0
	BREQ _0x204011D
	SBRC R21,2
	RJMP _0x204011E
_0x204011D:
	RJMP _0x204011C
_0x204011E:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x20E0008
_0x204011C:
	CALL SUBOPT_0xA2
	CALL SUBOPT_0xFD
	__PUTD1S 24
	MOVW R26,R30
	MOVW R24,R22
	RCALL _check_fs_G102
	MOV  R17,R30
	CPI  R17,1
	BRNE _0x204011F
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-446)
	SBCI R31,HIGH(-446)
	MOVW R18,R30
	MOVW R30,R18
	LDD  R30,Z+4
	CPI  R30,0
	BREQ _0x2040120
	MOVW R26,R18
	ADIW R26,8
	CALL __GETD1P
	__PUTD1S 22
	CALL SUBOPT_0xA2
	__GETD2S 24
	RCALL _check_fs_G102
	MOV  R17,R30
_0x2040120:
_0x204011F:
	CPI  R17,3
	BRNE _0x2040121
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0008
_0x2040121:
	CPI  R17,0
	BRNE _0x2040123
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,61
	CALL __GETW1P
	CPI  R30,LOW(0x200)
	LDI  R26,HIGH(0x200)
	CPC  R31,R26
	BREQ _0x2040122
_0x2040123:
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	RJMP _0x20E0008
_0x2040122:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-72)
	SBCI R27,HIGH(-72)
	CALL SUBOPT_0xDC
	CALL SUBOPT_0x11E
	CALL SUBOPT_0x4
	CALL __CPD10
	BRNE _0x2040125
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-86)
	SBCI R27,HIGH(-86)
	CALL __GETD1P
	CALL SUBOPT_0x11E
_0x2040125:
	CALL SUBOPT_0x4
	__PUTD1SNS 6,26
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUBI R30,LOW(-66)
	SBCI R31,HIGH(-66)
	LD   R30,Z
	__PUTB1SNS 6,3
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+3
	LDI  R31,0
	CALL SUBOPT_0xF5
	CALL __CWD1
	CALL __MULD12U
	CALL SUBOPT_0x11E
	CALL SUBOPT_0x11F
	CALL SUBOPT_0x120
	__PUTD1SNS 6,34
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+63
	__PUTB1SNS 6,2
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-67)
	SBCI R27,HIGH(-67)
	CALL __GETW1P
	__PUTW1SNS 6,8
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-69)
	SBCI R27,HIGH(-69)
	CALL SUBOPT_0xDC
	CALL SUBOPT_0x121
	CALL SUBOPT_0x122
	BRNE _0x2040126
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-82)
	SBCI R27,HIGH(-82)
	CALL SUBOPT_0x123
_0x2040126:
	CALL SUBOPT_0x11F
	CALL SUBOPT_0xDF
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x100
	CALL SUBOPT_0xF5
	CALL __SUBD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x124
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CLR  R22
	CLR  R23
	CALL __SUBD21
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R30,Z+2
	CALL SUBOPT_0xC8
	CALL __DIVD21U
	__ADDD1N 2
	__PUTD1S 10
	__PUTD1SNS 6,30
	LDI  R17,LOW(1)
	CALL SUBOPT_0x3
	__CPD2N 0xFF7
	BRLO _0x2040127
	LDI  R17,LOW(2)
_0x2040127:
	CALL SUBOPT_0x3
	__CPD2N 0xFFF7
	BRLO _0x2040128
	LDI  R17,LOW(3)
_0x2040128:
	CPI  R17,3
	BRNE _0x2040129
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-94)
	SBCI R27,HIGH(-94)
	CALL __GETD1P
	RJMP _0x204022D
_0x2040129:
	CALL SUBOPT_0x125
_0x204022D:
	__PUTD1SNS 6,38
	CALL SUBOPT_0x125
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x124
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x107
	__PUTD1SNS 6,42
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,14
	CALL SUBOPT_0xDE
	CALL __PUTDP1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,4
	LDI  R30,LOW(0)
	ST   X,R30
	CPI  R17,3
	BREQ PC+3
	JMP _0x204012B
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,5
	ST   X,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-98)
	SBCI R27,HIGH(-98)
	CALL __GETW1P
	CALL SUBOPT_0x120
	__PUTD1SNS 6,18
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	CALL SUBOPT_0x126
	CALL __PUTPARD2
	CALL SUBOPT_0xD0
	BRNE _0x204012D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL SUBOPT_0x11B
	BRNE _0x204012D
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,50
	CALL __GETD1P
	__CPD1N 0x41615252
	BRNE _0x204012D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-484)
	SBCI R31,HIGH(-484)
	MOVW R26,R30
	CALL __GETD1P
	__CPD1N 0x61417272
	BREQ _0x204012E
_0x204012D:
	RJMP _0x204012C
_0x204012E:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-492)
	SBCI R31,HIGH(-492)
	MOVW R26,R30
	CALL __GETD1P
	__PUTD1SNS 6,10
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,50
	SUBI R30,LOW(-488)
	SBCI R31,HIGH(-488)
	MOVW R26,R30
	CALL __GETD1P
	__PUTD1SNS 6,14
_0x204012C:
_0x204012B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ST   X,R17
	ADIW R26,46
	CALL SUBOPT_0x114
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,22
	CALL SUBOPT_0x114
	LDI  R26,LOW(_Fsid_G102)
	LDI  R27,HIGH(_Fsid_G102)
	CALL SUBOPT_0x127
	__PUTW1SNS 6,6
_0x20E0009:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20E0008:
	CALL __LOADLOCR6
	ADIW R28,31
	RET
_validate_G102:
	ST   -Y,R27
	ST   -Y,R26
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x2040130
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x2040130
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R26,Z+6
	LDD  R27,Z+7
	LD   R30,Y
	LDD  R31,Y+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x204012F
_0x2040130:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	RJMP _0x20E0007
_0x204012F:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	LDD  R26,Z+1
	CALL _disk_status
	ANDI R30,LOW(0x1)
	BREQ _0x2040132
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP _0x20E0007
_0x2040132:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20E0007:
	ADIW R28,4
	RET
_f_mount:
	CALL SUBOPT_0xC9
	LDD  R26,Y+4
	CPI  R26,LOW(0x1)
	BRLO _0x2040133
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
_0x2040133:
	LDD  R30,Y+4
	CALL SUBOPT_0x11D
	LD   R16,X+
	LD   R17,X
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040134
	MOVW R26,R16
	LDI  R30,LOW(0)
	ST   X,R30
_0x2040134:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	SBIW R30,0
	BREQ _0x2040135
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x2040135:
	LDD  R30,Y+4
	LDI  R26,LOW(_FatFs_G102)
	LDI  R27,HIGH(_FatFs_G102)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	STD  Z+0,R26
	STD  Z+1,R27
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	JMP  _0x20E0002
_f_open:
	ST   -Y,R26
	SBIW R28,34
	CALL __SAVELOCR4
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CALL SUBOPT_0x116
	LDD  R30,Y+38
	ANDI R30,LOW(0x1F)
	STD  Y+38,R30
	MOVW R30,R28
	ADIW R30,39
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,18
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+42
	ANDI R30,LOW(0x1E)
	MOV  R26,R30
	RCALL _chk_mounted
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040136
	MOVW R30,R16
	RJMP _0x20E0006
_0x2040136:
	MOVW R30,R28
	ADIW R30,4
	STD  Y+36,R30
	STD  Y+36+1,R31
	MOVW R30,R28
	ADIW R30,16
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	RCALL _follow_path_G102
	MOVW R16,R30
	LDD  R30,Y+38
	ANDI R30,LOW(0x1C)
	BRNE PC+3
	JMP _0x2040137
	SBIW R28,8
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040138
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x2040139
	MOVW R26,R28
	ADIW R26,24
	RCALL _dir_register_G102
	MOVW R16,R30
_0x2040139:
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x204013A
	MOVW R30,R16
	ADIW R28,8
	RJMP _0x20E0006
_0x204013A:
	LDD  R30,Y+46
	ORI  R30,8
	STD  Y+46,R30
	__GETWRS 18,19,42
	RJMP _0x204013B
_0x2040138:
	LDD  R30,Y+46
	ANDI R30,LOW(0x4)
	BREQ _0x204013C
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ADIW R28,8
	RJMP _0x20E0006
_0x204013C:
	__GETWRS 18,19,42
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x204013E
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x11)
	BREQ _0x204013D
_0x204013E:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ADIW R28,8
	RJMP _0x20E0006
_0x204013D:
	LDD  R30,Y+46
	ANDI R30,LOW(0x8)
	BRNE PC+3
	JMP _0x2040140
	CALL SUBOPT_0x117
	CALL __LSLD16
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x118
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x119
	CALL SUBOPT_0xEF
	MOVW R30,R18
	ADIW R30,20
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	STD  Z+0,R26
	STD  Z+1,R27
	MOVW R30,R18
	ADIW R30,26
	STD  Z+0,R26
	STD  Z+1,R27
	MOVW R30,R18
	ADIW R30,28
	CALL SUBOPT_0xEC
	CALL __PUTDZ20
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	ADIW R26,46
	CALL SUBOPT_0xD4
	CALL SUBOPT_0xF2
	CALL __CPD10
	BREQ _0x2040141
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x1
	RCALL _remove_chain_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040142
	MOVW R30,R16
	ADIW R28,8
	RJMP _0x20E0006
_0x2040142:
	CALL SUBOPT_0xF2
	CALL SUBOPT_0x128
	__PUTD1SNS 24,10
_0x2040141:
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x2
	CALL _move_window_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040143
	MOVW R30,R16
	ADIW R28,8
	RJMP _0x20E0006
_0x2040143:
_0x2040140:
_0x204013B:
	LDD  R30,Y+46
	ANDI R30,LOW(0x8)
	BREQ _0x2040144
	MOVW R30,R18
	ADIW R30,11
	LDI  R26,LOW(0)
	STD  Z+0,R26
	CALL _get_fattime
	CALL SUBOPT_0xF3
	CALL SUBOPT_0xF9
	__PUTD1RNS 18,14
	LDD  R26,Y+24
	LDD  R27,Y+24+1
	ADIW R26,4
	LDI  R30,LOW(1)
	ST   X,R30
	LDD  R30,Y+46
	ORI  R30,0x20
	STD  Y+46,R30
_0x2040144:
	ADIW R28,8
	RJMP _0x2040145
_0x2040137:
	MOV  R0,R16
	OR   R0,R17
	BREQ _0x2040146
	MOVW R30,R16
	RJMP _0x20E0006
_0x2040146:
	__GETWRS 18,19,34
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x2040148
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x10)
	BREQ _0x2040147
_0x2040148:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RJMP _0x20E0006
_0x2040147:
	LDD  R30,Y+38
	ANDI R30,LOW(0x2)
	BREQ _0x204014B
	MOVW R30,R18
	LDD  R30,Z+11
	ANDI R30,LOW(0x1)
	BRNE _0x204014C
_0x204014B:
	RJMP _0x204014A
_0x204014C:
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x20E0006
_0x204014A:
_0x2040145:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,46
	CALL __GETD1P
	__PUTD1SNS 41,26
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	__PUTW1SNS 41,30
	LDD  R30,Y+38
	__PUTB1SNS 41,4
	CALL SUBOPT_0x117
	CALL __LSLD16
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x118
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x119
	__PUTD1SNS 41,14
	MOVW R26,R18
	ADIW R26,28
	CALL __GETD1P
	__PUTD1SNS 41,10
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ADIW R26,6
	CALL SUBOPT_0x114
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ADIW R26,5
	LDI  R30,LOW(255)
	ST   X,R30
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ADIW R26,22
	CALL SUBOPT_0x114
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	ST   X+,R30
	ST   X,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,6
	CALL __GETW1P
	__PUTW1SNS 41,2
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20E0006:
	CALL __LOADLOCR4
	ADIW R28,43
	RET
_f_read:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,14
	CALL __SAVELOCR6
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	CALL SUBOPT_0x116
	CALL SUBOPT_0x129
	CALL SUBOPT_0x12A
	CALL SUBOPT_0x12B
	BREQ _0x204014D
	MOVW R30,R16
	RJMP _0x20E0005
_0x204014D:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x80)
	BREQ _0x204014E
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0005
_0x204014E:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x1)
	BRNE _0x204014F
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	RJMP _0x20E0005
_0x204014F:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	__GETD2Z 10
	PUSH R25
	PUSH R24
	PUSH R27
	PUSH R26
	CALL SUBOPT_0x12C
	POP  R30
	POP  R31
	POP  R22
	POP  R23
	CALL __SUBD12
	CALL SUBOPT_0xFA
	CALL SUBOPT_0xFB
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	CLR  R24
	CLR  R25
	CALL __CPD12
	BRSH _0x2040150
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	STD  Y+22,R30
	STD  Y+22+1,R31
_0x2040150:
_0x2040152:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	SBIW R30,0
	BRNE PC+3
	JMP _0x2040153
	CALL SUBOPT_0x12C
	MOVW R30,R26
	MOVW R22,R24
	ANDI R31,HIGH(0x1FF)
	SBIW R30,0
	BREQ PC+3
	JMP _0x2040154
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R0,Z+5
	CALL SUBOPT_0x129
	LDD  R30,Z+2
	CP   R0,R30
	BRLO _0x2040155
	CALL SUBOPT_0x12C
	CALL __CPD02
	BRNE _0x2040156
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,14
	CALL __GETD1P
	RJMP _0x2040157
_0x2040156:
	CALL SUBOPT_0x129
	CALL SUBOPT_0x12A
	CALL SUBOPT_0x126
	CALL _get_fat
_0x2040157:
	__PUTD1S 16
	CALL SUBOPT_0x12D
	CALL SUBOPT_0xD2
	BRSH _0x2040159
	CALL SUBOPT_0x12E
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0005
_0x2040159:
	CALL SUBOPT_0x12D
	CALL SUBOPT_0xFE
	BRNE _0x204015A
	CALL SUBOPT_0x12E
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0005
_0x204015A:
	CALL SUBOPT_0xF0
	__PUTD1SNS 26,18
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,5
	LDI  R30,LOW(0)
	ST   X,R30
_0x2040155:
	CALL SUBOPT_0x129
	CALL SUBOPT_0x12A
	CALL SUBOPT_0x126
	CALL _clust2sect
	__PUTD1S 12
	CALL SUBOPT_0xF8
	CALL __CPD10
	BRNE _0x204015B
	CALL SUBOPT_0x12E
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0005
_0x204015B:
	CALL SUBOPT_0x12F
	CALL SUBOPT_0xF7
	CALL __CWD1
	CALL __ADDD12
	__PUTD1S 12
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CALL __DIVW21U
	MOVW R20,R30
	MOV  R0,R20
	OR   R0,R21
	BRNE PC+3
	JMP _0x204015C
	CALL SUBOPT_0x12F
	ADD  R30,R20
	ADC  R31,R21
	MOVW R0,R30
	CALL SUBOPT_0x129
	LDD  R30,Z+2
	MOVW R26,R0
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x204015D
	CALL SUBOPT_0x129
	CALL SUBOPT_0x101
	MOVW R26,R30
	CALL SUBOPT_0x12F
	SUB  R26,R30
	SBC  R27,R31
	MOVW R20,R26
_0x204015D:
	CALL SUBOPT_0x129
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	CALL SUBOPT_0x130
	CALL __PUTPARD1
	MOV  R26,R20
	CALL _disk_read
	SBIW R30,0
	BREQ _0x204015E
	CALL SUBOPT_0x12E
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0005
_0x204015E:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x40)
	BREQ _0x2040160
	CALL SUBOPT_0x131
	CALL __SUBD21
	MOVW R30,R20
	CLR  R22
	CLR  R23
	CALL __CPD21
	BRLO _0x2040161
_0x2040160:
	RJMP _0x204015F
_0x2040161:
	CALL SUBOPT_0x131
	CALL __SUBD21
	__GETD1N 0x200
	CALL __MULD12U
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CLR  R24
	CLR  R25
	CALL SUBOPT_0xC5
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(512)
	LDI  R27,HIGH(512)
	CALL _mem_cpy_G102
_0x204015F:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,5
	LD   R30,X
	ADD  R30,R20
	ST   X,R30
	MOVW R30,R20
	LSL  R30
	ROL  R31
	MOV  R31,R30
	LDI  R30,0
	MOVW R18,R30
	RJMP _0x2040151
_0x204015C:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x40)
	BREQ _0x2040162
	CALL SUBOPT_0x129
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+27
	LDD  R31,Y+27+1
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+29
	LDD  R31,Y+29+1
	CALL SUBOPT_0x132
	BREQ _0x2040163
	CALL SUBOPT_0x12E
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0005
_0x2040163:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,4
	LD   R30,X
	ANDI R30,0xBF
	ST   X,R30
_0x2040162:
	CALL SUBOPT_0x131
	CALL __CPD12
	BREQ _0x2040164
	CALL SUBOPT_0x129
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+27
	LDD  R31,Y+27+1
	ADIW R30,32
	CALL SUBOPT_0x130
	CALL SUBOPT_0x11A
	BREQ _0x2040165
	CALL SUBOPT_0x12E
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0005
_0x2040165:
_0x2040164:
	CALL SUBOPT_0xF8
	__PUTD1SNS 26,22
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,5
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
_0x2040154:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,6
	CALL __GETW1P
	ANDI R31,HIGH(0x1FF)
	LDI  R26,LOW(512)
	LDI  R27,HIGH(512)
	SUB  R26,R30
	SBC  R27,R31
	MOVW R18,R26
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	CP   R30,R18
	CPC  R31,R19
	BRSH _0x2040166
	__GETWRS 18,19,22
_0x2040166:
	CALL SUBOPT_0xA2
	LDD  R26,Y+28
	LDD  R27,Y+28+1
	ADIW R26,6
	CALL __GETW1P
	ANDI R31,HIGH(0x1FF)
	LDD  R26,Y+28
	LDD  R27,Y+28+1
	ADIW R26,32
	CALL SUBOPT_0xC5
	MOVW R26,R18
	CALL _mem_cpy_G102
_0x2040151:
	MOVW R30,R18
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	CALL SUBOPT_0x133
	MOVW R26,R30
	MOVW R24,R22
	MOVW R30,R18
	CALL SUBOPT_0x107
	MOVW R26,R0
	CALL __PUTDP1
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	LD   R30,X+
	LD   R31,X+
	ADD  R30,R18
	ADC  R31,R19
	ST   -X,R31
	ST   -X,R30
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	SUB  R30,R18
	SBC  R31,R19
	STD  Y+22,R30
	STD  Y+22+1,R31
	RJMP _0x2040152
_0x2040153:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x20E0005:
	CALL __LOADLOCR6
	ADIW R28,28
	RET
_f_lseek:
	CALL __PUTPARD2
	SBIW R28,16
	ST   -Y,R17
	ST   -Y,R16
	CALL SUBOPT_0x134
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	CALL SUBOPT_0x12B
	BREQ _0x2040191
	RJMP _0x20E0004
_0x2040191:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x80)
	BREQ _0x2040192
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0003
_0x2040192:
	CALL SUBOPT_0x135
	CALL SUBOPT_0xF5
	CALL __CPD12
	BRSH _0x2040194
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x2)
	BREQ _0x2040195
_0x2040194:
	RJMP _0x2040193
_0x2040195:
	CALL SUBOPT_0x135
	CALL SUBOPT_0x11E
_0x2040193:
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	CALL SUBOPT_0x102
	CALL SUBOPT_0xFD
	CALL SUBOPT_0xE1
	CALL SUBOPT_0x136
	ADIW R26,5
	LDI  R30,LOW(255)
	ST   X,R30
	CALL SUBOPT_0xF5
	CALL __CPD02
	BRLO PC+3
	JMP _0x2040196
	CALL SUBOPT_0x134
	LDD  R30,Z+2
	CALL SUBOPT_0xC8
	__GETD2N 0x200
	CALL __MULD12U
	__PUTD1S 10
	CALL SUBOPT_0x1
	CALL __CPD02
	BRSH _0x2040198
	CALL SUBOPT_0x4
	CALL SUBOPT_0x137
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0xE9
	CALL SUBOPT_0x137
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __CPD21
	BRSH _0x2040199
_0x2040198:
	RJMP _0x2040197
_0x2040199:
	CALL SUBOPT_0xE9
	CALL SUBOPT_0x128
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x6
	CALL SUBOPT_0x128
	CALL __COMD1
	CALL __ANDD12
	CALL SUBOPT_0x136
	ADIW R26,6
	CALL __GETD1P
	CALL SUBOPT_0xF5
	CALL __SUBD21
	__PUTD2S 18
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,18
	CALL SUBOPT_0x123
	RJMP _0x204019A
_0x2040197:
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,14
	CALL SUBOPT_0x123
	CALL SUBOPT_0x122
	BRNE _0x204019B
	CALL SUBOPT_0x134
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xEC
	CALL _create_chain_G102
	CALL SUBOPT_0x121
	CALL SUBOPT_0xDF
	CALL SUBOPT_0xFF
	BRNE _0x204019C
	CALL SUBOPT_0x138
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0003
_0x204019C:
	CALL SUBOPT_0xDF
	CALL SUBOPT_0xFE
	BRNE _0x204019D
	CALL SUBOPT_0x138
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0003
_0x204019D:
	CALL SUBOPT_0x139
	__PUTD1SNS 22,14
_0x204019B:
	CALL SUBOPT_0x13A
_0x204019A:
	CALL SUBOPT_0x122
	BRNE PC+3
	JMP _0x204019E
_0x204019F:
	CALL SUBOPT_0x6
	CALL SUBOPT_0xF5
	CALL __CPD12
	BRLO PC+3
	JMP _0x20401A1
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x2)
	BREQ _0x20401A2
	CALL SUBOPT_0x134
	CALL SUBOPT_0x13B
	CALL _create_chain_G102
	CALL SUBOPT_0x121
	CALL SUBOPT_0x122
	BRNE _0x20401A3
	CALL SUBOPT_0x6
	CALL SUBOPT_0x11E
	RJMP _0x20401A1
_0x20401A3:
	RJMP _0x20401A4
_0x20401A2:
	CALL SUBOPT_0x134
	CALL SUBOPT_0x13B
	CALL _get_fat
	CALL SUBOPT_0x121
_0x20401A4:
	CALL SUBOPT_0xDF
	CALL SUBOPT_0xFE
	BRNE _0x20401A5
	CALL SUBOPT_0x138
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0003
_0x20401A5:
	CALL SUBOPT_0xDF
	CALL SUBOPT_0xD2
	BRLO _0x20401A7
	CALL SUBOPT_0x134
	ADIW R30,30
	MOVW R26,R30
	CALL SUBOPT_0xE0
	BRLO _0x20401A6
_0x20401A7:
	CALL SUBOPT_0x138
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0003
_0x20401A6:
	CALL SUBOPT_0x13A
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	CALL SUBOPT_0x133
	CALL SUBOPT_0x3
	CALL __ADDD12
	MOVW R26,R0
	CALL __PUTDP1
	CALL SUBOPT_0x3
	CALL SUBOPT_0x4
	CALL __SUBD12
	CALL SUBOPT_0x11E
	RJMP _0x204019F
_0x20401A1:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	CALL SUBOPT_0x133
	CALL SUBOPT_0xF5
	CALL __ADDD12
	MOVW R26,R0
	CALL __PUTDP1
	CALL SUBOPT_0xF5
	__GETD1N 0x200
	CALL __DIVD21U
	__PUTB1SNS 22,5
	CALL SUBOPT_0x4
	ANDI R31,HIGH(0x1FF)
	SBIW R30,0
	BREQ _0x20401A9
	CALL SUBOPT_0x134
	CALL SUBOPT_0x13B
	CALL _clust2sect
	CALL SUBOPT_0xE1
	CALL SUBOPT_0x5
	CALL __CPD10
	BRNE _0x20401AA
	CALL SUBOPT_0x138
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x20E0003
_0x20401AA:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	LDD  R30,Z+5
	LDI  R31,0
	CALL SUBOPT_0x2
	CALL __CWD1
	CALL __ADDD12
	CALL SUBOPT_0xE1
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,5
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
_0x20401A9:
_0x204019E:
_0x2040196:
	CALL SUBOPT_0x13C
	MOVW R30,R26
	MOVW R22,R24
	ANDI R31,HIGH(0x1FF)
	SBIW R30,0
	BREQ _0x20401AC
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,22
	CALL __GETD1P
	CALL SUBOPT_0x2
	CALL __CPD12
	BRNE _0x20401AD
_0x20401AC:
	RJMP _0x20401AB
_0x20401AD:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	LDD  R26,Z+4
	ANDI R26,LOW(0x40)
	BREQ _0x20401AE
	CALL SUBOPT_0x134
	CALL SUBOPT_0x13D
	LDD  R30,Y+25
	LDD  R31,Y+25+1
	CALL SUBOPT_0x132
	BREQ _0x20401AF
	CALL SUBOPT_0x138
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0003
_0x20401AF:
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,4
	LD   R30,X
	ANDI R30,0xBF
	ST   X,R30
_0x20401AE:
	CALL SUBOPT_0x134
	CALL SUBOPT_0x13D
	__GETD1S 9
	CALL SUBOPT_0x11A
	BREQ _0x20401B0
	CALL SUBOPT_0x138
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x20E0003
_0x20401B0:
	CALL SUBOPT_0x5
	__PUTD1SNS 22,22
_0x20401AB:
	CALL SUBOPT_0x13C
	MOVW R0,R26
	CALL SUBOPT_0x135
	MOVW R26,R0
	CALL __CPD12
	BRSH _0x20401B1
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,6
	CALL __GETD1P
	__PUTD1SNS 22,10
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,4
	LD   R30,X
	ORI  R30,0x20
	ST   X,R30
_0x20401B1:
_0x20E0004:
	MOVW R30,R16
_0x20E0003:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,24
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_getchar:
getchar0:
     sbis usr,rxc
     rjmp getchar0
     in   r30,udr
	RET
_putchar:
	ST   -Y,R26
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
_put_usart_G103:
	ST   -Y,R27
	ST   -Y,R26
	LDD  R26,Y+2
	RCALL _putchar
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x127
	ADIW R28,3
	RET
_put_buff_G103:
	CALL SUBOPT_0xC9
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2060027
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2060029
	__CPWRN 16,17,2
	BRLO _0x206002A
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2060029:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL SUBOPT_0x127
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x206002B
	CALL SUBOPT_0x127
_0x206002B:
_0x206002A:
	RJMP _0x206002C
_0x2060027:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x206002C:
_0x20E0002:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G103:
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL SUBOPT_0x116
_0x2060031:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2060033
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2060037
	CPI  R18,37
	BRNE _0x2060038
	LDI  R17,LOW(1)
	RJMP _0x2060039
_0x2060038:
	CALL SUBOPT_0x13E
_0x2060039:
	RJMP _0x2060036
_0x2060037:
	CPI  R30,LOW(0x1)
	BRNE _0x206003A
	CPI  R18,37
	BRNE _0x206003B
	CALL SUBOPT_0x13E
	RJMP _0x20600EC
_0x206003B:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x206003C
	LDI  R16,LOW(1)
	RJMP _0x2060036
_0x206003C:
	CPI  R18,43
	BRNE _0x206003D
	LDI  R20,LOW(43)
	RJMP _0x2060036
_0x206003D:
	CPI  R18,32
	BRNE _0x206003E
	LDI  R20,LOW(32)
	RJMP _0x2060036
_0x206003E:
	RJMP _0x206003F
_0x206003A:
	CPI  R30,LOW(0x2)
	BRNE _0x2060040
_0x206003F:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2060041
	ORI  R16,LOW(128)
	RJMP _0x2060036
_0x2060041:
	RJMP _0x2060042
_0x2060040:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x2060036
_0x2060042:
	CPI  R18,48
	BRLO _0x2060045
	CPI  R18,58
	BRLO _0x2060046
_0x2060045:
	RJMP _0x2060044
_0x2060046:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x2060036
_0x2060044:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x206004A
	CALL SUBOPT_0x13F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x140
	RJMP _0x206004B
_0x206004A:
	CPI  R30,LOW(0x73)
	BRNE _0x206004D
	CALL SUBOPT_0x13F
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL SUBOPT_0x10F
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL _strlen
	MOV  R17,R30
	RJMP _0x206004E
_0x206004D:
	CPI  R30,LOW(0x70)
	BRNE _0x2060050
	CALL SUBOPT_0x13F
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL SUBOPT_0x10F
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x206004E:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2060051
_0x2060050:
	CPI  R30,LOW(0x64)
	BREQ _0x2060054
	CPI  R30,LOW(0x69)
	BRNE _0x2060055
_0x2060054:
	ORI  R16,LOW(4)
	RJMP _0x2060056
_0x2060055:
	CPI  R30,LOW(0x75)
	BRNE _0x2060057
_0x2060056:
	LDI  R30,LOW(_tbl10_G103*2)
	LDI  R31,HIGH(_tbl10_G103*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x2060058
_0x2060057:
	CPI  R30,LOW(0x58)
	BRNE _0x206005A
	ORI  R16,LOW(8)
	RJMP _0x206005B
_0x206005A:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x206008C
_0x206005B:
	LDI  R30,LOW(_tbl16_G103*2)
	LDI  R31,HIGH(_tbl16_G103*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x2060058:
	SBRS R16,2
	RJMP _0x206005D
	CALL SUBOPT_0x13F
	CALL SUBOPT_0x141
	LDD  R26,Y+11
	TST  R26
	BRPL _0x206005E
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x206005E:
	CPI  R20,0
	BREQ _0x206005F
	SUBI R17,-LOW(1)
	RJMP _0x2060060
_0x206005F:
	ANDI R16,LOW(251)
_0x2060060:
	RJMP _0x2060061
_0x206005D:
	CALL SUBOPT_0x13F
	CALL SUBOPT_0x141
_0x2060061:
_0x2060051:
	SBRC R16,0
	RJMP _0x2060062
_0x2060063:
	CP   R17,R21
	BRSH _0x2060065
	SBRS R16,7
	RJMP _0x2060066
	SBRS R16,2
	RJMP _0x2060067
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x2060068
_0x2060067:
	LDI  R18,LOW(48)
_0x2060068:
	RJMP _0x2060069
_0x2060066:
	LDI  R18,LOW(32)
_0x2060069:
	CALL SUBOPT_0x13E
	SUBI R21,LOW(1)
	RJMP _0x2060063
_0x2060065:
_0x2060062:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x206006A
_0x206006B:
	CPI  R19,0
	BREQ _0x206006D
	SBRS R16,3
	RJMP _0x206006E
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x206006F
_0x206006E:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x206006F:
	CALL SUBOPT_0x13E
	CPI  R21,0
	BREQ _0x2060070
	SUBI R21,LOW(1)
_0x2060070:
	SUBI R19,LOW(1)
	RJMP _0x206006B
_0x206006D:
	RJMP _0x2060071
_0x206006A:
_0x2060073:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2060075:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x2060077
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x2060075
_0x2060077:
	CPI  R18,58
	BRLO _0x2060078
	SBRS R16,3
	RJMP _0x2060079
	SUBI R18,-LOW(7)
	RJMP _0x206007A
_0x2060079:
	SUBI R18,-LOW(39)
_0x206007A:
_0x2060078:
	SBRC R16,4
	RJMP _0x206007C
	CPI  R18,49
	BRSH _0x206007E
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x206007D
_0x206007E:
	RJMP _0x20600ED
_0x206007D:
	CP   R21,R19
	BRLO _0x2060082
	SBRS R16,0
	RJMP _0x2060083
_0x2060082:
	RJMP _0x2060081
_0x2060083:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2060084
	LDI  R18,LOW(48)
_0x20600ED:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2060085
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x140
	CPI  R21,0
	BREQ _0x2060086
	SUBI R21,LOW(1)
_0x2060086:
_0x2060085:
_0x2060084:
_0x206007C:
	CALL SUBOPT_0x13E
	CPI  R21,0
	BREQ _0x2060087
	SUBI R21,LOW(1)
_0x2060087:
_0x2060081:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2060074
	RJMP _0x2060073
_0x2060074:
_0x2060071:
	SBRS R16,0
	RJMP _0x2060088
_0x2060089:
	CPI  R21,0
	BREQ _0x206008B
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x140
	RJMP _0x2060089
_0x206008B:
_0x2060088:
_0x206008C:
_0x206004B:
_0x20600EC:
	LDI  R17,LOW(0)
_0x2060036:
	RJMP _0x2060031
_0x2060033:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	CALL SUBOPT_0x142
	SBIW R30,0
	BRNE _0x206008D
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20E0001
_0x206008D:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL SUBOPT_0x10F
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL SUBOPT_0x142
	CALL SUBOPT_0x12
	LDI  R30,LOW(_put_buff_G103)
	LDI  R31,HIGH(_put_buff_G103)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G103
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20E0001:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
	STD  Y+6,R30
	STD  Y+6+1,R30
	MOVW R26,R28
	ADIW R26,8
	CALL SUBOPT_0x142
	CALL SUBOPT_0x12
	LDI  R30,LOW(_put_usart_G103)
	LDI  R31,HIGH(_put_usart_G103)
	CALL SUBOPT_0xC7
	RCALL __print_G103
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,8
	POP  R15
	RET

	.CSEG
_strlen:
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_tolower:
	ST   -Y,R26
    ld   r30,y+
    cpi  r30,'A'
    brlo tolower1
    cpi  r30,'Z'+1
    brcc tolower1
    subi r30,-32
tolower1:
    ret

	.CSEG

	.DSEG
_prtc_get_time:
	.BYTE 0x2
_prtc_get_date:
	.BYTE 0x2
_TFT_margin_xl:
	.BYTE 0x2
_TFT_margin_xr:
	.BYTE 0x2
_TFT_margin_yu:
	.BYTE 0x2
_TFT_margin_yl:
	.BYTE 0x2
_rot:
	.BYTE 0x1
_Reverse:
	.BYTE 0x1
_Horizontal:
	.BYTE 0x1
_FgColor:
	.BYTE 0x2
_BkColor:
	.BYTE 0x2
_FontFixed:
	.BYTE 0x1
_NonTransparence:
	.BYTE 0x1
_FontWidth:
	.BYTE 0x1
_FontHeight:
	.BYTE 0x1
_FontXScale:
	.BYTE 0x1
_FontYScale:
	.BYTE 0x1
_FontSpace:
	.BYTE 0x1
_cursorX:
	.BYTE 0x2
_cursorY:
	.BYTE 0x2
_peLETTER:
	.BYTE 0x2
_drive:
	.BYTE 0x232
_fil:
	.BYTE 0x220
_bmpWidth:
	.BYTE 0x4
_bmpHeight:
	.BYTE 0x4
_path:
	.BYTE 0x14
_xt:
	.BYTE 0x2
_yt:
	.BYTE 0x2
_n:
	.BYTE 0x2
_i:
	.BYTE 0x1
_nk:
	.BYTE 0x1
_exit:
	.BYTE 0x1
_bsn:
	.BYTE 0x1
_bnun:
	.BYTE 0x1
_v1:
	.BYTE 0x1
_n1:
	.BYTE 0x1
_j:
	.BYTE 0x1
_ATH:
	.BYTE 0x3
_ATA:
	.BYTE 0x3
_number:
	.BYTE 0xD
_kibord:
	.BYTE 0x32
_atcmgs:
	.BYTE 0x8
_buffer:
	.BYTE 0x32
_ATD:
	.BYTE 0x4
_a:
	.BYTE 0x32
_text:
	.BYTE 0x32
_TFT_ID_code:
	.BYTE 0x2
_newX:
	.BYTE 0x2
_newY:
	.BYTE 0x2
_FontPointer:
	.BYTE 0x2
_fontSize:
	.BYTE 0x2
_firstchar:
	.BYTE 0x1
_lastchar:
	.BYTE 0x1
_charwidth:
	.BYTE 0x1
_prevLet:
	.BYTE 0x1
_nextLet:
	.BYTE 0x1
__seed_G100:
	.BYTE 0x4
_status_G101:
	.BYTE 0x1
_timer1_G101:
	.BYTE 0x1
_timer2_G101:
	.BYTE 0x1
_card_type_G101:
	.BYTE 0x1
_pv_S101000B000:
	.BYTE 0x1
_FatFs_G102:
	.BYTE 0x2
_Fsid_G102:
	.BYTE 0x2
_Drive_G102:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(_fil)
	LDI  R31,HIGH(_fil)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x1:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x2:
	__GETD2S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x3:
	__GETD2S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x4:
	__GETD1S 18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	__GETD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6:
	__GETD1S 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x7:
	__GETW2SX 273
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x8:
	__GETW2SX 271
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x9:
	LDS  R30,_TFT_margin_xl
	LDS  R31,_TFT_margin_xl+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	LDS  R30,_TFT_margin_xr
	LDS  R31,_TFT_margin_xr+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	__GETW2SX 267
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	LDS  R30,_TFT_margin_yu
	LDS  R31,_TFT_margin_yu+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	LDS  R30,_TFT_margin_yl
	LDS  R31,_TFT_margin_yl+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	__GETW2SX 265
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R26,LOW(3)
	LDI  R27,0
	JMP  _TFTOutCmd

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	LDI  R26,LOW(16)
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x11:
	LDI  R27,0
	JMP  _TFTOutCmd

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x13:
	LDI  R26,LOW(48)
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x14:
	CALL _bmpFile
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(160)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	CALL _bmpFile
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x16:
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x17:
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	CLR  R22
	CLR  R23
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_number)
	LDI  R31,HIGH(_number)
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	CALL _putchar
	MOV  R26,R7
	CALL _putchar
	LDI  R30,LOW(0)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x1B:
	LDS  R30,_i
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x1C:
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1D:
	__POINTW1FN _0x0,263
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1E:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	LDI  R26,LOW(0)
	LDI  R27,0
	JMP  _SetLetter

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x1F:
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _SetLine
	LDI  R30,LOW(2047)
	LDI  R31,HIGH(2047)
	STS  _FgColor,R30
	STS  _FgColor+1,R31
	LDS  R30,_BkColor
	LDS  R31,_BkColor+1
	STS  _BkColor,R30
	STS  _BkColor+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x20:
	LDI  R26,LOW(1)
	LDI  R27,0
	JMP  _SetLetter

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x21:
	SUBI R30,LOW(-_kibord)
	SBCI R31,HIGH(-_kibord)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 125 TIMES, CODE SIZE REDUCTION:245 WORDS
SUBOPT_0x22:
	LDI  R26,LOW(0)
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	CALL _SetLetter
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x24:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x25:
	SUBI R30,LOW(-_text)
	SBCI R31,HIGH(-_text)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x26:
	SUBI R30,LOW(-_number)
	SBCI R31,HIGH(-_number)
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _SetLine

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:77 WORDS
SUBOPT_0x28:
	STS  _FgColor,R30
	STS  _FgColor+1,R31
	LDS  R30,_BkColor
	LDS  R31,_BkColor+1
	STS  _BkColor,R30
	STS  _BkColor+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x29:
	ST   -Y,R30
	LDI  R26,LOW(0)
	JMP  _SetLine

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	CALL __CWD1
	CALL __CDF1
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2B:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_path)
	LDI  R27,HIGH(_path)
	JMP  _itoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2C:
	LDI  R30,LOW(130)
	LDI  R31,HIGH(130)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2D:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP SUBOPT_0x28

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2E:
	ST   -Y,R30
	LDI  R26,LOW(2)
	CALL _SetLine
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2F:
	LDI  R26,LOW(_path)
	LDI  R27,HIGH(_path)
	JMP  _Puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 60 TIMES, CODE SIZE REDUCTION:115 WORDS
SUBOPT_0x30:
	LDS  R26,_xt
	LDS  R27,_xt+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 160 TIMES, CODE SIZE REDUCTION:315 WORDS
SUBOPT_0x31:
	LDS  R26,_yt
	LDS  R27,_yt+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 81 TIMES, CODE SIZE REDUCTION:317 WORDS
SUBOPT_0x32:
	LDS  R30,_n
	LDS  R31,_n+1
	SUBI R30,LOW(-_kibord)
	SBCI R31,HIGH(-_kibord)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x33:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x48)
	LDI  R30,HIGH(0x48)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x34:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x4A)
	LDI  R30,HIGH(0x4A)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x35:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x5A)
	LDI  R30,HIGH(0x5A)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x36:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x5B)
	LDI  R30,HIGH(0x5B)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x37:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x6A)
	LDI  R30,HIGH(0x6A)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x38:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x6E)
	LDI  R30,HIGH(0x6E)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x39:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x7C)
	LDI  R30,HIGH(0x7C)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3A:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x81)
	LDI  R30,HIGH(0x81)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3B:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x8B)
	LDI  R30,HIGH(0x8B)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3C:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x8F)
	LDI  R30,HIGH(0x8F)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x3D:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0x9E)
	LDI  R30,HIGH(0x9E)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x3E:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0xA1)
	LDI  R30,HIGH(0xA1)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x3F:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0xAF)
	LDI  R30,HIGH(0xAF)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x40:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0xB2)
	LDI  R30,HIGH(0xB2)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x41:
	RCALL SUBOPT_0x31
	CPI  R26,LOW(0xBF)
	LDI  R30,HIGH(0xBF)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x42:
	LDI  R26,LOW(200)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x43:
	LDS  R30,_FgColor
	LDS  R31,_FgColor+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x44:
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x45:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0x84)
	LDI  R30,HIGH(0x84)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x46:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0x99)
	LDI  R30,HIGH(0x99)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x47:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0x9D)
	LDI  R30,HIGH(0x9D)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x48:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0xB5)
	LDI  R30,HIGH(0xB5)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x49:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0xB6)
	LDI  R30,HIGH(0xB6)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4A:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0xCE)
	LDI  R30,HIGH(0xCE)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4B:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0xD0)
	LDI  R30,HIGH(0xD0)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4C:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0xE9)
	LDI  R30,HIGH(0xE9)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4D:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0xFF)
	LDI  R30,HIGH(0xFF)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4E:
	RCALL SUBOPT_0x30
	CPI  R26,LOW(0x112)
	LDI  R30,HIGH(0x112)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x4F:
	LDI  R26,LOW(100)
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x50:
	LDS  R30,_n
	LDS  R31,_n+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x51:
	LDI  R26,LOW(_n)
	LDI  R27,HIGH(_n)
	LD   R30,X+
	LD   R31,X+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 33 TIMES, CODE SIZE REDUCTION:61 WORDS
SUBOPT_0x52:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x53:
	LDI  R30,LOW(220)
	LDI  R31,HIGH(220)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(65)
	LDI  R31,HIGH(65)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x52

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x54:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x55:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x52

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x56:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x57:
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x58:
	LDS  R30,_v1
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x59:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	STS  _FgColor,R30
	STS  _FgColor+1,R31
	STS  _BkColor,R30
	STS  _BkColor+1,R31
	LDI  R26,LOW(_kibord)
	LDI  R27,HIGH(_kibord)
	JMP  _Puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x5A:
	LDS  R30,_n1
	ST   -Y,R30
	LDS  R26,_j
	CALL _SetLine
	LDI  R30,LOW(2016)
	LDI  R31,HIGH(2016)
	STS  _FgColor,R30
	STS  _FgColor+1,R31
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	STS  _BkColor,R30
	STS  _BkColor+1,R31
	LDI  R26,LOW(_kibord)
	LDI  R27,HIGH(_kibord)
	JMP  _Puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5B:
	LDI  R30,LOW(239)
	LDI  R31,HIGH(239)
	RJMP SUBOPT_0x55

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5C:
	LDI  R30,LOW(319)
	LDI  R31,HIGH(319)
	RJMP SUBOPT_0x55

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5D:
	LDI  R31,0
	STS  _n,R30
	STS  _n+1,R31
	SET
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5E:
	LDS  R26,_i
	LDI  R27,0
	SUBI R26,LOW(-_kibord)
	SBCI R27,HIGH(-_kibord)
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x5F:
	LDS  R30,_n1
	ST   -Y,R30
	LDS  R26,_j
	CALL _SetLine
	LDI  R30,LOW(2016)
	LDI  R31,HIGH(2016)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:53 WORDS
SUBOPT_0x60:
	STS  _FgColor,R30
	STS  _FgColor+1,R31
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	STS  _BkColor,R30
	STS  _BkColor+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x61:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP SUBOPT_0x60

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x62:
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	OUT  0x15,R30
	CBI  0x12,3
	SBI  0x12,3
	LD   R30,Y
	OUT  0x15,R30
	CBI  0x12,3
	SBI  0x12,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x63:
	LDS  R26,_TFT_ID_code
	LDS  R27,_TFT_ID_code+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x64:
	LDI  R30,LOW(227)
	LDI  R31,HIGH(227)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(12296)
	LDI  R27,HIGH(12296)
	CALL _TFTSetReg
	LDI  R30,LOW(231)
	LDI  R31,HIGH(231)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(18)
	LDI  R27,0
	CALL _TFTSetReg
	LDI  R30,LOW(239)
	LDI  R31,HIGH(239)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(4657)
	LDI  R27,HIGH(4657)
	CALL _TFTSetReg
	RJMP SUBOPT_0x52

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x65:
	LDI  R26,LOW(1)
	LDI  R27,0
	JMP  _TFTSetReg

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0x66:
	CALL _delay_ms
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(256)
	LDI  R27,HIGH(256)
	CALL _TFTSetReg
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1792)
	LDI  R27,HIGH(1792)
	CALL _TFTSetReg
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x67:
	CALL _TFTSetReg
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x68:
	CALL _TFTSetReg
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(514)
	LDI  R27,HIGH(514)
	CALL _TFTSetReg
	RJMP SUBOPT_0x56

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x69:
	CALL _TFTSetReg
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x6A:
	CALL _TFTSetReg
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x6B:
	CALL _TFTSetReg
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x6C:
	CALL _TFTSetReg
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x6D:
	CALL _TFTSetReg
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x6E:
	CALL _TFTSetReg
	LDI  R30,LOW(17)
	LDI  R31,HIGH(17)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x6F:
	LDI  R26,LOW(7)
	LDI  R27,0
	JMP  _TFTSetReg

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x70:
	LDI  R30,LOW(18)
	LDI  R31,HIGH(18)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x71:
	CALL _TFTSetReg
	LDI  R30,LOW(19)
	LDI  R31,HIGH(19)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:54 WORDS
SUBOPT_0x72:
	LDI  R27,0
	JMP  _TFTSetReg

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x73:
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x74:
	CALL _TFTSetReg
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x75:
	CALL _delay_ms
	RJMP SUBOPT_0x70

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x76:
	CALL _delay_ms
	LDI  R30,LOW(19)
	LDI  R31,HIGH(19)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x77:
	CALL _TFTSetReg
	LDI  R30,LOW(41)
	LDI  R31,HIGH(41)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x78:
	CALL _delay_ms
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x79:
	CALL _TFTSetReg
	LDI  R30,LOW(33)
	LDI  R31,HIGH(33)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7A:
	CALL _TFTSetReg
	LDI  R30,LOW(48)
	LDI  R31,HIGH(48)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x6F

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7B:
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7C:
	CALL _TFTSetReg
	RJMP SUBOPT_0x54

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7D:
	CALL _TFTSetReg
	LDI  R30,LOW(53)
	LDI  R31,HIGH(53)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7E:
	CALL _TFTSetReg
	LDI  R30,LOW(54)
	LDI  R31,HIGH(54)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7F:
	CALL _TFTSetReg
	LDI  R30,LOW(55)
	LDI  R31,HIGH(55)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x80:
	LDI  R30,LOW(56)
	LDI  R31,HIGH(56)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x81:
	LDI  R30,LOW(57)
	LDI  R31,HIGH(57)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x82:
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x83:
	CALL _TFTSetReg
	LDI  R30,LOW(61)
	LDI  R31,HIGH(61)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x84:
	CALL _TFTSetReg
	LDI  R30,LOW(80)
	LDI  R31,HIGH(80)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x85:
	CALL _TFTSetReg
	LDI  R30,LOW(81)
	LDI  R31,HIGH(81)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(239)
	RJMP SUBOPT_0x72

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x86:
	LDI  R30,LOW(82)
	LDI  R31,HIGH(82)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x87:
	CALL _TFTSetReg
	LDI  R30,LOW(83)
	LDI  R31,HIGH(83)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(319)
	LDI  R27,HIGH(319)
	CALL _TFTSetReg
	LDI  R30,LOW(96)
	LDI  R31,HIGH(96)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x88:
	CALL _TFTSetReg
	LDI  R30,LOW(97)
	LDI  R31,HIGH(97)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x65

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x89:
	LDI  R30,LOW(106)
	LDI  R31,HIGH(106)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8A:
	CALL _TFTSetReg
	RJMP SUBOPT_0x57

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x8B:
	CALL _TFTSetReg
	LDI  R30,LOW(129)
	LDI  R31,HIGH(129)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8C:
	CALL _TFTSetReg
	RJMP SUBOPT_0x2C

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x8D:
	CALL _TFTSetReg
	LDI  R30,LOW(131)
	LDI  R31,HIGH(131)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x8E:
	CALL _TFTSetReg
	LDI  R30,LOW(132)
	LDI  R31,HIGH(132)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x8F:
	CALL _TFTSetReg
	LDI  R30,LOW(133)
	LDI  R31,HIGH(133)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x90:
	CALL _TFTSetReg
	LDI  R30,LOW(144)
	LDI  R31,HIGH(144)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x91:
	CALL _TFTSetReg
	LDI  R30,LOW(146)
	LDI  R31,HIGH(146)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x92:
	CALL _TFTSetReg
	LDI  R30,LOW(147)
	LDI  R31,HIGH(147)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(3)
	RJMP SUBOPT_0x72

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x93:
	LDI  R30,LOW(149)
	LDI  R31,HIGH(149)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(272)
	LDI  R27,HIGH(272)
	CALL _TFTSetReg
	LDI  R30,LOW(151)
	LDI  R31,HIGH(151)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x94:
	CALL _TFTSetReg
	LDI  R30,LOW(152)
	LDI  R31,HIGH(152)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x95:
	CALL _TFTSetReg
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x96:
	LDI  R30,LOW(229)
	LDI  R31,HIGH(229)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(32768)
	LDI  R27,HIGH(32768)
	CALL _TFTSetReg
	RJMP SUBOPT_0x52

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x97:
	CALL _TFTSetReg
	RJMP SUBOPT_0x17

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x98:
	LDI  R30,LOW(54)
	LDI  R31,HIGH(54)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(1799)
	LDI  R27,HIGH(1799)
	RJMP SUBOPT_0x7F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x99:
	LDI  R26,LOW(1030)
	LDI  R27,HIGH(1030)
	CALL _TFTSetReg
	RJMP SUBOPT_0x80

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9A:
	LDI  R26,LOW(1028)
	LDI  R27,HIGH(1028)
	CALL _TFTSetReg
	RJMP SUBOPT_0x82

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9B:
	LDI  R26,LOW(1792)
	LDI  R27,HIGH(1792)
	RJMP SUBOPT_0x83

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9C:
	LDI  R26,LOW(2568)
	LDI  R27,HIGH(2568)
	RJMP SUBOPT_0x84

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9D:
	LDI  R26,LOW(9984)
	LDI  R27,HIGH(9984)
	RJMP SUBOPT_0x88

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x9E:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9F:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	JMP  _TFTSetReg

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA0:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	JMP  _TFTSetReg

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA1:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	JMP  _TFTSetReg

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA2:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA3:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA4:
	LDS  R30,_newY
	LDS  R31,_newY+1
	CP   R18,R30
	CPC  R19,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA5:
	LDS  R30,_newX
	LDS  R31,_newX+1
	CP   R16,R30
	CPC  R17,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA6:
	LDS  R30,_FontPointer
	LDS  R31,_FontPointer+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA7:
	STS  _fontSize,R30
	STS  _fontSize+1,R31
	RJMP SUBOPT_0xA6

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA8:
	LDS  R26,_fontSize
	LDS  R27,_fontSize+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0xA9:
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xAA:
	LDS  R26,_FontWidth
	CLR  R27
	LDS  R30,_FontXScale
	LDI  R31,0
	CALL __MULW12U
	MOVW R26,R30
	LD   R30,Y
	LDI  R31,0
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xAB:
	LDI  R26,LOW(239)
	LDI  R27,HIGH(239)
	SUB  R26,R30
	SBC  R27,R31
	STS  _cursorX,R26
	STS  _cursorX+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xAC:
	STS  _cursorX,R30
	STS  _cursorX+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0xAD:
	LDS  R26,_FontHeight
	CLR  R27
	LDS  R30,_FontYScale
	LDI  R31,0
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0xAE:
	LDI  R31,0
	CALL __MULW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xAF:
	STS  _cursorY,R30
	STS  _cursorY+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB0:
	LDI  R30,LOW(0)
	STS  _cursorX,R30
	STS  _cursorX+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB1:
	LDD  R26,Y+58
	LDD  R27,Y+58+1
	LD   R30,X+
	STD  Y+58,R26
	STD  Y+58+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xB2:
	LDD  R26,Y+58
	LDD  R27,Y+58+1
	SBIW R26,1
	STD  Y+58,R26
	STD  Y+58+1,R27
	ADIW R26,1
	LD   R16,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB3:
	SUBI R30,LOW(193)
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_PEmap*2)
	SBCI R31,HIGH(-_PEmap*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0xB4:
	CALL __SAVELOCR6
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	__GETWRN 20,21,0
	LDI  R18,0
	LDD  R30,Y+18
	LDI  R31,0
	ADIW R30,7
	MOVW R26,R30
	LDS  R30,_firstchar
	LDI  R31,0
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	LDS  R26,_FontPointer
	LDS  R27,_FontPointer+1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R0,Z
	STS  _charwidth,R0
	LDD  R26,Y+18
	CPI  R26,LOW(0xA)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xB5:
	LDS  R26,_cursorY
	LDS  R27,_cursorY+1
	ADD  R30,R26
	ADC  R31,R27
	RJMP SUBOPT_0xAF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xB6:
	LDS  R30,_FontXScale
	LDS  R26,_charwidth
	MUL  R30,R26
	MOVW R30,R0
	LDS  R26,_cursorX
	LDS  R27,_cursorX+1
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xB7:
	LDS  R26,_charwidth
	CLR  R27
	LDS  R30,_FontXScale
	RJMP SUBOPT_0xAE

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB8:
	LDS  R26,_cursorX
	LDS  R27,_cursorX+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB9:
	SUB  R26,R30
	SBC  R27,R31
	STS  _cursorX,R26
	STS  _cursorX+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xBA:
	MOV  R30,R18
	LDI  R31,0
	ADIW R30,7
	LDS  R26,_FontPointer
	LDS  R27,_FontPointer+1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R30,Z
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RJMP SUBOPT_0xA9

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xBB:
	LDS  R30,_FontHeight
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	RJMP SUBOPT_0xAE

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0xBC:
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDS  R26,_lastchar
	CLR  R27
	LDS  R30,_firstchar
	LDI  R31,0
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	ADIW R30,7
	CALL __LSLW3
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+16,R30
	STD  Y+16+1,R31
	CALL __LSRW3
	STD  Y+14,R30
	STD  Y+14+1,R31
	LDD  R30,Y+16
	ANDI R30,LOW(0x7)
	MOV  R16,R30
	MOV  R30,R16
	ANDI R30,LOW(0x7)
	MOV  R19,R30
	LDI  R30,LOW(0)
	STD  Y+9,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0xBD:
	MOVW R30,R20
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	ADD  R30,R26
	ADC  R31,R27
	ADIW R30,1
	LDS  R26,_FontPointer
	LDS  R27,_FontPointer+1
	ADD  R30,R26
	ADC  R31,R27
	LPM  R17,Z
	LDD  R26,Y+9
	CLR  R27
	LDS  R30,_FontXScale
	RJMP SUBOPT_0xAE

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xBE:
	RCALL SUBOPT_0xB8
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDS  R30,_Horizontal
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0xBF:
	LDS  R26,_FontHeight
	CLR  R27
	LDD  R30,Y+8
	LDI  R31,0
	SUB  R26,R30
	SBC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xC0:
	LDS  R26,_cursorY
	LDS  R27,_cursorY+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC1:
	LDD  R30,Y+6
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	RJMP SUBOPT_0xA9

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC2:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+9
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC3:
	LDD  R30,Y+7
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RJMP SUBOPT_0xA9

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC4:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC5:
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC6:
	LDS  R30,_BkColor
	LDS  R31,_BkColor+1
	RJMP SUBOPT_0x9E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC7:
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xC8:
	LDI  R31,0
	CALL __CWD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC9:
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xCA:
	ST   -Y,R27
	ST   -Y,R26
	CALL __SAVELOCR6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xCB:
	__GETD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xCC:
	__GETD2S 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xCD:
	LDD  R30,Y+9
	LDD  R31,Y+9+1
	LDD  R26,Z+1
	ST   -Y,R26
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 4
	CALL __PUTPARD1
	LDI  R26,LOW(1)
	JMP  _disk_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xCE:
	__GETD2Z 34
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xCF:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 8
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD0:
	LDI  R26,LOW(1)
	CALL _disk_read
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xD1:
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0xD2:
	__CPD2N 0x2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD3:
	__GETD1N 0x1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xD4:
	CALL __GETD1P
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD5:
	LD   R30,X
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xD6:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R18
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CALL __DIVW21U
	RCALL SUBOPT_0x2
	CLR  R22
	CLR  R23
	CALL __ADDD21
	CALL _move_window_G102
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD7:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,50
	MOVW R30,R18
	ANDI R31,HIGH(0x1FF)
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD8:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD9:
	__GETD1N 0x100
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xDA:
	RCALL SUBOPT_0x2
	CALL __ADDD21
	CALL _move_window_G102
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xDB:
	CALL __MULB1W2U
	ANDI R31,HIGH(0x1FF)
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADIW R26,50
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xDC:
	CALL __GETW1P
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xDD:
	__GETD1N 0x80
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xDE:
	__GETD1N 0xFFFFFFFF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xDF:
	__GETD2S 14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE0:
	CALL __GETD1P
	RCALL SUBOPT_0xDF
	CALL __CPD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE1:
	__PUTD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xE2:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R16
	LDI  R30,LOW(512)
	LDI  R31,HIGH(512)
	CALL __DIVW21U
	RCALL SUBOPT_0xD1
	CLR  R22
	CLR  R23
	CALL __ADDD21
	CALL _move_window_G102
	MOVW R20,R30
	MOV  R0,R20
	OR   R0,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE3:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,50
	MOVW R30,R16
	ANDI R31,HIGH(0x1FF)
	ADD  R30,R26
	ADC  R31,R27
	MOVW R18,R30
	LDD  R30,Y+14
	ANDI R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE4:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ST   -Y,R31
	ST   -Y,R30
	__GETD2S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xE5:
	RCALL SUBOPT_0xD1
	CALL __ADDD21
	CALL _move_window_G102
	MOVW R20,R30
	MOV  R0,R20
	OR   R0,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE6:
	CALL __MULB1W2U
	ANDI R31,HIGH(0x1FF)
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	ADIW R26,50
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xE7:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADIW R26,30
	CALL __GETD1P
	RCALL SUBOPT_0x2
	CALL __CPD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE8:
	CALL _get_fat
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xE9:
	__GETD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xEA:
	RCALL SUBOPT_0x1
	__CPD2N 0x1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xEB:
	RCALL SUBOPT_0x1
	__CPD2N 0xFFFFFFFF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xEC:
	__GETD2N 0x0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xED:
	__GETD2Z 14
	__CPD2N 0xFFFFFFFF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xEE:
	ADIW R26,14
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xEF:
	CALL __PUTD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF0:
	__GETD1S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xF1:
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xF2:
	CALL __GETD1S0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xF3:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF4:
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xF5:
	__GETD2S 18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF6:
	CALL _get_fat
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xF7:
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xF8:
	__GETD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xF9:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xFA:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xFB:
	__GETD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xFC:
	RCALL SUBOPT_0xF9
	RCALL SUBOPT_0xD1
	CALL __CPD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xFD:
	__GETD1N 0x0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xFE:
	__CPD2N 0xFFFFFFFF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xFF:
	__CPD2N 0x1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x100:
	CALL __SWAPD12
	CALL __SUBD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x101:
	LDD  R30,Z+2
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x102:
	ADIW R26,6
	CALL __GETD1P
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x103:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x104:
	ADIW R30,30
	MOVW R26,R30
	CALL __GETD1P
	RCALL SUBOPT_0x1
	CALL __CPD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x105:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	LDD  R17,Y+1
	LDD  R16,Y+0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x106:
	RCALL SUBOPT_0xE9
	__PUTD1SNS 8,10
	RJMP SUBOPT_0x103

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x107:
	CLR  R22
	CLR  R23
	CALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x108:
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	LSL  R30
	CALL __LSLW4
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x109:
	LDD  R26,Y+9
	LDD  R27,Y+9+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10A:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	__GETD2Z 10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10B:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0xEC
	CALL _move_window_G102
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10C:
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x2
	JMP  _clust2sect

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x10D:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	__GETD2Z 14
	CALL _move_window_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x10E:
	ST   -Y,R21
	ST   -Y,R20
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Z+20
	LDD  R27,Z+21
	ST   -Y,R27
	ST   -Y,R26
	LDI  R26,LOW(11)
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10F:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x110:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x111:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	SBIW R30,1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x112:
	MOV  R30,R18
	SUBI R18,-1
	LDI  R31,0
	ADD  R30,R20
	ADC  R31,R21
	ST   Z,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x113:
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+11
	LDD  R27,Y+11+1
	ST   X+,R30
	ST   X,R31
	CPI  R16,33
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x114:
	RCALL SUBOPT_0xFD
	CALL __PUTDP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x115:
	__PUTD1SNS 8,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x116:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x117:
	MOVW R26,R18
	ADIW R26,20
	RJMP SUBOPT_0xDC

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x118:
	MOVW R26,R18
	ADIW R26,26
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x119:
	CLR  R22
	CLR  R23
	CALL __ORD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11A:
	CALL __PUTPARD1
	RJMP SUBOPT_0xD0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11B:
	ADIW R30,50
	SUBI R30,LOW(-510)
	SBCI R31,HIGH(-510)
	MOVW R26,R30
	CALL __GETW1P
	CPI  R30,LOW(0xAA55)
	LDI  R26,HIGH(0xAA55)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x11C:
	CALL __GETD1P
	__ANDD1N 0xFFFFFF
	__CPD1N 0x544146
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11D:
	LDI  R26,LOW(_FatFs_G102)
	LDI  R27,HIGH(_FatFs_G102)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x11E:
	__PUTD1S 18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11F:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SUBI R26,LOW(-64)
	SBCI R27,HIGH(-64)
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x120:
	__GETD2S 22
	RJMP SUBOPT_0x107

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x121:
	__PUTD1S 14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x122:
	__GETD1S 14
	CALL __CPD10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x123:
	CALL __GETD1P
	RJMP SUBOPT_0x121

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x124:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LDD  R26,Z+8
	LDD  R27,Z+9
	MOVW R30,R26
	CALL __LSRW4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x125:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RCALL SUBOPT_0xCE
	RCALL SUBOPT_0x4
	CALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x126:
	__GETD2Z 18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x127:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x128:
	__SUBD1N 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x129:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12A:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12B:
	LDD  R26,Z+2
	LDD  R27,Z+3
	CALL _validate_G102
	MOVW R16,R30
	MOV  R0,R16
	OR   R0,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12C:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	__GETD2Z 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12D:
	__GETD2S 16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x12E:
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	ADIW R26,4
	LD   R30,X
	ORI  R30,0x80
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12F:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	LDD  R30,Z+5
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x130:
	ST   -Y,R31
	ST   -Y,R30
	__GETD1S 15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x131:
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	__GETD2Z 22
	RJMP SUBOPT_0xF8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x132:
	__GETD2Z 22
	CALL __PUTPARD2
	LDI  R26,LOW(1)
	CALL _disk_write
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x133:
	ADIW R30,6
	MOVW R0,R30
	MOVW R26,R30
	CALL __GETD1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x134:
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x135:
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,10
	CALL __GETD1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x136:
	__PUTD1SNS 22,6
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x137:
	RCALL SUBOPT_0x128
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x6
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x138:
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,4
	LD   R30,X
	ORI  R30,0x80
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x139:
	__GETD1S 14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13A:
	RCALL SUBOPT_0x139
	__PUTD1SNS 22,18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13B:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x12D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13C:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	__GETD2Z 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13D:
	LDD  R30,Z+1
	ST   -Y,R30
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ADIW R30,32
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x13E:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x13F:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x140:
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x141:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x142:
	CALL __ADDW2R15
	CALL __GETW1P
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANDD12:
	AND  R30,R26
	AND  R31,R27
	AND  R22,R24
	AND  R23,R25
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__LSLD16:
	MOV  R22,R30
	MOV  R23,R31
	LDI  R30,0
	LDI  R31,0
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__COMD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__GETD2S0:
	LD   R26,Y
	LDD  R27,Y+1
	LDD  R24,Y+2
	LDD  R25,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTDZ20:
	ST   Z,R26
	STD  Z+1,R27
	STD  Z+2,R24
	STD  Z+3,R25
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__PUTPARD2:
	ST   -Y,R25
	ST   -Y,R24
	ST   -Y,R27
	ST   -Y,R26
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
